#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#define		_CCI_DLL_COMPILE
#include	"cci.h"

#include	"local.h"
#include	"defs.h"
#include	"lib.h"
#include	"token.h"
#include	"vcpu.h"
#include	"code.h"

#ifdef	__HIGHC__
	pragma	On(Align_labels);
#endif

int 		push_size = 0;
CAST	   *now_cp = NULL;

int 		heep_pos = 0;
int 		base_pos /*= HEEPMAX*/;
int 		stak_pos /*= HEEPMAX*/;
int 		code_pos = 0;
int 		symb_pos /*= CODEMAX*/;

int			HeepMax;
int			CodeMax;
char	   *heep_buf;
char	   *code_buf;

int 		cast_clas = C_GLOB;
int 		cast_type = T_INT;

int 		cast_init = T_CHAR;
char	   *cast_ptr = NULL;

CAST	   *func_cp = NULL;

int 		func_ret = 0;
int 	   *base_ptr = NULL;
int 		stak_nst = 0;
int 		stak_vac = 0;

VALPTR	   *glob_top[HASHMAX] =
{
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
};
VALPTR	   *loca_top = NULL;
JMPTR	   *stak_top = NULL;

int 		reg_size_tab[] =
{
	sizeof(char)  , sizeof(unsigned char) ,
	sizeof(short) , sizeof(unsigned short),
	sizeof(long)  , sizeof(unsigned long) ,
	sizeof(float) , sizeof(double),
	sizeof(void *), sizeof(void *),
	sizeof(void *), sizeof(void *)
};
int 		reg_mode_tab[] =
{
	S_CHAR , S_CHAR  ,
	S_SHORT, S_SHORT ,
	S_LONG , S_LONG  ,
	S_FLOAT, S_DOUBLE,
	S_INT  , S_INT   ,
	S_INT  , S_INT
};

static int			mknd_flg = FALSE;
static int			jmp_no = 0;
static JMPTR	   *jmp_top = NULL;
static JMPTR	   *jmp_ptr = NULL;
static JMPTR	   *break_ptr = NULL;
static JMPTR	   *goto_ptr = NULL;
static JMPTR	   *case_ptr = NULL;

static int	type_level[] =
{
	0, 1, 2, 3, 4, 5,
	6, 7, 8, 8, 8, 8
};
static int	type_point[] =
{
	0, 0, 0, 0, 0, 0,
	0, 0, 1, 1, 0, 0
};
static int	type_mask[] =
{
	0, 0xFF, 0, 0xFFFF, 0, 0xFFFFFFFF,
	0, 0, 0, 0, 0, 0
};

int _FAST alias(int n)
{
	if (n >= 0)
		n += 3;
	else
		n -= 3;

	n -= (n % 4);

	return n;
}
char * _FAST yystak(int len)
{
	len = alias(len);
	if ((stak_pos - len) <= heep_pos)
	{
		yyerror("out of Heep Stack Space");
		return NULL;
	}
	stak_pos -= len;
	return &(heep_buf[stak_pos]);
}
char * _FAST yyheep(int len)
{
	char	   *p;

	len = alias(len);
	if ((heep_pos + len) >= HEEPMAX)
	{
		yyerror("out of Heep Buffer Space");
		return NULL;
	}
	p = &(heep_buf[heep_pos]);
	heep_pos += len;
	return p;
}
char * _FAST yysymb(int len)
{
	len = alias(len);
	if ((symb_pos - len) <= code_pos)
	{
		yyerror("out of Code Symbol Space");
		return NULL;
	}
	symb_pos -= len;
	return &(code_buf[symb_pos]);
}
void _FAST stak_push(void)
{
	JMPTR	   *jp;

	jp = (JMPTR *) yystak(sizeof(JMPTR));
	jp->next = stak_top;
	stak_top = jp;
	jp->addr = NULL;
}
void _FAST stak_pop(void)
{
	if (stak_top == NULL)
		yyerror("Stak Fream Not Push");
	stak_top = stak_top->next;
}
void _FAST stak_set(VALPTR * vp)
{
	if (stak_top == NULL)
		yyerror("Stak Fream Not Define");
	vp->next = (VALPTR *) (stak_top->addr);
	stak_top->addr = (char *) vp;
}
void _FAST glob_set(VALPTR * vp)
{
	int 		hs;

	hs = hash(vp->name);
	vp->next = glob_top[hs];
	glob_top[hs] = vp;
}
VALPTR * _FAST get_cast(const char *name)
{
	JMPTR	   *jp;
	VALPTR	   *cp;

#ifdef	_DEBUG
	printf("name = %s\n", name);
#endif
	jp = stak_top;
	while (jp != NULL)
	{
		cp = (VALPTR *) (jp->addr);
		while (cp != NULL)
		{
			if ( strcmp(name, cp->name) == 0)
			{
				return cp;
			}
			cp = cp->next;
		}
		jp = jp->next;
	}

	cp = loca_top;
	while (cp != NULL)
	{
		if ( strcmp(name, cp->name) == 0)
		{
			return cp;
		}
		cp = cp->next;
	}

	cp = glob_top[hash(name)];
	while (cp != NULL)
	{
#ifdef	_DEBUG
			printf("    3 strcmp(%s, %s)\n", name, cp->name);
#endif
		if ( strcmp(name, cp->name) == 0)
		{
#ifdef	_DEBUG
			printf("    return\n");
#endif
			return cp;
		}
		cp = cp->next;
	}
	return NULL;
}
int _FAST make_node(int op, int left, int right)
{
	NODE	   *np;

	if (mknd_flg == FALSE)
	{
		base_pos = stak_pos;
		mknd_flg = TRUE;
	}
	np = (NODE *) yystak(sizeof(NODE));
	np->op = op;
	np->left = (NODE *) left;
	np->right = (NODE *) right;
	return (int) np;
}
int _FAST make_label_node(const char *name)
{
	VALPTR	   *vp;
	CAST	   *cp;

	if ((vp = get_cast(name)) == NULL)
	{
#if	0
		yyerror("'%s' is undeclared", name);
#else
		char	*s, tmp[256];

		s = tmp;
		*s++ = '\'';
		strcpy( s, name );
		s += strlen(name);
		strcpy( s, "' is undeclared");
		yyerror(tmp);
#endif
	}
	cp = vp->cast;

	switch (cp->type)
	{
		case T_CHAR:
		case T_UCHAR:
		case T_SHORT:
		case T_USHORT:
		case T_LONG:
		case T_ULONG:
		case T_FLOAT:
		case T_DOUBLE:
		case T_POINT:
		case T_ARRY:
			return make_node('I', make_node('A', (int) vp, 0), 0);
			/* case T_ARRY: */
		case T_EXTF:
			return make_node('a', (int) vp, 0);
		case T_FUNC:
			return make_node('I', make_node('f', (int) vp, 0), 0);
	}
	return 0;
}
void _FAST make_node_flush(void)
{
	if (mknd_flg != FALSE)
		stak_pos = base_pos;
	mknd_flg = FALSE;
}
void _FAST gen_op(int op, int type, int reg)
{
	if (code_pos >= symb_pos)
		yyerror("out of Code Buffer Space");
	code_buf[code_pos++] = op;
	code_buf[code_pos++] = T_MODE(type) | (reg << 5);
}
void _FAST gen_addr(char *addr)
{
	if (((unsigned)code_pos + sizeof(int)) >= (unsigned)symb_pos)
		yyerror("out of Code Buffer Space");
	*((char **) &(code_buf[code_pos])) = addr;
	code_pos += sizeof(int);
}
char * _FAST now_code_pos(void)
{
	return &(code_buf[code_pos]);
}
int _FAST gen_label_make(void)
{
	JMPTR	   *jp;

	jp = (JMPTR *) yystak(sizeof(JMPTR));
	jp->no = jmp_no++;
	jp->addr = NULL;
	jp->next = jmp_top;
	jmp_top = jp;
	return jp->no;
}
void _FAST gen_label_set(int no, char *addr)
{
	JMPTR	   *jp;

	jp = jmp_top;
	while (jp != NULL)
	{
		if (jp->no == no)
		{
			jp->addr = addr;
			return;
		}
		jp = jp->next;
	}
}
char * _FAST gen_label_get(int no)
{
	JMPTR	   *jp;

	jp = jmp_top;
	while (jp != NULL)
	{
		if (jp->no == no)
			return jp->addr;
		jp = jp->next;
	}
	yyerror("Not Found Jmp Label Address");
	return NULL;
}
void _FAST gen_jmp_make(int no, char *addr)
{
	JMPTR	   *jp;

	jp = (JMPTR *) yystak(sizeof(JMPTR));
	jp->no = no;
	jp->addr = addr;
	jp->next = jmp_ptr;
	jmp_ptr = jp;
}
void _FAST gen_jmp_flush(void)
{
	JMPTR	   *jp;

	jp = jmp_ptr;
	while (jp != NULL)
	{
		*((int *) (jp->addr)) = gen_label_get(jp->no) - jp->addr;
		jp = jp->next;
	}
	jmp_ptr = jmp_top = break_ptr = goto_ptr = NULL;
}
void _FAST break_push(void)
{
	JMPTR	   *jp;

	jp = (JMPTR *) yystak(sizeof(JMPTR));
	jp->no = gen_label_make();	/* break label */
		 gen_label_make();	/* continue label */
	jp->next = break_ptr;
	break_ptr = jp;
}
int _FAST break_pop(void)
{
	int 		no;

	if (break_ptr == NULL)
		yyerror("Not Found Break Jmp Address");
	no = break_ptr->no;
	break_ptr = break_ptr->next;
	return no;
}
int _FAST break_now(void)
{
	if (break_ptr == NULL)
		yyerror("Not Found Break Jmp Address");
	return break_ptr->no;
}
int _FAST goto_make(char *name)
{
	JMPTR	   *jp;

	jp = goto_ptr;
	while (jp != NULL)
	{
		if (jp->addr == name)
			return jp->no;
		jp = jp->next;
	}

	jp = (JMPTR *) yystak(sizeof(JMPTR));
	jp->no = gen_label_make();
	jp->addr = name;
	jp->next = goto_ptr;
	goto_ptr = jp;

	return jp->no;
}
void _FAST switch_make(void)
{
	JMPTR	   *jp;

	jp = (JMPTR *) yystak(sizeof(JMPTR));
	jp->next = case_ptr;
	case_ptr = jp;
	jp->no = ERR;
	jp->addr = NULL;
}
void _FAST switch_flush(void)
{
	JMPTR	   *jp;
	int 		n;

	jp = (JMPTR *) (case_ptr->addr);
	while (jp != NULL)
	{
		gen_op(CM_CMPI, T_INT, 0);
		gen_addr((char *) (jp->no));
		gen_op(CM_JNE, 0, 0);
		n = jp->addr - now_code_pos();
		gen_addr((char *) n);
		jp = jp->next;
	}
	if (case_ptr->no != ERR)
	{
		gen_op(CM_JMP, 0, 0);
		n = case_ptr->no - (int) (now_code_pos());
		gen_addr((char *) n);
	}
	case_ptr = case_ptr->next;
}
void _FAST case_make(int val, char *addr)
{
	JMPTR	   *jp;

	if (case_ptr == NULL)
		yyerror("Not Switch Case");
	jp = (JMPTR *) yystak(sizeof(JMPTR));
	jp->next = (JMPTR *) (case_ptr->addr);
	case_ptr->addr = (char *) jp;
	jp->no = val;
	jp->addr = addr;
}
void _FAST default_make(char *addr)
{
	if (case_ptr == NULL)
		yyerror("Not Switch Default");
	case_ptr->no = (int) addr;
}
void _FAST gen_push(int type, int reg)
{
	gen_op(CM_PUSH, type, reg);
	push_size += T_SIZE(type);
}
void _FAST gen_pop(int type, int reg)
{
	gen_op(CM_POP, type, reg);
	push_size -= T_SIZE(type);
}
void _FAST gen_conv(int ot, int nt, int reg)
{
	if (T_MODE(ot) == T_MODE(nt))
		return;
	else if (type_mask[ot] == 0)
	{
		gen_op(CM_CNV, nt, reg);
		gen_addr((char *) T_MODE(ot));
	} else
	{
		gen_op(CM_UCNV, nt, reg);
		gen_addr((char *) T_MODE(ot));
	}
}
void _FAST gen_type_chk(int type, int reg)
{
	switch (type)
	{
			case T_CHAR:case T_UCHAR:
			case T_SHORT:case T_USHORT:
			case T_LONG:case T_ULONG:
			if (type == T_INT)
				break;
			gen_conv(type, T_INT, reg);
			now_cp = (CAST *) yystak(sizeof(CAST));
			now_cp->next = NULL;
			now_cp->type = T_INT;
			now_cp->size = T_SIZE(T_INT);
			break;

		case T_FLOAT:
			gen_conv(type, T_DOUBLE, reg);
			now_cp = (CAST *) yystak(sizeof(CAST));
			now_cp->next = NULL;
			now_cp->type = T_DOUBLE;
			now_cp->size = T_SIZE(T_DOUBLE);
			break;
	}
}
int _FAST type_cmp(int st, int dt)
{
	return (type_level[st] - type_level[dt]);
}
CAST * _FAST gen_expr(int op, CAST * sp, CAST * ap)
{
	int 		cd;
	CAST	   *cp;

	gen_pop(sp->type, 1);

	if (op == CM_ADD)
	{
		if (type_point[ap->type] != 0 &&
			type_point[sp->type] == 0)
		{
			gen_op(CM_MULI, sp->type, 1);
			gen_addr((char *) (ap->next->size));

		} else if (type_point[sp->type] != 0 &&
				   type_point[ap->type] == 0)
		{
			gen_op(CM_MULI, ap->type, 0);
			gen_addr((char *) (sp->next->size));
		}
	}
	if ((cd = type_cmp(sp->type, ap->type)) > 0)
	{
		gen_conv(ap->type, sp->type, 0);
		cp = sp;
	} else if (cd < 0)
	{
		gen_conv(sp->type, ap->type, 1);
		cp = ap;
	} else
		cp = ap;

	gen_op(op, cp->type, 1);

	gen_op(CM_EXG, cp->type, 0);

	if (op == CM_SUB)
	{
		if (type_point[ap->type] != 0 &&
			type_point[sp->type] != 0 &&
			ap->next->size == sp->next->size)
		{
			gen_op(CM_DIVI, cp->type, 0);
			gen_addr((char *) (cp->next->size));
		}
	}
	return cp;
}
void _FAST gen_code(NODE * np)
{
	int 		pos;
	int 		dmy;
	VALPTR	   *vp;
	CAST	   *cp;

	if (np == NULL)
		return;

	switch (np->op & 255)
	{
		case 'E':
			gen_op(CM_LD, T_INT, 0);
			gen_addr((char *) np->left);

			now_cp = (CAST *) yystak(sizeof(CAST));
			now_cp->next = NULL;
			now_cp->type = T_INT;
			now_cp->size = T_SIZE(T_INT);
			break;

		case 'F':
			gen_op(CM_LD, T_DOUBLE, 0);
			gen_addr((char *) np->left);

			now_cp = (CAST *) yystak(sizeof(CAST));
			now_cp->next = NULL;
			now_cp->type = T_DOUBLE;
			now_cp->size = T_SIZE(T_DOUBLE);
			break;

		case 'S':
			gen_op(CM_LD, T_POINT, 0);
			gen_addr((char *) np->left);

			now_cp = (CAST *) yystak(sizeof(CAST));
			now_cp->next = NULL;
			now_cp->type = T_INT;
			now_cp->size = T_SIZE(T_INT);
			break;

		case 'I':
			gen_code(np->left);
			cp = now_cp;
			if ((now_cp = now_cp->next) == NULL)
				yyerror("Not Address InDirect?");

			if ((cp->type != T_ARRY) || (now_cp->type != T_ARRY))
			{
				gen_op(CM_LDR, now_cp->type, 0);
			}
			gen_type_chk(now_cp->type, 0);

			break;

		case 'A':
			vp = (VALPTR *) (np->left);
			gen_op(CM_LEA, T_POINT, vp->clas);
			gen_addr((char *) vp->addr);

			cp = (CAST *) yystak(sizeof(CAST));
			cp->next = vp->cast;
			cp->type = T_POINT;
			cp->size = T_SIZE(T_INT);
			now_cp = cp;
			break;

		case 'a':
			vp = (VALPTR *) (np->left);
			gen_op(CM_LEA, T_POINT, vp->clas);
			gen_addr((char *) vp->addr);
			now_cp = vp->cast;
			break;

		case 'f':
			vp = (VALPTR *) (np->left);
			gen_op(CM_LEA, T_POINT, vp->clas);
			gen_addr((char *) (vp->addr - now_code_pos()));

			cp = (CAST *) yystak(sizeof(CAST));
			cp->next = vp->cast;
			cp->type = T_POINT;
			cp->size = T_SIZE(T_INT);
			now_cp = cp;
			break;

		case '@':
			gen_code(np->right);
			vp = (VALPTR *) (np->left);
			now_cp = vp->cast;
			break;

		case 'D':
			if (np->left == NULL || np->left->op != 'I')
				yyerror("Not '&' Label ?");
			gen_code(np->left->left);
			break;

		case 'V':
			gen_code(np->left);
			cp = now_cp;
			gen_push(cp->type, 0);
			gen_code(np->right);
			now_cp = gen_expr(np->op >> 8, cp, now_cp);
			break;

		case 'x':
			gen_code(np->left);
			cp = now_cp;
			gen_push(cp->type, 0);
			gen_code(np->right);
			gen_expr(np->op >> 8, cp, now_cp);
			now_cp = (CAST *) yystak(sizeof(CAST));
			now_cp->next = NULL;
			now_cp->type = T_INT;
			now_cp->size = T_SIZE(T_INT);
			break;

		case 'v':
			gen_code(np->left);
			gen_op(np->op >> 8, now_cp->type, 0);
			break;

		case 'T':
			gen_code(np->left);
			gen_op(CM_TEST, now_cp->type, 0);
			break;

		case 'l':				/* ++n, --n */
			if (np->left == NULL || np->left->op != 'I')
				yyerror("Not Label Let ?");

			gen_code(np->left->left);

			if ((now_cp = now_cp->next) == NULL)
				yyerror("Not Address InDirect?");

			gen_op(np->op >> 8, now_cp->type, 0);

			gen_op(CM_LDR, now_cp->type, 0);

			gen_type_chk(now_cp->type, 0);
			break;

		case 'i':				/* n++, n-- */
			if (np->left == NULL || np->left->op != 'I')
				yyerror("Not Label Let ?");

			gen_code(np->left->left);

			if ((now_cp = now_cp->next) == NULL)
				yyerror("Not Address InDirect?");

			gen_op(CM_LDR, now_cp->type, 1);

			gen_op(np->op >> 8, now_cp->type, 0);

			gen_op(CM_EXG, now_cp->type, 0);

			gen_type_chk(now_cp->type, 0);
			break;

		case '=':
			if ((np->op >> 8) != 0)
			{
				gen_code(np->left);
				cp = now_cp;
				gen_push(cp->type, 0);	/* Append (TaroPYON)	*/
				gen_code(np->right);
				now_cp = gen_expr(np->op >> 8, cp, now_cp);
			} else
			{
				gen_code(np->right);
			}

			cp = now_cp;
			gen_push(cp->type, 0);

			if (np->left == NULL || np->left->op != 'I')
				yyerror("Not Label Let ?");

			gen_code(np->left->left);

			if ((now_cp = now_cp->next) == NULL)
				yyerror("Not Address InDirect?");

			gen_pop(cp->type, 1);

			/* gen_type_chk(now_cp->type, 1); */
			gen_conv(cp->type, now_cp->type, 1);

			gen_op(CM_STR, now_cp->type, 1);

			gen_op(CM_EXG, cp->type, 0);

			now_cp = cp;
			break;

		case '?':
			gen_code(np->left);

			gen_op(CM_TEST, now_cp->type, 0);

			gen_op(CM_JE, 0, 0);
			pos = code_pos;
			gen_addr(NULL);

			gen_code(np->right->left);

			gen_op(CM_JMP, 0, 0);
			dmy = code_pos;
			gen_addr(NULL);

			*((int *) &(code_buf[pos])) = code_pos - pos;

			gen_code(np->right->right);

			*((int *) &(code_buf[dmy])) = code_pos - dmy;

			break;

		case '&':				/* && */
			gen_code(np->left);

			gen_op(CM_TEST, now_cp->type, 0);

			gen_op(CM_JE, 0, 0);
			pos = code_pos;
			gen_addr(NULL);

			gen_code(np->right);

			*((int *) &(code_buf[pos])) = code_pos - pos;
			break;

		case '|':				/* || */
			gen_code(np->left);

			gen_op(CM_TEST, now_cp->type, 0);

			gen_op(CM_JNE, 0, 0);
			pos = code_pos;
			gen_addr(NULL);

			gen_code(np->right);

			*((int *) &(code_buf[pos])) = code_pos - pos;
			break;

		case 'c':				/* nn ( ) */
			pos = push_size;

			gen_code(np->right);
			/* cp = now_cp; */
			gen_code(np->left);

			if (now_cp->type == T_FUNC)
			{
				gen_op(CM_CALR, now_cp->type, 0);
				/* gen_conv(cp->type,now_cp->next->type,0); */
				/* gen_op(CM_CNV,now_cp->next->type , 0); */
			} else if (now_cp->type == T_EXTF)
			{
				gen_op(CM_CALI, now_cp->type, 0);
				gen_addr((char *) (push_size - pos));
			} else
				yyerror("Not Func ?");

			gen_op(CM_ADDI, T_INT, 4);
			gen_addr((char *) (push_size - pos));
			push_size = pos;

			if ((now_cp = now_cp->next) == NULL)
				yyerror("Not Funcsin Return Cast ?");
			break;

		case 'p':				/* push ( ... ) */
			if (np->right != NULL)
			{
				gen_code(np->right);
				if (T_SIZE(now_cp->type) > T_SIZE(T_INT))
					gen_conv(now_cp->type, T_DOUBLE, 0);
				else
					gen_conv(now_cp->type, T_INT, 0);
				gen_push(now_cp->type, 0);
			}
			gen_code(np->left);
			break;
	}
}

_DLLEXPORT int	CCI_init( int codeSize, int heepSize )
{
	HeepMax = heepSize;
	CodeMax = codeSize;

	heep_pos = 0;
	base_pos = HEEPMAX;
	stak_pos = HEEPMAX;
	code_pos = 0;
	symb_pos = CODEMAX;

	if ( (heep_buf = MALLOC(heepSize)) == NULL )
		return (ERR);
	if ( (code_buf = MALLOC(codeSize)) == NULL )
	{
		FREE(heep_buf);
		return (ERR);
	}
	memset( heep_buf, 0, heepSize);
	memset( code_buf, 0, codeSize);

	{
		static CCIFUNC_T	tbl[] =
		{
			{"_heep_max", (char *)&HeepMax , {T_INT, T_POINT, ERR}},
			{"_code_max", (char *)&CodeMax , {T_INT, T_POINT, ERR}},
			{"_heep_pos", (char *)&heep_pos, {T_INT, T_POINT, ERR}},
			{"_base_pos", (char *)&base_pos, {T_INT, T_POINT, ERR}},
			{"_stak_pos", (char *)&stak_pos, {T_INT, T_POINT, ERR}},
			{"_code_pos", (char *)&code_pos, {T_INT, T_POINT, ERR}},
			{"_symb_pos", (char *)&symb_pos, {T_INT, T_POINT, ERR}},
		};
		CCIFUNC_T	*func;

		for ( func = tbl; func < tbl+(sizeof(tbl)/sizeof(*tbl)); ++func )
			CCI_setFunc( func );
	}
	return (0);
}

_DLLEXPORT int		CCI_setFunc( CCIFUNC_T *func )
{
	int 		i;
	VALPTR	   *vp;
	CAST	   *cp;

	if ( func == NULL || func->name == NULL || *func->name == '\0' )
		return (0);
	vp = (VALPTR *) yysymb(sizeof(VALPTR));
	vp->name = func->name;
	glob_set(vp);
	vp->clas = C_GLOB;
	vp->addr = func->addr;
	vp->cast = NULL;
	for ( i = 0; func->cast[i] != ERR; ++i)
	{
		cp = (CAST *) yysymb(sizeof(CAST));
		cp->next = vp->cast;
		vp->cast = cp;
		cp->type = func->cast[i];
		if (cp->type == T_ARRY)
			cp->size = cp->next->size * func->cast[++i];
		else
			cp->size = T_SIZE(cp->type);
	}
	return (0);
}
