#ifndef	_CODE_H
#define	_CODE_H

#ifndef	_CCI_H
#	include	<cci.h>
#endif
#ifndef	_DEFS_H
#	include	"defs.h"
#endif

#define T_SIZE(c)		(reg_size_tab[(c)])
#define T_MODE(c)		(reg_mode_tab[(c)])

#define S_CHAR			0
#define S_SHORT 		1
#define S_LONG			2
#define S_FLOAT 		3
#define S_DOUBLE		4

#define S_INT			S_LONG

#define C_GLOB			0
#define C_LOCA			1
#define C_STAK			2
#define C_CODE			3

#if	0
#	define HEEPMAX 		(128 * 1024)
#	define CODEMAX 		(128 * 1024)
	extern char heep_buf[];
	extern char code_buf[];
#else
	extern	int			HeepMax;
	extern	int			CodeMax;
#	define HEEPMAX 		HeepMax
#	define CODEMAX 		CodeMax
	extern char *heep_buf;
	extern char *code_buf;
#endif

#define NESTMAX 		32

#if	defined(WIN32)
#	pragma pack(push,4)
#endif
typedef struct _CP
{
	struct _CP *next;
	int 		type;
	int 		size;
} CAST;

typedef struct _VP
{
	struct _VP *next;
	char	   *name;
	CAST	   *cast;
	int 		clas;
	char	   *addr;
} VALPTR;

typedef struct _NP
{
	int 		op;
	struct _NP *left;
	struct _NP *right;
} NODE;

typedef struct _JP
{
	struct _JP *next;
	int 		no;
	char	   *addr;
} JMPTR;
#if	defined(WIN32)
#	pragma pack(pop)
#endif

extern int	push_size;
extern CAST *now_cp;

extern int	heep_pos;
extern int	base_pos;
extern int	stak_pos;
extern int	code_pos;
extern int	symb_pos;

extern int	cast_clas;
extern int	cast_type;

extern int	cast_init;
extern char *cast_ptr;

extern CAST *func_cp;

extern int	func_ret;
extern int *base_ptr;
extern int	stak_nst;
extern int	stak_vac;

extern VALPTR *glob_top[];
extern VALPTR *loca_top;
extern JMPTR *stak_top;

extern int	reg_size_tab[];
extern int	reg_mode_tab[];

extern int 		_FAST alias(int n);
extern char *	_FAST yystak(int len);
extern char *	_FAST yyheep(int len);
extern char *	_FAST yysymb(int len);
extern void		_FAST stak_push(void);
extern void		_FAST stak_pop(void);
extern void		_FAST stak_set(VALPTR * vp);
extern void		_FAST glob_set(VALPTR * vp);
extern VALPTR * _FAST get_cast(const char *name);
extern int 		_FAST make_node(int op, int left, int right);
extern int 		_FAST make_label_node(const char *name);
extern void		_FAST make_node_flush(void);
extern void		_FAST gen_op(int op, int type, int reg);
extern void		_FAST gen_addr(char *addr);
extern char *	_FAST now_code_pos(void);
extern int 		_FAST gen_label_make(void);
extern void		_FAST gen_label_set(int no, char *addr);
extern char *	_FAST gen_label_get(int no);
extern void		_FAST gen_jmp_make(int no, char *addr);
extern void		_FAST gen_jmp_flush(void);
extern void		_FAST break_push(void);
extern int 		_FAST break_pop(void);
extern int 		_FAST break_now(void);
extern int 		_FAST goto_make(char *name);
extern void		_FAST switch_make(void);
extern void		_FAST switch_flush(void);
extern void		_FAST case_make(int val, char *addr);
extern void		_FAST default_make(char *addr);
extern void		_FAST gen_push(int type, int reg);
extern void		_FAST gen_pop(int type, int reg);
extern void		_FAST gen_conv(int ot, int nt, int reg);
extern void		_FAST gen_type_chk(int type, int reg);
extern int 		_FAST type_cmp(int st, int dt);
extern CAST *	_FAST gen_expr(int op, CAST * sp, CAST * ap);
extern void		_FAST gen_code(NODE * np);
/*extern int 		func_exec(char *func);*/

#endif
