#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<string.h>
#include	<ctype.h>

#define		_CCI_DLL_COMPILE
#include	"local.h"
#include	"defs.h"
#include	"lib.h"
#include	"token.h"
#include	"vcpu.h"
#include	"code.h"

#ifdef	__HIGHC__
	pragma	On(Align_labels);
#endif

#define TR				(-1)
#define FS				0

typedef union
{
	char		ac;
	short		as;
	long		al;
	float		af;
	double		ad;
	char	   *ap;
	int 		ax;
} REGS;

static REGS		reg_set[2];
static char	   *reg_sp = NULL;
static char	   *reg_bp = NULL;
static char	   *reg_ip = NULL;
static int		reg_flg = 0;

#ifdef	__HIGHC__
#	ifndef	PASCAL
#		define	PASCAL	(_DEFAULT_CALLING_CONVENTION | _CALLEE_POPS_STACK)
#	endif
#	pragma	Calling_convention(PASCAL);
#endif
static int		_FAST ip_int(void);
static char *	_FAST ip_addr(void);
static void cm_jmp(int sz, int rg);
static void cm_je(int sz, int rg);
static void cm_jne(int sz, int rg);
static void cm_ce(int sz, int rg);
static void cm_cne(int sz, int rg);
static void cm_clt(int sz, int rg);
static void cm_cle(int sz, int rg);
static void cm_cgt(int sz, int rg);
static void cm_cge(int sz, int rg);
static void cm_test(int sz, int rg);
static void cm_and(int sz, int rg);
static void cm_or(int sz, int rg);
static void cm_xor(int sz, int rg);
static void cm_shl(int sz, int rg);
static void cm_shr(int sz, int rg);
static void cm_add(int sz, int rg);
static void cm_sub(int sz, int rg);
static void cm_mul(int sz, int rg);
static void cm_div(int sz, int rg);
static void cm_mod(int sz, int rg);
static void cm_neg(int sz, int rg);
static void cm_not(int sz, int rg);
static void cm_jmpr(int sz, int rg);
static void cm_push(int sz, int rg);
static void cm_pop(int sz, int rg);
static void cm_cnv(int sz, int rg);
static void cm_ucnv(int sz, int rg);
static void cm_exg(int sz, int rg);
static void cm_ld(int sz, int rg);
static void cm_ldr(int sz, int rg);
static void cm_st(int sz, int rg);
static void cm_str(int sz, int rg);
static void cm_ret(int sz, int rg);
static void cm_inc(int sz, int rg);
static void cm_dec(int sz, int rg);
static void cm_lea(int sz, int rg);
static void cm_base(int sz, int rg);
static void cm_addi(int sz, int rg);
static void cm_muli(int sz, int rg);
static void cm_divi(int sz, int rg);
static void cm_cmpi(int sz, int rg);
static void cm_calr(int sz, int rg);
static void cm_cali(int sz, int rg);
#ifdef	__HIGHC__
#	pragma	Calling_convention();
#endif

static int _FAST ip_int(void)
{
	int 		n;

	n = *((int *) reg_ip);
	reg_ip += sizeof(int);
	return n;
}
static char * _FAST ip_addr(void)
{
	int 		n;
	char	   *addr;

	n = *((int *) reg_ip);
	addr = reg_ip + n;
	reg_ip += sizeof(int);
	return addr;
}

/***
		vcpu set
***/

static void cm_jmp(int sz, int rg)
{
	reg_ip = ip_addr();
}
static void cm_je(int sz, int rg)
{
	char	   *addr;

	addr = ip_addr();
	if (reg_flg == 0)
		reg_ip = addr;
}
static void cm_jne(int sz, int rg)
{
	char	   *addr;

	addr = ip_addr();
	if (reg_flg != 0)
		reg_ip = addr;
}
static void cm_ce(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ax = (reg_set[rg].ac == reg_set[rg ^ 1].ac ? TR : FS);
			break;
		case S_SHORT:
			reg_set[rg].ax = (reg_set[rg].as == reg_set[rg ^ 1].as ? TR : FS);
			break;
		case S_LONG:
			reg_set[rg].ax = (reg_set[rg].al == reg_set[rg ^ 1].al ? TR : FS);
			break;
		case S_FLOAT:
			reg_set[rg].ax = (reg_set[rg].af == reg_set[rg ^ 1].af ? TR : FS);
			break;
		case S_DOUBLE:
			reg_set[rg].ax = (reg_set[rg].ad == reg_set[rg ^ 1].ad ? TR : FS);
			break;
	}
}
static void cm_cne(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ax = (reg_set[rg].ac != reg_set[rg ^ 1].ac ? TR : FS);
			break;
		case S_SHORT:
			reg_set[rg].ax = (reg_set[rg].as != reg_set[rg ^ 1].as ? TR : FS);
			break;
		case S_LONG:
			reg_set[rg].ax = (reg_set[rg].al != reg_set[rg ^ 1].al ? TR : FS);
			break;
		case S_FLOAT:
			reg_set[rg].ax = (reg_set[rg].af != reg_set[rg ^ 1].af ? TR : FS);
			break;
		case S_DOUBLE:
			reg_set[rg].ax = (reg_set[rg].ad != reg_set[rg ^ 1].ad ? TR : FS);
			break;
	}
}
static void cm_clt(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ax = (reg_set[rg].ac > reg_set[rg ^ 1].ac ? TR : FS);
			break;
		case S_SHORT:
			reg_set[rg].ax = (reg_set[rg].as > reg_set[rg ^ 1].as ? TR : FS);
			break;
		case S_LONG:
			reg_set[rg].ax = (reg_set[rg].al > reg_set[rg ^ 1].al ? TR : FS);
			break;
		case S_FLOAT:
			reg_set[rg].ax = (reg_set[rg].af > reg_set[rg ^ 1].af ? TR : FS);
			break;
		case S_DOUBLE:
			reg_set[rg].ax = (reg_set[rg].ad > reg_set[rg ^ 1].ad ? TR : FS);
			break;
	}
}
static void cm_cle(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ax = (reg_set[rg].ac >= reg_set[rg ^ 1].ac ? TR : FS);
			break;
		case S_SHORT:
			reg_set[rg].ax = (reg_set[rg].as >= reg_set[rg ^ 1].as ? TR : FS);
			break;
		case S_LONG:
			reg_set[rg].ax = (reg_set[rg].al >= reg_set[rg ^ 1].al ? TR : FS);
			break;
		case S_FLOAT:
			reg_set[rg].ax = (reg_set[rg].af >= reg_set[rg ^ 1].af ? TR : FS);
			break;
		case S_DOUBLE:
			reg_set[rg].ax = (reg_set[rg].ad >= reg_set[rg ^ 1].ad ? TR : FS);
			break;
	}
}
static void cm_cgt(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ax = (reg_set[rg].ac < reg_set[rg ^ 1].ac ? TR : FS);
			break;
		case S_SHORT:
			reg_set[rg].ax = (reg_set[rg].as < reg_set[rg ^ 1].as ? TR : FS);
			break;
		case S_LONG:
			reg_set[rg].ax = (reg_set[rg].al < reg_set[rg ^ 1].al ? TR : FS);
			break;
		case S_FLOAT:
			reg_set[rg].ax = (reg_set[rg].af < reg_set[rg ^ 1].af ? TR : FS);
			break;
		case S_DOUBLE:
			reg_set[rg].ax = (reg_set[rg].ad < reg_set[rg ^ 1].ad ? TR : FS);
			break;
	}
}
static void cm_cge(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ax = (reg_set[rg].ac <= reg_set[rg ^ 1].ac ? TR : FS);
			break;
		case S_SHORT:
			reg_set[rg].ax = (reg_set[rg].as <= reg_set[rg ^ 1].as ? TR : FS);
			break;
		case S_LONG:
			reg_set[rg].ax = (reg_set[rg].al <= reg_set[rg ^ 1].al ? TR : FS);
			break;
		case S_FLOAT:
			reg_set[rg].ax = (reg_set[rg].af <= reg_set[rg ^ 1].af ? TR : FS);
			break;
		case S_DOUBLE:
			reg_set[rg].ax = (reg_set[rg].ad <= reg_set[rg ^ 1].ad ? TR : FS);
			break;
	}
}
static void cm_test(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_flg = (reg_set[rg].ac != 0 ? TR : FS);
			break;
		case S_SHORT:
			reg_flg = (reg_set[rg].as != 0 ? TR : FS);
			break;
		case S_LONG:
			reg_flg = (reg_set[rg].al != 0 ? TR : FS);
			break;
		case S_FLOAT:
			reg_flg = (reg_set[rg].af != 0 ? TR : FS);
			break;
		case S_DOUBLE:
			reg_flg = (reg_set[rg].ad != 0 ? TR : FS);
			break;
	}
}
static void cm_and(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac &= reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as &= reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al &= reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
		case S_DOUBLE:
			yyerror("Float/Double Not '&' Expr");
			break;
	}
}
static void cm_or(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac |= reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as |= reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al |= reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
		case S_DOUBLE:
			yyerror("Float/Double Not '|' Expr");
			break;
	}
}
static void cm_xor(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac ^= reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as ^= reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al ^= reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
		case S_DOUBLE:
			yyerror("Float/Double Not '^' Expr");
			break;
	}
}
static void cm_shl(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac <<= reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as <<= reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al <<= reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
		case S_DOUBLE:
			yyerror("Float/Double Not '<<' Expr");
			break;
	}
}
static void cm_shr(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac >>= reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as >>= reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al >>= reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
		case S_DOUBLE:
			yyerror("Float/Double Not '>>' Expr");
			break;
	}
}
static void cm_add(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac += reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as += reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al += reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
			reg_set[rg].af += reg_set[rg ^ 1].af;
			break;
		case S_DOUBLE:
			reg_set[rg].ad += reg_set[rg ^ 1].ad;
			break;
	}
}
static void cm_sub(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac -= reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as -= reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al -= reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
			reg_set[rg].af -= reg_set[rg ^ 1].af;
			break;
		case S_DOUBLE:
			reg_set[rg].ad -= reg_set[rg ^ 1].ad;
			break;
	}
}
static void cm_mul(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac *= reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as *= reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al *= reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
			reg_set[rg].af *= reg_set[rg ^ 1].af;
			break;
		case S_DOUBLE:
			reg_set[rg].ad *= reg_set[rg ^ 1].ad;
			break;
	}
}
static void cm_div(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac /= reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as /= reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al /= reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
			reg_set[rg].af /= reg_set[rg ^ 1].af;
			break;
		case S_DOUBLE:
			reg_set[rg].ad /= reg_set[rg ^ 1].ad;
			break;
	}
}
static void cm_mod(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac %= reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as %= reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al %= reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
		case S_DOUBLE:
			yyerror("Float/Double Not '%' Expr");
			break;
	}
}
static void cm_neg(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac = 0 - reg_set[rg].ac;
			break;
		case S_SHORT:
			reg_set[rg].as = 0 - reg_set[rg].as;
			break;
		case S_LONG:
			reg_set[rg].al = 0 - reg_set[rg].al;
			break;
		case S_FLOAT:
			reg_set[rg].af = (float)(0.0 - reg_set[rg].af);
			break;
		case S_DOUBLE:
			reg_set[rg].ad = 0.0 - reg_set[rg].ad;
			break;
	}
}
static void cm_not(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac = ~reg_set[rg].ac;
			break;
		case S_SHORT:
			reg_set[rg].as = ~reg_set[rg].as;
			break;
		case S_LONG:
			reg_set[rg].al = ~reg_set[rg].al;
			break;
		case S_FLOAT:
		case S_DOUBLE:
			yyerror("Float/Double Not '~' Expr");
			break;
	}
}
static void cm_jmpr(int sz, int rg)
{
	reg_ip = (char *) ip_int();
}
static void cm_push(int sz, int rg)
{
	switch (rg)
	{
		case 0:case 1:
			switch (sz)
			{
					case S_CHAR:
					reg_sp -= sizeof(char);
					*((char *) reg_sp) = reg_set[rg].ac;
					break;
				case S_SHORT:
					reg_sp -= sizeof(short);
					*((short *) reg_sp) = reg_set[rg].as;
					break;
				case S_LONG:
					reg_sp -= sizeof(long);
					*((long *) reg_sp) = reg_set[rg].al;
					break;
				case S_FLOAT:
					reg_sp -= sizeof(float);
					*((float *) reg_sp) = reg_set[rg].af;
					break;
				case S_DOUBLE:
					reg_sp -= sizeof(double);
					*((double *) reg_sp) = reg_set[rg].ad;
					break;
			}
			break;

		case 2:
			reg_sp -= sizeof(char *);
			*((char **) reg_sp) = reg_bp;
			break;
	}
}
static void cm_pop(int sz, int rg)
{
	switch (rg)
	{
		case 0:case 1:
			switch (sz)
			{
					case S_CHAR:
					reg_set[rg].ac = *((char *) reg_sp);
					reg_sp += sizeof(char);
					break;
				case S_SHORT:
					reg_set[rg].as = *((short *) reg_sp);
					reg_sp += sizeof(short);
					break;
				case S_LONG:
					reg_set[rg].al = *((long *) reg_sp);
					reg_sp += sizeof(long);
					break;
				case S_FLOAT:
					reg_set[rg].af = *((float *) reg_sp);
					reg_sp += sizeof(float);
					break;
				case S_DOUBLE:
					reg_set[rg].ad = *((double *) reg_sp);
					reg_sp += sizeof(double);
					break;
			}
			break;
		case 2:
			reg_bp = *((char **) reg_sp);
			reg_sp += sizeof(char *);
			break;

	}
}
static void cm_cnv(int sz, int rg)
{
	int 		oz;

	oz = ip_int();
	switch (sz)
	{
		case S_CHAR:
			switch (oz)
			{
				case S_SHORT:
					reg_set[rg].ac = (char) (reg_set[rg].as);
					break;
				case S_LONG:
					reg_set[rg].ac = (char) (reg_set[rg].al);
					break;
				case S_FLOAT:
					reg_set[rg].ac = (char) (reg_set[rg].af);
					break;
				case S_DOUBLE:
					reg_set[rg].ac = (char) (reg_set[rg].ad);
					break;
			}
			break;
		case S_SHORT:
			switch (oz)
			{
				case S_CHAR:
					reg_set[rg].as = reg_set[rg].ac;
					break;
				case S_LONG:
					reg_set[rg].as = (short) (reg_set[rg].al);
					break;
				case S_FLOAT:
					reg_set[rg].as = (short) (reg_set[rg].af);
					break;
				case S_DOUBLE:
					reg_set[rg].as = (short) (reg_set[rg].ad);
					break;
			}
			break;
		case S_LONG:
			switch (oz)
			{
				case S_CHAR:
					reg_set[rg].al = reg_set[rg].ac;
					break;
				case S_SHORT:
					reg_set[rg].al = reg_set[rg].as;
					break;
				case S_FLOAT:
					reg_set[rg].al = (long) (reg_set[rg].af);
					break;
				case S_DOUBLE:
					reg_set[rg].al = (long) (reg_set[rg].ad);
					break;
			}
			break;
		case S_FLOAT:
			switch (oz)
			{
				case S_CHAR:
					reg_set[rg].af = reg_set[rg].ac;
					break;
				case S_SHORT:
					reg_set[rg].af = reg_set[rg].as;
					break;
				case S_LONG:
					reg_set[rg].af = (float)(reg_set[rg].al);
					break;
				case S_DOUBLE:
					reg_set[rg].af = (float)(reg_set[rg].ad);
					break;
			}
			break;
		case S_DOUBLE:
			switch (oz)
			{
				case S_CHAR:
					reg_set[rg].ad = reg_set[rg].ac;
					break;
				case S_SHORT:
					reg_set[rg].ad = reg_set[rg].as;
					break;
				case S_LONG:
					reg_set[rg].ad = reg_set[rg].al;
					break;
				case S_FLOAT:
					reg_set[rg].ad = reg_set[rg].af;
					break;
			}
			break;
	}
}
static void cm_ucnv(int sz, int rg)
{
	int 		oz;

	oz = ip_int();
	switch (sz)
	{
		case S_CHAR:
			switch (oz)
			{
				case S_SHORT:
					reg_set[rg].ac = (char) (reg_set[rg].as);
					break;
				case S_LONG:
					reg_set[rg].ac = (char) (reg_set[rg].al);
					break;
				case S_FLOAT:
					reg_set[rg].ac = (char) (reg_set[rg].af);
					break;
				case S_DOUBLE:
					reg_set[rg].ac = (char) (reg_set[rg].ad);
					break;
			}
			break;
		case S_SHORT:
			switch (oz)
			{
				case S_CHAR:
					reg_set[rg].as = (unsigned char) (reg_set[rg].ac);
					break;
				case S_LONG:
					reg_set[rg].as = (short) (reg_set[rg].al);
					break;
				case S_FLOAT:
					reg_set[rg].as = (short) (reg_set[rg].af);
					break;
				case S_DOUBLE:
					reg_set[rg].as = (short) (reg_set[rg].ad);
					break;
			}
			break;
		case S_LONG:
			switch (oz)
			{
				case S_CHAR:
					reg_set[rg].as = (unsigned char) (reg_set[rg].ac);
					break;
				case S_SHORT:
					reg_set[rg].al = (unsigned short) (reg_set[rg].as);
					break;
				case S_FLOAT:
					reg_set[rg].al = (long) (reg_set[rg].af);
					break;
				case S_DOUBLE:
					reg_set[rg].al = (long) (reg_set[rg].ad);
					break;
			}
			break;
		case S_FLOAT:
			switch (oz)
			{
				case S_CHAR:
					reg_set[rg].as = (unsigned char) (reg_set[rg].ac);
					break;
				case S_SHORT:
					reg_set[rg].al = (unsigned short) (reg_set[rg].as);
					break;
				case S_LONG:
					reg_set[rg].af = (float)((unsigned long) (reg_set[rg].al));
					break;
				case S_DOUBLE:
					reg_set[rg].af = (float) (reg_set[rg].ad);
					break;
			}
			break;
		case S_DOUBLE:
			switch (oz)
			{
				case S_CHAR:
					reg_set[rg].as = (unsigned char) (reg_set[rg].ac);
					break;
				case S_SHORT:
					reg_set[rg].al = (unsigned short) (reg_set[rg].as);
					break;
				case S_LONG:
					reg_set[rg].af = (float)((unsigned long) (reg_set[rg].al));
					break;
				case S_FLOAT:
					reg_set[rg].ad = reg_set[rg].af;
					break;
			}
			break;
	}
}
static void cm_exg(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac = reg_set[rg ^ 1].ac;
			break;
		case S_SHORT:
			reg_set[rg].as = reg_set[rg ^ 1].as;
			break;
		case S_LONG:
			reg_set[rg].al = reg_set[rg ^ 1].al;
			break;
		case S_FLOAT:
			reg_set[rg].af = reg_set[rg ^ 1].af;
			break;
		case S_DOUBLE:
			reg_set[rg].ad = reg_set[rg ^ 1].ad;
			break;
	}
}
static void cm_ld(int sz, int rg)
{
	int 		n;

	n = ip_int();
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac = n;
			break;
		case S_SHORT:
			reg_set[rg].as = n;
			break;
		case S_LONG:
			reg_set[rg].al = n;
			break;
		case S_FLOAT:
			reg_set[rg].af = *((float *) n);
			break;
		case S_DOUBLE:
			reg_set[rg].ad = *((double *) n);
			break;
	}
}
static void cm_ldr(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			reg_set[rg].ac = *((char *) (reg_set[0].ap));
			break;
		case S_SHORT:
			reg_set[rg].as = *((short *) (reg_set[0].ap));
			break;
		case S_LONG:
			reg_set[rg].al = *((long *) (reg_set[0].ap));
			break;
		case S_FLOAT:
			reg_set[rg].af = *((float *) (reg_set[0].ap));
			break;
		case S_DOUBLE:
			reg_set[rg].ad = *((double *) (reg_set[0].ap));
			break;
	}
}
static void cm_st(int sz, int rg)
{
	char	   *p;

	p = (char *) ip_int();
	switch (sz)
	{
		case S_CHAR:
			*((char *) p) = reg_set[rg].ac;
			break;
		case S_SHORT:
			*((short *) p) = reg_set[rg].as;
			break;
		case S_LONG:
			*((long *) p) = reg_set[rg].al;
			break;
		case S_FLOAT:
			*((float *) p) = reg_set[rg].af;
			break;
		case S_DOUBLE:
			*((double *) p) = reg_set[rg].ad;
			break;
	}
}
static void cm_str(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			*((char *) (reg_set[0].ap)) = reg_set[rg].ac;
			break;
		case S_SHORT:
			*((short *) (reg_set[0].ap)) = reg_set[rg].as;
			break;
		case S_LONG:
			*((long *) (reg_set[0].ap)) = reg_set[rg].al;
			break;
		case S_FLOAT:
			*((float *) (reg_set[0].ap)) = reg_set[rg].af;
			break;
		case S_DOUBLE:
			*((double *) (reg_set[0].ap)) = reg_set[rg].ad;
			break;
	}
}
static void cm_ret(int sz, int rg)
{
	reg_ip = *((char **) reg_sp);
	reg_sp += sizeof(char *);
}
static void cm_inc(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			(*((char *) (reg_set[rg].ap)))++;
			break;
		case S_SHORT:
			(*((short *) (reg_set[rg].ap)))++;
			break;
		case S_LONG:
			(*((long *) (reg_set[rg].ap)))++;
			break;
		case S_FLOAT:
			(*((float *) (reg_set[rg].ap)))++;
			break;
		case S_DOUBLE:
			(*((double *) (reg_set[rg].ap)))++;
			break;
	}
}
static void cm_dec(int sz, int rg)
{
	switch (sz)
	{
		case S_CHAR:
			(*((char *) (reg_set[rg].ap)))--;
			break;
		case S_SHORT:
			(*((short *) (reg_set[rg].ap)))--;
			break;
		case S_LONG:
			(*((long *) (reg_set[rg].ap)))--;
			break;
		case S_FLOAT:
			(*((float *) (reg_set[rg].ap)))--;
			break;
		case S_DOUBLE:
			(*((double *) (reg_set[rg].ap)))--;
			break;
	}
}
static void cm_lea(int sz, int rg)
{
	switch (rg)
	{
		case 0:case 1:
			reg_set[0].ax = ip_int();
			break;
		case 2: 		/* reg_bp */
			reg_set[0].ap = reg_bp + ip_int();
			break;
		case 3: 		/* reg_ip */
			reg_set[0].ap = ip_addr();
			break;
		case 4: 		/* reg_sp */
			reg_set[0].ap = reg_sp + ip_int();
			break;
	}
}
static void cm_base(int sz, int rg)
{
	reg_bp = reg_sp;
}
static void cm_addi(int sz, int rg)
{
	switch (rg)
	{
		case 0:case 1:		/* ax , bx */
			switch (sz)
			{
					case S_CHAR:
					reg_set[rg].ac += ip_int();
					break;
				case S_SHORT:
					reg_set[rg].as += ip_int();
					break;
				case S_LONG:
					reg_set[rg].al += ip_int();
					break;
				case S_FLOAT:
					reg_set[rg].af += ip_int();
					break;
				case S_DOUBLE:
					reg_set[rg].ad += ip_int();
					break;
			}
			break;
		case 2: 		/* reg_bp */
			reg_bp += ip_int();
			break;
		case 3: 		/* reg_ip */
			reg_ip += ip_int();
			break;
		case 4: 		/* reg_sp */
			reg_sp += ip_int();
			break;
	}
}
static void cm_muli(int sz, int rg)
{
	switch (rg)
	{
			case 0:case 1:		/* ax , bx */
			switch (sz)
			{
				case S_CHAR:
					reg_set[rg].ac *= ip_int();
					break;
				case S_SHORT:
					reg_set[rg].as *= ip_int();
					break;
				case S_LONG:
					reg_set[rg].al *= ip_int();
					break;
				case S_FLOAT:
					reg_set[rg].af *= ip_int();
					break;
				case S_DOUBLE:
					reg_set[rg].ad *= ip_int();
					break;
			}
			break;
	}
}
static void cm_divi(int sz, int rg)
{
	switch (rg)
	{
		case 0:case 1:		/* ax , bx */
			switch (sz)
			{
					case S_CHAR:
					reg_set[rg].ac /= ip_int();
					break;
				case S_SHORT:
					reg_set[rg].as /= ip_int();
					break;
				case S_LONG:
					reg_set[rg].al /= ip_int();
					break;
				case S_FLOAT:
					reg_set[rg].af /= ip_int();
					break;
				case S_DOUBLE:
					reg_set[rg].ad /= ip_int();
					break;
			}
			break;
	}
}
static void cm_cmpi(int sz, int rg)
{
	int 		n;

	n = ip_int();
	switch (sz)
	{
		case S_CHAR:
			reg_flg = (reg_set[rg].ac == n ? TR : FS);
			break;
		case S_SHORT:
			reg_flg = (reg_set[rg].as == n ? TR : FS);
			break;
		case S_LONG:
			reg_flg = (reg_set[rg].al == n ? TR : FS);
			break;
		case S_FLOAT:
		case S_DOUBLE:
			yyerror("Float/Double Binary Cmp ?");
			break;
	}
}
static void cm_calr(int sz, int rg)
{
	reg_sp -= sizeof(char *);
	*((char **) reg_sp) = reg_ip;

	switch (rg)
	{
		case 0: 		/* ax */
			reg_ip = reg_set[0].ap;
			break;
		case 1: 		/* bx */
			reg_ip = reg_set[1].ap;
			break;
	}
}
static void cm_cali(int sz, int rg)
{
	int 		n;
	int 	   *p;
	int 		(*func) ();

	n = (ip_int() + sizeof(int) - 1) / sizeof(int);
	p = (int *) reg_sp;
	func = (int (*)()) (reg_set[rg].ax);

	switch (n)
	{
		case 0:
			reg_set[0].ax = (*func) ();
			break;
		case 1:
			reg_set[0].ax = (*func) (p[0]);
			break;
		case 2:
			reg_set[0].ax = (*func) (p[0], p[1]);
			break;
		case 3:
			reg_set[0].ax = (*func) (p[0], p[1], p[2]);
			break;
		case 4:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3]);
			break;
		case 5:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4]);
			break;
		case 6:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5]);
			break;
		case 7:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6]);
			break;
		case 8:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7]);
			break;
		case 9:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8]);
			break;
		case 10:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8], p[9]);
			break;
		case 11:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8], p[9], p[10]);
			break;
		case 12:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8], p[9], p[10], p[11]);
			break;
		case 13:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8], p[9], p[10], p[11],
									 p[12] );
			break;
		case 14:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8], p[9], p[10], p[11],
									 p[12], p[13] );
			break;
		case 15:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8], p[9], p[10], p[11],
									 p[12], p[13], p[14] );
			break;
		case 16:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8], p[9], p[10], p[11],
									 p[12], p[13], p[14], p[15] );
			break;

		case 17:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8], p[9], p[10], p[11],
									 p[12], p[13], p[14], p[15], p[16] );
			break;

		case 18:
			reg_set[0].ax = (*func) (p[0], p[1], p[2], p[3], p[4], p[5],
									 p[6], p[7], p[8], p[9], p[10], p[11],
									 p[12], p[13], p[14], p[15], p[16], p[17] );
			break;
	}
}

#ifdef	__HIGHC__
#	pragma	Calling_convention(PASCAL);
#endif
static void (* cm_tab[])(int,int) =
{
	cm_jmp, cm_je, cm_jne, cm_ce, cm_cne,
	cm_clt, cm_cle, cm_cgt, cm_cge, cm_and,
	cm_or, cm_xor, cm_add, cm_sub, cm_mul,
	cm_div, cm_mod, cm_shl, cm_shr, cm_neg,
	cm_not, cm_jmpr, cm_push, cm_pop, cm_cnv,
	cm_ucnv, cm_test, cm_exg, cm_ld, cm_ldr,
	cm_st, cm_str, cm_ret, cm_inc, cm_dec,
	cm_lea, cm_base, cm_addi, cm_muli, cm_divi,
	cm_calr, cm_cali, cm_cmpi
};
#ifdef	__HIGHC__
#	pragma	Calling_convention();
#endif

#ifdef	DEBUG
static char *cm_name[] =
{
	"jmp", "je", "jne", "ce", "cne",
	"clt", "cle", "cgt", "cge", "and",
	"or", "xor", "add", "sub", "mul",
	"div", "mod", "shl", "shr", "neg",
	"not", "jmpr", "push", "pop", "cnv",
	"ucnv", "test", "exg", "ld", "ldr",
	"st", "str", "ret", "inc", "dec",
	"lea", "base", "addi", "muli", "divi",
	"calr", "cali", "cmpi",
};
#endif

void		code_exec(char *ip)
{
	int 		op, sz, rg;

	reg_ip = ip;
	while (reg_ip != NULL)
	{
		op = *(reg_ip++);
		sz = *reg_ip & 0x1F;
		rg = (*(reg_ip++) >> 5) & 7;
#ifdef	DEBUG
		printf("ax:%04x bx:%04x bp:%04x sp:%04x ip:%04x\t%s %d.%d\n",
			   reg_set[0].ax, reg_set[1].ax, reg_bp, reg_sp, reg_ip,
			   cm_name[op], rg, sz);
#endif
		(*cm_tab[op]) (sz, rg);
	}
}

_DLLEXPORT int 	CCI_exec(const char *func, int len,...)
{
	int 		n;
/*	int 		rc = ERR;	*/
	VALPTR	   *vp;
	jmp_buf 	save_jmp;
	char	   *save_sp;
	char	   *save_ip;
	va_list 	arg;
	char	   *reg_sp_va;

	memcpy(save_jmp, yyerrjmp, sizeof(jmp_buf));
	save_ip = reg_ip;
	save_sp = reg_sp;

	if (setjmp(yyerrjmp) != 0)
		goto ENDOF;

	if ((vp = get_cast(func)) == NULL ||
		vp->clas != C_CODE || vp->cast->type != T_FUNC)
		goto ENDOF;

	reg_sp -= sizeof(int)*len;
	reg_sp_va = reg_sp;
	va_start(arg, len);
	for ( n = 0 ; n < len ; n++ )
	{
/*		reg_sp -= sizeof(int);*/
		*((int *)reg_sp_va) = va_arg(arg,int);
		reg_sp_va += sizeof(int);
	}
	va_end(arg);

	reg_sp -= sizeof(int);
	*((int *)reg_sp) = 0;

	code_exec(*((char **)(vp->addr)));
/*	rc = FALSE;	*/

ENDOF:
	reg_sp = save_sp;
	reg_ip = save_ip;
	memcpy(yyerrjmp, save_jmp, sizeof(jmp_buf));
	return (reg_set[0].ax);
}

_DLLEXPORT int	CCI_load(const char *file)
{
	if (setjmp(yyerrjmp) != 0)
	{
		yyclose();
		return (ERR);
	}
	if (yyopen(file))
		return (ERR);

	yyparse();
	yyclose();

	stak_pos = HEEPMAX;
	reg_set[0].ax = reg_set[1].ax = 0;
	reg_sp = reg_bp = &(heep_buf[stak_pos]);
	reg_ip = NULL;

	return (FALSE);
}
