#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"cci.h"

#ifndef	ERR
#	define	ERR	(-1)
#endif

#ifdef	__HIGHC__
static	void	*__stdin  = (void *)(stdin );
static	void	*__stdout = (void *)(stdout);
static	void	*__stderr = (void *)(stderr);
#endif

long		clock();
long		time();
int 	   *localtime();
long		mktime();
char	   *ctime();
char	   *asctime();
double		difftime();

#if	defined(__HIGHC__)
#pragma Off(Warn)
#endif

static int	_getch(void)		{	return getc(stdin);			}
static int	_putch(int ch)		{	return putc(ch, stdout);	}
static void _cleae(FILE * fp)	{	clearerr(fp);				}
static int	__feof(FILE * fp)	{	return feof(fp);			}
static int	__ferror(FILE * fp)	{	return ferror(fp);			}
static int	__fileno(FILE * fp)	{	return fileno(fp);			}
static int	__strcmp(char *s1,char *s2) { return strcmp(s1,s2);	}
static int	__isalpha(int c)	{	return isalpha(c);			}
static int	__isupper(int c)	{	return isupper(c);			}
static int	__islower(int c)	{	return islower(c);			}
static int	__isdigit(int c)	{	return isdigit(c);			}
static int	__isxdigit(int c)	{	return isxdigit(c);			}
static int	__isalnum(int c)	{	return isalnum(c);			}
static int	__isspace(int c)	{	return isspace(c);			}
static int	__ispunct(int c)	{	return ispunct(c);			}
static int	__isprint(int c)	{	return isprint(c);			}
static int	__isgraph(int c)	{	return isgraph(c);			}
static int	__iscntrl(int c)	{	return iscntrl(c);			}
static int	__isascii_(int c)	{	return isascii(c);			}
static int	__touppe(int c)		{	return toupper(c);			}
static int	__tolowe(int c)		{	return tolower(c);			}
/* static		int 	__toascii(int c) { return toascii(c); } */

static CCIFUNC_T	ext_tab[] =
{
	{"errno",	(char *)&errno,			{T_INT, ERR}},
#ifdef	__HIGHC__
	{"stdin",	(char *)&__stdin,		{T_INT, T_POINT, ERR}},
	{"stdout",	(char *)&__stdout,		{T_INT, T_POINT, ERR}},
	{"stderr",	(char *)&__stderr,		{T_INT, T_POINT, ERR}},
#else
	{"stdin",	(char *) stdin,			{T_INT, ERR}},
	{"stdout",	(char *) stdout,		{T_INT, ERR}},
	{"stderr",	(char *) stderr,		{T_INT, ERR}},
#endif

	{"putc",	(char *) fputc,		{T_INT, T_EXTF, ERR}},
	{"puts",	(char *) puts,		{T_INT, T_EXTF, ERR}},
	{"fputc",	(char *) fputc,		{T_INT, T_EXTF, ERR}},
	{"fputs",	(char *) fputs,		{T_INT, T_EXTF, ERR}},
	{"fread",	(char *) fread,		{T_INT, T_EXTF, ERR}},

	{"getc",	(char *) fgetc,		{T_INT, T_EXTF, ERR}},
	{"gets",	(char *) gets,		{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"fgetc",	(char *) fgetc,		{T_INT, T_EXTF, ERR}},
	{"fgets",	(char *) fgets,		{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"fwrite",	(char *) fwrite,	{T_INT, T_EXTF, ERR}},

	{"fopen",	(char *) fopen,		{T_INT, T_EXTF, ERR}},
	{"fclose",	(char *) fclose,	{T_INT, T_EXTF, ERR}},
	{"fseek",	(char *) fseek,		{T_INT, T_EXTF, ERR}},
	{"ftell",	(char *) ftell,		{T_LONG, T_EXTF, ERR}},
	{"rewind",	(char *) rewind,	{T_VOID, T_EXTF, ERR}},
	{"setbuf",	(char *) setbuf,	{T_INT, T_EXTF, ERR}},
	{"fflush",	(char *) fflush,	{T_INT, T_EXTF, ERR}},
	{"ungetc",	(char *) ungetc,	{T_INT, T_EXTF, ERR}},

	{"getchar",	(char *) _getch,	{T_INT, T_EXTF, ERR}},
	{"putchar",	(char *) _putch,	{T_INT, T_EXTF, ERR}},
	{"clearerr",(char *) _cleae,	{T_INT, T_EXTF, ERR}},
	{"feof",	(char *) __feof,	{T_INT, T_EXTF, ERR}},
	{"ferror",	(char *) __ferror,	{T_INT, T_EXTF, ERR}},
	{"fileno",	(char *) __fileno,	{T_INT, T_EXTF, ERR}},

	{"printf",	(char *) printf,	{T_INT, T_EXTF, ERR}},
	{"fprintf",	(char *) fprintf,	{T_INT, T_EXTF, ERR}},
	{"sprintf",	(char *) sprintf,	{T_INT, T_EXTF, ERR}},

	{"vprintf",	(char *) vprintf,	{T_INT, T_EXTF, ERR}},
	{"vfprintf",(char *) vfprintf,	{T_INT, T_EXTF, ERR}},
	{"vsprintf",(char *) vsprintf,	{T_INT, T_EXTF, ERR}},

	{"scanf",	(char *) scanf,		{T_INT, T_EXTF, ERR}},
	{"fscanf",	(char *) fscanf,	{T_INT, T_EXTF, ERR}},
	{"sscanf",	(char *) sscanf,	{T_INT, T_EXTF, ERR}},

	{"system",	(char *) system,	{T_INT, T_EXTF, ERR}},
	{"freopen",	(char *) freopen,	{T_INT, T_EXTF, ERR}},

	{"strcpy",	(char *) strcpy,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strncpy",	(char *) strncpy,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strcat",	(char *) strcat,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strncat",	(char *) strncat,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strchr",	(char *) strchr,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strrchr",	(char *) strrchr,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strpbrk",	(char *) strpbrk,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strtok",	(char *) strtok,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strdup",	(char *) strdup,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strstr",	(char *) strstr,	{T_CHAR, T_POINT, T_EXTF, ERR}},

	{"strcmp",	(char *) __strcmp,	{T_INT, T_EXTF, ERR}},
	{"strcmpi",	(char *) strcmpi,	{T_INT, T_EXTF, ERR}},
	{"strncmp",	(char *) strncmp,	{T_INT, T_EXTF, ERR}},
	{"strlen",	(char *) strlen,	{T_INT, T_EXTF, ERR}},
	{"strspn",	(char *) strspn,	{T_INT, T_EXTF, ERR}},
	{"strcspn",	(char *) strcspn,	{T_INT, T_EXTF, ERR}},

	{"memccpy",	(char *) memccpy,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"memchr",	(char *) memchr,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"memcpy",	(char *) memcpy,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"memset",	(char *) memset,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"memcmp",	(char *) memcmp,	{T_INT, T_EXTF, ERR}},

	{"atof",	(char *) atof,		{T_DOUBLE, T_EXTF, ERR}},
	{"atoi",	(char *) atoi,		{T_INT, T_EXTF, ERR}},
	{"atol",	(char *) atol,		{T_LONG, T_EXTF, ERR}},
	{"rand",	(char *) rand,		{T_INT, T_EXTF, ERR}},
	{"srand",	(char *) srand,		{T_INT, T_EXTF, ERR}},

#if	0
	{"calloc",	(char *) TL_calloc,	{T_INT, T_EXTF, ERR}},
	{"malloc",	(char *) TL_malloc,	{T_INT, T_EXTF, ERR}},
	{"realloc",	(char *) TL_realloc,{T_INT, T_EXTF, ERR}},
	{"free",	(char *) TL_free,	{T_INT, T_EXTF, ERR}},
#else
	{"calloc",	(char *) calloc,	{T_INT, T_EXTF, ERR}},
	{"malloc",	(char *) malloc,	{T_INT, T_EXTF, ERR}},
	{"realloc",	(char *) realloc,	{T_INT, T_EXTF, ERR}},
	{"free",	(char *) free,		{T_INT, T_EXTF, ERR}},
#endif

	{"exit",	(char *) exit,		{T_INT, T_EXTF, ERR}},
	{"abort",	(char *) abort,		{T_INT, T_EXTF, ERR}},

	{"getenv",	(char *) getenv,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"bsearch",	(char *) bsearch,	{T_INT, T_EXTF, ERR}},
	{"qsort",	(char *) qsort,		{T_INT, T_EXTF, ERR}},

	{"isalpha",	(char *) __isalpha,	{T_INT, T_EXTF, ERR}},
	{"isupper",	(char *) __isupper,	{T_INT, T_EXTF, ERR}},
	{"islower",	(char *) __islower,	{T_INT, T_EXTF, ERR}},
	{"isdigit",	(char *) __isdigit,	{T_INT, T_EXTF, ERR}},
	{"isxdigit",(char *) __isxdigit,{T_INT, T_EXTF, ERR}},
	{"isalnum",	(char *) __isalnum,	{T_INT, T_EXTF, ERR}},
	{"isspace",	(char *) __isspace,	{T_INT, T_EXTF, ERR}},
	{"ispunct",	(char *) __ispunct,	{T_INT, T_EXTF, ERR}},
	{"isprint",	(char *) __isprint,	{T_INT, T_EXTF, ERR}},
	{"isgraph",	(char *) __isgraph,	{T_INT, T_EXTF, ERR}},
	{"iscntrl",	(char *) __iscntrl,	{T_INT, T_EXTF, ERR}},
	{"isascii",	(char *) __isascii_,{T_INT, T_EXTF, ERR}},
	{"toupper",	(char *) __touppe,	{T_INT, T_EXTF, ERR}},
	{"tolower",	(char *) __tolowe,	{T_INT, T_EXTF, ERR}},
/*	{"toascii",	(char *) __toascii,	{T_INT,T_EXTF,ERR }},	 */

	{"clock",	(char *) clock,		{T_LONG, T_EXTF, ERR}},
	{"time",	(char *) time,		{T_LONG, T_EXTF, ERR}},
	{"localtime",(char *)localtime,	{T_INT, T_POINT, T_EXTF, ERR}},
	{"mktime",	(char *) mktime,	{T_LONG, T_EXTF, ERR}},
	{"ctime",	(char *) ctime,		{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"asctime",	(char *) asctime,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"difftime",(char *) difftime,	{T_DOUBLE, T_EXTF, ERR}},

#ifdef	__HIGHC__
	{"_ltoa",		(char *) _ltoa,			{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"_ultoa",		(char *) _ultoa,		{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"_searchenv",	(char *) _searchenv,	{T_VOID, T_EXTF, ERR}},
	{"_putenv",		(char *) _putenv,		{T_INT, T_EXTF, ERR}},
#endif

	{NULL}
};
#if	defined(__HIGHC__)
#pragma On(Warn)
#endif

void		gen_init(void)
{
	int 		n;

	for (n = 0; ext_tab[n].name != NULL; n++)
	{
		CCI_setFunc( &ext_tab[n] );
	}
}
