#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<string.h>
#include	<ctype.h>

#if	defined(WIN32)
# include	"windows.h"
#else
# include	<fcntl.h>
#endif
#include	"local.h"
#include	"defs.h"
#include	"lib.h"
#include	"parse.h"
#include	"token.h"
#include	"code.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

#if	!defined(WIN32)
#	define	HANDLE	int
#endif

#define STRMAX			256

#if	defined(WIN32)
#	pragma pack(push,4)
#endif
typedef struct _LP
{
	struct _LP *next;
	char		name[1];
} LABPTR;
#if	defined(WIN32)
#	pragma pack(pop)
#endif

extern int		yylval; 			/* = 0; */
		jmp_buf	yyerrjmp;
static HANDLE	yy_hFile = 0;
static int		yyline = 0;
static char		yyfile[STRMAX];
static int		yynewline = TRUE;
static int		str_len = 0;
static char		str_buf[STRMAX + 2];
static LABPTR	*label_tab[HASHMAX];

char	YYerrMsg[256];
#define	CCI_BUFSIZ			(4096)
static unsigned char	   *ccibuf     = NULL;
#if	defined(WIN32)
static DWORD				ccibuflen  = 0;
static DWORD				ccireadlen = 0;
#else
static int					ccibuflen  = 0;
static int					ccireadlen = 0;
#endif
static int					cciech     = -1;

#ifdef	DEBUG

char	   *token_str[] =
{
	"break", "case", "char", "continue",		/* 1 */
	"default", "define", "do", "double",		/* 2 */
	"else", "extern", "float", "for",	/* 3 */
	"goto", "if", "ifdef", "ifndef",	/* 4 */
	"include", "int", "long", "register",		/* 5 */
	"return", "short", "signed", "sizeof",		/* 6 */
	"static", "struct", "switch", "typedef",	/* 7 */
	"undef", "union", "unsigned", "void",		/* 8 */
	"while"

	"&&", "||", "++", "--",
	"+=", "-=", "*=", "/=",
	"%=", "&=", "|=", "^=",
	"==", "!=", "<<=", ">>=",
	"<<", ">>", "<=", ">=",
	"EXPR", "LABEL", ".", "STRING",
	"DEXPR", NULL
};

void		print_tkn(int ch)
{
	if (ch == LABEL)
		printf("[%s] ", yylval);
	else if (ch == STRING)
		printf("\"%s\" ", yylval);
	else if (ch == EXPR)
		printf("%d ", yylval);
	else if (ch == DEXPR)
		printf("%f ", *((double *) yylval));
	else if (ch >= BREAK)
		printf("%s ", token_str[ch - BREAK]);
	else if (ch == ';')
		printf(";\n");
	else
		printf("%c ", ch);
}
#endif

int _FAST hash(const char *str)
{
	unsigned int 		hs = 0;

	while (*str != '\0')
		hs = hs * 31 + *(unsigned char *)(str++);
	return (hs & (HASHMAX - 1));
}

void _FAST yyerror(const char *msg)
{
	char	*s = YYerrMsg;

	/* " \"file\" (line#): message" */
	*s++ = '\"';
	strcpy( s, yyfile);
	s += strlen(yyfile);
	*s++ = '\"';
	*s++ = ' ';
	*s++ = '(';
	{
		char	tmp[16];

#if	defined(WIN32)
		_ultoa(yyline+1,tmp,10);
#else
		sprintf(tmp, "%d", yyline + 1);
#endif
		strcpy(s,tmp);
		s += strlen(tmp);
	}
	*s++ = ')';
	*s++ = ':';
	*s++ = ' ';
	strcpy( s, msg);

	longjmp(yyerrjmp, 1);
}

static char * _FAST yylabel(const char *name)
{
	int 		hs;
	LABPTR	   *lp;

	hs = hash(name);
	lp = label_tab[hs];
	while (lp != NULL)
	{
		if (strcmp(lp->name, name) == 0)
			return lp->name;
		lp = lp->next;
	}

	if ((lp = (LABPTR *) yysymb(sizeof(LABPTR) + strlen(name))) == NULL)
		return NULL;

	strcpy(lp->name, name);
	lp->next = label_tab[hs];
	label_tab[hs] = lp;

	return lp->name;
}

static int _FAST yygetc(void)
{
	int		ch;

	do
	{
		if ( cciech >= 0 )	/* unget charactor */
		{
			ch = cciech;
			cciech = -1;
		} else
		{
			if ( ccireadlen < ccibuflen )
			{	/* Хåե⤫Ф	*/
				ch = ccibuf[ccireadlen++];
			} else
			{	/* Хåե	*/
#if	defined(WIN32)
				if ( !ReadFile(yy_hFile, ccibuf, CCI_BUFSIZ, &ccibuflen, NULL) || ccibuflen == 0 )
#else
				if ( (ccibuflen = read(yy_hFile, ccibuf, CCI_BUFSIZ)) < 1 )
#endif
					return (EOF);	/* error */
				ccireadlen = 1;
				ch = ccibuf[0];
			}
		}
	} while ( ch == '\r' );
	if ( ch == '\n' )
		yyline++;
	return ch;
}

static void _FAST yyungetc(int ch)
{
	cciech = ch;
}

static int _FAST yydigit(int ch)
{
	int 		n = 0;

	if (ch == '0')
	{
		ch = yygetc();
		if (ch == 'X' || ch == 'x')
		{
			ch = yygetc();
			while (isxdigit(ch))
			{
				if (isdigit(ch))
					n = n * 16 + (ch - '0');
				else
					n = n * 16 + (toupper(ch) - 'A' + 10);
				ch = yygetc();
			}
			yyungetc(ch);

		} else
		{
			while (ch >= '0' && ch <= '7')
			{
				n = n * 8 + (ch - '0');
				ch = yygetc();
			}
			yyungetc(ch);
		}

	} else
	{
		while (isdigit(ch))
		{
			n = n * 10 + (ch - '0');
			ch = yygetc();
		}
		yyungetc(ch);
	}
	return n;
}

void		yycpp(char *p)
{
	char	   *s;

	while (isspace(*p))
		p++;
	if ( isdigit(*p) )
	{
		yyline = atoi(p) - 1;
		if ((p = strchr(p, '\"')) == NULL)
			return;
		++p;	/* skip '"' */
		if ((s = strrchr(p, '\"')) != NULL)
			*s = '\0';
		strcpy(yyfile, p);
	}
}

int _FAST yylex(void)
{
#define IDTR			(4 * 8 + 1)
	static char *func[] =
	{
		"break", "case", "char", "continue",	/* 1 */
		"default", "define", "do", "double",	/* 2 */
		"else", "extern", "float", "for",		/* 3 */
		"goto", "if", "ifdef", "ifndef",		/* 4 */
		"include", "int", "long", "register",	/* 5 */
		"return", "short", "signed", "sizeof",	/* 6 */
		"static", "struct", "switch", "typedef",		/* 7 */
		"undef", "union", "unsigned", "void",	/* 8 */
		"while"
	};
	static int	adr_tbl[] =
	{
		ANDAND, OROR, INC, DEC
	};
	static int	let_tbl[] =
	{
		ADDLET, SUBLET, MULLET, DIVLET, MODLET,
		ANDLET, ORLET, XORLET, EQU, UNEQU
	};
	static int	sfl_tbl[] =
	{
		LEFTLET, RIGHTLET
	};
	static int	sft_tbl[] =
	{
		LEFT, RIGHT
	};
	static int	bse_tbl[] =
	{
		SML, BIG
	};
	static char chr_tbl[] =
	{
		0x07, 0x08, 0x0C, 0x0A, 0x0D, 0x09, 0x0F		/* abfnrtv */
	};
	int 		ch, n, i;
	double		d;

  LOOP:
	do
	{
		ch = yygetc();
	} while ( ch == ' ' || ch == '\t' );

	if (ch == '/')
	{
		if ((n = yygetc()) == '*')
		{
			ch = yygetc();
			n = yygetc();
			while (!(ch == '*' && n == '/'))
			{
				if (ch == '/' && n == '*')
					yyerror("Nest Comment ?");
				ch = n;
				if ((n = yygetc()) == EOF)
				{
					yyerror("Comment End of file ?");
					break;
				}
			}
			goto LOOP;
		} else
			yyungetc(n);
	}
	if (ch == '\n')
	{
		yynewline = TRUE;
		goto LOOP;

	} else if (ch == '#' && yynewline != FALSE)
	{
		ch = yygetc();
		for (n = 0; ch != '\n' && ch != EOF; n++)
		{
			if (n < STRMAX)
				str_buf[n] = ch;
			ch = yygetc();
		}
		str_buf[n] = '\0';
		yycpp(str_buf);
		goto LOOP;
	}
	yynewline = FALSE;

	if (isdigit(ch))
	{
		yylval = yydigit(ch);
		ch = yygetc();
		if (ch == '.')
		{
			d = (double) yylval;
			yylval = yydigit(yygetc());
			d = d + (double) yylval *0.1;
			yylval = (int) yyheep(sizeof(double));
			*((double *) yylval) = d;
			ch = DEXPR;

		} else
		{
			yyungetc(ch);
			ch = EXPR;
		}

	} else if (ch == '\'')
	{
		ch = yygetc();
		if (ch == '\\')
		{
			ch = yygetc();
			if ((i = inchr(ch, "abfnrtv")) >= 0)
			{
				yylval = chr_tbl[i];
			} else if (ch == 'X' || ch == 'x')
			{
				yyungetc(ch);
				yylval = yydigit('0');
			} else if (isdigit(ch))
			{
				yylval = yydigit(ch);
			} else
			{
				yylval = ch;
			}
		} else
		{
			yylval = ch;
		}
		ch = yygetc();
		if (ch != '\'')
			yyerror("Not Found ' Character");
		ch = EXPR;

	} else if (isalnum(ch) || ch == '_')
	{
		for (n = 0; isalnum(ch) || ch == '_'; n++)
		{
			if (n < STRMAX)
				str_buf[n] = ch;
			ch = yygetc();
		}
		if (n >= STRMAX)
			yyerror("Word String buffer overflow");
		str_buf[n++] = '\0';
		str_len = n;
		yyungetc(ch);

		if ((n = strbin(IDTR, func, str_buf)) >= 0)
			ch = (BREAK + n);
		else
		{
			yylval = (int) yylabel(str_buf);
			ch = LABEL;
		}

	} else if ((i = inchr(ch, "+-*/%&|^=!")) >= 0)
	{
		if ((n = yygetc()) == '=')
		{
			ch = let_tbl[i];
		} else if ((i = inchr(ch, "&|+-")) >= 0 && ch == n)
		{
			ch = adr_tbl[i];
		} else if (ch == '-' && n == '>')
		{
			ch = MENBA;
		} else
		{
			yyungetc(n);
		}

	} else if ((i = inchr(ch, "<>")) >= 0)
	{
		if ((n = yygetc()) == ch)
		{
			if ((n = yygetc()) == '=')
			{
				ch = sfl_tbl[i];
			} else
			{
				yyungetc(n);
				ch = sft_tbl[i];
			}
		} else if (n == '=')
		{
			ch = bse_tbl[i];
		} else
		{
			yyungetc(n);
		}

	} else if (ch == '.')
	{
		n = yygetc();
		yyungetc(n);
		if (isdigit(n))
		{
			yylval = yydigit(n);
			d = (double) yylval *0.1;
			yylval = (int) yyheep(sizeof(double));
			*((double *) yylval) = d;
			ch = DEXPR;
		}
	} else if (ch == '\"')
	{
		ch = yygetc();
		n = 0;
		while (ch != '\"')
		{

			if (ch == EOF || ch == '\n')
				yyerror("Not Found \" Character");

			if (ch == '\\')
			{
				ch = yygetc();
				if ((i = inchr(ch, "abfnrtv")) >= 0)
				{
					ch = chr_tbl[i];
				} else if (ch == 'X' || ch == 'x')
				{
					yyungetc(ch);
					ch = yydigit('0');
				} else if (isdigit(ch))
				{
					ch = yydigit(ch);
				}
			}
			if (n < STRMAX)
				str_buf[n++] = ch;

			ch = yygetc();
		}
		if (n >= STRMAX)
			yyerror("String Buffer overflow");
		str_buf[n++] = '\0';
		str_len = n;
		if ((yylval = (int) yyheep(str_len)) != 0)
			memcpy((char *) yylval, str_buf, str_len);
		ch = STRING;
	}
#ifdef	DEBUG
	print_tkn(ch);
#endif
	if (ch == '\n')
		yynewline = TRUE;
	return ch;
}

int _FAST yyopen(const char *file)
{
#if	defined(WIN32)
	if ((yy_hFile = CreateFile(file, GENERIC_READ, FILE_SHARE_READ, NULL,OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,NULL)) == INVALID_HANDLE_VALUE)
#else
	if ((yy_hFile = open(file, O_RDONLY)) == -1 )
#endif
	{
		strcpy( YYerrMsg, "File open error! (");
		strcpy( YYerrMsg+18,file);
		strcpy( YYerrMsg+18+strlen(file),")");
		return (ERR);
	}

	if ( (ccibuf = MALLOC(CCI_BUFSIZ)) == NULL )
	{
#if	defined(WIN32)
		CloseHandle(yy_hFile);
#else
		close(yy_hFile);
#endif
		strcpy( YYerrMsg, "Out of memory!");
		return ERR;
	}
	ccibuflen = ccireadlen = 0;
	cciech    = -1;

	yyline = 0;
	yynewline = TRUE;
	strcpy(yyfile, file);
	return FALSE;
}

void _FAST yyclose(void)
{
	FREE(ccibuf);
#if	defined(WIN32)
	CloseHandle(yy_hFile);
#else
	close(yy_hFile);
#endif
}
