/*
 * int	yylex(); int	yyerror();
 */

#ifndef YYMAXSTK
#define YYMAXSTK		100
#endif

YYSTYPE 	yyastk[YYMAXSTK];
short		yysstk[YYMAXSTK];

#ifdef	YYDEBUG
char		yydebug = 1;
#endif

void		yydef()
{
}

#ifdef	YYDISPLAY
char	   *yydisplay(int n)
{
	static char buf[2];

	if (n >= (YYLNK + 1))
		return (yytnames[n - (YYLNK + 1)]);
	switch (n)
	{
		case '\n':
			return ("\\n");
		case '\t':
			return ("\\t");
		default:
			buf[0] = n;
			buf[1] = '\0';
			return (buf);
	}
}
#endif

#define YYRED	20000

int _FAST yyparse(void)
{
	short	   *yyssp;
	int 		toksave, st, n, l;
	YYACT	   *p;
	YYGOTO	   *q;

	if ((n = setjmp(yyjmp)) != 0)
		return (n - 1);
	yyssp = yysstk + YYMAXSTK;
	yyasp = yyastk + YYMAXSTK;
	st = toksave = yytoken = 0;
	for (;;)
	{
		p = yyia + st + 1;
		if (yytoken == 0 && p->input != 0)
		{
			if ((yytoken = yylex()) <= 0)
				yytoken = YYEOF;
			if (yyerrflag != 0)
				yyerrflag--;
		}
		while (p->input != 0 && p->input != yytoken)
			if (p->input == YYLNK)
				p = yyia + p->num;
			else
				p++;
		if (p->input == 0)
			p = yyia + st;
		if (yytoken == YYERR && p->input == 0)
			n = -1;
		else
			n = p->num;
		if (n == -1)
		{
			/* error */
			if (yyerrflag == 0)
			{
#ifdef	YYDISPLAY
				yyerror("syntax error near \"");
				yyerror(yydisplay(yytoken));
				yyerror("\": expecting");
				for (p = yyia + st; (++p)->input != 0;)
					if (p->input == YYLNK)
						p = yyia + p->num;
					else if (p->num != -1 &&
							 p->input != YYERR)
					{
						yyerror(" ");
						yyerror(yydisplay((int) p->input));
					}
				yyerror("\n");
#else
				yyerror("syntax error");
#endif
			}
			if (yyerrflag < 3)
				toksave = yytoken;
			else
			{
				if (st == 0 || yytoken == YYEOF)
					return (1); /* can't recover */
#ifdef	YYDEBUG
				if (yydebug)
					printf("[yydebug] %3d: uncovers %d\n",
						   st, yyssp[0]);
#endif
				st = *yyssp++;
				yyasp++;
#ifdef	YYDEBUG
				if (yytoken != YYERR && yydebug)
					printf("[yydebug] discard %s\n",
						   yydisplay(yytoken));
#endif
			}
			yytoken = YYERR;
			yyerrflag = 3;
		} else if (n < YYRED)
		{
			/* shift */
#ifdef	YYDEBUG
			if (yydebug)
				printf("[yydebug] %3d: shift %s\n", st, yydisplay(yytoken));
#endif
			*--yyssp = st;
			*--yyasp = yylval;
			st = n;
			yytoken = toksave;
			toksave = 0;
		} else
		{
			/* reduce */
#ifdef	YYDEBUG
			if (yydebug)
				printf("[yydebug] %3d: reduce by %s\n", st, yypnames[n - YYRED]);
#endif
			if (n == YYRED + 0)
				return (0); 	/* accept */
			l = yylen[n - YYRED];
			yyval = yyasp[l - 1];		/* default value */
			(*yya[n - YYRED]) ();
			*--yyssp = st;
			yyssp += l;
			yyasp += l;
			st = *yyssp;
			for (q = yyg[n - YYRED]; q->old != -1; q++)
				if (q->old == st)
					break;
			*--yyasp = yyval;
			st = q->new;
		}
	}
}
