/*************************************************************************
*	ե饤֥
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"mmfile.h"

#if	!defined(__HE386__)
# if	!defined(_ISKAN)
#  if	defined(CONFIG_USE_MBC)
#   include	<mbctype.h>
#   define	iskanji(_ch)	(_ismbblead ((unsigned char)(_ch)))
#   define	iskanji2(_ch)	(_ismbbtrail((unsigned char)(_ch)))
#  define	_ISKAN(_s)		(_ismbblead(*((unsigned char *)(_s))) && _ismbbtrail(*((unsigned char *)(_s) + 1)))
#  else
#   define	iskanji(c)		(((unsigned char)(c) >= 0x80 && (unsigned char)(c) <= 0x9F) || ((unsigned char)(c) >= 0xE0 && (unsigned char)(c) <= 0xFE))
#   define	iskanji2(c)		(((unsigned char)(c) >= 0x30 && (unsigned char)(c) <= 0x7E) || ((unsigned char)(c) >= 0x80 && (unsigned char)(c) <= 0xFE))
#  define	_ISKAN(_s)		(iskanji(*((unsigned char *)(_s))) && iskanji2(*((unsigned char *)(_s) + 1)))
#  endif
# endif
#endif

char	StartPath[256];

int		FsPathDelim = '/';
int		FsDosDelim  = '\\';

#define	SP_FREE		free
#define	SP_MALLOC	malloc
#define	SP_CALLOC	calloc

#if	!defined(CONFIG_USE_STRCMPI)
int	strcmpi(const char *s1, const char *s2)
{
	int			ret;

	for (;;)
	{
		if ( *s1 == '\0' || *s2 == '\0' )
			return 0;
		ret = tolower(*s1) - tolower(*s2);
		if ( ret )
			return ret;
		++s1;
		++s2;
	}
}
#endif

/*************************************************************************
*	򼨤ʸ֤
*************************************************************************/

char	*GetSizeStr( long siz, char *buf )
{
	if ( siz == 0l )
		strcpy( buf, "0");
	else if ( siz < 1024l )
		sprintf( buf, "%l", siz );
	else if ( siz < 1024l*1024l )
		sprintf( buf, "%.1fK", (float)siz / (float)1024l );
	else
		sprintf( buf, "%.1fM", (float)siz / (float)(1024.0*1024.0) );

	return (buf);
}

int		iskan( CONST char *s )
{
#if	defined(__HE386__)
	if ( iskanji(*s) && iskanji2(s[1]) )
		return (TRUE);
	else
		return (FALSE);
#else
	return _ISKAN(s);
#endif
}

char	*FS_addFnam( char *path, const char *fnam)
{
	size_t	len;

	if ( path == NULL || fnam == NULL )
		return (NULL);

	if ( (len = strlen(path)) > 0 )
	{
		char	tmp[512];

		FS_unix2dos( tmp, path);
		if ( len == strlen(tmp) )
		{
			if ( tmp[len-1] != ':' && !FS_ISDELIM(tmp[len-1]) )
				goto _SET_DELIM;
		} else
		{
			if ( !FS_ISDELIM(path[len-1]) )
			{
_SET_DELIM:
				path[len++] = (char)FsPathDelim;
			}
		}
	}
	strcpy( path + len, fnam );

	return (path);
}

void	FS_dos2unix(char *_unix, CONST char *dos)
{
	while ( *dos )
	{
		if ( iskan(dos) )
		{
			*_unix++ = *dos++;
			*_unix++ = *dos++;
		} else if ( *dos == FsDosDelim )
		{
			*_unix++ = FsPathDelim;
			++dos;
		} else
			*_unix++ = *dos++;
	}
	*_unix = '\0';
}

void	FS_unix2dos( char *dos, CONST char *_unix)
{
	while ( *_unix )
	{
		if ( iskan(_unix) )
		{
			*dos++ = *_unix++;
			*dos++ = *_unix++;
		} else if ( *_unix == FsPathDelim )
		{	*dos++ = FsDosDelim;
			++_unix;
		} else
			*dos++ = *_unix++;
	}
	*dos = '\0';
}

/*************************************************************************
*	FS_argSet : ʸʬ򤹤
*************************************************************************/

int		FS_argSet( CONST char *s, char **argv[] )
{
	int			i, j, k;
	char		*buff;
	int			ch;
	char		top_flg = TRUE;
	char		cma_flg = FALSE;	/* ',' flag	*/
	int			argc = 0;			/* ñο */
	char		*strBuf;
	char		**strPtr;

	if ( s == NULL || (i = strlen( s )) == 0 )
		return	(0);
	if ( (strBuf = SP_MALLOC(i + 1)) == NULL )
		return	(0);
	buff = strBuf;

	for (;;)
	{
		ch = *s++;
		if( top_flg )			/* ñƬ */
		{	if ( ch == '\0' )
			{	if ( cma_flg )	/* ľ(,) ʤ */
					goto	SKIP_0;
				goto	SKIP;
			}
			if ( ch <= ' ' )		/* Skipf Sapce */
				goto SKIP;
			if ( ch == ',' )
			{	if( cma_flg )
					goto	SKIP_0;
				cma_flg =TRUE;
				goto	SKIP;
			}
			if ( ch == '"' )
				goto	DQMARKS;
		}
		/* ñ */
		top_flg = FALSE;
		cma_flg = FALSE;
		if ( ch == '\0' )
			goto SKIP_0;
		if ( ch <= ' ' )
		{	top_flg = TRUE;
			goto	SKIP_0;
		}
		if ( ch == ',' )
		{	cma_flg = TRUE;
			top_flg = TRUE;
			goto	SKIP_0;
		}
		*buff++ = ch;
		goto SKIP;
 
DQMARKS:/*  "  */
		ch = *s++;
		if ( ch == '\0' || ch == '"' )
			goto	SKIP_0;	/* End of Job */
		*buff++ = ch;
		goto DQMARKS;
 
SKIP_0:	++argc;
		*buff++ ='\0';
SKIP:	if ( ch == '\0' )
			break;
	}	/* LOOP */

	if ( argc == 0 || (strPtr = SP_MALLOC( sizeof(char *) * (argc+1) )) == NULL )
	{
		SP_FREE( strBuf );
		return	(0);
	}
	for ( i = j = k = 0; (size_t)k <= (size_t)(buff - strBuf); ++k )
	{
		if ( strBuf[k] == '\0' )
		{
			if ( (strPtr[i] = SP_MALLOC( strlen(&strBuf[j]) + 1) ) == NULL )
			{
				while ( --i >= 0 )
					SP_FREE( strPtr[i] );
				SP_FREE( strPtr );
				SP_FREE( strBuf );
				return	0;
			}
			strcpy( strPtr[i], &strBuf[j] );
			++i;
			if ( i >= argc )
			{
				strPtr[argc] = NULL;
				break;
			}
			j = k + 1;
		}
	}
	SP_FREE( strBuf );
	*argv = strPtr;

	return	(argc);
}

/*************************************************************************
*	FS_argClear : γ
*************************************************************************/

void	FS_argClear( int argc, char **argv )
{
	if ( argc > 0 && argv )
	{
		while ( --argc >= 0 )
			SP_FREE( argv[argc] );
		SP_FREE( argv );
	}
}


/*************************************************************************
*	ե̾˳ĥҤɲä	("fslib16.c")
*-------------------------------------------------------------------------
*	ef == df Ǥ
*	char	*df;	ϥե̾
*	char	*ef		ϥե̾
*	char	*sub;	ĥ
*************************************************************************/

void	FS_appendSnam( char *df, CONST char *ef, CONST char *sub )
{
	int		l;
	char	*s, *p;

	if ( df != (char *)ef )
		strcpy( df, ef );
	p = s = df;
	while ( *s )
	{
		if ( iskan(s) )
		{
			s += 2;
		} else if ( FS_ISDELIM(*s) )
			p = ++s;
		else
			++s;
	}
	s = p;	/* ե̾	*/
	l = 0;
	while ( s[l] && isspace(s[l]) == FALSE )
		++l;
	if ( strchr( s, '.')==NULL )
	{	/* ĥҤλ꤬ʤ	*/
		strcpy( &s[l], sub );	/* ĥɲ	*/
	}
}


/*************************************************************************
*	ѥ̾ǥ쥤Ф	"fslib04.c"
*-------------------------------------------------------------------------
*	ex.
*		"a:\dir\pathname"		"a:/dir"
*		"filename"				"."	
*		"a:filename"			"a:."
*		"a:\filename"			"a:/"
*************************************************************************/

void	FS_getDnamPath( char *directory, CONST char *pathname )
{
	char	*top, *trm;
	REG int	ch;
	int		flg;

	flg = FALSE;
	top = trm = directory;
	while ( ( ch = ((*(char *)(pathname++))&255) ) != '\0' )
	{
		if ( iskanji(ch) && iskanji2(*pathname) )
		{
			*directory++ = ch;
			*directory++ = *(char *)(pathname++);
		} else if( ch == ':' )
		{
			flg = TRUE;
			*directory = ':';
			trm = directory++;
		} else if ( FS_ISDELIM(ch) )
		{
			flg = TRUE;
			*directory = FsPathDelim;	/* '//' */
			trm = directory++;
		} else
			*directory++ = ch;
	}
	
	if( flg == FALSE )				/* 	*/
		strcpy( top, "." );
	else if( *trm == ':' )	/* if ( *trm==':' )	*/
	{
		trm[1] = '.';
		trm[2] = '\0';
	} else					/* if ( *trm=='\\' ) */
	{
		*trm = '\0';
		if ( *top == '\0' )
		{
			*top = FsPathDelim;
			top[1] = '\0';
		} else if ( strlen(top) == 2 && top[1] == ':' )
		{
			top[2] = FsPathDelim;
			top[3] = '\0';
		}
	}
}

char	*FS_getFnam( char *fnam, CONST char *filename )
{
	char	*p, *r;

	r = fnam;
	if ( strcmp( filename, "..") == 0 || strcmp( filename, "." ) == 0 )
		strcpy( fnam, filename );
	else
	{
		if ( ( p = strrchr( filename,'.') )==0 )
			strcpy( fnam, filename );	/* ĥҤϻꤵƤʤ	*/
		else
		{	/* ĥҤޤǥԡ	*/
			while ( (size_t)filename < (size_t)p )
				*fnam++ = *filename++;
			*fnam = '\0';
		}
	}
	return	r;
}

/*************************************************************************
*	ѥ̾ե̾ФʳĥҤޤ
*-------------------------------------------------------------------------
*	ex.
*		"a:/dir/filename.sub"  "filename.sub"
*************************************************************************/

int		FS_getFnamPath( char *filename, CONST char *pathname )
{
	int			i, p, l;
	REG char	*s;
	char		tmp[256], fnam[256], snam[256];

	strcpy( tmp, pathname );
	l = strlen( s = tmp );
	if ( l == 0 || (l == 1 && s[l-1] == '.')
	  || (l > 1 && FS_ISDELIM(s[l-2]) && s[l-1] == '.')
	  || (l > 1 && s[l-1] == '.'  && s[l-2] == '.') )
	{
		*filename = '\0';
		return	(ERR);
	}
	if ( l > 2 && s[1] == ':' )	/* ɥ饤̾	*/
		s = &s[2];
	if ( s[0] == '.' && s[1] == '.' && FS_ISDELIM(s[2]) )	/* ex. [..\] */
		s = &s[2];
	else if( s[0] == '.' || FS_ISDELIM(s[1]) )	/* ex. [.\]	*/
		s = &s[1];
	l = strlen( s );
	p = 0;
	for (;;)
	{
		if ( l == 1 && (FS_ISDELIM(*s) || *s == ':') )
			return (ERR);
		for ( i = 0; i < l; ++i )	/* ѥζڤõ */
		{
			if ( iskanji(s[i]) && iskanji2(s[i+1]) )
			{	/* 	*/
				++i;
			} else if ( FS_ISDELIM(s[i]) )
				p = i + 1;
		}
		if( p >= l )			/* Ǹ夬'\' ʤƺ١¹ */
		{
			s[ --l ] = '\0';	/* Retry */
			p = 0;				/* BugFig ver.1.02a	*/
		} else
		{
			strcpy( filename, &s[p] );
			break;				/* LOOP exit */
		}
	}
	if ( strchr( filename, '.') == NULL )
	{	/* ĥҤλ꤬ʤ	*/
		if ( strlen(filename) > 8 )
			filename[8] = '\0';
	} else
	{	/* ĥҤλ꤬	*/
		FS_getFnam( fnam, filename );
		FS_getSnam( snam, filename );
		if ( strlen(fnam) > 8 )
			fnam[8] = '\0';
		if ( strlen(snam) > 3 )
			snam[3] = '\0';
		sprintf( filename, "%s.%s", fnam, snam );
	}

	return NORMAL;
}

char	*FS_getSnam( char *snam, CONST char *filename )
{
	char	*p, *r;

	r = snam;
	if ( strcmp( filename, "..") == 0 || strcmp( filename, "." ) == 0 )
	{
		snam[0] = '\0';
	} else
	{	if ( ( p = strrchr(filename,'.') )==0 )
			snam[0] = '\0';
		else
			strcpy( snam, p+1 );
	}
	return (r);
}


/*************************************************************************
*	ȥåץǥ쥯ȥ
*************************************************************************/

int		FS_setStartPath( char *start, CONST char *cmd)
{
#if	defined(WIN32)
	int		drv;
	char	whare[256], tmp[256];

	/* ѥФ	*/
	FS_getDnamPath( tmp, cmd );

	drv = FS_getdrv();			/* ȥɥ饤֤¸			*/
	if ( isalpha(tmp[0]) && tmp[1] == ':' )
		FS_chdrv( toupper(tmp[0])-'A' );
	whare[0] = FsPathDelim;
	FS_getdir( &whare[1] );		/* ȥǥ쥯ȥ¸		*/

	FS_chdir( tmp );
	FS_getdir2( start );		/* ǥ쥯ȥ					*/

	FS_chdir( whare );			/* ȥǥ쥯ȥ򸵤᤹	*/
	FS_chdrv( drv );			/* ȥɥ饤֤򸵤᤹		*/
#else
	FS_getDnamPath(start, cmd);
#endif

	return (NORMAL);
}


#if	defined(WIN32)
/*************************************************************************
*	DOS ե󥯥󥳡
*************************************************************************/

int		FS_getdrv(void)
{
	char		tmp[256];

	if ( GetCurrentDirectory(sizeof(tmp)/sizeof(*tmp), tmp) == 0 )
		return (-1);	/* error */
	if ( !isalpha(tmp[0]) || tmp[1] != ':' )
		return (-1);	/* error */
	return (int)(toupper(tmp[0]) - 'A');
}

int		FS_chdrv(int drv)
{
	char	tmp[4];

	tmp[0] = 'A' + drv;
	tmp[1] = ':';
	tmp[2] = '\0';
	return ( SetCurrentDirectory(tmp) ) ? 0 : -1;
}

int		FS_getdir(char *s)
{
	char	tmp[256];

	{
		char	*p;

		if ( GetCurrentDirectory(sizeof(tmp)/sizeof(*tmp), tmp) == 0 )
			return (-1);	/* error */
		p = tmp;
		if ( isalpha(p[0]) && p[1] == ':' )
			p += 2;
		if ( FS_ISDELIM(*p) )
			++p;
		FS_unix2dos( s, p);
	}
	return (0);
}

int		FS_chdir(const char *s)
{
	char	tmp[256];

	FS_unix2dos(tmp, s);

	return ( SetCurrentDirectory(tmp) ) ? 0 : -1;
}

int		FS_getdir2( char *name )	/* ȥǥꥯȥμ(ɥ饤֤)	*/
{
	*(name++) = FS_getdrv() + 'A';
	*(name++) = ':';
	*(name++) = FsPathDelim;
	FS_getdir(name);
	if ( *name != '\0' )
		strcat(name, "/");
	return (0);
}
#endif
