/*************************************************************************
*	ץ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

/*	#define	DEBUG	*/

#include	"getopt32.h"

char	GopDefaultStr[] = "";

#define	SET_VAR(_key,_var)	{											\
	switch ( (_key)->varTyp )											\
	{																	\
		case GOP_VAR_CHAR : *(char  *)((_key)->varPtr) = _var; break;	\
		case GOP_VAR_SHORT: *(SHORT *)((_key)->varPtr) = _var; break;	\
		case GOP_VAR_INT  : *(int   *)((_key)->varPtr) = _var; break;	\
	}																	\
}

static	int		is_switch( GOP_T *gop, int top_ch )
{
	CONST char	*sw;

	sw = gop->sw;
	while ( *sw )
	{
		if ( *sw++ == top_ch )
			return	(TRUE);
	}
	return (FALSE);
}

static	int			nextopt( GOP_T *gop, int argc, char **argv, int *i, char **s )
{
	if ( ++(*i) == argc )
		return (-1);
	*s = argv[*i];
	if ( is_switch(gop,**s) )
		 return (1);
	return (0);
}

int		GOP_decode( GOP_T *gop, int argc, char **argv )
{
	int			i, mm, ret = NORMAL;
	char		*s;

#define	CHKNEXT()	if((mm=nextopt(gop,argc,argv,&i,&s))<0){goto L_END;}else if(mm>0){goto L_NEXT;}
#define	PARAERR(_s)	{				\
	if ( gop->errFunc )				\
	{	ret = (gop->errFunc)(_s);	\
		if ( ret == 0 )				\
		{	ret = 0;				\
			goto L_NEXT;			\
		} else if ( ret > 0 )		\
			ret = 0;				\
	}								\
	goto L_END;						\
}

	for ( i = 0; i < argc; ++i )
	{
		s = argv[i];
L_NEXT:
		if ( is_switch(gop,*s) )
		{
			GOPKEY_T	*key;
			int			decFlag;
			int			keyNo;

			decFlag = FALSE;
			++s;
			keyNo = 0;
			while ( 1 )
			{
				key = &(gop->key[keyNo++]);
				if ( key->typ < 0 )
					break;

				if ( strcmpi( s, key->name ) == 0 )
				{
					decFlag = TRUE;
					switch ( key->typ )
					{
						case	GOP_TYP_FLAG:
						{
							SET_VAR(key,TRUE);
							break;
						}

						case	GOP_TYP_DIGIT:
						{
							int				var;
							GOP_DIGIT_T	*digit;

							digit = key->ptr;
							SET_VAR(key,digit->def);

							CHKNEXT();
							var = atoi(s);
							if ( var < digit->min || var > digit->max )
								PARAERR(s);
							SET_VAR(key,var);
							break;
						}

						case	GOP_TYP_NAME:
						{
							*(char **)(key->varPtr) = GopDefaultStr;
							CHKNEXT();
							*(char **)(key->varPtr) = s;
							break;
						}

						case	GOP_TYP_ON_OFF:
						{
							int				flag;

							SET_VAR(key,-1);
							CHKNEXT();
							if ( strcmpi(s,"ON") == 0 )
								flag = 1;
							else
								flag = 0;
							SET_VAR(key,flag);
							break;
						}

						case	GOP_TYP_SELECT:
						{
							int					k;
							GOP_SELECT_T		*select;
							GOP_SELECT_OBJ_T	*obj;

							select = key->ptr;
							obj    = &(select->obj[0]);
							if ( key->varTyp == GOP_VAR_STR )
							{
								*(char **)(key->varPtr) = s;
							} else
							{
								SET_VAR(key,obj->ret);
							}
							CHKNEXT();

							for ( k = 0; k < select->n; ++k )
							{
								obj = &(select->obj[k]);
								if ( strcmpi( s, obj->name ) == 0 )
								{
									if ( key->varTyp == GOP_VAR_STR )
									{
										*(char **)(key->varPtr) = s;
									} else
									{
										SET_VAR(key,obj->ret);
									}
								}
							}
							break;
						}
					}
					break;
				}
			}
			if ( decFlag == FALSE )
			{
				if ( gop->mode == GOP_MODE_SET_ETC_UNKNOWN )
					goto SET_ETC;
				PARAERR(s);
			}
		} else
		{
			GOPETC_T	*etc;
SET_ETC:
			if ( (etc = malloc(sizeof(GOPETC_T))) != NULL )
			{
				GOPETC_T	*ptr;

				++(gop->etcNum);
				etc->next = NULL;
				etc->s    = s;
				if ( (ptr = gop->etc) == NULL )
				{
					gop->etc = etc;
				} else
				{
					while(1)
					{
						if ( ptr->next == NULL )
						{
							ptr->next = etc;
							break;
						}
						ptr = ptr->next;
					}
				}
			}
		}
	}
L_END:

	return (ret);
}

void	GOP_free( GOP_T *gop )
{
	GOPETC_T	*etc;

	if ( (etc = gop->etc) != NULL )
	{
		while ( etc )
		{
			GOPETC_T	*next;
			next = etc->next;
			free( etc );
			etc = next;
		}
	}
}

#ifdef	DEBUG

int		FlagVar   = 0;
int		DigitVar  = 0;
char	*NameVar  = "";
int		OnOffVar  = 0;
int		SelectVar = 0;

GOP_DIGIT_T	DigitSub = { 0, 0, 100 };

#define	SELECT_OBJ_N	(4)
GOP_SELECT_OBJ_T	SelectObj[SELECT_OBJ_N] =
{
	{0,"sel_1"},
	{1,"sel_2"},
	{2,"sel_3"},
	{3,"sel_4"},
};
GOP_SELECT_T	SelectSub = {SELECT_OBJ_N, SelectObj};


GOPKEY_T	GetoptKey[] = 
{
	{ GOP_TYP_FLAG   , "flag"  , GOP_VAR_INT, &FlagVar  , NULL      },
	{ GOP_TYP_DIGIT  , "digit" , GOP_VAR_INT, &DigitVar , &DigitSub },
	{ GOP_TYP_NAME   , "name"  , GOP_VAR_STR, &NameVar  , NULL      },
	{ GOP_TYP_ON_OFF , "on_off", GOP_VAR_INT, &OnOffVar , NULL      },
	{ GOP_TYP_SELECT , "select", GOP_VAR_INT, &SelectVar, &SelectSub},
	{ -1             ,  NULL   , 0          , NULL      , NULL      },
};

int		errFunc( CONST char *s )
{

	printf( "error %s\n", s );
	return (NORMAL);

	/* return (-1) ¨               */
	/* return (1)  顼̵뤷 */
	/* return (0)  顼̵         */
}

void	main(int argc,char **argv)
{
	GOP_T	gop = {-,"-/",GetoptKey,errFunc,0,NULL};

	GOP_decode(&gop,argc - 1, &argv[1]);
	printf("Flag   %d\n", FlagVar );
	printf("Digit  %d\n", DigitVar );
	printf("Name   %s\n", NameVar );
	printf("On_off %d\n", OnOffVar );
	printf("Select %d\n", SelectVar );
	{
		GOPETC_T	*etc;
		etc = gop.etc;
		while ( etc )
		{
			printf("etc : %s\n", etc->s );
			etc = etc->next;
		}
	}
}
#endif
