/*************************************************************************
*	ꥹȽ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<string.h>

#include	"listwork.h"

#ifndef	MALLOC
#	define	MALLOC	malloc
#endif
#ifndef	CALLOC
#	define	CALLOC	calloc
#endif
#ifndef	FREE
#	define	FREE	free
#endif


void _FAST	listwork_init( LISTWORK *listwork)
{
	listwork->datTop  = NULL;
	listwork->datLast = NULL;
	listwork->numDat  = 0;
	listwork->sizDat  = 0;
}

void _FAST	list_clear( LISTWORK *listwork)
{
	LISTDATA	*listdata, *next;

	if ( listwork == NULL )
		return;
	listdata = listwork->datTop;
	while ( listdata != NULL )
	{
		next = listdata->next;
		FREE(listdata);
		listdata = next;
	}
	listwork->datTop  = NULL;
	listwork->datLast = NULL;
	listwork->numDat  = 0;
	listwork->sizDat  = 0;
}

LISTDATA * _FAST list_allocData(size_t size)
{
	LISTDATA	   *listdata;

	if ( (listdata = MALLOC(sizeof(LISTDATA) + size)) == NULL )
		return (NULL);
	listdata->next = NULL;
	listdata->siz  = size;
	listdata->ptr  = (void *)(listdata + 1);
	return (listdata);
}

LISTDATA * _FAST list_allocName(const char *name)
{
	LISTDATA	   *listdata;

	if ( (listdata = list_allocData(strlen(name)+1)) == NULL )
		return (NULL);
	strcpy( (char *)listdata->ptr, name );
	return (listdata);
}

void _FAST	list_linkData( LISTWORK *listwork, LISTDATA *listdata )
{
	if ( listwork == NULL || listdata == NULL )
		return;
	if ( listwork->datLast != NULL )
	{
		listwork->datLast->next = listdata;
		listwork->datLast       = listdata;
	} else
		listwork->datTop = listwork->datLast = listdata;
	++listwork->numDat;
	listwork->sizDat += listdata->siz;
}

int _FAST	list_linkPutf( LISTWORK *listwork, const char *form, ... )
{
	char			tmp[BUFSIZ];
	va_list			ap;
	LISTDATA	   *listdata;

	va_start(ap,form);
	vsprintf(tmp,form,ap);
	va_end(ap);

	if ( (listdata = list_allocName(tmp)) == NULL )
		return (-1);	/* error */

	list_linkData( listwork, listdata );

	return (0);
}

int _FAST	list_sort( LISTWORK *listwork, LISTDATA ***tblptr, int (*compfunc)(const LISTDATA **, const LISTDATA **) )
{
	if ( listwork == NULL || tblptr == NULL || compfunc == (int (*)(const LISTDATA **,const LISTDATA **))0 )
		return (-1);

	*tblptr = NULL;
	if ( listwork->numDat == 0 || listwork->datTop == NULL )
		return (0);	/* ǡʤ	*/
	if ( (*tblptr = MALLOC(sizeof(LISTDATA *) * listwork->numDat)) == NULL )
		return (-1);

	{
		int					n;
		LISTDATA		   *data;

		for ( n= 0, data = listwork->datTop; data != NULL; ++n, data = data->next )
			(*tblptr)[n] = data;
		qsort( *tblptr, listwork->numDat, sizeof(LISTDATA *),
		    (int (*)(const void *, const void *))compfunc );
	}
	return (listwork->numDat);
}
