/*************************************************************************
*	ޥ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>

#include	"he386.h"
#include	"mmac.h"
#include	"mmlib.h"
#include	"mmsg.h"
#include	"msgdat.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

static int		MMfunc_expr(MMSQR_T *sqr,size_t bufSiz,char *buf,int argc, char **argv);
extern int		MMfunc_chord(MMSQR_T *sqr,size_t bufSiz,char *buf,int argc, char **argv);
extern int		MMfunc_slide(MMSQR_T *sqr,size_t bufSiz,char *buf,int argc, char **argv);
extern int		MMfunc_wave(MMSQR_T *sqr,size_t bufSiz,char *buf,int argc, char **argv);
extern int		MMfunc_swave(MMSQR_T *sqr,size_t bufSiz,char *buf,int argc, char **argv);

static int  _FAST	hash( CONST char *name );
static int  _FAST	mmac_checkName( CONST char *name );
static void _FAST	mmac_free( MMAC_T *mac );

static int _FAST		hash( CONST char *name )
{
	register int		hash = 0;

	while ( *name )
	{
		hash = hash + (tolower(*name)) * 31;
		++name;
	}
	return (hash & (_MMAC_HASH_MAX-1));
}


/*************************************************************************
*	ޥν
*************************************************************************/

int		MMac_init( MMSQR_T *sqr )
{
	int		i;
#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
	static struct	_mactbl_t
	{
		const char	   *name;
		const char	   *str;
		int				att;
		int			  (*func)();
	} tbl[] =
	{
		{ "expr" , "", MMAC_ATT_FUNC, MMfunc_expr  },
		{ "chord", "", MMAC_ATT_FUNC, MMfunc_chord },
		{ "slide", "", MMAC_ATT_FUNC, MMfunc_slide },
		{ "wave" , "", MMAC_ATT_FUNC, MMfunc_wave  },
		{ "swave", "", MMAC_ATT_FUNC, MMfunc_swave },
	};
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

	for ( i = 0; i < _MMAC_HASH_MAX; ++i )
		sqr->macTbl[i] = NULL;

	/* 16ʿ	*/
	for ( i = 0xA0; i < 0xFF; ++i )
	{
		char	name[8], str[8];

		sprintf( name, "%02X", i );
		sprintf( str , "%d"  , i );
		MMac_extDefine(sqr, name, str, MMAC_ATT_INP, (int (*)())0);
	}

	for ( i = 0; i < sizeof(tbl)/sizeof(*tbl); ++i )
		MMac_extDefine(sqr,tbl[i].name, tbl[i].str, tbl[i].att, tbl[i].func);

	HE_puts(sqr,_HE_MSG_DE1,"$$$ MMac_init() Ok ");

	return (NORMAL);
}

int		MMac_term( MMSQR_T *sqr )
{
	int		i;

	for ( i = 0; i < _MMAC_HASH_MAX; ++i )
	{
		register MMAC_T	   *mac;

		if ( (mac = sqr->macTbl[i]) != NULL )
		{
			do
			{
				MMAC_T	   *next;

				next = mac->next;
				if ( mac->name != NULL )	free( mac->name );
				if ( mac->str  != NULL )	free( mac->str );
				free( mac );
				mac = next;
			} while ( mac != NULL );
			sqr->macTbl[i] = NULL;
		}
	}
	return (NORMAL);
}

MMAC_T * _FAST	MMac_getmac( MMSQR_T *sqr, CONST char *name )
{
	MMAC_T	*mac = sqr->macTbl[ hash(name) ];

	while ( mac != NULL )
	{
		if ( strcmpi(name,mac->name) == 0 )
			return (mac);
		mac = mac->next;
	}
	return (NULL);
}


static int _FAST	mmac_checkName( CONST char *name )
{
	register int		ch;

	if ( !MMAC_ISTOPCH(*name) )
		return (ERR);
	++name;
	while ( (ch = ( *(name++) ) & 0xFF) != '\0' )
	{
		if ( !(ch == '_' || isdigit(ch) || isalpha(ch)) )
			return (ERR);
	}
	return (NORMAL);
}

static MMAC_T	   *mmac_alloc( CONST char *name, CONST char *str, size_t siz, int att, int (*func)() )
{
	MMAC_T	*mac;

	if ( (mac = calloc(sizeof(MMAC_T),1)) == NULL )
		return (NULL);
	if ( (mac->name = malloc(strlen(name)+1)) == NULL )
	{
		free(mac);
		return (NULL);
	}
	mac->att  = att;
	mac->func = func;
	strcpy( mac->name, name );

	if ( mac->att != MMAC_ATT_TABLE )
	{
		mac->len = str != NULL ? strlen(str) : 0;
		if ( (mac->str = malloc(mac->len+1)) == NULL )
		{
			free(mac->name);
			free(mac);
			return (NULL);
		}
		if ( str )
		{
			CONST char	*sp;
			char		*dp;

			sp = str;
			dp = mac->str;
			LOOP
			{
				int		ch;
				ch = *sp;
				if ( ch == '\0' )
				{
					*dp = '\0';
					break;
				}
				if ( ch == '/' && sp[1] == '*' )
				{
					int		remark;

					sp += 2;
					remark = 1;
					while ( *sp )
					{
						if ( *sp == '*' && sp[1] == '/' )
						{
							sp += 2;
							if ( --remark == 0 )
								break;
						} else if ( *sp == '/' && sp[1] == '*' )
						{
							sp += 2;
							++remark;
						} else
							++sp;
					}
				} else
				{
					*dp++ = ch;	++sp;
				}
			}
		} else
			mac->str[0] = '\0';
	} else
	{	/* ơ֥	*/
		mac->len = siz;
		if ( (mac->str = malloc(mac->len)) == NULL )
		{
			free(mac->name);
			free(mac);
			return (NULL);
		}
		memcpy( mac->str, str, siz );
	}

	return (mac);
}

static void _FAST	mmac_free( MMAC_T *mac )
{
	if ( mac != NULL )
	{
		if ( mac->name != NULL )	free(mac->name);
		if ( mac->str  != NULL )	free(mac->str);
		free( mac );
	}
}

/*************************************************************************
*	ޥ
*************************************************************************/
int _FAST	MMac_define( MMSQR_T *sqr, CONST char *name, CONST char *str, int mode )
{
	int		i = hash(name);
	MMAC_T	*mac = sqr->macTbl[ i ];

	if ( mmac_checkName(name) )
	{
		sqr->errMsg = _msg_Macro_name_must_be_identifier[TypMsg];
		return (-1);
	}

RETRY:
	if ( mac == NULL )
	{
		if ( (sqr->macTbl[i] = mmac_alloc(name,str,0,MMAC_ATT_NORMAL,(int (*)())0)) == NULL )
		{
			sqr->errMsg = _msg_out_of_memory[TypMsg];
			return (ERR);
		}
	} else
	{
		while ( mac )
		{
			if ( strcmpi(name,mac->name) == 0 )
			{	/* ΥޥϴƤ	*/
				if ( mode )
				{	/* Ok	*/
					if ( MMac_undef( sqr, name ) )
						return (ERR);
					mac = sqr->macTbl[ i ];
					goto RETRY;
				} else
				{
					MM_setErrMsg( sqr, _msg_mmac_Redefining_defined_variable[TypMsg], name );
					return (ERR);
				}
			}
			if ( mac->next == NULL )
			{
				if ( (mac->next = mmac_alloc(name,str,0,MMAC_ATT_NORMAL,(int (*)())0)) == NULL )
				{
					sqr->errMsg = _msg_out_of_memory[TypMsg];
					return (ERR);
				}
				break;
			}
			mac = mac->next;
		}
	}
	return (NORMAL);
}

/*************************************************************************
*	ޥ
*************************************************************************/

int _FAST	MMac_undef( MMSQR_T *sqr, CONST char *name )
{
	int			i = hash(name);
	MMAC_T	   *mac = sqr->macTbl[i];
	MMAC_T	   *last = NULL;

	if ( mmac_checkName(name) )
	{
		sqr->errMsg = _msg_Macro_name_must_be_identifier[TypMsg];
		return (-1);
	}

	while ( mac != NULL )
	{
		if ( strcmpi(name,mac->name) == 0 )
		{
			if ( mac->att !=  MMAC_ATT_NORMAL )
			{
				MM_setErrMsg( sqr, _msg_mmac_Cant_undefine_variable[TypMsg], name );
				return (ERR);
			}
			if ( last == NULL )
			{	sqr->macTbl[i] = mac->next;
			} else
				last->next = mac->next;
			mmac_free(mac);
			break;
		}
		last = mac;
		mac = mac->next;
	}
	return (NORMAL);
}

/*************************************************************************
*	ĥޥ
*************************************************************************/

int _FAST	MMac_extDefine( MMSQR_T *sqr, CONST char *name, CONST char *str, int att, int (*func)() )
{
	int			i = hash(name);
	MMAC_T	   *mac = sqr->macTbl[i];

	if ( mmac_checkName(name) )
	{
		sqr->errMsg = _msg_Macro_name_must_be_identifier[TypMsg];
		return (-1);
	}

//RETRY:
	if ( mac == NULL )
	{
		if ( (sqr->macTbl[i] = mmac_alloc(name,str,strlen(str),att,func)) == NULL )
		{
			sqr->errMsg = _msg_out_of_memory[TypMsg];
			return (ERR);
		}
	} else
	{
		while ( mac != NULL )
		{
			if ( strcmpi(name,mac->name) == 0 )
			{	/* ΥޥϴƤ	*/
				MM_setErrMsg( sqr, _msg_mmac_Redefining_defined_variable[TypMsg], name );
				return (ERR);
			}
			if ( mac->next == NULL )
			{
				if ( (mac->next = mmac_alloc(name,str,strlen(str),att,func)) == NULL )
				{
					sqr->errMsg = _msg_out_of_memory[TypMsg];
					return (ERR);
				}
				break;
			}
			mac = mac->next;
		}
	}
	return (NORMAL);
}

/*************************************************************************
*	ơ֥
*************************************************************************/

int _FAST	MMac_table( MMSQR_T *sqr, CONST char *name, CONST char *s )
{
	int			i = hash(name);
	MMAC_T	   *mac = sqr->macTbl[ i ];
	int			arn = 0;
	int			ar[MMTABLE_MAX];

	if ( mmac_checkName(name) )
	{
		sqr->errMsg = _msg_Macro_name_must_be_identifier[TypMsg];
		return (-1);
	}
	while ( *s )
	{
		MMV_T	a;

		SKIP_SPACE(s);
		if ( *s == '/' && s[1] == '*' )
			break;	/* 	*/
		else if ( *s == ',' )
		{
			a = 0;
			++s;
		} else
		{
			if ( mm_getdigit( &a, &s ) )
			{
				sqr->errMsg = _msg_mmac_Table_error[TypMsg];
				return (ERR);
			}
		}
		ar[arn++] = a;
		if ( arn >= MMTABLE_MAX )
		{
			sqr->errMsg = _msg_mmac_Over_table_number[TypMsg];
			return (ERR);
		}
		SKIP_SPACE(s);
		if ( *s != ',' )
			break;
		++s;
	}

//RETRY:
	if ( mac == NULL )
	{
		if ( (sqr->macTbl[i]
		    = mmac_alloc(name,(char *)(&ar[0]),(sizeof(int))*arn,
		                  MMAC_ATT_TABLE,(int (*)())0)) == NULL )
		{
			sqr->errMsg = _msg_out_of_memory[TypMsg];
			return (ERR);
		}
	} else
	{
		while ( mac != NULL )
		{
			if ( strcmpi(name,mac->name) == 0 )
			{	/* ΥޥϴƤ	*/
				MM_setErrMsg( sqr, _msg_mmac_Redefining_defined_variable[TypMsg], name );
				return (ERR);
			}
			if ( mac->next == NULL )
			{
				if ( (mac->next
				    = mmac_alloc(name,(char *)(&ar[0]),(sizeof(int))*arn,
				                  MMAC_ATT_TABLE,(int (*)())0)) == NULL )
				{
					sqr->errMsg = _msg_out_of_memory[TypMsg];
					return (ERR);
				}
				break;
			}
			mac = mac->next;
		}
	}
	return (NORMAL);
}

/*************************************************************************
*	$slide$waveΥޥŸ
*************************************************************************/

int _FAST	mmac_cmdform( char *buf, const char *form, int n)
{
	int		len = 0, flag = 0;
	char	nbuf[32];
	int		nlen;

	sprintf( nbuf, "%d", n);
	nlen = strlen(nbuf);

	while ( *form )
	{
		if ( *form == '=' )
		{
			++form;
			strcpy( buf, nbuf);
			buf += nlen;
			len += nlen;
			flag = 1;
		} else
		{
			*buf++ = *form++;
			++len;
		}
	}
	if ( flag == 0 )
	{
		strcpy( buf, nbuf);
		buf += nlen;
		len += nlen;
	}
	*buf = '\0';

	return (len);
}

#include	"expr.h"

/*************************************************************************
*	$EXPR(<>)
*************************************************************************/

static int		MMfunc_expr(MMSQR_T *sqr,size_t bufsiz, char *buf,int argc, char **argv)
{
	int		ans;
	size_t	len;
	char	tmp[32];

	if ( argc < 1 )
		goto _ERR;
	if ( EXPR_calc(&ans, argv[0]) < 0 )
		goto _ERR;
	sprintf( tmp, "%d", ans);
	len = strlen(tmp);
	if ( len >= bufsiz )
		goto _SET_ERR;
	strcpy( buf, tmp);
	return ((int)len);

_ERR:
	sqr->errMsg = "Expression error!";
	return (-1);

_SET_ERR:
	sqr->errMsg = _OUT_OF_STRING_SPACE;
	return (-1);
}
