/*************************************************************************
*	CCI 󥿡ե
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<ctype.h>
#include	<string.h>

#ifdef	__HIGHC__
#	include	<msdos.cf>
#	include	<egb.h>
#endif

#include	"he386.h"
#include	"mmcci.h"
#include	"mmac.h"
#include	"mmlib.h"
#include	"cci.h"

#ifdef	__HIGHC__
static void	*__stdin  = (void *)(stdin );
static void	*__stdout = (void *)(stdout);
static void	*__stderr = (void *)(stderr);
#endif

#if	!defined(CCICALL)
#	define	CCICALL
#endif

static int CCICALL cci_extDefine( MMSQR_T *sqr, CONST char *name, CONST char *str, int att, int (*func)() )
{
	return MMac_extDefine( sqr, name, str, att, func);
}

#ifdef	__HIGHC__
#	pragma Off(Warn)
#endif
static int	CCICALL _getch(void)		{	return getc(stdin);			}
static int	CCICALL _putch(int ch)		{	return putc(ch, stdout);	}
static void CCICALL _cleae(FILE * fp)	{	clearerr(fp);				}
static int	CCICALL __feof(FILE * fp)	{	return feof(fp);			}
static int	CCICALL __ferror(FILE * fp)	{	return ferror(fp);			}
static int	CCICALL __fileno(FILE * fp)	{	return fileno(fp);			}
static int	CCICALL __strcmp(char *s1,char *s2) { return strcmp(s1,s2);	}
static int	CCICALL __strcmpi(char *s1,char *s2) { return strcmpi(s1,s2);	}
static int	CCICALL __isalpha(int c)	{	return isalpha(c);			}
static int	CCICALL __isupper(int c)	{	return isupper(c);			}
static int	CCICALL __islower(int c)	{	return islower(c);			}
static int	CCICALL __isdigit(int c)	{	return isdigit(c);			}
static int	CCICALL __isxdigit(int c)	{	return isxdigit(c);			}
static int	CCICALL __isalnum(int c)	{	return isalnum(c);			}
static int	CCICALL __isspace(int c)	{	return isspace(c);			}
static int	CCICALL __ispunct(int c)	{	return ispunct(c);			}
static int	CCICALL __isprint(int c)	{	return isprint(c);			}
static int	CCICALL __isgraph(int c)	{	return isgraph(c);			}
static int	CCICALL __iscntrl(int c)	{	return iscntrl(c);			}
static int	CCICALL cci_isascii(int c)	{	return isascii(c);			}
static int	CCICALL __touppe(int c)		{	return toupper(c);			}
static int	CCICALL __tolowe(int c)		{	return tolower(c);			}
static int	CCICALL cci_toascii(int c)
{
#if	defined(__HIGHC__) || defined(__WATCOMC__)
	return (c & 0x7F);
#else
	return toascii(c);
#endif
}

static void   CCICALL *cci_memcpy(void *dst, const void *src, size_t size) { return memcpy(dst,src,size);};
static int    CCICALL  cci_memcmp(void *p1, const void *p2, size_t size) { return memcmp(p1,p2,size);};
static size_t CCICALL  cci_strlen(const char *src) { return strlen(src);};
static char   CCICALL *cci_strcpy(char *dst, const char *src) { return strcpy(dst,src);};
static char   CCICALL *cci_strncpy(char *dst, const char *src, size_t len) { return strncpy(dst,src,len);};
static int    CCICALL  cci_atoi(const char *src) { return atoi(src);};
#if	0
static int CCICALL cci_printf(const char *form, int p1, int p2, int p3, int p4, int p5 ,int p6, int p7, int p8, int p9)
{
	return printf(form, p1,p2,p3,p4,p5,p6,p7,p8,p9);
}
static int CCICALL cci_sprintf(char *buf,const char *form, int p1, int p2, int p3, int p4, int p5 ,int p6, int p7, int p8, int p9)
{
	return sprintf(buf,form, p1,p2,p3,p4,p5,p6,p7,p8,p9);
}
#else
#	define	cci_printf	printf
#	define	cci_sprintf	sprintf
#endif

#ifdef	__HIGHC__
#	pragma On(Warn)
#endif



static int CCICALL		_funcCall( char *func, int n, ... )
{
	int				i, ret;
	unsigned int	p[18];
	va_list			arg;

	va_start( arg, n );
	if ( n > 18 )
		n = 18;
	for ( i = 0; i < n; ++i )
		i = va_arg( arg, UINT );
	va_end(arg);
	switch( n )
	{
		case  0:	ret = CCI_exec( func, 0 );	break;
		case  1:	ret = CCI_exec( func, 1, p[0] );	break;
		case  2:	ret = CCI_exec( func, 2, p[0],p[1] );	break;
		case  3:	ret = CCI_exec( func, 3, p[0],p[1],p[2] );	break;
		case  4:	ret = CCI_exec( func, 4, p[0],p[1],p[2],p[3] );	break;
		case  5:	ret = CCI_exec( func, 5, p[0],p[1],p[2],p[3],p[4] );	break;
		case  6:	ret = CCI_exec( func, 6, p[0],p[1],p[2],p[3],p[4],p[5] );	break;
		case  7:	ret = CCI_exec( func, 7, p[0],p[1],p[2],p[3],p[4],p[5],p[6] );	break;
		case  8:	ret = CCI_exec( func, 8, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7] );	break;
		case  9:	ret = CCI_exec( func, 9, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8] );	break;
		case 10:	ret = CCI_exec( func,10, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9] );	break;
		case 11:	ret = CCI_exec( func,11, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9], p[10] );	break;
		case 12:	ret = CCI_exec( func,12, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9], p[10], p[11] );	break;
		case 13:	ret = CCI_exec( func,13, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9], p[10], p[11], p[12] );	break;
		case 14:	ret = CCI_exec( func,14, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9], p[10], p[11], p[12], p[13] );	break;
		case 15:	ret = CCI_exec( func,15, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9], p[10], p[11], p[12], p[13], p[14] );	break;
		case 16:	ret = CCI_exec( func,16, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9], p[10], p[11], p[12], p[13], p[14], p[15] );	break;
		case 17:	ret = CCI_exec( func,17, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9], p[10], p[11], p[12], p[13], p[14], p[15], p[16] );	break;
		case 18:	ret = CCI_exec( func,18, p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9], p[10], p[11], p[12], p[13], p[14], p[15], p[16], p[17] );	break;
	}
	return (ret);
}

#ifdef	__HE386__
static UINT	__getds(void)					{	return	getds();}
#endif

static void CCICALL	_setByte ( char *ptr, int dat )	{ *(BYTE  *)(ptr) = (BYTE ) dat;	}
static void CCICALL	_setWord ( char *ptr, int dat )	{ *(WORD  *)(ptr) = (WORD ) dat;	}
static void CCICALL	_setDword( char *ptr, int dat )	{ *(DWORD *)(ptr) = (DWORD) dat;	}
static int  CCICALL	_getByte ( char *ptr )	{ return (int)((*(BYTE  *)(ptr)) &   0xFF);	}
static int  CCICALL	_getWord ( char *ptr )	{ return (int)((*(WORD  *)(ptr)) & 0xFFFF);	}
static int  CCICALL	_getDword( char *ptr )	{ return (int)( *(DWORD *)(ptr)          );	}

#if	defined(__WATCOMC__)
static int		   *watcom_errno;
#endif

#ifdef	__HIGHC__
#	pragma Off(Warn)
#endif
static CCIFUNC_T ext_tbl[] =
{
#if	defined(__WATCOMC__)
	{"errno",	(char *)&watcom_errno,	{T_INT, T_POINT, ERR}},
#else
	{"errno",	(char *)&errno,			{T_INT, ERR}},
#endif
#ifdef	__HIGHC__
	{"stdin",	(char *)&__stdin,		{T_INT, T_POINT, ERR}},
	{"stdout",	(char *)&__stdout,		{T_INT, T_POINT, ERR}},
	{"stderr",	(char *)&__stderr,		{T_INT, T_POINT, ERR}},
#else
	{"stdin",	(char *) stdin,			{T_INT, ERR}},
	{"stdout",	(char *) stdout,		{T_INT, ERR}},
	{"stderr",	(char *) stderr,		{T_INT, ERR}},
#endif

	{"putc",	(char *) fputc,		{T_INT, T_EXTF, ERR}},
	{"puts",	(char *) puts,		{T_INT, T_EXTF, ERR}},
	{"fputc",	(char *) fputc,		{T_INT, T_EXTF, ERR}},
	{"fputs",	(char *) fputs,		{T_INT, T_EXTF, ERR}},
	{"fread",	(char *) fread,		{T_INT, T_EXTF, ERR}},

	{"getc",	(char *) fgetc,		{T_INT, T_EXTF, ERR}},
	{"gets",	(char *) gets,		{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"fgetc",	(char *) fgetc,		{T_INT, T_EXTF, ERR}},
	{"fgets",	(char *) fgets,		{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"fwrite",	(char *) fwrite,	{T_INT, T_EXTF, ERR}},

	{"fopen",	(char *) fopen,		{T_INT, T_EXTF, ERR}},
	{"fclose",	(char *) fclose,	{T_INT, T_EXTF, ERR}},
	{"fseek",	(char *) fseek,		{T_INT, T_EXTF, ERR}},
	{"ftell",	(char *) ftell,		{T_LONG, T_EXTF, ERR}},
	{"rewind",	(char *) rewind,	{T_VOID, T_EXTF, ERR}},
	{"setbuf",	(char *) setbuf,	{T_INT, T_EXTF, ERR}},
	{"fflush",	(char *) fflush,	{T_INT, T_EXTF, ERR}},
	{"ungetc",	(char *) ungetc,	{T_INT, T_EXTF, ERR}},

	{"getchar",	(char *) _getch,	{T_INT, T_EXTF, ERR}},
	{"putchar",	(char *) _putch,	{T_INT, T_EXTF, ERR}},
	{"clearerr",(char *) _cleae,	{T_INT, T_EXTF, ERR}},
	{"feof",	(char *) __feof,	{T_INT, T_EXTF, ERR}},
	{"ferror",	(char *) __ferror,	{T_INT, T_EXTF, ERR}},
	{"fileno",	(char *) __fileno,	{T_INT, T_EXTF, ERR}},

	{"printf",	(char *) cci_printf,	{T_INT, T_EXTF, ERR}},
	{"fprintf",	(char *) fprintf,		{T_INT, T_EXTF, ERR}},
	{"sprintf",	(char *) cci_sprintf,	{T_INT, T_EXTF, ERR}},

	{"vprintf",	(char *) vprintf,	{T_INT, T_EXTF, ERR}},
	{"vfprintf",(char *) vfprintf,	{T_INT, T_EXTF, ERR}},
	{"vsprintf",(char *) vsprintf,	{T_INT, T_EXTF, ERR}},

	{"scanf",	(char *) scanf,		{T_INT, T_EXTF, ERR}},
	{"fscanf",	(char *) fscanf,	{T_INT, T_EXTF, ERR}},
	{"sscanf",	(char *) sscanf,	{T_INT, T_EXTF, ERR}},

	{"system",	(char *) system,	{T_INT, T_EXTF, ERR}},
	{"freopen",	(char *) freopen,	{T_INT, T_EXTF, ERR}},

	{"strcpy",	(char *) cci_strcpy,{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strncpy",	(char *) cci_strncpy,{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strcat",	(char *) strcat,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strncat",	(char *) strncat,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strchr",	(char *) strchr,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strrchr",	(char *) strrchr,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strpbrk",	(char *) strpbrk,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strtok",	(char *) strtok,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strdup",	(char *) strdup,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"strstr",	(char *) strstr,	{T_CHAR, T_POINT, T_EXTF, ERR}},

	{"strcmp",	(char *) __strcmp,	{T_INT, T_EXTF, ERR}},
	{"strcmpi",	(char *) __strcmpi,	{T_INT, T_EXTF, ERR}},
	{"strncmp",	(char *) strncmp,	{T_INT, T_EXTF, ERR}},
	{"strlen",	(char *) cci_strlen,{T_INT, T_EXTF, ERR}},
	{"strspn",	(char *) strspn,	{T_INT, T_EXTF, ERR}},
	{"strcspn",	(char *) strcspn,	{T_INT, T_EXTF, ERR}},

	{"memccpy",	(char *) memccpy,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"memchr",	(char *) memchr,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"memcpy",	(char *) cci_memcpy,{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"memset",	(char *) memset,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"memcmp",	(char *) cci_memcmp,{T_INT, T_EXTF, ERR}},

	{"atof",	(char *) atof,		{T_DOUBLE, T_EXTF, ERR}},
	{"atoi",	(char *) cci_atoi,	{T_INT, T_EXTF, ERR}},
	{"atol",	(char *) atol,		{T_LONG, T_EXTF, ERR}},
	{"rand",	(char *) rand,		{T_INT, T_EXTF, ERR}},
	{"srand",	(char *) srand,		{T_INT, T_EXTF, ERR}},

	{"calloc",	(char *) calloc,	{T_INT, T_EXTF, ERR}},
	{"malloc",	(char *) malloc,	{T_INT, T_EXTF, ERR}},
	{"realloc",	(char *) realloc,	{T_INT, T_EXTF, ERR}},
	{"free",	(char *) free,		{T_INT, T_EXTF, ERR}},

	{"exit",	(char *) exit,		{T_INT, T_EXTF, ERR}},
	{"abort",	(char *) abort,		{T_INT, T_EXTF, ERR}},

	{"getenv",	(char *) getenv,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"bsearch",	(char *) bsearch,	{T_INT, T_EXTF, ERR}},
	{"qsort",	(char *) qsort,		{T_INT, T_EXTF, ERR}},

	{"isalpha",	(char *) __isalpha,	{T_INT, T_EXTF, ERR}},
	{"isupper",	(char *) __isupper,	{T_INT, T_EXTF, ERR}},
	{"islower",	(char *) __islower,	{T_INT, T_EXTF, ERR}},
	{"isdigit",	(char *) __isdigit,	{T_INT, T_EXTF, ERR}},
	{"isxdigit",(char *) __isxdigit,{T_INT, T_EXTF, ERR}},
	{"isalnum",	(char *) __isalnum,	{T_INT, T_EXTF, ERR}},
	{"isspace",	(char *) __isspace,	{T_INT, T_EXTF, ERR}},
	{"ispunct",	(char *) __ispunct,	{T_INT, T_EXTF, ERR}},
	{"isprint",	(char *) __isprint,	{T_INT, T_EXTF, ERR}},
	{"isgraph",	(char *) __isgraph,	{T_INT, T_EXTF, ERR}},
	{"iscntrl",	(char *) __iscntrl,	{T_INT, T_EXTF, ERR}},
	{"isascii",	(char *) cci_isascii,{T_INT, T_EXTF, ERR}},
	{"toupper",	(char *) __touppe,	{T_INT, T_EXTF, ERR}},
	{"tolower",	(char *) __tolowe,	{T_INT, T_EXTF, ERR}},
	{"toascii",	(char *) cci_toascii,{T_INT,T_EXTF,ERR }},

	{"clock",	(char *) clock,		{T_LONG, T_EXTF, ERR}},
	{"time",	(char *) time,		{T_LONG, T_EXTF, ERR}},
	{"localtime",(char *)localtime,	{T_INT, T_POINT, T_EXTF, ERR}},
	{"mktime",	(char *) mktime,	{T_LONG, T_EXTF, ERR}},
	{"ctime",	(char *) ctime,		{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"asctime",	(char *) asctime,	{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"difftime",(char *) difftime,	{T_DOUBLE, T_EXTF, ERR}},

#ifdef	__HIGHC__
	{"_ltoa",		(char *) _ltoa,			{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"_ultoa",		(char *) _ultoa,		{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"_searchenv",	(char *) _searchenv,	{T_VOID, T_EXTF, ERR}},
	{"_putenv",		(char *) _putenv,		{T_INT, T_EXTF, ERR}},
#endif

	{"_funcCall",			(char *) _funcCall,			{T_INT, T_EXTF, ERR}},

#ifdef	__HIGHC__
	{"getds",				(char *) __getds,			{T_INT, T_EXTF, ERR}},
#endif
	{"_setByte",			(char *) _setByte,			{T_VOID, T_EXTF, ERR}},
	{"_setWord",			(char *) _setWord,			{T_VOID, T_EXTF, ERR}},
	{"_setDword",			(char *) _setDword,			{T_VOID, T_EXTF, ERR}},
	{"_getByte",			(char *) _getByte,			{T_INT, T_EXTF, ERR}},
	{"_getWord",			(char *) _getWord,			{T_INT, T_EXTF, ERR}},
	{"_getDword",			(char *) _getDword,			{T_INT, T_EXTF, ERR}},

	{"MM_setErrMsg",		(char *) MM_setErrMsg,		{T_VOID, T_EXTF, ERR}},
	{"MM_fopen",			(char *) MM_fopen,			{T_CHAR, T_POINT, T_EXTF, ERR}},
	{"MMac_extDefine",		(char *) cci_extDefine,		{T_INT, T_EXTF, ERR}},

	{NULL}
};
#ifdef	__HIGHC__
#	pragma On(Warn)
#endif

void	MM_cci_setFunc(void)
{
	int		i;

#if	defined(__WATCOMC__)
	watcom_errno = __get_errno_ptr();
#endif
	for ( i = 0; ext_tbl[i].name != NULL; ++i )
		CCI_setFunc( &ext_tbl[i] );
}
