/*************************************************************************
*	MML ǥ
*************************************************************************/

#include	<stdio.h>
	#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"midicc.h"
#include	"mml.h"
#include	"mmac.h"
#include	"mmlib.h"
#include	"mmtrk.h"
#include	"mmpart.h"
#include	"mmdec.h"
#include	"mmcmdtyp.h"
#include	"mmsg.h"
#include	"msgdat.h"
#include	"midicc.h"

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

static int _FAST	MMdec_tempo( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_ch( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_delay( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_clock( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_keyShift( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_octave( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_velocity( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_offVelocity( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_stepTime( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_gateRatio( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_gateTime( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_prog( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_pitch( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_caf( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_cafPres( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_cafDelay( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_paf( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_pafPres( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_pafDelay( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_cc( MMSQR_T *sqr, MMPART_T *part, CONST char **s);
static int _FAST	MMdec_ccv( MMSQR_T *sqr, MMPART_T *part, int cc, CONST char **s);

#define	OFFSETTER_ERR_PUT(_sqr,_msg)	\
	MM_setErrMsg((_sqr),_msg_mmcmd_offsetter_error[TypMsg],(_msg))
#define	PARAMETER_ERR_PUT(_sqr,_msg)	\
	MM_setErrMsg((_sqr),_msg_mmcmd_parameter_error[TypMsg],(_msg))

int _FAST	MMdec_jump( MMSQR_T *sqr, MMPART_T *part, CONST char **s, int cmd)
{
	switch ( cmd )
	{
		case MMCMDTYP_TEMPO:		return MMdec_tempo(sqr,part,s);
		case MMCMDTYP_CH:			return MMdec_ch(sqr,part,s);
		case MMCMDTYP_DELAY:		return MMdec_delay(sqr,part,s);
		case MMCMDTYP_CLOCK:		return MMdec_clock(sqr,part,s);

		case MMCMDTYP_KEYSHIFT:		return MMdec_keyShift(sqr,part,s);
		case MMCMDTYP_OCTAVE:		return MMdec_octave(sqr,part,s);
		case MMCMDTYP_VELOCITY:		return MMdec_velocity(sqr,part,s);
		case MMCMDTYP_OFFVELOCITY:	return MMdec_offVelocity(sqr,part,s);
		case MMCMDTYP_STEPTIME:		return MMdec_stepTime(sqr,part,s);
		case MMCMDTYP_GATERATIO:	return MMdec_gateRatio(sqr,part,s);
		case MMCMDTYP_GATETIME:		return MMdec_gateTime(sqr,part,s);

		case MMCMDTYP_PROG:			return MMdec_prog(sqr,part,s);
		case MMCMDTYP_PITCH:		return MMdec_pitch(sqr,part,s);

		case MMCMDTYP_CAF:			return MMdec_caf(sqr,part,s);
		case MMCMDTYP_CAFPRES:		return MMdec_cafPres(sqr,part,s);
		case MMCMDTYP_CAFDELAY:		return MMdec_cafDelay(sqr,part,s);
		case MMCMDTYP_PAF:			return MMdec_paf(sqr,part,s);
		case MMCMDTYP_PAFPRES:		return MMdec_pafPres(sqr,part,s);
		case MMCMDTYP_PAFDELAY:		return MMdec_pafDelay(sqr,part,s);

		case MMCMDTYP_CC:			return MMdec_cc(sqr,part,s);

#ifdef	__HIGHC__
		case MMCMDTYP_CCV..(MMCMDTYP_CCV+127):
#else
		default:
		if ( cmd >= MMCMDTYP_CCV && cmd <= MMCMDTYP_CCV+127 )
#endif
		{	int		cc = cmd - MMCMDTYP_CCV;

			return MMdec_ccv(sqr,part,cc,s);
		}
#ifdef	__HIGHC__
		default:
#endif
			return MMdec_unknown( sqr, part, s);
	}
}

/*************************************************************************
*	ƥ
*************************************************************************/

static int _FAST	MMdec_tempo( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.tempo;
		if ( mm_getValue( &val, s )
		    || MM_CHKVALUE(&val,-(MMTEMPO_MAX-MMTEMPO_MIN),(MMTEMPO_MAX-MMTEMPO_MIN)) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Tempo[TypMsg]);
			return (ERR);
		}
		part->ofs.tempo = val;
		return (NORMAL);
	} else
	{
		int		clk = mmpart_get_clock(part);

		val = part->set.tempo;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Tempo[TypMsg]);
			return (ERR);
		}
		return	mmpart_set_tempo( part, clk, &val );
	}
}

/*************************************************************************
*	MIDIͥ
*************************************************************************/

static int _FAST	MMdec_ch( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	int		ch;

	++(*s);	/* skip 'cha.' */
	if ( mm_getIntDigit( &ch, s ) || ch < 1 || ch > 16 )
	{
		sqr->errPoint = *s;
		PARAMETER_ERR_PUT(sqr,_msg_MIDI_channel[TypMsg]);
		return (ERR);
	}
	return	mmpart_set_midich( part, ch - 1);
}

/*************************************************************************
*	ǥ쥤
*************************************************************************/

static int _FAST	MMdec_delay( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.delay;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-32767,32767) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Delay[TypMsg]);
			return (ERR);
		}
		part->ofs.delay = val;
		return (NORMAL);
	} else
	{
		val = part->set.delay;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Delay[TypMsg]);
			return (ERR);
		}
		return	mmpart_set_delay( part, &val );
	}
}

/*************************************************************************
*	å
*	<cmd> <beat>:<step>
*************************************************************************/

static int _FAST	MMdec_clock( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	int		beat, step, clk;

	++(*s);	/* skip 'cha.' */
	if ( mm_getIntDigit( &beat, s) || beat < 1 || beat > 32 )
	{
_CLOCK_ERR:
		sqr->errPoint = *s;
		PARAMETER_ERR_PUT(sqr,_msg_Clock[TypMsg]);
		return (ERR);
	}
	SKIP_SPACE(*s);
	if ( *(*s) != ':' )
		goto _CLOCK_ERR;
	++(*s);
	if ( mm_getIntDigit( &step, s) || step < 0 || step >= sqr->division )
		goto _CLOCK_ERR;
	clk = (beat-1) * sqr->division + step;
	part->clk = ((MMTRK_T *)(part->trk))->clk + clk;

	return (NORMAL);
}

/*************************************************************************
*	ե
*************************************************************************/

static int _FAST	MMdec_keyShift( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.keyShift;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-127,127) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Key_shift[TypMsg]);
			return (ERR);
		}
		part->ofs.keyShift = val;
		return (NORMAL);
	} else
	{
		val = part->set.keyShift;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Key_shift[TypMsg]);
			return (ERR);
		}
		return	mmpart_set_keyShift( part, &val );
	}
}

/*************************************************************************
*	
*************************************************************************/

static int _FAST	MMdec_octave( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.octave;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-10,10) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Octave[TypMsg]);
			return (ERR);
		}
		part->ofs.octave = val;
		return (NORMAL);
	} else
	{
		val = part->set.octave;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Octave[TypMsg]);
			return (ERR);
		}
		return mmpart_set_octave( part, &val );
	}
}


/*************************************************************************
*	٥ƥ
*************************************************************************/

static int _FAST	MMdec_velocity( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.vel;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-127,127) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Velocity[TypMsg]);
			return (ERR);
		}
		part->ofs.vel = val;
		return (NORMAL);
	} else
	{
		val = part->set.vel;
		if ( mm_getValue( &val, s ) )
		{
_SET_ERR:	sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Velocity[TypMsg]);
			return (ERR);
		}
		if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,1,127) )
			goto _SET_ERR;
		else if ( !(val.mode & _MMVAL_RANDOM) )
		{
			if ( val.value < 1 )
				val.value = 1;
			else if ( val.value > 127 )
				val.value = 127;
		}
		return mmpart_set_velocity( part, &val );
	}
}

/*************************************************************************
*	ե٥ƥ
*************************************************************************/

static int _FAST	MMdec_offVelocity( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.offVel;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-127,127) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Off_velocity[TypMsg]);
			return (ERR);
		}
		part->ofs.offVel = val;
		return (NORMAL);
	} else
	{
		val = part->set.offVel;
		if ( mm_getValue( &val, s ) )
		{
_SET_ERR:	sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Off_velocity[TypMsg]);
			return (ERR);
		}
		if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
			goto _SET_ERR;
		else if ( !(val.mode & _MMVAL_RANDOM) )
		{
			if ( val.value < 0 )
				val.value = 0;
			else if ( val.value > 127 )
				val.value = 127;
		}
		return mmpart_set_offVelocity( part, &val );
	}
}


/*************************************************************************
*	ƥåץ
*************************************************************************/

static int _FAST	MMdec_stepTime( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.stepTime;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-65535,65535) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Steptime[TypMsg]);
			return (ERR);
		}
		part->ofs.stepTime = val;
		return (NORMAL);
	} else
	{
		val = part->set.stepTime;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Steptime[TypMsg]);
			return (ERR);
		}
		return mmpart_set_steptime( part, &val );
	}
}

/*************************************************************************
*	ȥΨ
*************************************************************************/

static int _FAST	MMdec_gateRatio( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.gateRatio;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-1000,1000) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Gatetime_ratio[TypMsg]);
			return (ERR);
		}
		part->ofs.gateRatio = val;
		return (NORMAL);
	} else
	{
		val = part->set.gateRatio;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Gatetime_ratio[TypMsg]);
			return (ERR);
		}
		return mmpart_set_gateratio( part, &val );
	}
}

/*************************************************************************
*	ȥ
*************************************************************************/

static int _FAST	MMdec_gateTime( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.gateTime;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-65535,65535) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Gatetime[TypMsg]);
			return (ERR);
		}
		part->ofs.gateTime = val;
		return (NORMAL);
	} else
	{
		val = part->set.gateTime;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Gatetime[TypMsg]);
			return (ERR);
		}
		return mmpart_set_gatetime( part, &val );
	}
}

/*************************************************************************
*	ץ
*************************************************************************/

static int _FAST	MMdec_prog( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.prog;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-127,127) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Program_change[TypMsg]);
			return (ERR);
		}
		part->ofs.prog = val;
		return (NORMAL);
	} else
	{
		int		clk = mmpart_get_clock(part);

		val = part->set.prog;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Program_change[TypMsg]);
			return (ERR);
		}
		return mmpart_set_prog( part, clk, &val );
	}
}

/*************************************************************************
*	ԥå٥
*************************************************************************/

static int _FAST	MMdec_pitch( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.pitch;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-16383,16383) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_msg_Pitchbend[TypMsg]);
			return (ERR);
		}
		part->ofs.pitch = val;
		return (NORMAL);
	} else
	{
		int		clk = mmpart_get_clock(part);

		val = part->set.pitch;
		if ( mm_getValue( &val, s ) )
		{
_SET_ERR:	sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_msg_Pitchbend[TypMsg]);
			return (ERR);
		}
		if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,-8192,8191) )
			goto _SET_ERR;
		else if ( !(val.mode & _MMVAL_RANDOM) )
		{
			if ( val.value < -8192 )
				val.value = -8192;
			else if ( val.value > 8191 )
				val.value = 8191;
		}
		return mmpart_set_pitch( part, clk, &val );
	}
}

/*************************************************************************
*	ͥ롦եå
*************************************************************************/

static int _FAST	MMdec_caf( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.caf;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-127,127) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_Channel_after_touch_);
			return (ERR);
		}
		part->ofs.caf = val;
		return (NORMAL);
	} else
	{
		int		clk = mmpart_get_clock(part);

		val = part->set.caf;
		if ( mm_getValue( &val, s ) )
		{
_SET_ERR:	sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_Channel_after_touch_);
			return (ERR);
		}
		if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
			goto _SET_ERR;
		else if ( !(val.mode & _MMVAL_RANDOM) )
		{
			if ( val.value < 0 )
				val.value = 0;
			else if ( val.value > 127 )
				val.value = 127;
		}
		return mmpart_set_caf( part, clk, &val );
	}
}

/*************************************************************************
*	ͥ롦եåץå
*************************************************************************/

static int _FAST	MMdec_cafPres( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.caf;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-127,127) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_Channel_after_touch_);
			return (ERR);
		}
		part->ofs.caf = val;
		return (NORMAL);
	} else
	{
		val = part->set.caf;
		if ( mm_getValue( &val, s ) )
		{
_SET_ERR:	sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_Channel_after_touch_);
			return (ERR);
		}
		if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
			goto _SET_ERR;
		else if ( !(val.mode & _MMVAL_RANDOM) )
		{
			if ( val.value < 0 )
				val.value = 0;
			else if ( val.value > 127 )
				val.value = 127;
		}
		return mmpart_set_cafPres( part, &val );
	}
}

/*************************************************************************
*	ͥ롦եåǥ쥤
*************************************************************************/

static int _FAST	MMdec_cafDelay( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.cafDelay;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-65535,65535) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,"Channel-after-touch delay");
			return (ERR);
		}
		part->ofs.cafDelay = val;
		return (NORMAL);
	} else
	{
		val = part->set.cafDelay;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,"Channel-after-touch delay");
			return (ERR);
		}
		return mmpart_set_cafDelay( part, &val );
	}
}

/*************************************************************************
*	ݥե˥åեå
*************************************************************************/

static int _FAST	MMdec_paf( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.paf;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-127,127) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_Polyphonic_after_touch_);
			return (ERR);
		}
		part->ofs.paf = val;
		return (NORMAL);
	} else
	{
		int		clk = mmpart_get_clock(part);

		if ( part->noteLast < 0 )
			goto _SET_ERR;
		val = part->set.paf;
		if ( mm_getValue( &val, s ) )
		{
_SET_ERR:	sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_Polyphonic_after_touch_);
			return (ERR);
		}
		if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
			goto _SET_ERR;
		else if ( !(val.mode & _MMVAL_RANDOM) )
		{
			if ( val.value < 0 )
				val.value = 0;
			else if ( val.value > 127 )
				val.value = 127;
		}
		return mmpart_set_paf( part, clk, part->noteLast, &val );
	}
}

/*************************************************************************
*	ݥե˥åեåץå
*************************************************************************/

static int _FAST	MMdec_pafPres( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.paf;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-127,127) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,_Polyphonic_after_touch_);
			return (ERR);
		}
		part->ofs.paf = val;
		return (NORMAL);
	} else
	{
		val = part->set.paf;
		if ( mm_getValue( &val, s ) )
		{
_SET_ERR:	sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,_Polyphonic_after_touch_);
			return (ERR);
		}
		if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
			goto _SET_ERR;
		else if ( !(val.mode & _MMVAL_RANDOM) )
		{
			if ( val.value < 0 )
				val.value = 0;
			else if ( val.value > 127 )
				val.value = 127;
		}
		return mmpart_set_pafPres( part, &val );
	}
}

/*************************************************************************
*	ݥե˥åեåǥ쥤
*************************************************************************/

static int _FAST	MMdec_pafDelay( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMVALUE_T	val;

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.pafDelay;
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-65535,65535) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,"Polyohonic-after-touch delay");
			return (ERR);
		}
		part->ofs.pafDelay = val;
		return (NORMAL);
	} else
	{
		val = part->set.pafDelay;
		if ( mm_getValue( &val, s ) )
		{
			sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,"Polyohonic-after-touch delay");
			return (ERR);
		}
		return mmpart_set_pafDelay( part, &val );
	}
}

/*************************************************************************
*	ȥ롦
*	<cc>/<value>
*************************************************************************/

static int _FAST	MMdec_cc( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	int			cc;

	++(*s);	/* skip 'cha.' */
	if ( mm_getIntDigit(&cc,s) || cc < 0 || cc > 127 )
	{
_CTRL_ERR:
		sqr->errPoint = *s;
		sqr->errMsg = "Controle change error!";
		return (ERR);
	}
	while ( isspace(*(*s)) )
		++(*s);
	if ( *(*s) != '/' && *(*s) != ',' )
		goto _CTRL_ERR;
	return MMdec_ccv(sqr,part,cc,s);
}

/*************************************************************************
*	ȥ
*************************************************************************/

static int _FAST	MMdec_ccv( MMSQR_T *sqr, MMPART_T *part, int cc, CONST char **s)
{
	MMVALUE_T	val;
	char		tmp[32];

	sprintf( tmp, _msg_mmcmd_cc_form[TypMsg], cc);

	++(*s);	/* skip 'cha.' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		++(*s);
		val = part->ofs.ccv[cc];
		if ( mm_getValue( &val, s ) || MM_CHKVALUE(&val,-127,127) )
		{
			sqr->errPoint = *s;
			OFFSETTER_ERR_PUT(sqr,tmp);
			return (ERR);
		}
		part->ofs.ccv[cc] = val;
		return (NORMAL);
	} else
	{
		int		clk = mmpart_get_clock(part);
		int		base = ((MMTRK_T *)(part->trk))->tbl.ccvBase[cc];

		val = part->set.ccv[cc];
		if ( mm_getValue( &val, s ) )
		{
_SET_ERR:	sqr->errPoint = *s;
			PARAMETER_ERR_PUT(sqr,tmp);
			return (ERR);
		}
		if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,-base,127-base) )
			goto _SET_ERR;
		else if ( !(val.mode & _MMVAL_RANDOM) )
		{
			if ( val.value < -base )
				val.value = -base;
			else if ( val.value > 127 - base )
				val.value = 127 - base;
		}
		return mmpart_set_cc( part, clk, cc, &val );
	}
}
