/*************************************************************************
*	MML ǥ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"midicc.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmtrk.h"
#include	"mmpart.h"
#include	"mmdec.h"
#include	"mmptn.h"
#include	"mmpin.h"
#include	"mmsetter.h"
#include	"mmsg.h"
#include	"msgdat.h"
#include	"midicc.h"

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

/*************************************************************************
*	MML ԤΥǥ
*************************************************************************/

int _FAST	MML_line( MMSQR_T *sqr, CONST char *s )
{
	MMTRK_T	*trk;
	int		partNo;
	char	macro[_MMTRK_NAME_LEN];

#ifdef	_DEBUG
	HE_printf(sqr,_HE_MSG_DE3,"### MM_line(\x22%s\x22)", s );
#endif

	if ( sqr->tempoSetFlag == FALSE )
	{	/* top tempo */
		if ( mmtrk_set_tempo( sqr->ctrlTrk, 0, sqr->top_tempo ) )
			return (ERR);
	}
	if ( sqr->signSetFlag == FALSE )
	{	/* top signature */
		if ( mmtrk_set_signature( sqr->ctrlTrk, 0, sqr->top_sign ) )
			return (ERR);
	}

	SKIP_SPACE(s);

	{	/* ȥåޥ̾μФ	*/
		int		ch;
		size_t	len = 0;

		while ( (ch = *s) != '\0' )
		{
			if ( isspace(ch) || ch == '(' )
				break;
			++s;
			macro[len++] = ch;
			if ( len >= _MMTRK_NAME_LEN )
			{
				sqr->errMsg = _msg_Too_long_macro_name[TypMsg];
				return (ERR);
			}
		}
		macro[len] = '\0';
	}

	SKIP_SPACE(s);
	if ( *s != '(' )
	{
_SYNTAX_ERROR:
		sqr->errMsg = _msg_MML_syntax_error[TypMsg];
		return (ERR);
	}
	++s;	/* skip '(' */
	if ( mm_getIntDigit(&partNo,&s) || partNo < 0 )
		goto _SYNTAX_ERROR;

	SKIP_SPACE(s);
	if ( *s != ')' )			goto _SYNTAX_ERROR;
	++s;	/* skip ')' */

	SKIP_SPACE(s);
	if ( *s != '=' )			goto _SYNTAX_ERROR;
	++s;	/* skip '=' */

	SKIP_SPACE(s);

	if ( (trk = MMtrk_gettrk( sqr, macro )) == NULL )
	{
		MM_setErrMsg( sqr, _msg_mmdec_Unknown_track_macro[TypMsg], macro );
		return (ERR);
	}
	return MMdec_line( sqr, trk, partNo, s );
}

static int _FAST	MMdec_skip( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	++(*s);
	return (NORMAL);
}

static int _FAST	MMdec_octave_inc( MMSQR_T *sqr, MMPART_T *part, CONST char **s );
static int _FAST	MMdec_octave_dec( MMSQR_T *sqr, MMPART_T *part, CONST char **s );

int _FAST	MMdec_line( MMSQR_T *sqr, MMTRK_T *trk, int partNo, CONST char *s )
{
	int			ch;
	MMPART_T	*part = MMpart_get(trk,partNo);
	static CONST struct
	{
#if	defined(_MSC_VER) || defined(__WATCOMC__)
		int 	(_FAST *func)(MMSQR_T *, MMPART_T *, CONST char **);
#else
		int 	_FAST (*func)(MMSQR_T *, MMPART_T *, CONST char **);
#endif
	} cmdtbl[96] =
	{
		{	MMdec_skip			},	/* 0x20 ' '	space		*/
		{	MMdec_pin			},	/* 0x21 '!'	pin			*/
		{	MMdec_unknown		},	/* 0x22 '"'				*/
		{	MMdec_unknown		},	/* 0x23 '#'				*/
		{	MMdec_unknown		},	/* 0x24 '$'				*/
		{	MMdec_setter		},	/* 0x25 '%'	setter		*/
		{	MMdec_unknown		},	/* 0x26 '&'				*/
		{	MMdec_unknown		},	/* 0x27 '''				*/
		{	MMdec_unknown		},	/* 0x28 '('				*/
		{	MMdec_unknown		},	/* 0x29 ')'				*/
		{	MMdec_pattern		},	/* 0x2A '*'	pattern		*/
		{	MMdec_unknown		},	/* 0x2B '+'				*/
		{	MMdec_unknown		},	/* 0x2C ','				*/
		{	MMdec_unknown		},	/* 0x2D '-'				*/
		{	MMdec_unknown		},	/* 0x2E '.'				*/
		{	MMdec_unknown		},	/* 0x2F '/'				*/

		{	MMdec_unknown		},	/* 0x30 '0'				*/
		{	MMdec_unknown		},	/* 0x31 '1'				*/
		{	MMdec_unknown		},	/* 0x32 '2'				*/
		{	MMdec_unknown		},	/* 0x33 '3'				*/
		{	MMdec_unknown		},	/* 0x34 '4'				*/
		{	MMdec_unknown		},	/* 0x35 '5'				*/
		{	MMdec_unknown		},	/* 0x36 '6'				*/
		{	MMdec_unknown		},	/* 0x37 '7'				*/
		{	MMdec_unknown		},	/* 0x38 '8'				*/
		{	MMdec_unknown		},	/* 0x39 '9'				*/
		{	MMdec_unknown		},	/* 0x3A ':'				*/
		{	MMdec_unknown		},	/* 0x3B ';'				*/
		{	MMdec_octave_dec	},	/* 0x3C '<'	octave dec	*/
		{	MMdec_unknown		},	/* 0x3D '='				*/
		{	MMdec_octave_inc	},	/* 0x3E '>'	octave inc	*/
		{	MMdec_setter		},	/* 0x3F '?'				*/

		{	MMdec_trackCmd		},	/* 0x40 '@'	track		*/
		{	MMdec_note			},	/* 0x41 'A'				*/
		{	MMdec_note			},	/* 0x42 'B'				*/
		{	MMdec_note			},	/* 0x43 'C'				*/
		{	MMdec_note			},	/* 0x44 'D'				*/
		{	MMdec_note			},	/* 0x45 'E'				*/
		{	MMdec_note			},	/* 0x46 'F'				*/
		{	MMdec_note			},	/* 0x47 'G'				*/
		{	MMdec_unknown		},	/* 0x48 'H'				*/
		{	MMdec_unknown		},	/* 0x49 'I'				*/
		{	MMdec_unknown		},	/* 0x4A 'J'				*/
		{	MMdec_unknown		},	/* 0x4B 'K'				*/
		{	MMdec_note_len		},	/* 0x4C 'L'				*/
		{	MMdec_unknown		},	/* 0x4D 'M'				*/
		{	MMdec_note			},	/* 0x4E 'N'	note		*/
		{	MMdec_unknown		},	/* 0x4F 'O'				*/

		{	MMdec_unknown		},	/* 0x50 'P'				*/
		{	MMdec_unknown		},	/* 0x51 'Q'				*/
		{	MMdec_rest			},	/* 0x52 'R'	rest		*/
		{	MMdec_unknown		},	/* 0x53 'S'				*/
		{	MMdec_unknown		},	/* 0x54 'T'				*/
		{	MMdec_unknown		},	/* 0x55 'U'				*/
		{	MMdec_unknown		},	/* 0x56 'V'				*/
		{	MMdec_unknown		},	/* 0x57 'W'				*/
		{	MMdec_unknown		},	/* 0x58 'X'				*/
		{	MMdec_unknown		},	/* 0x59 'Y'				*/
		{	MMdec_unknown		},	/* 0x5A 'Z'				*/
		{	MMdec_unknown		},	/* 0x5B '['				*/
		{	MMdec_unknown		},	/* 0x5C '/'				*/
		{	MMdec_unknown		},	/* 0x5D ']'				*/
		{	MMdec_partCmd		},	/* 0x5E '^'				*/
		{	MMdec_unknown		},	/* 0x5F '_'				*/

		{	MMdec_unknown		},	/* 0x60 '`'				*/
		{	MMdec_note			},	/* 0x61 'a'				*/
		{	MMdec_note			},	/* 0x62 'b'				*/
		{	MMdec_note			},	/* 0x63 'c'				*/
		{	MMdec_note			},	/* 0x64 'd'				*/
		{	MMdec_note			},	/* 0x65 'e'				*/
		{	MMdec_note			},	/* 0x66 'f'				*/
		{	MMdec_note			},	/* 0x67 'g'				*/
		{	MMdec_unknown		},	/* 0x68 'h'				*/
		{	MMdec_unknown		},	/* 0x69 'i'				*/
		{	MMdec_unknown		},	/* 0x6A 'j'				*/
		{	MMdec_unknown		},	/* 0x6B 'k'				*/
		{	MMdec_note_len		},	/* 0x6C 'l'				*/
		{	MMdec_unknown		},	/* 0x6D 'm'				*/
		{	MMdec_note			},	/* 0x6E 'n'				*/
		{	MMdec_unknown		},	/* 0x6F 'o'				*/

		{	MMdec_unknown		},	/* 0x70 'p'				*/
		{	MMdec_unknown		},	/* 0x71 'q'				*/
		{	MMdec_rest			},	/* 0x72 'r'				*/
		{	MMdec_unknown		},	/* 0x73 's'				*/
		{	MMdec_unknown		},	/* 0x74 't'				*/
		{	MMdec_unknown		},	/* 0x75 'u'				*/
		{	MMdec_unknown		},	/* 0x76 'v'				*/
		{	MMdec_unknown		},	/* 0x77 'w'				*/
		{	MMdec_unknown		},	/* 0x78 'x'				*/
		{	MMdec_unknown		},	/* 0x79 'y'				*/
		{	MMdec_unknown		},	/* 0x7A 'z'				*/
		{	MMdec_ren_start		},	/* 0x7B '{'				*/
		{	MMdec_unknown		},	/* 0x7C '|'				*/
		{	MMdec_ren_end		},	/* 0x7D '}'				*/
		{	MMdec_unknown		},	/* 0x7E '~'				*/
		{	MMdec_unknown		},	/* 0x7F 'dl'			*/
	};

	if ( part == NULL )
		return (ERR);	/* out of memory */
	while ( (ch = ((*s)&0xFF)) != '\0' )
	{
#ifdef	_DEBUG
		HE_printf(sqr,_HE_MSG_DE4, "--- MML decode charactor '%c' (sqr:$%08X)", ch, sqr );
#endif
		sqr->errPoint = s;
		if ( isalpha(ch) )
		{	/* ץޥ֥MML ޥ	*/
			int		cmd;

			if ( (cmd = part->mmlCmd[ tolower(ch) - 'a' ]) < 0 )
				goto _CMD;
			if ( MMdec_jump( sqr, part, &s, cmd) )
				return (ERR);
		} else if ( ch <= 0x20 )
		{	/* skip */
			++s;
		} else if ( ch > 0x7F )
		{
			return MMdec_unknown(sqr,part,&s);
		} else
		{
_CMD:		if ( (cmdtbl[ch - 0x20].func)(sqr,part,&s) )
				return (ERR);
		}
	}
	return (NORMAL);
}

int _FAST	MMdec_unknown( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MM_setErrMsg( sqr, _msg_mmdec_Unknown_command_charactor[TypMsg], (*(*s))&0xFF );
	return (ERR);
}

static int _FAST	MMdec_octave_inc( MMSQR_T *sqr, MMPART_T *part, CONST char **s )
{
	MMVALUE_T	val;

	++(*s);	/* skip '>' */
	val = part->set.octave;
	MM_setValue( &val, _MMVAL_RELATIVE,  1 );
	return	mmpart_set_octave( part, &val );
}

static int _FAST	MMdec_octave_dec( MMSQR_T *sqr, MMPART_T *part, CONST char **s )
{
	MMVALUE_T	val;

	++(*s);	/* skip '>' */
	val = part->set.octave;
	MM_setValue( &val, _MMVAL_RELATIVE,  -1 );
	return	mmpart_set_octave( part, &val );
}
