/*************************************************************************
*	MIDIեɤ߹
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"mmfile.h"
#include	"mml.h"
#include	"mmimport.h"
#include	"mmlib.h"
#include	"mmtrk.h"
#include	"mmctrl.h"
#include	"mmsg.h"
#include	"msgdat.h"
#include	"smfmet.h"
#include	"search.h"

/*#define	_DEBUG*/
#ifdef	_DEBUG
#	define	DPUTF(_msg)	HE_printf _msg
#else
#	define	DPUTF(_msg)
#endif

typedef struct
{
	int			inpTrack;
	int			inpCh;

	char		inpExcl;
	char		inpTempo;
	char		inpMeta;

	char		inpNote;
	char		inpProg;
	char		inpPitch;
	char		inpPaf;
	char		inpCaf;
	char		inpCc[128];
} MMINPORT_PARA;

static int _FAST	MMtrk_includeFile( MMSQR_T *sqr, MMTRK_T *trk, const char *fn ,MMINPORT_PARA *para);

/*************************************************************************
*	.import	<track no.>	fn:<filename> inpTrack:<no> inpCh:<midi ch>
*					inpExcl:on|off inpMeta:on|off
*************************************************************************/

int _FAST	MMctr_import( MMSQR_T *sqr, CONST char *s )
{
	MMTRK_T		   *trk;
	char			argc;
	char		  **argv;
	const char	   *fn = NULL;
	MMINPORT_PARA	para;

#ifdef	_DEBUG
	HE_printf(sqr,_HE_MSG_DE2,"--- MMctrl_import(\x22%s\x22)", s);
#endif

	if ( (trk = MMtrk_gettrk3( sqr, &s)) == NULL )
		return (-1);
	if ( (argc = FS_argSet( s, &argv)) < 1 )
		goto _ERR;

	{
		int			n, sw;

		if ( trk->trkNo > 0 )
		{
			para.inpTrack = -1;
			sw = 1;
		} else
		{	/* ȥå	*/
			para.inpTrack = 0;
			sw = 0;
		}
		para.inpCh    = -1;
		para.inpExcl  = sw;
		para.inpTempo = sw;
		para.inpMeta  = sw;
		para.inpNote  = sw;
		para.inpProg  = sw;
		para.inpPitch = sw;
		para.inpPaf   = sw;
		para.inpCaf   = sw;
		para.inpCaf   = sw;
		for ( n = 0; n < 128; ++n )
			para.inpCc[n] = sw;
	}
	{
		int			n;

		for ( n = 0; n < argc; ++n )
		{
			const char	   *p;

			p = argv[n];
			if ( mm_strncmpi(p, "inpCC",5) == 0 )
			{
				int			ac, cc, sw;
				char		**av;

				p += 5;
				if ( *p == '(' )
				{
					if ( (ac = mm_get_arg( &p, &av)) <= 0 )
						goto _ERR;
				} else
					ac = 0;
				if ( *p != ':' )
					goto _ERR;
				++p;

				if ( (sw = mm_chkOnOff(p)) < 0 )
					goto _ERR;
				if ( ac > 0 )
				{
					int		an;

					for ( an = 0; an < ac; ++an )
					{
						if ( isdigit(av[an][0]) )
						{
							cc = atoi( av[an] );
							if ( cc < 0 || cc > 127 )
								goto _ERR;
							para.inpCc[cc] = sw;
						} else
							goto _ERR;
					}
					mm_clear_arg( ac, av);
				} else
				{
					for ( cc = 0; cc < 128; ++cc )
						para.inpCc[cc] = sw;
				}
			} else
			{
				enum _type_enum
				{
					_TYPE_FN      ,
					_TYPE_INPTRACK,
					_TYPE_INPCH   ,
					_TYPE_INPEXCL ,
					_TYPE_INPTEMPO,
					_TYPE_INPMETA ,
					_TYPE_INPNOTE ,
					_TYPE_INPPROG ,
					_TYPE_INPPITCH,
					_TYPE_INPPAF  ,
					_TYPE_INPCAF  ,
				/*	_TYPE_INPCC   , */
				};
				static SEA_NO tbl[] =
				{
					{ "fn"      , _TYPE_FN       },
					{ "inpCaf"  , _TYPE_INPCAF   },
				/*	{ "inpCC"   , _TYPE_INPCC    }, */
					{ "inpCh"   , _TYPE_INPCH    },
					{ "inpExcl" , _TYPE_INPEXCL  },
					{ "inpMeta" , _TYPE_INPMETA  },
					{ "inpNote" , _TYPE_INPNOTE  },
					{ "inpPaf"  , _TYPE_INPPAF   },
					{ "inpPitch", _TYPE_INPPITCH },
					{ "inpProg" , _TYPE_INPPROG  },
					{ "inpTempo", _TYPE_INPTEMPO },
					{ "inpTrack", _TYPE_INPTRACK },
				};
				char		name[32];
				char	   *swptr;

				swptr = NULL;
				if ( (mm_getname( name, sizeof(name) - 1, &p)) < 0 )
					goto _ERR;
				if ( *p != ':' )
					goto _ERR;
				++p;
				switch ( sea_getno(name,tbl,sizeof(tbl)/sizeof(*tbl)) )
				{
					case _TYPE_FN:
						fn = p;
						break;

					case _TYPE_INPTRACK:
					{
						MMV_T		track;

						if ( mm_strcmpi(p,"all") == 0 )
							para.inpTrack = -1;
						else if ( mm_getdigit( &track, &p ) == 0 && track >= 0 )
							para.inpTrack = track;
						else
							goto _ERR;
						break;
					}

					case _TYPE_INPCH:
					{
						MMV_T		ch;

						if ( mm_strcmpi(p,"omni") == 0 )
							para.inpCh = -1;
						else if ( mm_getdigit( &ch, &p ) == 0 && ch >= 1 && ch <= 16 )
							para.inpCh = ch - 1;
						else
							goto _ERR;
					}
					case _TYPE_INPEXCL :	swptr = &para.inpExcl ; goto _GET_SW;
					case _TYPE_INPTEMPO:	swptr = &para.inpTempo; goto _GET_SW;
					case _TYPE_INPMETA :	swptr = &para.inpMeta ; goto _GET_SW;
					case _TYPE_INPNOTE :	swptr = &para.inpNote ; goto _GET_SW;
					case _TYPE_INPPROG :	swptr = &para.inpProg ; goto _GET_SW;
					case _TYPE_INPPITCH:	swptr = &para.inpPitch; goto _GET_SW;
					case _TYPE_INPPAF  :	swptr = &para.inpPaf  ; goto _GET_SW;
					case _TYPE_INPCAF  :	swptr = &para.inpCaf  ; goto _GET_SW;
					{
						int		sw;
			_GET_SW:
						if ( (sw = mm_chkOnOff(p)) < 0 )
							goto _ERR;
						*swptr = sw;
						break;
					}
					default:
						goto _ERR;
				} /* end of switch() */
			}
		} /* end of for(;;) */
	}
	if ( fn == NULL || *fn == '\0' )
		goto _ERR;

	if ( MMtrk_includeFile( sqr, trk, fn, &para) )
		return (-1);

	FS_argClear(argc,argv);
	return (0);

_ERR:
	sqr->errMsg = "Track data import error!";
	return (-1);
}


static int _FAST	MMtrk_includeFile( MMSQR_T *sqr, MMTRK_T *trk, const char *fn ,MMINPORT_PARA *para)
{
	FILE	   *fp = NULL;
	int			retcode;
#define	term(_ret)	{ retcode = (_ret); goto _TERM;}
	struct
	{
		unsigned			format;
		unsigned			trackNum;
		unsigned			division;
	} inp;

	DPUTF((sqr,_HE_MSG_DE3,"MMtrk_includeFile(%s)",fn));
	DPUTF((sqr,_HE_MSG_DE4,"    sqr->inc[0].fn = %s", sqr->inc[0].fn));
	if ( (fp = MM_fopen(sqr, fn, FOPEN_READ_BIN)) == NULL )
	{
		MM_setErrMsg( sqr, "Track data import file error! (%s)", fn);
		return (-1);
	}

	/* SMF header check */
	{
		{
			static const char	SMF_HEADER[4] = {'M','T','h','d'};
			int					len = 0;

			while ( len < sizeof(SMF_HEADER) )
			{
				register int		ch;

				if ( (ch = fgetc(fp)) == EOF )
					term(-1);
				if ( ch == SMF_HEADER[len] )
					++len;
				else
					len = 0;
			}
		}
		{
			unsigned char	tmp[8];
			unsigned int	size;

			if ( fread( tmp, 4, 1, fp ) ==  0 )
				term(-1);
			size = (tmp[0]<<24) | (tmp[1]<<16) | (tmp[2]<<8) | (tmp[3]);
			if ( size < 6 )
				term(-1);
			if ( fread( tmp, 6, 1, fp ) == 0 )
				term(-1);
			while ( size-- > 6 )	/* skip data */
			{
				if ( fgetc(fp) == EOF )
					term(-1);
			}
			inp.format   = (tmp[0]<<8) | tmp[1];
			inp.trackNum = (tmp[2]<<8) | tmp[3];
			inp.division = (tmp[4]<<8) | tmp[5];
			DPUTF((sqr,_HE_MSG_DE4, "    format   %d",inp.format  ));
			DPUTF((sqr,_HE_MSG_DE4, "    trackNum %d",inp.trackNum));
			DPUTF((sqr,_HE_MSG_DE4, "    division %d",inp.division));
		}
		if ( inp.format != 0 && inp.format != 1 )
			term(-1);
	}

	{
		unsigned		trackNo;

		for ( trackNo = 0; trackNo < inp.trackNum; ++trackNo )
		{
			unsigned int	trackSize;
			unsigned		total_clock;
			unsigned		last_stt;

#define	CHK_INPTRACK(_trkno)	(para->inpTrack < 0 || (inp.format == 1 && para->inpTrack == (int)(_trkno)))
#define	CHK_INPCH(_ch)			(para->inpCh < 0 || (_ch) == para->inpCh)
#define	CHK_INPEXCL()			(para->inpExcl)
#define	CHK_INPTEMPO()			(para->inpTempo)
#define	CHK_INPMETA()			(para->inpMeta)
#define	CHK_INPNOTE()			(para->inpNote)
#define	CHK_INPPROG()			(para->inpProg)
#define	CHK_INPPITCH()			(para->inpPitch)
#define	CHK_INPPAF()			(para->inpPaf)
#define	CHK_INPCAF()			(para->inpCaf)
#define	CHK_INPCC(_cc)			(para->inpCc[(_cc)])

			DPUTF((sqr,_HE_MSG_DE3,"Track (%2d)",trackNo));
			/* ȥåإåβ	*/
			{
				static const char	SMF_TRACK[4] = {'M','T','r','k'};
				register int		len = 0;

				while ( len < sizeof(SMF_TRACK) )
				{
					register int		ch;

					if ( (ch = fgetc(fp)) == EOF )
						term(-1);
					if ( ch == SMF_TRACK[len] )
						++len;
					else
						len = 0;
				}
			}
			{
				unsigned char	tmp[4];

				if ( fread( tmp, 4, 1, fp ) ==  0 )
					term(-1);
				trackSize = (tmp[0]<<24) | (tmp[1]<<16) | (tmp[2]<<8) | (tmp[3]);
				DPUTF((sqr,_HE_MSG_DE3,"    size %u", trackSize));
			}

			if ( !CHK_INPTRACK(trackNo) )
			{	/* skip track */
				fseek(fp,(long)trackSize,SEEK_CUR);
				goto _NEXT_TRACK;
			}

#define	GETTRKBYTE(_val)					\
{	register int		_ch;				\
	if ( trackSize-- == 0 )					\
		term(-1);							\
	if ( (_ch = fgetc(fp)) == EOF )			\
		term(-1);							\
	_val = _ch;								\
}

#define	GETTRKVAL(_val)						\
{	register unsigned	_n;					\
	register int		_ch;				\
	_n = 0;									\
	do										\
	{										\
		if ( trackSize-- == 0 )				\
			term(-1);						\
		if ( (_ch = fgetc(fp)) == EOF )		\
			term(-1);						\
		_n <<= 7;							\
		_n += (_ch & 0x7F);					\
	} while ( _ch & 0x80 );					\
	_val = _n;								\
}

			/* եǡɤ߹	*/
			total_clock = 0;
			last_stt    = 0;
			while ( trackSize > 0 )
			{
				MMCLK_T			track_clock;

				/* get delta time */
				{
					unsigned		delta_time;

					GETTRKVAL(delta_time);
					total_clock += delta_time;
					track_clock = trk->clk + total_clock * sqr->division / inp.division;
				}
				{
					int				delay;

					delay = mmtrk_get_delay(trk);
					if ( (long)track_clock + delay < 0 )
						track_clock = 0;
					else
						track_clock += delay;
				}

				{
					unsigned	stt;

					GETTRKBYTE(stt);
					if ( stt < 0xF0 )
					{	/* ͥå	*/
						int			ch;

						if ( stt < 0x80 )
						{	/* ơХ	*/
							ungetc( stt, fp);
							++trackSize;
							stt = last_stt;
						}
						ch = stt & 0x0F;
						switch ( stt & 0xF0 )
						{
							case 0x80:	/* note off */
							case 0x90:	/* note on  */
							{
								unsigned char	note, velo;

								GETTRKBYTE(note);
								GETTRKBYTE(velo);
								if ( CHK_INPCH(ch) && CHK_INPNOTE())
								{
									if ( (stt & 0xF0) == 0x90 && velo > 0 )
										mmtrk_set_noteon(  trk, track_clock, ch, note, velo);
									else
										mmtrk_set_noteoff( trk, track_clock, ch, note, velo);
								}
								break;
							}
							case 0xA0:	/* PAF      */
							{
								unsigned char	note, pres;

								GETTRKBYTE(note);
								GETTRKBYTE(pres);
								if ( CHK_INPCH(ch) && CHK_INPPAF() )
									mmtrk_set_paf( trk, track_clock, ch, note, pres);
								break;
							}
							case 0xB0:	/* CC       */
							{
								unsigned char	cc, cv;

								GETTRKBYTE(cc);
								GETTRKBYTE(cv);
								if ( CHK_INPCH(ch) && CHK_INPCC(cc) )
									mmtrk_set_cc( trk, track_clock, ch, cc, cv);
								break;
							}
							case 0xC0:	/* PC       */
							{
								unsigned char	prog;

								GETTRKBYTE(prog);
								if ( CHK_INPCH(ch) && CHK_INPPROG() )
									mmtrk_set_prog( trk, track_clock, ch, prog);
								break;
							}
							case 0xD0:	/* CAF      */
							{
								unsigned char	pres;

								GETTRKBYTE(pres);
								if ( CHK_INPCH(ch) && CHK_INPCAF() )
									mmtrk_set_caf( trk, track_clock, ch, pres);
								break;
							}
							case 0xE0:	/* PB        */
							{
								unsigned		p1, p2;

								GETTRKBYTE(p1);
								GETTRKBYTE(p2);
								if ( CHK_INPCH(ch) && CHK_INPPITCH() )
									mmtrk_set_pitch( trk, track_clock, ch, (p1<<7) + p2);
								break;
							}
							default:
								stt = 0;
								break;
						}
						if ( stt >= 0x80 )
							last_stt = stt;
					} else
					{
						switch ( stt )
						{
							case 0xFF:	/* meta event */
							{
								unsigned			type, size;
								unsigned char	   *buf;

								GETTRKBYTE(type);
								GETTRKVAL(size);
								DPUTF((sqr,_HE_MSG_DE4,"    meta event type:%2X size:%u",type, size));
								if ( size > trackSize )
									term(-1);
								if ( (buf = malloc(size + 1)) == NULL )
									term(-1);
								if ( size > 0 )
								{
									if ( fread( buf, size, 1, fp ) == 0 )
										term(-1);
									trackSize -= size;
								}
								switch ( type )
								{
									case SMF_MET_ENDOFTRK:
										goto _NEXT_TRACK;

									case SMF_MET_TEMPO:
										if ( trackNo == 0 && trk->trkNo == 0 && CHK_INPTEMPO() )
										{
											unsigned long	tempo;

											tempo = (buf[0]<<16) | (buf[1]<<8) | buf[2];
											mmtrk_set_tempo( trk, track_clock, tempo);
										}
										break;
									case SMF_MET_SIGNATURE:
										/* skip */
										break;

									default:
										if ( CHK_INPMETA() )
											mmtrk_set_meta( trk, track_clock, type, size, (char *)buf);
										break;
								}
								free(buf);
								break;
							}

							case 0xF0:	/* exclusive message */
							case 0xF7:
							{
								unsigned		size;
								unsigned char  *buf;

								GETTRKVAL(size);
								if ( size > trackSize )
									term(-1);
								if ( (buf = malloc(size + 1)) == NULL )
									term(-1);
								if ( fread( buf, size, 1, fp ) == 0 )
									term(-1);
								trackSize -= size;
								if ( stt == 0xF0 )
								{
									if ( CHK_INPEXCL() )
										mmtrk_set_excl( trk, track_clock, size, buf);
								}
								free(buf);
								break;
							}
						} /* end of switch() */
					}
				}
			} /* end of while () */
_NEXT_TRACK:
			;
		} /* end of for(;;) */
	}
	retcode = 0;

_TERM:
	if ( fp != NULL )
		SP_FCLOSE(fp);
	if ( retcode < 0 )
		sqr->errMsg = "Track data import error!";
	return (retcode);
#undef	term
}
