#ifndef	_MML_H
#define	_MML_H

#include	<stdio.h>

#ifndef	__DEFS_H
#	include	"_defs.h"
#endif

#if	!defined(_MAX_PATH)
#	define	_MAX_PATH	(256)
#endif

#if	defined(WIN32)
#	pragma	pack(push,4)
#endif

struct _mmsqr_t;
struct _mmtrk_t;
struct _mmpart_t;

/*--------------------------------------------------------------------*/
#ifndef	ULONG
#	define	ULONG	unsigned long int
#endif

/*	Macro	------------------------------------------------------------*/

typedef struct _mmac_t
{
	struct _mmac_t	   *next;
	int					att;
	char			   *name;
	size_t				len;
	char			   *str;
	int				  (*func)();	/* ؿΥݥ	*/
} MMAC_T;

#define	_MMAC_HASH_MAX	(256)
#define	MMTABLE_MAX		(512)

#define	MMAC_ATT_NORMAL		(0)
#define	MMAC_ATT_INP		(1)		/* ¢Ȥ߹	*/
#define	MMAC_ATT_TABLE		(2)		/* ơ֥		*/
#define	MMAC_ATT_FUNC		(3)		/* ¢ؿ		*/
#define	MMAC_ATT_EXT		(4)		/* CCI ؿ		*/

/*	pre-processor	----------------------------------------------------*/
#define	_MMINC_MAX	(16)
#define	_MMNEST_MAX	(32)

typedef	struct
{
	FILE	   *fp;		/* եݥ	*/
	char		fn[256];
	size_t		ln;			/* ֹ	*/
	int			cNestMax;	/* if  else  endif Υͥȥ٥	*/
	int			cLevel;		/* if  else  endif θߥ٥	*/
	int			cFlag[_MMNEST_MAX];
} MMINC_T;

/*	types	------------------------------------------------------------*/

typedef unsigned long		MMCLK_T;	/* å¤	*/
typedef long				MMV_T;

#if	defined(WIN32)
#	pragma	pack(push,2)
#endif
typedef	struct			/* ƥå׹¤	*/
{
	USHORT				beat;
	USHORT				step;
} MMSTEP_T;
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

#define	_MMVAL_ABS		(1)		/* 	*/
#define	_MMVAL_RELATIVE	(2)		/* 		*/
#define	_MMVAL_RATIO	(4)		/* ѲΨ	*/
#define	_MMVAL_RANDOM	(8)		/* 	*/

#define	_MMVAL_RATIO_BASE	(1024)

typedef	struct
{
	int			mode;
	MMV_T		value;
	MMV_T		rnd_min, rnd_max;
} MMVALUE_T;

#define	MMSET_ABS(     _ptr,_val)	{(_ptr)->mode = _MMVAL_ABS     ;(_ptr)->value    = (_val);}
#define	MMSET_RELATIVE(_ptr,_val)	{(_ptr)->mode = _MMVAL_RELATIVE;(_ptr)->relative = (_val);}
#define	MMSET_RATIO(   _ptr,_val)	{(_ptr)->mode = _MMVAL_RATIO   ;(_ptr)->ratio    = (_val);}
#define	MMSET_RANDOM(_ptr,_min,_max)	{(_ptr)->mode = _MMVAL_RANDOM;(_ptr)->rnd_min = (_min);(_ptr)->rnd_max = (_max);}

/*	mml setup	--------------------------------------------------------*/

#define	MMSETYP_TEMPO		(1)
#define	MMSETYP_CH			(2)
#define	MMSETYP_DELAY		(3)
#define	MMSETYP_KEYSHIFT	(11)
#define	MMSETYP_OCTAVE		(12)
#define	MMSETYP_VELOCITY	(13)
#define	MMSETYP_OFFVELOCITY	(14)
#define	MMSETYP_STEPTIME	(15)
#define	MMSETYP_GATERATIO	(16)
#define	MMSETYP_GATETIME	(17)
#define	MMSETYP_PROG		(21)
#define	MMSETYP_PITCH		(22)
#define	MMSETYP_CAF			(23)
#define	MMSETYP_CAFPRES		(24)
#define	MMSETYP_CAFDELAY	(25)
#define	MMSETYP_PAF			(26)
#define	MMSETYP_PAFPRES		(27)
#define	MMSETYP_PAFDELAY	(28)
#define	MMSETYP_CC			(128)

typedef	struct _mmsetv_t
{
	struct _mmsetv_t	*next;
	int					typ;		/* 	*/
	MMVALUE_T			val;
} MMSETV_T;
/* midi ch ͻΤ	*/
/*	prog	1127 			*/
/*	pitch	-81208191	*/

typedef	struct _mmset_t			/* å			*/
{
	struct _mmset_t		*next;
	int					no;		/* ֹ			*/
	MMSETV_T			*v;
} MMSET_T;

typedef	struct	_mmofs_t		/* եå	*/
{
	struct _mmofs_t		*next;
	int					no;		/* ֹ			*/
	MMSETV_T			*v;
} MMOFS_T;

typedef	struct	_mmpin_t		/* ԥ				*/
{
	struct _mmpin_t		*next;
	int					no;		/* ֹ			*/
	int					flag;	/* ԥͭե饰	*/
	MMSETV_T			*v;
} MMPIN_T;

/*	part work	--------------------------------------------------------*/
#define	_MMSET_HASH_MAX	(16)
#define	_MMOFS_HASH_MAX	(16)
#define	_MMPIN_HASH_MAX	(16)

#define	MMGATE_MODE_RATIO	(0)	/* Ψ		*/
#define	MMGATE_MODE_CLOCK	(1)	/* å	*/

#define	MMPRES_MODE_OFF		(0)
#define	MMPRES_MODE_DELAY	(1)	/* ǥ쥤å	*/

typedef	struct	_mmpart_para_t
{
	MMVALUE_T		tempo;			/* ƥ						*/
	MMVALUE_T		octave;			/* 	-19			*/
	MMVALUE_T		delay;			/* ǥ쥤						*/

	MMVALUE_T		keyShift;		/* ե					*/
	MMVALUE_T		vel;			/* ٥ƥ					*/
	MMVALUE_T		offVel;			/* ե٥ƥ				*/
	MMVALUE_T		stepTime;		/* Ĺ							*/
	MMVALUE_T		gateTime;		/* ȥ					*/
	MMVALUE_T		gateRatio;		/* ȥΨ(110010000) */

	MMVALUE_T		prog;			/* ץ	1128			*/
	MMVALUE_T		pitch;			/* ԥå٥(-81928191)	*/
	MMVALUE_T		caf;			/* CAf ץå				*/
	MMVALUE_T		paf;			/* PAf ץå				*/

	MMVALUE_T		cafDelay;		/* CAf ǥ쥤					*/
	MMVALUE_T		pafDelay;		/* PAf ǥ쥤					*/
	MMVALUE_T		ccv[128];		/* ȡХ塼			*/
} MMPART_PARA_T;

typedef struct _mmpart_t			/* ѡ湽¤			*/
{
	struct _mmpart_t	*next;

	struct _mmtrk_t	*trk;			/* ȥå				*/
	int				partNo;			/* ѡֹ				*/
	int				mmlCmd[26];		/* MML ޥ			*/

	int				port;
	int				ch;				/* 0 - 15					*/

	MMCLK_T			clk;			/* å					*/
	int				noteLast;		/* ǸȯΡ		*/
	UCHAR			noteVel[128];	/* Ʋȯ			*/

	int				renFlag;		/* Ϣեե饰				*/
	int				renMax;			/* Ϣս				*/
	int				renNo;			/* Ϣս				*/
	MMCLK_T			renStep;		/* Ϣեƥåץ		*/
	MMCLK_T			renTopClk;		/* Ϣճϥå			*/
	MMCLK_T			renLastClk;		/* Ϣսλå			*/

	int				gateMode;		/* ȥ⡼	*/
	int				cafMode;		/* CAF ⡼				*/
	int				pafMode;		/* PAF ⡼				*/
	MMPART_PARA_T	set;			/* ǡ				*/
	MMPART_PARA_T	ofs;			/* եå				*/

	MMSET_T			*setPtr;
	MMSET_T			*setTbl[_MMPIN_HASH_MAX];

	MMOFS_T			*ofsTbl[_MMOFS_HASH_MAX];
	MMOFS_T			*ofsPtr;

	int				pinNo;			/* ͭԥֹ				*/
	int				pinFlag;		/* ԥͭե饰			*/
	MMPIN_T		   *pinPtr;
	MMPIN_T		   *pinTbl[_MMSET_HASH_MAX];

	int				alShift[7];		/* 'A''G'Ρȥե		*/
} MMPART_T;

/*	pattern	------------------------------------------------------------*/
typedef struct _mmptndat_t
{
	struct _mmptndat_t	*prev;
	struct _mmptndat_t	*next;
	int					no;
	char				ptn[1];
} MMPTNDAT_T;

typedef	struct	_mmptn_t
{
	struct _mmptn_t	*next;
	int				n;			/* ϿƤ	*/
	MMPTNDAT_T		*ptnDat;
	char			name[1];	/* ѥ̾		*/
} MMPTN_T;

#define	_MMPTN_HASH_MAX	(32)


/*	note assign	--------------------------------------------------------*/
typedef struct		/* Ρȥ	*/
{
	struct
	{
		int		vel_flag;
		char	*vel;

		int		pitch_flag;
		SHORT	*pitch;

		int		prog_flag;
		char	*prog;

		int		paf_flag;
		char	*paf;

		int		caf_flag;
		char	*caf;

		struct
		{
			int		cc_flag;
			char	*ccv;
		} cc[128];
	} abs;							/* ͻ	*/

	struct
	{
		int		vel_flag;
		char	*vel;

		int		pitch_flag;
		SHORT	*pitch;				/* 016383 */

		int		paf_flag;
		char	*paf;

		int		caf_flag;
		char	*caf;

		struct
		{
			int		cc_flag;
			char	*ccv;
		} cc[128];
	} off;
} MMNOTEASN_T;

/*	program assign	----------------------------------------------------*/
typedef	struct		/* ץॢ	*/
{
	struct							/* ͻ	*/
	{
		int		vel_flag;
		char	*vel;		/* ٥ƥ			*/

		int		note_flag;
		char	*note;

		int		pitch_flag;
		SHORT	*pitch;			/* 016383 */

		int		paf_flag;
		char	*paf;

		int		caf_flag;
		char	*caf;

		struct
		{
			int		cc_flag;
			char	*ccv;
		} cc[128];
	} abs;

	struct
	{
		int		vel_flag;
		char	*vel;

		int		note_flag;
		char	*note;

		int		pitch_flag;
		SHORT	*pitch;

		int		paf_flag;
		char	*paf;

		int		caf_flag;
		char	*caf;

		struct
		{
			int		cc_flag;
			char	*ccv;
		} cc[128];
	} off;
} MMPROGASN_T;

/*	filter	------------------------------------------------------------*/
#if	defined(WIN32)
#	pragma	pack(push,1)
#endif
typedef	struct							/* 32ӥåȥե륿¤	*/
{
	int			ratio;					/* Ψ				*/
	long		offset;					/* եå		*/
	long		min, max;				/* Ǿ		*/
	char		max_bit;				/* ӥåȿ		*/
	UCHAR		bit;					/* ͭӥåȿ		*/
	UCHAR		att;					/* °				*/
	char		rnd;					/* ե饰	*/
	long		rnd_min, rnd_max;		/* 			*/
} MMFILTER32_T;

typedef	struct							/* 16ӥåȥե륿¤	*/
{
	int			ratio;					/* Ψ				*/
	SHORT		offset;					/* եå		*/
	SHORT		min, max;				/* Ǿ		*/
	char		max_bit;				/* ӥåȿ		*/
	UCHAR		bit;					/* ͭӥåȿ		*/
	UCHAR		att;					/* °				*/
	char		rnd;					/* ե饰	*/
	SHORT		rnd_min, rnd_max;		/* 			*/
} MMFILTER16_T;

typedef	struct							/* 8ӥåȥե륿¤	*/
{
	int			ratio;					/* Ψ				*/
	char		offset;					/* եå		*/
	char		min, max;				/* Ǿ		*/
	char		max_bit;				/* ӥåȿ		*/
	UCHAR		bit;					/* ͭӥåȿ		*/
	UCHAR		att;					/* °				*/
	char		rnd;					/* ե饰	*/
	char		rnd_min, rnd_max;		/* 			*/
} MMFILTER08_T;
#if	defined(WIN32)
#	pragma	pack(pop)
#endif


/*	optimize	--------------------------------------------------------*/
#if	defined(WIN32)
#	pragma	pack(push,1)
#endif
typedef struct		/* ץƥޥå				*/
{
	USHORT			tempo;			/* ƥ					*/
	USHORT			note;			/* 						*/
	USHORT			pitch;			/* ԥå٥				*/
	USHORT			prog;			/* ץ		*/
	USHORT			caf;			/* CAF						*/
	USHORT			paf;			/* PAf						*/
	USHORT			excl;			/* ƥ२롼	*/
	USHORT			cc[128];		/* ȥ		*/
} MMOPT_T;
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

#define	MMOPT_SW_OFF		(0x0000)	/* 							*/
#define	MMOPT_SW_ON			(0x0001)	/* ץƥޥON				*/
#define	MMOPT_FLAG_NOTEON	(0x0010)	/* Ρȥꥢ					*/
#define	MMOPT_FLAG_NOTEOFF	(0x0020)	/* Ρȥꥢ					*/
#define	MMOPT_FLAG_NOTE		(MMOPT_FLAG_NOTEON | MMOPT_FLAG_NOTEOFF)
#define	MMOPT_FLAG_PROG		(0x0040)	/* ץ९ꥢ				*/
#define	MMOPT_FLAG_PITCH	(0x0080)	/* ԥå٥ɥꥢ			*/
#define	MMOPT_FLAG_PAF		(0x0100)	/* PAf							*/
#define	MMOPT_FLAG_CAF		(0x0200)	/* CAf							*/
#define	MMOPT_FLAG_PRES		(MMOPT_FLAG_PAF | MMOPT_FLAG_CAF)
#define	MMOPT_FLAG_CC		(0x0400)	/* ȥ󥸥ꥢ	*/
#define	MMOPT_FLAG_EXCL		(0x1000)	/* ƥ२롼		*/
#define	MMOPT_FLAG_META		(0x2000)	/* ᥿٥					*/
#define	MMOPT_FLAG_TEMPO	(0x4000)	/* ƥ						*/

#define	MMOPT_CLEAR_NOTE	MMOPT_FLAG_NOTE
#define	MMOPT_CLEAR_PROG	MMOPT_FLAG_PROG
#define	MMOPT_CLEAR_PITCH	MMOPT_FLAG_PITCH
#define	MMOPT_CLEAR_PRES	MMOPT_FLAG_PRES
#define	MMOPT_CLEAR_PAF		MMOPT_FLAG_PAF
#define	MMOPT_CLEAR_CAF		MMOPT_FLAG_CAF
#define	MMOPT_CLEAR_CC		MMOPT_FLAG_CC
#define	MMOPT_CLEAR_EXCL	MMOPT_FLAG_EXCL
#define	MMOPT_CLEAR_META	MMOPT_FLAG_META
#define	MMOPT_CLEAR_TEMPO	MMOPT_FLAG_TEMPO

/*	track table	--------------------------------------------------------*/

typedef struct					/* ɸơ֥				*/
{
	UCHAR		ch[16];			/* MIDIͥ			*/
	UCHAR		note[128];		/* ơ֥				*/
	UCHAR		vel[128];		/* ٥ƥơ֥		*/
	UCHAR		prog[128];		/* ץơ֥		*/
	UCHAR		caf[128];		/* CAf ơ֥				*/
	UCHAR		paf[128];		/* PAf ơ֥				*/
	UCHAR		cc[128];		/* ȥơ֥		*/
	char		ccvBase[128];	/* ȥ١		*/
} MMSTDTBL_T;

typedef struct					/* ĥơ֥				*/
{
	USHORT		*pitch;			/* ԥå٥ɥơ֥		*/
	char		*ccv[128];		/* ȥͥơ֥	*/
} MMEXTTBL_T;

/*	track work	--------------------------------------------------------*/
typedef struct _mmdat_t		/* վǼ¤	*/
{
	struct _mmdat_t	*next, *prev;

	MMCLK_T			clk;		/* å		*/
	void			*trk;		/* ȥå	*/
	size_t			siz;		/* ǡ	*/
	UCHAR			dat[1];
} MMDAT_T;

#define	SIZEOF_MMDAT	(sizeof(MMDAT_T) - sizeof(UCHAR))

#define	_MMTRK_NAME_LEN			(64)
#define	_MMTRK_PART_HASH_MAX	(16)

typedef	struct _mmtrk_t				/* ȥå湽¤	*/
{
	struct _mmtrk_t	*next;

	struct _mmsqr_t	*sqr;			/* 󥹾		*/

	int				trkNo;			/* ȥåֹ			*/
	char			name[_MMTRK_NAME_LEN];
									/* ȥå̾			*/

	int			port;
	int			ch;

	int			end_flag;			/* λե饰			*/
	ULONG		tempo;
	MMCLK_T		clk;				/* Ƭå	*/
	MMCLK_T		max_clk;			/* 祯å			*/

	int			delay_flag;			/* ǥ쥤ͭե饰	*/
	MMV_T		delay;				/* ǥ쥤				*/

	int			prog;				/* ץ					*/
	int			pitch;				/* ԥå٥	(016383)		*/
	int			cafPres;			/* CAf ץå㡼				*/
	int			pafPres;			/* CAf ץå㡼				*/
	UCHAR		ccv[128];			/* ȡХ塼(0127)	*/

	MMSTDTBL_T	tbl;				/* ơ֥				*/
	MMEXTTBL_T	extTbl;				/* ơ֥				*/
	MMNOTEASN_T	noteAsn;			/* Ρȥ		*/
	MMPROGASN_T	progAsn;			/* ץॢ	*/

	struct							/* ե륿			*/
	{
		MMFILTER32_T	tempo;		/* msec */
		MMFILTER16_T	delay;
		MMFILTER08_T	note;
		MMFILTER08_T	vel;
		MMFILTER16_T	pitch;
		MMFILTER08_T	prog;
		MMFILTER08_T	caf;
		MMFILTER08_T	paf;
		MMFILTER08_T	ccv[128];
	} filter;

	MMOPT_T		opt;
	MMDAT_T		*datTop;
	MMDAT_T		*datPtr;
	MMDAT_T		*datLast;

	FILE		*fp;				/* եݥ	*/
	char		fn[256];			/* ե̾		*/

	MMPART_T		*partTbl[_MMTRK_PART_HASH_MAX];
} MMTRK_T;


/*	track data work	----------------------------------------------------*/
#define	MMFOPEN_MAX	(8)

typedef struct
{
	int			mode;
	int			pos;
	struct
	{
		unsigned int	count;	/* 󥿡		*/
		MMTRK_T			*trkPtr;
	} fwk[MMFOPEN_MAX];
	char	path[256];			/* ѥѥ		*/
} MMTRKWORK_T;

#define	MMTRKWORK_MODE_MEMORY	(0)
#define	MMTRKWORK_MODE_FILE		(1)

/*	sequence work	----------------------------------------------------*/

#define	_MMSQR_TRK_HASH_MAX		(16)
#define	_MMSQR_TITLE_LEN		(256)
#define	_MMSQR_COPYRIGHT_LEN	(256)

#define	_MM_DEC_BUFSIZ			(16*1024)

#if	defined(WIN32)
#	pragma	pack(push,1)
#endif
typedef struct _mmsqr_t			/* MML 󥹹¤	*/
{
	int			trkNum;
	MMTRK_T		*trkTbl[_MMSQR_TRK_HASH_MAX];
	MMTRK_T		*ctrlTrk;
	int			mmlCmd[26];

	int			end_flag;			/* λե饰			*/
	int			division;
	int			tempoSetFlag;
	ULONG		top_tempo;
	ULONG		tempo;
	int			signSetFlag;
	UCHAR		top_sign[4];
	UCHAR		sign[4];
	MMCLK_T		clk;			/* Ƭå	*/
	MMCLK_T		max_clk;		/* 祯å			*/
	int			meas;			/* 				*/

	MMTRKWORK_T	trkWork;
	char		inpFn[_MAX_PATH];		/* ϥե̾	*/
	char		outFn[_MAX_PATH];		/* ϥե̾	*/
	char		errFn[_MAX_PATH];		/* 顼	*/
	char		infFn[_MAX_PATH];		/* ̾	*/
	FILE		*inpFp;
	FILE		*outFp;
	FILE		*errFp;
	FILE		*infFp;

	int			incLevel;
	MMINC_T		inc[_MMINC_MAX];

	char		linBuf[_MM_DEC_BUFSIZ];
	char		decBuf[_MM_DEC_BUFSIZ];

	MMAC_T		*macTbl[_MMAC_HASH_MAX];
	MMPTN_T		*ptnTbl[_MMPTN_HASH_MAX];

	char		title[_MMSQR_TITLE_LEN];
	char		copyright[_MMSQR_COPYRIGHT_LEN];

	struct		/* 	*/
	{
		char	cns;	/* 󥽡		*/
		char	src;	/* 			*/
		char	mpp;	/* ץץå	*/
		char	dmp;	/* ƥȥ		*/
		char	rem;	/* Ƚ			*/
		char	deb;	/* ǥХå			*/
		char	de2;
		char	de3;
	} output;

	int			msgMode;
	char		errMsgBuf[512];
	CONST char	*errMsg;
	CONST char	*errPoint;

	ULONG		workSize;
} MMSQR_T;
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

/*----------------------------------------------------------------------*/
extern MMSQR_T	MMsqr;

/*----------------------------------------------------------------------*/

#define	MM_DEFAULT_DIVISION	(960)

#define	MMTEMPO_MIN			(16)
#define	MMTEMPO_MAX			(512)

#define	MMOCTAVE_MIN		(-1)
#define	MMOCTAVE_MAX		(9)

#define	_MM_NOTELEN_4(_division)	(_division)
/*----------------------------------------------------------------------*/

#if	defined(WIN32)
#	pragma	pack(pop)
#endif

#endif
