#ifndef	_MMLIB_H
#define	_MMLIB_H

#ifndef	_MML_H
#	include	"mml.h"
#endif

#ifndef	_TIME_H
#	include	<time.h>
#endif

#define	MM_ISSTRTERM(_ch)	((_ch)=='\0'||(_ch)==' '||(_ch)=='\t'||(_ch)=='\n')

extern void		MM_error( MMSQR_T *sqr );
extern void		MM_setErrMsg( MMSQR_T *sqr, CONST char *form, ... );
extern void	   *MM_fopen( MMSQR_T *sqr, CONST char *fn, CONST char *md );

extern int   _FAST	mm_strcmp( CONST char *s1, CONST char *s2 );
extern int   _FAST	mm_strcmpi( CONST char *s1, CONST char *s2 );
extern int   _FAST	mm_strncmpi( CONST char *s1, CONST char *s2, size_t len );
extern MMV_T _FAST	mm_getXdigit( int ch );
extern int   _FAST	mm_getdigit( MMV_T *ans, CONST char **s );
extern int   _FAST	mm_getIntDigit( int *ans, CONST char **s );
extern int   _FAST	mm_getname( char *buf, size_t bufsiz, CONST char **s );
extern MMV_T		MM_setValue( MMVALUE_T *val, int mode, ... );
extern int   _FAST	mm_getValue( MMVALUE_T *val, CONST char **s );
extern int   _FAST	mm_getValue2( MMVALUE_T *val, CONST char **s );
extern int   _FAST	mm_get_arg( CONST char **sp, char **argv[] );
extern void  _FAST	mm_clear_arg(int argc,char **argv);
extern char  * _FAST mm_getTimeStr(time_t tm);
extern int  _FAST	mm_chkOnOff( const char *s );
extern int   _FAST	mm_getport( CONST char **p );
extern int   _FAST	mm_getmidich( CONST char **p );
extern int   _FAST	mm_getnote( CONST char **p );
extern int   _FAST	mm_getnote_range( int *n1, int *n2, CONST char **s );
extern int   _FAST	mm_getprog_range( int *p1, int *p2, CONST char **s );
extern int   _FAST	mm_get_mmlcmd( CONST char **s );
extern void  _FAST	mm_srand( UINT seed );
extern UINT  _FAST	mm_rand(void);

/*----------------------------------------------------------------------*/
#define	MM_READVALUE(_val)	\
	( !((_val)->mode & _MMVAL_RANDOM ) ? ((_val)->value) : \
	MM_setValue(_val,(_val)->mode,(_val)->rnd_min,(_val)->rnd_max ))
#define	MM_READVALUE_MIN(_val)	\
	( !((_val)->mode & _MMVAL_RANDOM ) ? ((_val)->value) : (_val)->rnd_min)
#define	MM_READVALUE_MAX(_val)	\
	( !((_val)->mode & _MMVAL_RANDOM ) ? ((_val)->value) : (_val)->rnd_max)
#define	MM_CHKVALUE(_val,_min,_max)	(	\
	!((_val)->mode & _MMVAL_RANDOM )	\
		? (((_val)->value < (_min) || (_val)->value > (_max)))	\
		: ((_val)->rnd_min < (_min) || (_val)->rnd_max > (_max))	\
)

/*----------------------------------------------------------------------*/
#define	MMFILTER_READ(_filter,_val)	( (_val)							\
	     + ((_val) * (_filter)->ratio / _MMVAL_RATIO_BASE) - (_val)		\
	     + (_filter)->offset											\
	     + ( (_filter)->att && ((_filter)->rnd)							\
	          ? ((_filter)->rnd_min + (mm_rand()						\
	               % ((_filter)->rnd_max - (_filter)->rnd_min + 1)))	\
	          : 0														\
	       )															\
)
/*----------------------------------------------------------------------*/
#define	SKIP_SPACE(_s)	while(isspace(*(_s))) ++(_s)

#endif
