/*************************************************************************
*	ꥹɽ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<ctype.h>
#include	<string.h>

#include	"he386.h"
#include	"mml.h"
#include	"mmlist.h"
#include	"mmtrk.h"
#include	"msgdat.h"
#include	"midicc.h"
#include	"smfmet.h"

static char	*note_name(int note)
{
	static CONST char	tbl[12][4] =
	{
		"C ","C#","D ","D#","E ","F ","F#","G ","G#","A ","A#","B "
	};
	static char	buf[8];

	sprintf( buf, "%s%d", tbl[note%12], note/12 - 1 );
	return (buf);
}

#define	cc_name(_cc)	(MmControlNameTbl[(_cc)])
static CONST char	*MmControlNameTbl[128] =
{		/*          --------------- */
		/* 0x00 */ "Bank select",
		/* 0x01 */ "Moduration",
		/* 0x02 */ "Breath control",
		/* 0x03 */ "",
		/* 0x04 */ "Foot control",
		/* 0x05 */ "Portament time",
		/* 0x06 */ "Data entry",
		/* 0x07 */ "Volume",
		/* 0x08 */ "Blance control",
		/* 0x09 */ "",
		/* 0x0A */ "Panpot",
		/* 0x0B */ "Expression",
		/* 0x0C */ "",
		/* 0x0D */ "",
		/* 0x0E */ "",
		/* 0x0F */ "",
		/* 0x10 */ "General purpose 1",
		/* 0x11 */ "General purpose 2",
		/* 0x12 */ "General purpose 3",
		/* 0x13 */ "General purpose 4",
		/* 0x14 */ "",
		/* 0x15 */ "",
		/* 0x16 */ "",
		/* 0x17 */ "",
		/* 0x18 */ "",
		/* 0x19 */ "",
		/* 0x1A */ "",
		/* 0x1B */ "",
		/* 0x1C */ "",
		/* 0x1D */ "",
		/* 0x1E */ "",
		/* 0x1F */ "",
		/*          --------------- */
		/* 0x20 */ "bank select",
		/* 0x21 */ "moduration",
		/* 0x22 */ "breath control",
		/* 0x23 */ "",
		/* 0x24 */ "foot control",
		/* 0x25 */ "portament time",
		/* 0x26 */ "data entry",
		/* 0x27 */ "volume",
		/* 0x28 */ "balnce control",
		/* 0x29 */ "",
		/* 0x2A */ "panpot",
		/* 0x2B */ "expression",
		/* 0x2C */ "",
		/* 0x2D */ "",
		/* 0x2E */ "",
		/* 0x2F */ "",
		/* 0x30 */ "",
		/* 0x31 */ "",
		/* 0x32 */ "",
		/* 0x33 */ "",
		/* 0x34 */ "",
		/* 0x35 */ "",
		/* 0x36 */ "",
		/* 0x37 */ "",
		/* 0x38 */ "",
		/* 0x39 */ "",
		/* 0x3A */ "",
		/* 0x3B */ "",
		/* 0x3C */ "",
		/* 0x3D */ "",
		/* 0x3E */ "",
		/* 0x3F */ "",
		/*          --------------- */
		/* 0x40 */ "Hold1 (sustain)",
		/* 0x41 */ "Portament",
		/* 0x42 */ "Sostenute",
		/* 0x43 */ "Soft pedal",
		/* 0x44 */ "",
		/* 0x45 */ "Hold2 (freeze)",
		/* 0x46 */ "",
		/* 0x47 */ "",
		/* 0x48 */ "",
		/* 0x49 */ "",
		/* 0x4A */ "",
		/* 0x4B */ "",
		/* 0x4C */ "",
		/* 0x4D */ "",
		/* 0x4E */ "",
		/* 0x4F */ "",
		/* 0x50 */ "General purpose 5",
		/* 0x51 */ "General purpose 6",
		/* 0x52 */ "General purpose 7",
		/* 0x53 */ "General purpose 8",
		/* 0x54 */ "Legato control",
		/* 0x55 */ "",
		/* 0x56 */ "",
		/* 0x57 */ "",
		/* 0x58 */ "",
		/* 0x59 */ "",
		/* 0x5A */ "",
		/* 0x5B */ "Effect depth",
		/* 0x5C */ "Tremolo depth",
		/* 0x5D */ "Chorus depth",
		/* 0x5E */ "Celesta depth",
		/* 0x5F */ "Phaser depth",
		/*          --------------- */
		/* 0x60 */ "Data inc.",
		/* 0x61 */ "Data dec.",
		/* 0x62 */ "NRPN LSB",
		/* 0x63 */ "NRPN MSB",
		/* 0x64 */ "RPN LSB",
		/* 0x65 */ "RPN MSB",
		/* 0x66 */ "",
		/* 0x67 */ "",
		/* 0x68 */ "",
		/* 0x69 */ "",
		/* 0x6A */ "",
		/* 0x6B */ "",
		/* 0x6C */ "",
		/* 0x6D */ "",
		/* 0x6E */ "",
		/* 0x6F */ "",

		/* 0x70 */ "",
		/* 0x71 */ "",
		/* 0x72 */ "",
		/* 0x73 */ "",
		/* 0x74 */ "",
		/* 0x75 */ "",
		/* 0x76 */ "",
		/* 0x77 */ "",
		/* 0x78 */ "",
		/* 0x79 */ "Reset all ctr.",
		/* 0x7A */ "Local control",
		/* 0x7B */ "All note off",
		/* 0x7C */ "Omni mode off",
		/* 0x7D */ "Omni mode on",
		/* 0x7E */ "Mono mode",
		/* 0x7F */ "Poly mode on",
};

static int		trk_print( MMSQR_T *sqr, MMTRK_T *trk )
{
#	define	PUTF	HE_printf(sqr,_HE_MSG_TXT,
#	define	ENDPUTF	)

	if ( sqr->trkWork.mode == MMTRKWORK_MODE_FILE )
	{	/* ե⡼ɡǡɤ߹	*/
		if ( mmtrk_datLoad( trk ) )
			return (ERR);
	}

	HE_printf(sqr,_HE_MSG_TXT,"");
	if ( trk->trkNo == 0 )
	{	/* ƥȥå	*/
		HE_printf(sqr,_HE_MSG_TXT,"    Track ctrl : ch.%02d ", trk->ch + 1);
	} else
	{
		HE_printf(sqr,_HE_MSG_TXT,"    Track %4d : ch.%2d ", trk->trkNo, trk->ch + 1);
	}
	PUTF "    +--------------------------------------------------------------+" ENDPUTF;
	PUTF "    |meas| beat: step|ch| event                                    |" ENDPUTF;
	PUTF "    |----+-----------+--+------------------------------------------|" ENDPUTF;

	{
		MMDAT_T	*dat     = trk->datTop;
		MMDAT_T	*ctrlDat = sqr->ctrlTrk->datTop;
		int		ch;
		int		meas = 1, beat = 1, step = 0;
		int		sign_n = sqr->top_sign[0], sign_d = 1<<sqr->top_sign[1];
		MMCLK_T	meas_clk = 0, meas_dt = 4 * sqr->division * sign_n / sign_d;
		int		guide_flag;

		while ( dat )
		{
			UCHAR	*p;

			guide_flag = FALSE;
			{	/* 	*/

				/* ƥȥåƱå֤ޤǿʤ	*/
				for(;;)
				{
					{
						MMCLK_T	clk, one;

						clk = dat->clk - meas_clk;
						step = clk % sqr->division;
						one = meas_dt / sign_n;
						beat = (clk/one) % (meas_dt/one) + 1;
						for(;;)
						{
							if ( clk >= meas_dt )
							{
								if ( guide_flag == FALSE )
								{
									PUTF "    |----+-----------+--+------------------------------------------|" ENDPUTF;
									guide_flag = TRUE;
								}
								++meas;
								meas_clk += meas_dt;
								clk -= meas_dt;
							} else
								break;
						}
					}
					if ( ctrlDat == NULL )
						break;
					if ( ctrlDat->clk > dat->clk )
						break;
					p = ctrlDat->dat;
					switch ( *p )
					{
						case	0xFF:
						{
							switch( p[1] )
							{
								case	SMF_MET_SIGNATURE:
									meas_clk = ctrlDat->clk;
									sign_n = p[3];
									sign_d = 1<<p[4];
									meas_dt = 4 * sqr->division * sign_n / sign_d;
									break;
							}
						}
					}
					ctrlDat = ctrlDat->next;
				}
			}
			p = dat->dat;
			ch = (*p) & 0x0F;
			switch ( *p )
			{
#ifdef	__HIGHC__
				case	0x80..0x8F:	/* note off */
#else
				case 0x80: case 0x81: case 0x82: case 0x83: case 0x84: case 0x85: case 0x86: case 0x87:
				case 0x88: case 0x89: case 0x8A: case 0x8B: case 0x8C: case 0x8D: case 0x8E: case 0x8F:
#endif
				{
_NOTEOFF:
					PUTF "    |%4d| %4d:%5d|%2d| Note off               %3s (%3d) vel:%3d |",
					    meas, beat, step, ch+1, note_name(p[1]),p[1], p[2] ENDPUTF;
					break;
				}

#ifdef	__HIGHC__
				case	0x90..0x9F:	/* note on */
#else
				case 0x90: case 0x91: case 0x92: case 0x93: case 0x94: case 0x95: case 0x96: case 0x97:
				case 0x98: case 0x99: case 0x9A: case 0x9B: case 0x9C: case 0x9D: case 0x9E: case 0x9F:
#endif
				{
					if ( p[2] == 0 )
						goto _NOTEOFF;
					PUTF "    |%4d| %4d:%5d|%2d| Note on                %3s (%3d) vel:%3d |",
					    meas, beat, step, ch+1, note_name(p[1]),p[1], p[2] ENDPUTF;
					break;
				}

#ifdef	__HIGHC__
				case	0xA0..0xAF:	/* polyphonic after touch */
#else
				case 0xA0: case 0xA1: case 0xA2: case 0xA3: case 0xA4: case 0xA5: case 0xA6: case 0xA7:
				case 0xA8: case 0xA9: case 0xAA: case 0xAB: case 0xAC: case 0xAD: case 0xAE: case 0xAF:
#endif
				{
					PUTF "    |%4d| %4d:%5d|%2d| Polyphonic after touch %3s (%3d) prs:%3d |",
					    meas, beat, step, ch+1, note_name(p[1]),p[1], p[2] ENDPUTF;
					break;
				}

#ifdef	__HIGHC__
				case	0xB0..0xBF:	/* control change */
#else
				case 0xB0: case 0xB1: case 0xB2: case 0xB3: case 0xB4: case 0xB5: case 0xB6: case 0xB7:
				case 0xB8: case 0xB9: case 0xBA: case 0xBB: case 0xBC: case 0xBD: case 0xBE: case 0xBF:
#endif
				{
					PUTF "    |%4d| %4d:%5d|%2d| Control change %3d %-17s %3d |",
					    meas, beat, step, ch+1, p[1], cc_name(p[1]), p[2] ENDPUTF;
					break;
				}

#ifdef	__HIGHC__
				case	0xC0..0xCF:	/* program change */
#else
				case 0xC0: case 0xC1: case 0xC2: case 0xC3: case 0xC4: case 0xC5: case 0xC6: case 0xC7:
				case 0xC8: case 0xC9: case 0xCA: case 0xCB: case 0xCC: case 0xCD: case 0xCE: case 0xCF:
#endif
				{
					PUTF "    |%4d| %4d:%5d|%2d| Program change                       %3d |",
					    meas, beat, step, ch+1, p[1] + 1 ENDPUTF;
					break;
				}

#ifdef	__HIGHC__
				case	0xD0..0xDF:	/* channel after touch */
#else
				case 0xD0: case 0xD1: case 0xD2: case 0xD3: case 0xD4: case 0xD5: case 0xD6: case 0xD7:
				case 0xD8: case 0xD9: case 0xDA: case 0xDB: case 0xDC: case 0xDD: case 0xDE: case 0xDF:
#endif
				{
					PUTF "    |%4d| %4d:%5d|%2d| Channel after touch              prs:%3d |",
					    meas, beat, step, ch+1, p[1] ENDPUTF;
					break;
				}

#ifdef	__HIGHC__
				case	0xE0..0xEF:	/* pitchbend */
#else
				case 0xE0: case 0xE1: case 0xE2: case 0xE3: case 0xE4: case 0xE5: case 0xE6: case 0xE7:
				case 0xE8: case 0xE9: case 0xEA: case 0xEB: case 0xEC: case 0xED: case 0xEE: case 0xEF:
#endif
				{
					int		pitch;
					pitch = (int)(p[1] + (p[2]<<7)) - 8192;

					PUTF "    |%4d| %4d:%5d|%2d| Pitchbend                          %5d |",
					    meas, beat, step, ch+1, pitch ENDPUTF;
					break;
				}
				case	0xF0:	/* system exclusive message */
				{
					int		i, c, n, siz;

					PUTF "    |%4d| %4d:%5d|--| System exclusive message                 |",
					    meas, beat, step ENDPUTF;
					siz = dat->siz - 2;
					c = 0;
					n = (siz + 7) / 8;
					while ( n-- > 0 )
					{
						char	d[8][8];

						d[0][0] = d[1][0] = d[2][0] = d[3][0] =
						d[4][0] = d[5][0] = d[6][0] = d[7][0] = '\0';
						for ( i = 0; i < 8; ++i )
						{	if ( c++ >= siz )
								break;
							sprintf( d[i], "%02X", p[c] );
						}
						PUTF "    |    |     :     |  |                  %2s %2s %2s %2s %2s %2s %2s %2s |",
						    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7] ENDPUTF;
						
					}
					break;
				}
				case	0xFF:
				{
					switch( p[1] )
					{
						case SMF_MET_TEXT:
						{
							char	tmp[32];
							size_t	len;

							len = dat->siz - 2;
							if ( len > 27 )
								len = 27;
							strncpy( tmp, (CONST char *)(&p[2]), len );
							tmp[len] = '\0';
							PUTF "    |%4d| %4d:%5d|--| Text event : %-27s |",
							    meas, beat, step, tmp ENDPUTF;
							break;
						}
						case SMF_MET_INSTNAME:
						{
							char	tmp[32];
							size_t	len;

							len = dat->siz - 2;
							if ( len > 22 )
								len = 22;
							strncpy( tmp, (CONST char *)(&p[2]), len );
							tmp[len] = '\0';
							PUTF "    |%4d| %4d:%5d|--| Insturment name : %-22s |",
							    meas, beat, step, tmp ENDPUTF;
							break;
						}

						case	SMF_MET_ENDOFTRK:	/* end of track */
						{
							PUTF "    |%4d| %4d:%5d|--| End of track                             |",
							    meas, beat, step ENDPUTF;
							break;
						}
						case	SMF_MET_TEMPO:	/* tempo */
						{
							int		tempo;
							long	msec;

							msec = p[3]*65536l + p[4]*256l + p[5];
							tempo = 60000000l / msec;
							PUTF "    |%4d| %4d:%5d|--| Tempo                (%8ld msec) %3d |",
							    meas, beat, step, msec, tempo ENDPUTF;
							break;
						}
						case	SMF_MET_SIGNATURE:	/* signature */
						{
							PUTF "    |%4d| %4d:%5d|--| Signature                          %2d/%-2d |",
							    meas, beat, step, p[3], 1<<p[4] ENDPUTF;
							break;
						}
						case	0xFF:
						{
							switch ( p[2] )
							{
								case	MMTRK_MARK_OPT_CLEAR:
								{
									PUTF "    |%4d| %4d:%5d|--| Optimize buffer all clear                |",
									    meas, beat, step ENDPUTF;
									break;
								}
							}
							break;
						}
					}
					break;
				}
			}
			dat = dat->next;
		}
	}
	PUTF "    +--------------------------------------------------------------+" ENDPUTF;

	if ( sqr->trkWork.mode == MMTRKWORK_MODE_FILE )
	{	/* ե⡼ɡǡ¸	*/
		MMDAT_T	*dat = trk->datTop, *next;

		while ( dat )
		{
			next = dat->next;
			sqr->workSize -= (sizeof(MMDAT_T) + dat->siz);
			free( dat );
			dat = next;
		}
		trk->datTop = trk->datPtr = trk->datLast = NULL;
	}

	return (NORMAL);
}

int		MMlist_output( MMSQR_T *sqr )
{
/*	HE_printf(sqr,_HE_MSG_TXT,"Track number %d ", sqr->trkNum );	*/

	{
		int		trkNo = 0, trkNum = sqr->trkNum;

		while ( trkNum-- > 0 )
		{
			int		i;
			MMTRK_T	*dspTrk;

			dspTrk = NULL;
			for ( i = 0; i < _MMSQR_TRK_HASH_MAX; ++i )
			{
				MMTRK_T	*trk;

				trk = sqr->trkTbl[i];
				while ( trk )
				{
					if ( trk->trkNo >= trkNo )
					{
						if ( dspTrk )
						{
							if ( trk->trkNo < dspTrk->trkNo )
								dspTrk = trk;
						} else
							dspTrk = trk;
					}
					trk = trk->next;
				}
			}
			if ( dspTrk )
			{	/* ȥå	*/
				trk_print( sqr, dspTrk );
				trkNo = dspTrk->trkNo + 1;
			}
		}
	}
	HE_puts(sqr,_HE_MSG_TXT,"" );

	return (NORMAL);
}
