/*************************************************************************
*	Ρ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"midicc.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmtrk.h"
#include	"mmpart.h"
#include	"mmpin.h"
#include	"mmdec.h"
#include	"mmsg.h"
#include	"msgdat.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

struct _pincmd_t;
struct _noteopt_t;

static void _FAST	set_pincmd( MMPART_T *part, struct _pincmd_t *pinCmd );
static int  _FAST	set_noteopt( MMSQR_T *sqr, MMPART_T *part, CONST char **s, struct _noteopt_t *noteOpt );
static int  _FAST	getVal2( MMVALUE_T *val, MMVALUE_T *orgVal );

static int _FAST	mmpart_get_steptime(  MMSQR_T *sqr, MMPART_T *part, int omit, CONST char **s )
{
	int		step;

	sqr->errPoint = *s;
	/* Ĺʥƥåץ	*/
	{
		if ( *(*s) == ':' )
		{
			++(*s);	/* å	*/
			if ( mm_getIntDigit( &step, s ) || step < 0 )
			{
_STEP_ERR:
				sqr->errMsg = _msg_mmnote_Steptime_must_be_identifier[TypMsg];
			}
		} else if ( isdigit(*(*s)) )
		{
			if ( mm_getIntDigit( &step, s ) || step < 1 )
				goto _STEP_ERR;
			step = (sqr->division * 4) / step;
		} else
		{	if ( omit )	/* άOk	*/
				step = MM_READVALUE( &(part->set.stepTime) );
			else
				goto _STEP_ERR;
		}
		/* 	*/
		{
			int		st = 0;
			while ( *(*s) )
			{
				if ( *(*s) != '.' )
					break;
				{
					int		m;
					m = step;
					step = step + (step - st)/ 2;
					st = m;
				}
				++(*s);
			}
		}
	}
	return (step);
}

/*************************************************************************
*	ΡȲĹ
*************************************************************************/

int _FAST	MMdec_note_len( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	int		step;

	++(*s);	/* skip 'l'	*/
	SKIP_SPACE(*s);

	if ( (step = mmpart_get_steptime(sqr,part,0,s)) < 0 )
		return (ERR);
	MM_setValue( &(part->set.stepTime), _MMVAL_ABS, step );
	return (NORMAL);
}

#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
struct _pincmd_t
{
	int		tempo_flag   , tempo   , m_tempo;
	int		ch_flag      , ch      , m_ch;
	int		delay_flag   , delay   , m_delay;
	int		key_flag     , key     , m_key;
	int		octave_flag  , octave  , m_octave;
	int		vel_flag     , vel     , m_vel;
	int		off_flag     , off     , m_off;
	int		step_flag    , step    , m_step;
	int		rate_flag    , rate    , m_rate;
	int		gate_flag    , gate    , m_gate;
	int		prog_flag    , prog    , m_prog;
	int		pitch_flag   , pitch   , m_pitch;
	int		cafPres_flag , cafPres , m_cafPres;
	int		cafDelay_flag, cafDelay, m_cafDelay;
	int		pafPres_flag , pafPres , m_pafPres;
	int		pafDelay_flag, pafDelay, m_pafDelay;
	int		cc_flag;
	char	ccv_flag[128];
	UCHAR	  ccv[128];
	UCHAR	m_ccv[128];
};

struct _noteopt_t	/* Ρȥץ	*/
{
	int		caf_pres;
	int		paf_pres;
};
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

static int _FAST	getVal2( MMVALUE_T *val, MMVALUE_T *orgVal )
{
	if ( (val->mode & _MMVAL_RELATIVE) || (val->mode & _MMVAL_RATIO) )
	{
		MMVALUE_T	wk;

		wk = *orgVal;
		if ( val->mode & _MMVAL_RANDOM )
			MM_setValue( &wk, val->mode, val->rnd_min, val->rnd_max );
		else
			MM_setValue( &wk, val->mode, val->value );
		return (MM_READVALUE( &wk ));
	} else
		return ( MM_READVALUE( val ) );
}

static void _FAST	set_pincmd( MMPART_T *part, struct _pincmd_t *pinCmd )
{
	memset( pinCmd, 0, sizeof(struct _pincmd_t));
	if ( part->pinFlag && part->pinPtr )
	{	/* ԥ	*/
		REG MMSETV_T	*v = part->pinPtr->v;

		while ( v )
		{
			switch ( v->typ )
			{
				case MMSETYP_TEMPO:
				{
					pinCmd->tempo_flag = TRUE;
					pinCmd->tempo = MM_READVALUE( &(v->val) );
					pinCmd->m_tempo = MM_READVALUE(&(part->set.tempo)) + MM_READVALUE(&(part->ofs.tempo));
					break;
				}
				case MMSETYP_CH:
				{
					pinCmd->ch_flag = TRUE;
					pinCmd->ch = MM_READVALUE( &(v->val) );
					break;
				}
				case MMSETYP_DELAY:
				{
					pinCmd->delay_flag = TRUE;
					pinCmd->delay = getVal2( &(v->val), &(part->set.delay) );
					break;
				}
				case MMSETYP_KEYSHIFT:
				{
					pinCmd->key_flag = TRUE;
					pinCmd->key = getVal2( &(v->val), &(part->set.keyShift) );
					break;
				}
				case MMSETYP_OCTAVE:
				{
					pinCmd->octave_flag = TRUE;
					pinCmd->octave = getVal2( &(v->val), &(part->set.octave) );
					break;
				}
				case MMSETYP_VELOCITY:
				{
					pinCmd->vel_flag = TRUE;
					pinCmd->vel = getVal2( &(v->val), &(part->set.vel) );
					break;
				}
				case MMSETYP_OFFVELOCITY:
				{
					pinCmd->off_flag = TRUE;
					pinCmd->off = getVal2( &(v->val), &(part->set.offVel) );
					break;
				}
				case MMSETYP_STEPTIME:
				{
					pinCmd->step_flag = TRUE;
					pinCmd->step = getVal2( &(v->val), &(part->set.stepTime) );
					break;
				}
				case MMSETYP_GATERATIO:
				{
					pinCmd->rate_flag = TRUE;
					pinCmd->rate = getVal2( &(v->val), &(part->set.gateRatio) );
					break;
				}
				case MMSETYP_GATETIME:
				{
					pinCmd->gate_flag = TRUE;
					pinCmd->gate = getVal2( &(v->val), &(part->set.gateTime) );
					break;
				}
				case MMSETYP_PROG:
				{
					pinCmd->prog_flag = TRUE;
					pinCmd->prog = getVal2( &(v->val), &(part->set.prog) );
					break;
				}
				case MMSETYP_PITCH:
				{
					pinCmd->pitch_flag = TRUE;
					pinCmd->pitch = getVal2( &(v->val), &(part->set.pitch) );
					pinCmd->m_pitch = MM_READVALUE(&(part->set.pitch)) + MM_READVALUE(&(part->ofs.pitch));
					break;
				}
				case MMSETYP_CAFPRES:
				{
					pinCmd->cafPres_flag = TRUE;
					pinCmd->cafPres = getVal2( &(v->val), &(part->set.caf) );
					break;
				}
				case MMSETYP_CAFDELAY:
				{
					pinCmd->cafDelay_flag = TRUE;
					pinCmd->cafDelay = getVal2( &(v->val), &(part->set.cafDelay) );
					break;
				}
				case MMSETYP_PAFPRES:
				{
					pinCmd->pafPres_flag = TRUE;
					pinCmd->pafPres = getVal2( &(v->val), &(part->set.paf) );
					break;
				}
				case MMSETYP_PAFDELAY:
				{
					pinCmd->pafDelay_flag = TRUE;
					pinCmd->pafDelay = getVal2( &(v->val), &(part->set.pafDelay) );
					break;
				}
#ifdef	__HIGHC__
				case MMSETYP_CC..(MMSETYP_CC+127):
#else
				default:
				if ( v->typ >= MMSETYP_CC && v->typ <= (MMSETYP_CC+127) )
#endif
				{
					REG int		cc;

					cc = v->typ - MMSETYP_CC;
					pinCmd->cc_flag      = TRUE;
					pinCmd->ccv_flag[cc] = TRUE;
					pinCmd->ccv[cc]   = getVal2( &(v->val), &(part->set.ccv[cc]) );
					pinCmd->m_ccv[cc] = (UCHAR)(MM_READVALUE(&(part->set.ccv[cc]))
					                          + MM_READVALUE(&(part->ofs.ccv[cc])));
					break;
				}
			}
			v = v->next;
		}
		part->pinFlag = FALSE;
	}
}

/* NOTE ON ץѥ᡼ơ֥	*/
static CONST struct _cmdtbl_t
{
	int			typ;
	CONST char	*name;
} CmdTbl[] =
{
	{ MMSETYP_CAF,			_MM_CAF_		},
	{ MMSETYP_PAF,			_MM_PAF_		},
};
static int		cmd_name_len = 0;

static int		cmpFunc( const struct _cmdtbl_t *c1, const struct _cmdtbl_t *c2 )
{
	return (mm_strncmpi(c1->name,c2->name,cmd_name_len));
}

static int _FAST	set_noteopt( MMSQR_T *sqr, MMPART_T *part, CONST char **s, struct _noteopt_t *noteOpt )
{
	int		argc;
	char	**argv;

	if ( (argc = mm_get_arg( s, &argv )) < 1 )
	{
OPTION_ERR:
		sqr->errPoint = *s;
		sqr->errMsg   = _msg_mmnote_Note_on_option_error[TypMsg];
		return (ERR);
	}

	{
		int		i;

		for ( i = 0; i < argc; ++i )
		{
			int			typ;
			CONST char	*ap;

			ap = argv[i];
			typ = ERR;
			{
				struct _cmdtbl_t	key;
				struct _cmdtbl_t	*cmd;

				key.typ  = -1;
				key.name = ap;
				cmd_name_len = 0;
				while ( *ap )
				{
					++cmd_name_len;
					if ( *ap == ':' )
						break;
					++ap;
				}
				if ( *ap != ':' )
					goto OPTION_ERR;
				++ap;
				cmd = bsearch( &key, CmdTbl, sizeof(CmdTbl)/sizeof(*CmdTbl),
				  sizeof(*CmdTbl), (int (*)(const void *, const void *))cmpFunc );
				if ( cmd )
					typ = cmd->typ;
			}
			{
				MMVALUE_T		val;

				switch ( typ )
				{
					case MMSETYP_CAF:
						val = part->set.caf;
						if ( mm_getValue( &val, &ap ) )
							goto OPTION_ERR;
						if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
							goto OPTION_ERR;
						else if ( !(val.mode & _MMVAL_RANDOM) )
						{
							if ( val.value < 0 )
								val.value = 0;
							else if ( val.value > 127 )
								val.value = 127;
						}
						noteOpt->caf_pres = MM_READVALUE( &val );
						break;

					case MMSETYP_PAF:
						val = part->set.paf;
						if ( mm_getValue( &val, &ap ) )
							goto OPTION_ERR;
						if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
							goto OPTION_ERR;
						else if ( !(val.mode & _MMVAL_RANDOM) )
						{
							if ( val.value < 0 )
								val.value = 0;
							else if ( val.value > 127 )
								val.value = 127;
						}
						noteOpt->paf_pres = MM_READVALUE( &val );
						break;

					default:
						goto OPTION_ERR;
				} /* end of switch(typ) */
			}
		} /* end for */
	}
	mm_clear_arg(argc,argv);
	return (NORMAL);
}

#ifdef	__HIGHC__
#	pragma	On(Print_reg_vars);
#endif

/*************************************************************************
*	Ρȥ
*************************************************************************/

int _FAST	MMdec_note( MMSQR_T *sqr, MMPART_T *part, REG CONST char **s)
{
	MMTRK_T				*trk = part->trk;
	int					note, vel, offVel;
	int					step, gate;
	int					tie_flag = FALSE;
	struct _pincmd_t	pinCmd;
	struct _noteopt_t	noteOpt;

	noteOpt.caf_pres = -1;
	noteOpt.paf_pres = -1;

	set_pincmd( part, &pinCmd );
	/* 	*/
	{
		int REG	reg_note;

		{
			REG int		note_ch;

			note_ch = tolower( *(*s) );
			++(*s);
			if ( note_ch == 'n' )
			{
				if ( mm_getIntDigit(&note,s) )
				{
_NOTEON_ERR:		sqr->errPoint = *s;
					sqr->errMsg    = "Note-on error!";
					return (ERR);
				}
				reg_note = note;
				if ( reg_note < 0 || reg_note > 127 )
				{
_NOTERANGE_ERR:		sqr->errPoint = *s;
					sqr->errMsg   = _msg_mmnote_Note_range_error[TypMsg];
					return (ERR);
				}
			} else
			{

				if ( note_ch < 'a' || note_ch > 'g' )
					goto _NOTEON_ERR;

				note_ch -= 'a';
				{
					static CONST int	tbl[7] = {9,11,0,2,4,5,7};

					reg_note = tbl[note_ch] + part->alShift[note_ch];
				}
				SKIP_SPACE(*s);
				if ( *(*s) == '+' || *(*s) == '#' )
				{
					++(*s);
					if ( part->alShift[note_ch] < 1 )
						++reg_note;
				} else if ( *(*s) == '-' )
				{
					++(*s);
					if ( part->alShift[note_ch] > -1 )
						--reg_note;
				}

				{	/* ֽ	*/
					REG int		octave;

					if ( pinCmd.octave_flag )
						octave = pinCmd.octave
						       + MM_READVALUE(&(part->ofs.octave));
					else
						octave = MM_READVALUE(&(part->set.octave))
						       + MM_READVALUE(&(part->ofs.octave));
					reg_note += (octave + 1) * 12;
				}
			}
		}

		{
			REG int		key;

			if ( pinCmd.key_flag )
				key = pinCmd.key
				    + MM_READVALUE(&(part->ofs.keyShift));
			else
				key = MM_READVALUE(&(part->set.keyShift))
				    + MM_READVALUE(&(part->ofs.keyShift));
			reg_note += key;
		}
		if ( reg_note < 0 || reg_note > 127 )
			goto _NOTERANGE_ERR;
		note = reg_note;
	}

	SKIP_SPACE(*s);

	/* Ĺʥƥåץ	*/
	{
		REG int		reg_step;

		if ( *(*s) == ':' )
		{	++(*s);
			if ( mm_getIntDigit( &step, s ) )
			{
_NOTEON_STEP_ERR:	sqr->errPoint = *s;
					sqr->errMsg   = _msg_mmnote_Note_steptime_error[TypMsg];
					return (ERR);
			}
			reg_step  = step;
			if ( reg_step < 0 )	goto _NOTEON_STEP_ERR;
		} else if ( isdigit(*(*s)) )
		{	if ( mm_getIntDigit( &step, s ) )
				goto _NOTEON_STEP_ERR;
			reg_step  = step;
			if ( reg_step < 1 )	goto _NOTEON_STEP_ERR;
			reg_step = (sqr->division * 4) / reg_step;
		} else
		{	/* Ĺά	*/
			reg_step = MM_READVALUE( &(part->set.stepTime) );
		}

		SKIP_SPACE(*s);

		/* 	*/
		{
			REG int		st = 0;

			while ( *(*s) )
			{
				if ( *(*s) != '.' )
					break;
				{
					int		m;
					m = reg_step;
					reg_step = reg_step + (reg_step - st)/ 2;
					st = m;
				}
				++(*s);
			}
		}

		if ( part->renFlag )
		{	/* Ϣս	*/
			reg_step = part->renStep;
		} else if ( pinCmd.step_flag )
		{	/* ԥ	*/
			reg_step = pinCmd.step + MM_READVALUE(&(part->ofs.stepTime));
		} else
			reg_step += MM_READVALUE(&(part->ofs.stepTime));
		if ( reg_step < 0 )
			step = 0;
		else
			step = reg_step;
	}

	SKIP_SPACE(*s);

	{
		REG int	reg_gate;

		if ( *(*s) == ',' || *(*s) == '/' )
		{	/* ȥꤢ	*/
			++(*s);
			if ( mm_getIntDigit( &gate, s ) )
			{
_NOTEON_GATE_ERR:	sqr->errPoint = *s;
					sqr->errMsg   = _msg_mmnote_Note_gatetime_error[TypMsg];
					return (ERR);
			}
			reg_gate = gate;
			if ( reg_gate < 0 )
				goto _NOTEON_GATE_ERR;
			if ( **s == '%' )
			{	/* ѡơ	*/
				++(*s);
				reg_gate = step * reg_gate / 100;
			}
		} else
		{	/* ǥեȡȥ	*/
			if ( pinCmd.gate_flag )
			{	/* ԥʥȥ꤬ͥ	*/
				reg_gate = pinCmd.gate;
			} else if ( pinCmd.rate_flag )
			{
				REG int		rate = pinCmd.rate + MM_READVALUE(&(part->ofs.gateRatio));
				if ( rate < 1 )	rate = 1;
				reg_gate = step * rate / 100 - 1;
			} else
			{
				if ( part->gateMode == MMGATE_MODE_RATIO )
				{
					REG int		rate = MM_READVALUE(&(part->set.gateRatio))
					             + MM_READVALUE(&(part->ofs.gateRatio));
					if ( rate < 1 )	rate = 1;
					reg_gate = step * rate / 100 - 1;
				} else
					reg_gate = MM_READVALUE(&(part->set.gateTime));
			}
		}
		/* եåȤϾˤ	*/
		reg_gate += MM_READVALUE(&(part->ofs.gateTime));
		if ( reg_gate < 0 )
			gate = 0;
		else
			gate = reg_gate;
	}

	/* ץѥ᡼	*/
	SKIP_SPACE(*s);

	if ( *(*s) == '(' )
	{
		if ( set_noteopt( sqr, part, s, &noteOpt ) )
			return (ERR);
	}

	/* 	*/
	SKIP_SPACE(*s);
	if ( *(*s) == '&' )
	{	++(*s);
		tie_flag = TRUE;
	}

	/* ٥ƥ	*/
	{
		REG int	reg_vel;

		if ( pinCmd.vel_flag )
			reg_vel = pinCmd.vel;
		else
			reg_vel = MM_READVALUE(&(part->set.vel));
		reg_vel += MM_READVALUE(&(part->ofs.vel));

		if ( reg_vel < 1 )
			vel = 1;
		else if ( reg_vel > 127 )
			vel = 127;
		else
			vel = reg_vel;
	}

	/* ե٥ƥ	*/
	{
		REG int		reg_offVel;
		if ( pinCmd.off_flag )
			reg_offVel = pinCmd.off;
		else
			reg_offVel = MM_READVALUE(&(part->set.offVel));
		reg_offVel += MM_READVALUE(&(part->ofs.offVel));

		if ( reg_offVel < 0 )
			offVel = 0;
		else if ( reg_offVel > 127 )
			offVel = 127;
		else
			offVel = reg_offVel;
	}

	{
		int		clk = mmpart_get_clock(part);
		int		pinReset = FALSE;

		if ( part->noteVel[note] == 0 )
		{	/* ȯ NOTE-ON	*/

			/* Ρȥ	*/
			{
				MMNOTEASN_T	*noteAsn = &(trk->noteAsn);

				if ( noteAsn->abs.vel_flag || noteAsn->off.vel_flag )
				{
					REG int	reg_vel = vel;

					if ( noteAsn->abs.vel_flag
					    && noteAsn->abs.vel
					    && noteAsn->abs.vel[note] >= 0 )
						reg_vel = noteAsn->abs.vel[note];
					if ( noteAsn->off.vel_flag && noteAsn->off.vel )
						reg_vel += noteAsn->off.vel[note];
					if ( reg_vel < 0 )
						vel = 0;
					else if ( reg_vel > 127 )
						vel = 127;
					else
						vel = reg_vel;
				}

				if ( noteAsn->abs.prog_flag
				    && noteAsn->abs.prog
				    && noteAsn->abs.prog[note] >= 0 )
				{
					REG int		prog;
					prog = noteAsn->abs.prog[note];
					mmtrk_set_prog( part->trk, clk, part->ch, prog);
					if ( pinCmd.prog_flag )
						pinCmd.m_prog = prog;
				}

				{
					REG int		cc;

					for ( cc = 0; cc < 128; ++cc )
					{
						if ( noteAsn->abs.cc[cc].cc_flag || noteAsn->off.cc[cc].cc_flag )
						{
							REG int		ccv;
							int			base;

							base = trk->tbl.ccvBase[cc];
							if ( noteAsn->abs.cc[cc].cc_flag
							    && noteAsn->abs.cc[cc].ccv
							    && noteAsn->abs.cc[cc].ccv[note] >= 0 )
								ccv = noteAsn->abs.cc[cc].ccv[note] - base;	/* Change 1996/02/09	*/
							else
								ccv = MM_READVALUE(&(part->set.ccv[cc]));
							if ( noteAsn->off.cc[cc].cc_flag && noteAsn->off.cc[cc].ccv )
								ccv += noteAsn->off.cc[cc].ccv[note];
							if ( ccv < -base )
								ccv = -base;
							else if ( ccv > 127 - base )
								ccv = 127 - base;
							mmtrk_set_cc( part->trk, clk, part->ch, cc, ccv);
							if ( pinCmd.ccv_flag[cc] )
								pinCmd.m_ccv[cc] = ccv;
						}
					}
				}

				if ( noteAsn->abs.pitch_flag || noteAsn->off.pitch_flag )
				{
					REG int		pitch;
					if ( noteAsn->abs.pitch_flag
					    && noteAsn->abs.pitch
					    && noteAsn->abs.pitch[note] >= 0 )
						pitch = noteAsn->abs.pitch[note] - 8192;
					else
						pitch = MM_READVALUE(&(part->set.pitch));
					if ( noteAsn->off.pitch_flag && noteAsn->off.pitch )
						pitch += noteAsn->off.pitch[note];
					if ( pitch < -8192 )
						pitch = -8192;
					else if ( pitch > 8191 )
						pitch = 8191;
					if ( pinCmd.pitch_flag )
						pinCmd.m_pitch = pitch;
					mmtrk_set_pitch( part->trk, clk, part->ch, pitch + 8192);
				}
			} /* end of note assign */

			{	/* ץॢ	*/
				MMPROGASN_T	*progAsn = &(trk->progAsn);
				int			prog;

				prog = MM_READVALUE(&(part->set.prog));

				if ( progAsn->abs.note_flag || progAsn->off.note_flag )
				{
					int		note;

					if ( progAsn->abs.note_flag
					    && progAsn->abs.note
					    && progAsn->abs.note[prog] >= 0)
						note = progAsn->abs.note[prog];
					if ( progAsn->off.note_flag )
						note += progAsn->off.note[prog];
					if ( note < 0 )
						note = 0;
					else if ( note > 127 )
						note = 127;
				}

				if ( progAsn->abs.vel_flag || progAsn->off.vel_flag )
				{
					int		vel;

					if ( progAsn->abs.vel_flag
					    && progAsn->abs.vel
					    && progAsn->abs.vel[prog] >= 0 )
						vel = progAsn->abs.vel[prog];
					if ( progAsn->off.vel_flag )
						vel += progAsn->off.vel[prog];
					if ( vel < 1 )
						vel = 1;
					else if ( vel > 127 )
						vel = 127;
				}

			} /* end of program assign */

			/* Ƽԥ	*/
			if ( pinCmd.tempo_flag )
				mmtrk_set_tempo( part->trk, clk, 60000000l / pinCmd.tempo);
			if ( pinCmd.prog_flag )	/* Append 1996/02/15	*/
				mmtrk_set_prog( part->trk, clk, part->ch, pinCmd.prog);
			if ( pinCmd.pitch_flag )
				mmtrk_set_pitch( part->trk, clk, part->ch, pinCmd.pitch + 8192);
			if ( pinCmd.cc_flag )
			{
				REG MMSETV_T	*v = part->pinPtr->v;
				while ( v )
				{
					if ( v->typ >= MMSETYP_CC && v->typ <= MMSETYP_CC+127 )
					{	int		cc;
						cc = v->typ - MMSETYP_CC;
						mmtrk_set_cc( part->trk, part->ch, clk,
						    cc, pinCmd.ccv[cc] );
					}
					v = v->next;
				}
			}
			pinReset = TRUE;

			/* Ρȥ	*/
			if ( mmtrk_set_noteon(part->trk, clk, part->ch, note, vel) )
				return (ERR);
			part->noteVel[note] = vel;
			part->noteLast      = note;

			/* ͥ롦եå	*/
			{
				MMV_T	dly = 0;

				if ( pinCmd.cafDelay_flag )
					dly = pinCmd.cafDelay;
				else
					dly = MM_READVALUE(&(part->set.cafDelay));
				if ( dly > 0 )
				{
					int		pres = -1;

					if ( pinCmd.cafPres_flag )
					{
						pres = pinCmd.cafPres + MM_READVALUE(&(part->ofs.caf));
						if ( pres < 0 )
							pres = 0;
						else if ( pres > 127 )
							pres = 127;
					} else
					{	pres = MM_READVALUE(&(part->set.caf));
						if ( pres >= 0 )
						{
							pres += MM_READVALUE(&(part->ofs.caf));
							if ( pres < 0 )
								pres = 0;
							else if ( pres > 127 )
								pres = 127;
						}
					}
					if ( pres >= 0 )
					{	/* CAF ON */
						MMCLK_T	pclk;

						pclk = dly + MM_READVALUE(&(part->ofs.cafDelay));
						if ( mmtrk_set_caf(part->trk, pclk, part->ch, pres) )
							return (ERR);
						noteOpt.caf_pres = -1;
					}
				}
			}

			/* ݥե˥åեå	*/
			{
				MMV_T	dly = 0;

				if ( pinCmd.pafDelay_flag )
					dly = pinCmd.pafDelay;
				else
					dly = MM_READVALUE(&(part->set.pafDelay));

				if ( dly > 0 )
				{
					int		pres = -1;

					if ( pinCmd.pafPres_flag )
					{
						pres = pinCmd.pafPres + MM_READVALUE(&(part->ofs.paf));
						if ( pres < 0 )
							pres = 0;
						else if ( pres > 127 )
							pres = 127;
					} else
					{	pres = MM_READVALUE(&(part->set.paf));
						if ( pres >= 0 )
						{
							pres += MM_READVALUE(&(part->ofs.paf));
							if ( pres < 0 )
								pres = 0;
							else if ( pres > 127 )
								pres = 127;
						}
					}
					if ( pres >= 0 )
					{	/* CAF ON */
						MMCLK_T	pclk;

						pclk = dly + MM_READVALUE(&(part->ofs.pafDelay));
						if ( mmtrk_set_paf(part->trk, pclk, part->ch, note, pres) )
							return (ERR);
						noteOpt.paf_pres = -1;
					}
				}
			} /* end of paf */

		}

		if ( noteOpt.caf_pres >= 0 )
		{
			REG int	pres;

			pres = noteOpt.caf_pres + MM_READVALUE(&(part->ofs.caf));
			if ( pres < 0 )
				pres = 0;
			else if ( pres > 127 )
				pres = 127;
			if ( mmtrk_set_caf(part->trk, clk, part->ch, pres) )
				return (ERR);
		}

		if ( noteOpt.paf_pres >= 0 )
		{
			REG int	pres;

			pres = noteOpt.paf_pres + MM_READVALUE(&(part->ofs.paf));
			if ( pres < 0 )
				pres = 0;
			else if ( pres > 127 )
				pres = 127;
			if ( mmtrk_set_paf(part->trk, clk, part->ch, note, pres) )
				return (ERR);
		}

		part->clk += step;

		if ( tie_flag == FALSE )
		{	/* Ρȥ	*/
			if ( mmtrk_set_noteoff(part->trk, clk + gate, part->ch, note, offVel) )
				return (ERR);
			part->noteVel[note] = 0;
		}

		if ( pinReset )
		{
			/* ԥˤäꤵ줿ǡ򸵤᤹	*/

			clk += gate;
			if ( pinCmd.tempo_flag )
				mmtrk_set_tempo( part->trk, clk, 60000000l / pinCmd.m_tempo);
			if ( pinCmd.prog_flag )
				mmtrk_set_prog( part->trk, clk, part->ch, pinCmd.m_prog);
			if ( pinCmd.pitch_flag )	/* Append 1996/02/15	*/
				mmtrk_set_pitch( part->trk, clk, part->ch, pinCmd.m_pitch + 8192);
			if ( pinCmd.cc_flag )
			{
				REG MMSETV_T	*v = part->pinPtr->v;

				while ( v )
				{
					if ( v->typ >= MMSETYP_CC && v->typ <= MMSETYP_CC+127 )
					{	REG int		cc;
						cc = v->typ - MMSETYP_CC;
						mmtrk_set_cc( part->trk, clk,
						    part->ch, cc, pinCmd.m_ccv[cc] );
					}
					v = v->next;
				}
			}
		}
	}
	return (NORMAL);
}

#ifdef	__HIGHC__
#	pragma	Off(Print_reg_vars);
#endif

/*************************************************************************
*	
*************************************************************************/

int _FAST	MMdec_rest( MMSQR_T *sqr, MMPART_T *part, REG CONST char **s)
{
	int		step;

	++(*s);	/* skip 'r' */
	SKIP_SPACE(*s);

	if ( (step = mmpart_get_steptime(sqr,part,1,s)) < 0 )
		return (ERR);

	if ( part->renFlag )
	{	/* Ϣս	*/
		step = part->renStep;
	} else
		step += MM_READVALUE(&(part->ofs.stepTime));
	if ( step < 0 )
		step = 0;
	part->clk += step;

	return (NORMAL);
}

/*************************************************************************
*	Ϣճ
*************************************************************************/

int _FAST	MMdec_ren_start( MMSQR_T *sqr, MMPART_T *part, CONST char **s )
{
	sqr->errPoint = *s;
	++(*s);	/* skip '{' */
	if ( part->renFlag )
	{
_NEST_ERR:
		sqr->errMsg = _msg_mmnote_Nest_error[TypMsg];
		return (ERR);
	}

	{
		int				step, n;
		CONST char		*p;

		p = *s;	/* (*s)'{'μ	*/
		while ( *p )
		{	if ( *p == '{' )
				goto _NEST_ERR;
			else if ( *p == '}' )
				break;
			++p;
		}
		if ( *p != '}' )
		{
			sqr->errMsg = "EOL encountered within '{...}'";
			return (ERR);
		}
		++p;

		/* Ĺʥƥåץ	*/
		if ( (step = mmpart_get_steptime(sqr,part,1,&p)) < 0 )
			return (ERR);

		SKIP_SPACE(p);

		/* ʬ	*/
		if ( *p != '/' )
		{
_SYN_ERR:	sqr->errMsg = _msg_mmnote_Syntax_error[TypMsg];
			return (ERR);
		}
		++p;
		if ( mm_getIntDigit( &n, &p ) || n < 2 )
			goto _SYN_ERR;

		part->renMax     = n;
		part->renNo      = 0;
		part->renStep    = step / n;
		part->renTopClk  = part->clk;
		part->renLastClk = part->clk + step;
		part->renFlag    = TRUE;
	}

	return (NORMAL);
}

/*************************************************************************
*	Ϣսλ
*************************************************************************/

int _FAST	MMdec_ren_end( MMSQR_T *sqr, MMPART_T *part, CONST char **s )
{
	sqr->errPoint = *s;

	++(*s);	/* skip '{' */
	if ( !part->renFlag )
	{
		sqr->errMsg = "Found '}'!";
		return (ERR);
	}

	/* Ĺʥƥåץ	*/
	{
		int		n;

		if ( mmpart_get_steptime(sqr,part,1,s) < 0 )
			return (ERR);

		SKIP_SPACE(*s);
		if ( *(*s) != '/' )
		{
_SYN_ERR:	sqr->errMsg = _msg_mmnote_Syntax_error[TypMsg];
			return (ERR);
		}
		++(*s);
		if ( mm_getIntDigit( &n, s ) || n < 2 )
			goto _SYN_ERR;
		if ( n != part->renMax )
		{
/*_UNEXPECTED_ERR:*/
			sqr->errMsg = "'{...}' unexpected error!";
			return (ERR);
		}
	}
	part->renFlag    = FALSE;
	part->clk = part->renLastClk;

	return (NORMAL);
}
