/*************************************************************************
*	Ρȥ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"midicc.h"
#include	"mml.h"
#include	"mmac.h"
#include	"mmlib.h"
#include	"mmpart.h"
#include	"mmtrk.h"
#include	"msgdat.h"

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

static int		noteasn_set_vel(MMTRK_T *trk, int argc, char **argv);
static int		noteasn_set_pitch(MMTRK_T *trk, int argc, char **argv);
static int		noteasn_set_prog(MMTRK_T *trk, int argc, char **argv);
static int		noteasn_set_cc(MMTRK_T *trk, int argc, char **argv);

/*************************************************************************
*	Ρȥ
*-------------------------------------------------------------------------
*	@NOTEASN(<cmd>,<mode>,<par>)
*		<cmd>	vel
*				pitch
*				cc:<cc>
*				prog
*		<mode>	abs		
*				off		եå
*************************************************************************/

int		MMdec_trkNoteAsn(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
	static struct
	{
		CONST char	*name;
		int			(*func)(MMTRK_T *,int, char **);
	}  tbl[] =
	{
		{ _vel_    , noteasn_set_vel  },
		{ _pitch_  , noteasn_set_pitch},
		{ _prog_   , noteasn_set_prog },
		{ _cc_     , noteasn_set_cc   },
	};
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

	if ( argc < 3 )
	{
/*_NOTEASN_ERR:*/
		sqr->errMsg = "Note assign error!";
		return (ERR);
	}

	{
		int		i;
		char	*cmdname = argv[0];

		for ( i = 0; i < sizeof(tbl)/sizeof(*tbl); ++i )
		{
			int		len;

			len = strlen(tbl[i].name);
			if ( mm_strncmpi( cmdname, tbl[i].name, len) == 0 )
			{
				if ( (tbl[i].func)(trk,argc,argv) )
					return (ERR);
				break;
			}
		}
	}

	return (NORMAL);
}

static int		noteasn_set_vel(MMTRK_T *trk, int argc, char **argv)
{
	MMNOTEASN_T	*noteAsn = &(trk->noteAsn);
	int			i;
	int			mode = (strcmpi(argv[1],_off_) == 0) ? TRUE : FALSE;

	if ( mode )
		noteAsn->off.vel_flag = TRUE;
	else
		noteAsn->abs.vel_flag = TRUE;

	for ( i = 2; i < argc; ++i )
	{
		int			note, n1, n2, val;
		CONST char	*s;

		s = argv[i];
		if ( mm_getnote_range(&n1,&n2,&s) )
		{
			return (ERR);
		}
		if ( *s != ':' )
		{
			return (ERR);
		}
		++s;
		val = atoi(s);
		if ( mode )
		{	/* եå	*/
			if ( val < -127 || val > 127 )
				return (ERR);
			if ( noteAsn->off.vel == NULL )
			{
				REG int		i;
				if ( (noteAsn->off.vel = malloc(sizeof(char) * 128)) == NULL )
				{
					((MMSQR_T *)(trk->sqr))->errMsg = _OUT_OF_MEMORY;
					return (ERR);
				}
				for ( i = 0; i < 128; ++i )
					noteAsn->off.vel[i] = 0;
			}
			for ( note = n1; note <= n2; ++note )
				noteAsn->off.vel[note] = val;
		} else
		{	/* 		*/
			if ( val < 1 || val > 127 )
				return (ERR);
			if ( noteAsn->abs.vel == NULL )
			{
				REG int		i;
				if ( (noteAsn->abs.vel = malloc(sizeof(char) * 128)) == NULL )
				{
					((MMSQR_T *)(trk->sqr))->errMsg = _OUT_OF_MEMORY;
					return (ERR);
				}
				for ( i = 0; i < 128; ++i )
					noteAsn->abs.vel[i] = -1;
			}
			for ( note = n1; note <= n2; ++note )
				noteAsn->abs.vel[note] = val;
		}
	}
	return (NORMAL);
}

static int		noteasn_set_pitch(MMTRK_T *trk, int argc, char **argv)
{
	MMNOTEASN_T	*noteAsn = &(trk->noteAsn);
	int			i;
	int			mode = (strcmpi(argv[1],_off_) == 0) ? TRUE : FALSE;

	if ( mode )
		noteAsn->off.pitch_flag = TRUE;
	else
		noteAsn->abs.pitch_flag = TRUE;

	for ( i = 2; i < argc; ++i )
	{
		int			note, n1, n2, val;
		CONST char	*s;

		s = argv[i];
		if ( mm_getnote_range(&n1,&n2,&s) )
			return (ERR);
		if ( *s != ':' )
			return (ERR);
		++s;
		val = atoi(s);
		if ( mode )
		{	/* եå	*/
			if ( val < -16383 || val > 16383 )
				return (ERR);
			if ( noteAsn->off.pitch == NULL )
			{
				REG int		i;

				if ( (noteAsn->off.pitch = malloc(sizeof(SHORT) * 16384)) == NULL )
				{
					((MMSQR_T *)(trk->sqr))->errMsg = _OUT_OF_MEMORY;
					return (ERR);
				}
				for ( i = 0; i < 16384; ++i )
					noteAsn->off.pitch[i] = 0;
			}
			for ( note = n1; note <= n2; ++note )
				noteAsn->off.pitch[note] = val;
		} else
		{	/* 		*/
			if ( val < -8192 || val > 8191 )
				return (ERR);
			if ( noteAsn->abs.pitch == NULL )
			{
				REG int		i;
				if ( (noteAsn->abs.pitch = malloc(sizeof(SHORT) * 16384)) == NULL )
				{
					((MMSQR_T *)(trk->sqr))->errMsg = _OUT_OF_MEMORY;
					return (ERR);
				}
				for ( i = 0; i < 16384; ++i )
					noteAsn->abs.pitch[i] = -1;
			}
			for ( note = n1; note <= n2; ++note )
				noteAsn->abs.pitch[note] = val + 8192;
		}
	}
	return (NORMAL);
}

static int		noteasn_set_prog(MMTRK_T *trk, int argc, char **argv)
{
	MMNOTEASN_T	*noteAsn = &(trk->noteAsn);
	int			i;
	int			mode = (strcmpi(argv[1],_off_) == 0) ? TRUE : FALSE;

	if ( mode )
	{
		return (ERR);
	} else
		noteAsn->abs.prog_flag = TRUE;

	for ( i = 2; i < argc; ++i )
	{
		int			note, n1, n2, val;
		CONST char	*s;

		s = argv[i];
		if ( mm_getnote_range(&n1,&n2,&s) )
			return (ERR);
		if ( *s != ':' )
			return (ERR);
		++s;
		val = atoi(s) - 1;
		/* 		*/
		if ( val < 0 || val > 127 )
			return (ERR);
		if ( noteAsn->abs.prog == NULL )
		{
			REG int		i;
			if ( (noteAsn->abs.prog = malloc(sizeof(char) * 128)) == NULL )
			{
				((MMSQR_T *)(trk->sqr))->errMsg = _OUT_OF_MEMORY;
				return (ERR);
			}
			for ( i = 0; i < 128; ++i )
				noteAsn->abs.prog[i] = -1;
		}
		for ( note = n1; note <= n2; ++note )
			noteAsn->abs.prog[note] = val;
	}
	return (NORMAL);
}

static int		noteasn_set_cc(MMTRK_T *trk, int argc, char **argv)
{
	MMNOTEASN_T	*noteAsn = &(trk->noteAsn);
	int			i, cc, base;
	int			mode = (strcmpi(argv[1],_off_) == 0) ? TRUE : FALSE;

	{
		CONST char	*s = argv[0] ;

		s += 2;	/* skip 'CC' */
		if ( *s != ':' )
			return (ERR);
		++s;
		if ( mm_getIntDigit( &cc, &s) || cc < 0 || cc > 127 )
			return (ERR);
		base = trk->tbl.ccvBase[cc];
	}

	if ( mode )
		noteAsn->off.cc[cc].cc_flag = TRUE;
	else
		noteAsn->abs.cc[cc].cc_flag = TRUE;

	for ( i = 2; i < argc; ++i )
	{
		int			note, n1, n2, val;
		CONST char	*s;

		s = argv[i];
		if ( mm_getnote_range(&n1,&n2,&s) )
			return (ERR);
		if ( *s != ':' )
			return (ERR);
		++s;
		val = atoi(s);
		if ( mode )
		{	/* եå	*/
			if ( val < -127 || val > 127 )
				return (ERR);
			if ( noteAsn->off.cc[cc].ccv == NULL )
			{
				REG int		i;
				if ( (noteAsn->off.cc[cc].ccv = malloc(sizeof(char) * 128)) == NULL )
				{
					((MMSQR_T *)(trk->sqr))->errMsg = _OUT_OF_MEMORY;
					return (ERR);
				}
				for ( i = 0; i < 128; ++i )
					noteAsn->off.cc[cc].ccv[i] = 0;
			}
			for ( note = n1; note <= n2; ++note )
				noteAsn->off.cc[cc].ccv[note] = val;
		} else
		{	/* 		*/
			if ( val < -base || val > 127 - base )
				return (ERR);
			if ( noteAsn->abs.cc[cc].ccv == NULL )
			{
				REG int		i;
				if ( (noteAsn->abs.cc[cc].ccv = malloc(sizeof(char) * 128)) == NULL )
				{
					((MMSQR_T *)(trk->sqr))->errMsg = _OUT_OF_MEMORY;
					return (ERR);
				}
				for ( i = 0; i < 128; ++i )
					noteAsn->abs.cc[cc].ccv[i] = -1;
			}
			for ( note = n1; note <= n2; ++note )
				noteAsn->abs.cc[cc].ccv[note] = val + base;	/* Change 1996/02/09 */
		}
	}
	return (NORMAL);
}
