/*************************************************************************
*	եå
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"midicc.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmpart.h"
#include	"mmoffset.h"
#include	"mmsg.h"
#include	"msgdat.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

#define	OFS_HASH(_setNo)	((_setNo * 31) & (_MMOFS_HASH_MAX - 1))

/*************************************************************************
*	եåγ
*************************************************************************/

void _FAST	mmofs_allfree( MMPART_T *part )
{
	MMSQR_T		*sqr = ((MMTRK_T *)(part->trk))->sqr;
	int		j;

	for ( j = 0; j < _MMOFS_HASH_MAX; ++j )
	{
		MMOFS_T	*ofs, *ofsNext;

		ofs = part->ofsTbl[j];
		while ( ofs )
		{
			ofsNext = ofs->next;
			{
				MMSETV_T	*pv, *pvNext;

				pv = ofs->v;
				while ( pv )
				{
					pvNext = pv->next;
					free( pv );		sqr->workSize -= sizeof(MMSETV_T);
					pv = pvNext;
				}
			}
			free(ofs);		sqr->workSize -= sizeof(MMOFS_T);
			ofs = ofsNext;
		}
		part->ofsTbl[j] = NULL;
	}
}

/*************************************************************************
*	ԥֹΥԥ֤
*************************************************************************/

static MMOFS_T * _FAST mmofs_getOffset( MMPART_T *part, int ofsNo )
{
	MMOFS_T	*ofs = part->ofsTbl[OFS_HASH(ofsNo)];

	while ( ofs )
	{
		if ( ofs->no == ofsNo )
			break;
		ofs = ofs->next;
	}
	return (ofs);
}

/*************************************************************************
*	ԥѰդ
*************************************************************************/

static MMOFS_T * _FAST mmofs_newOffset( MMPART_T *part, int ofsNo)
{
	MMOFS_T	*ofs = mmofs_getOffset(part,ofsNo);

	if ( ofs == NULL )
	{
		if ( (ofs = calloc(sizeof(MMOFS_T),1)) != NULL )
		{
			MMOFS_T	**ofsPtr = &(part->ofsTbl[OFS_HASH(ofsNo)]);

			((MMSQR_T *)(((MMTRK_T *)(part->trk))->sqr))->workSize += sizeof(MMOFS_T);
			ofs->no   = ofsNo;
			ofs->next = *ofsPtr;
			*ofsPtr   = ofs;
		}
	} else
	{	/* 򥯥ꥢ	*/
		MMSETV_T	*pv, *next;
		MMSQR_T		*sqr = ((MMTRK_T *)(part->trk))->sqr;

		pv = ofs->v;
		while ( pv )
		{
			next = pv->next;
			free( pv );		sqr->workSize -= sizeof(MMSETV_T);
			pv = next;
		}
		ofs->v = NULL;
	}
	return (ofs);
}

/*************************************************************************
*	եåǡɲä
*************************************************************************/

static int _FAST	mmofs_offset( MMOFS_T *ofs, int typ, MMVALUE_T *val )
{
	MMSETV_T	*vdat, *v = ofs->v;

	if ( (vdat = calloc(sizeof(MMSETV_T),1)) == NULL )
		return (ERR);
	vdat->typ = typ;
	vdat->val = *val;

	if ( v == NULL )
		ofs->v = vdat;
	else
	{	LOOP
		{	if ( v->next == NULL )
			{	v->next = vdat;
				break;
			}
			v = v->next;
		}
	}
	return (NORMAL);
}

#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
static struct 		_cmdtbl_t
{
	CONST char	   *name;
	int				typ;
} CmdTbl[] =
{
	{ _MM_CAF_      , MMSETYP_CAF			},
	{ _MM_CAFDELAY_ , MMSETYP_CAFDELAY		},
	{ _MM_CAFPRES_  , MMSETYP_CAFPRES		},
	{ _MM_CC_       , MMSETYP_CC			},
	{ _MM_CD_       , MMSETYP_CAFDELAY		},
/*	{ _MM_CH_       , MMSETYP_CH			},	*/
	{ _MM_D_        , MMSETYP_DELAY			},
	{ _MM_DELAY_    , MMSETYP_DELAY			},
	{ _MM_G_        , MMSETYP_GATETIME		},
	{ _MM_GATE_     , MMSETYP_GATETIME		},
	{ _MM_GATEPER_  , MMSETYP_GATERATIO		},
	{ _MM_GP_       , MMSETYP_GATERATIO		},
	{ _MM_K_        , MMSETYP_KEYSHIFT		},
	{ _MM_KEY_      , MMSETYP_KEYSHIFT		},
	{ _MM_O_        , MMSETYP_OCTAVE		},
	{ _MM_OCTAVE_   , MMSETYP_OCTAVE		},
	{ _MM_OFFVEL_   , MMSETYP_OFFVELOCITY	},
	{ _MM_OV_       , MMSETYP_OFFVELOCITY	},
	{ _MM_P_        , MMSETYP_PITCH			},
	{ _MM_PAF_      , MMSETYP_PAF			},
	{ _MM_PAFDELAY_ , MMSETYP_PAFDELAY		},
	{ _MM_PAFPRES_  , MMSETYP_PAFPRES		},
	{ _MM_PD_       , MMSETYP_PAFDELAY		},
	{ _MM_PG_       , MMSETYP_PROG			},
	{ _MM_PITCH_    , MMSETYP_PITCH			},
	{ _MM_PROG_     , MMSETYP_PROG			},
	{ _MM_S_        , MMSETYP_STEPTIME		},
	{ _MM_STEP_     , MMSETYP_STEPTIME		},
	{ _MM_T_        , MMSETYP_TEMPO			},
	{ _MM_TEMPO_    , MMSETYP_TEMPO			},
	{ _MM_V_        , MMSETYP_VELOCITY		},
	{ _MM_VEL_      , MMSETYP_VELOCITY		},
};
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

static int		cmd_name_len = 0;

static int		cmpFunc( const struct _cmdtbl_t *c1, const struct _cmdtbl_t *c2 )
{
	return (mm_strncmpi(c1->name,c2->name,cmd_name_len));
}

/*************************************************************************
*	[?]#	ѡȥޥ
*-------------------------------------------------------------------------
*	[?]# <n> [(parameters)]
*************************************************************************/

int _FAST	MMdec_offset( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMTRK_T		   *trk = part->trk;
	MMOFS_T		   *ofs;
	int				ofsNo;
	CONST char	   *err = NULL;

	if ( *(*s) == '?' )
		++(*s);
	++(*s);	/* skip '#' */
	if ( isdigit(*(*s)) )
	{	/* ֹɤ߼	*/
		if ( mm_getIntDigit(&ofsNo,s) || ofsNo < 1 )
		{
			char	tmp[128];

_OFS_ERR:	if ( err )
				sprintf( tmp, " '%s'", err );
			else
				tmp[0] = '\0';
			MM_setErrMsg( sqr, _msg_mmoffset_Offsetter_command_error[TypMsg], tmp );
			return (ERR);
		}
	} else
		ofsNo = 0;	/* ƥॻåֹ	*/

	if ( *(*s) == '(' )
	{	/* ѥ᡼ɤ߼	*/
		int		argc;
		char	**argv;

		/* åѰդ	*/
		if ( (ofs = mmofs_newOffset(part,ofsNo)) == NULL )
		{
/*_MEM_ERR:*/
			sqr->errMsg = _msg_out_of_memory[TypMsg];
			return (ERR);
		}
		part->ofsPtr = ofs;

		if ( (argc = mm_get_arg( s, &argv )) > 0 )
		{
			int		i;

			for ( i = 0; i < argc; ++i )
			{
				int			typ;
				CONST char	*ap;

				err = ap = argv[i];
				typ = ERR;
				{
					struct _cmdtbl_t	key;
					struct _cmdtbl_t	*cmd;

					key.typ  = -1;
					key.name = ap;
					cmd_name_len = 0;
					while ( *ap )
					{
						++cmd_name_len;
						if ( *ap == ':' )
							break;
						++ap;
					}
					if ( *ap != ':' )
						goto _OFS_ERR;
					++ap;
					cmd = bsearch( &key, CmdTbl, sizeof(CmdTbl)/sizeof(*CmdTbl),
					  sizeof(*CmdTbl), (int (*)(const void *, const void *))cmpFunc );
					if ( cmd )
						typ = cmd->typ;
				}

				{
					MMPART_PARA_T	*para;
					MMVALUE_T		val;

					para = &(part->ofs);
					switch ( typ )
					{
						case MMSETYP_TEMPO:
						{
							if ( trk->trkNo > 0 )
							{
								sqr->errMsg = _msg_Tempo_change_error[TypMsg];
								return (ERR);
							}
							val = para->tempo;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,
							        -(MMTEMPO_MAX-MMTEMPO_MIN),
							         (MMTEMPO_MAX-MMTEMPO_MIN)) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_CH:
						{
							int		ch;
							if ( mm_getIntDigit( &ch, &ap ) || ch < 1 || ch > 16 )
								goto _OFS_ERR;
							MM_setValue( &val, _MMVAL_ABS, ch - 1);
							break;
						}
						case MMSETYP_DELAY:
						{
							val = para->delay;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-65535,65535) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_KEYSHIFT:
						{
							val = para->keyShift;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-255,255) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_OCTAVE:
						{
							val = para->octave;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-20,20) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_VELOCITY:
						{
							val = para->vel;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-127,127) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_OFFVELOCITY:
						{
							val = para->offVel;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-127,127) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_STEPTIME:
						{
							val = para->stepTime;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-65535,65535) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_GATETIME:
						{
							val = para->gateTime;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-65535,65535) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_GATERATIO:
						{
							val = para->gateRatio;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-1000,1000) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_PROG:
						{
							val = para->prog;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-127,127) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_PITCH:
						{
							val = para->pitch;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-16383,16383) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_CAF:
						case MMSETYP_CAFPRES:
						{
							val = para->caf;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-127,127) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_CAFDELAY:
						{
							val = para->cafDelay;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-65535,65535) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_PAF:
						case MMSETYP_PAFPRES:
						{
							val = para->paf;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-127,127) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_PAFDELAY:
						{
							val = para->pafDelay;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-65535,65535) )
								goto _OFS_ERR;
							break;
						}
						case MMSETYP_CC:
						{
							int		cc;
							if ( mm_getIntDigit( &cc, &ap ) || cc < 0 || cc > 127 )
								goto _OFS_ERR;
							if ( *ap != '/' )
								goto _OFS_ERR;
							++ap;
							typ = cc + MMSETYP_CC;
							val = para->ccv[cc];
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-127,127) )
								goto _OFS_ERR;
							break;
						}
						default:
							goto _OFS_ERR;
					}
					/* ԥ	*/
					if ( mmofs_offset( ofs, typ, &val ) )
						return (ERR);
					((MMSQR_T *)(trk->sqr))->workSize += sizeof(MMSETV_T);
				}
			}
			mm_clear_arg(argc,argv);
			if ( ofsNo == 0 )
				goto _OFS_SETUP;
		}
	} else
	{	/* 	*/
_OFS_SETUP:
		/* ֹΥեåѰդ	*/
		if ( (ofs = mmofs_getOffset(part,ofsNo)) == NULL )
		{
			MM_setErrMsg( sqr, _msg_mmoffset_Unknown_offsetter_number[TypMsg], ofsNo );
			return (ERR);
		}
		part->ofsPtr  = ofs;
		{
			MMSETV_T	*vp;
			vp = ofs->v;
			while ( vp )
			{
				switch ( vp->typ )
				{
					case MMSETYP_TEMPO:
					{
						part->ofs.tempo = vp->val;
						break;
					}
					case MMSETYP_DELAY:
					{
						part->ofs.delay = vp->val;
						break;
					}
					case MMSETYP_KEYSHIFT:
					{
						part->ofs.keyShift = vp->val;
						break;
					}
					case MMSETYP_OCTAVE:
					{
						part->ofs.octave = vp->val;
						break;
					}
					case MMSETYP_VELOCITY:
					{
						part->ofs.vel = vp->val;
						break;
					}
					case MMSETYP_OFFVELOCITY:
					{
						part->ofs.offVel = vp->val;
						break;
					}
					case MMSETYP_STEPTIME:
					{
						part->ofs.stepTime = vp->val;
						break;
					}
					case MMSETYP_GATETIME:
					{
						part->ofs.gateTime = vp->val;
						break;
					}
					case MMSETYP_GATERATIO:
					{
						part->ofs.gateRatio = vp->val;
						break;
					}
					case MMSETYP_PROG:
					{
						part->ofs.prog = vp->val;
						break;
					}
					case MMSETYP_PITCH:
					{
						part->ofs.pitch = vp->val;
						break;
					}
					case MMSETYP_CAF:
					case MMSETYP_CAFPRES:
					{
						part->ofs.caf = vp->val;
						break;
					}
					case MMSETYP_CAFDELAY:
					{
						part->ofs.cafDelay = vp->val;
						break;
					}
					case MMSETYP_PAF:
					case MMSETYP_PAFPRES:
					{
						part->ofs.paf = vp->val;
						break;
					}
					case MMSETYP_PAFDELAY:
					{
						part->ofs.pafDelay = vp->val;
						break;
					}
#ifdef	__HIGHC__
					case MMSETYP_CC..(MMSETYP_CC+127):
#else
					default:
					if ( vp->typ >= MMSETYP_CC && vp->typ <= (MMSETYP_CC+127) )
#endif
					{
						int		cc;
						cc = vp->typ - MMSETYP_CC;
						part->ofs.ccv[cc] = vp->val;
						break;
					}
				} /* end of switch( vp->typ ) */
				vp = vp->next;
			}
		}
	}

	return (NORMAL);
}
