/*************************************************************************
*	ץƥޥ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"midicc.h"
#include	"smfmet.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmopt.h"
#include	"mmpart.h"
#include	"mmtrk.h"
#include	"mmsg.h"
#include	"msgdat.h"
#include	"search.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
typedef struct
{
	long		tempo;
	struct
	{
		int		pitch;		/* 0  16383 */
		int		prog;
		int		caf;
		char	paf[128];
		char	ccv[128];
	} ch[16];
} MMOPTBUF_T;
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

static void _FAST	all_reset( MMOPTBUF_T *optBuf );
static void _FAST	allch_reset( MMOPTBUF_T *optBuf, unsigned int flags );
static int  _FAST	set_flagsw( const char *name, USHORT *flagptr);

int		MMopt_trk( MMSQR_T *sqr, MMTRK_T *trk )
{
	MMOPTBUF_T		optBuf;
	MMOPT_T		   *opt = &(trk->opt);

	if ( sqr->trkWork.mode == MMTRKWORK_MODE_FILE )
	{	/* ե⡼ɡǡɤ߹	*/
		if ( mmtrk_datLoad( trk ) )
			return (ERR);
	}

	all_reset( &optBuf );

	{
		MMDAT_T	   *dat = trk->datTop, *next;

#define	DEL(_dat)	{									\
	if ( (_dat)->prev )									\
		(_dat)->prev->next = (_dat)->next;				\
	else												\
		trk->datTop = (_dat)->next;						\
	if ( (_dat)->next )									\
		(_dat)->next->prev = (_dat)->prev;				\
	else												\
		trk->datLast = (_dat)->prev;					\
	sqr->workSize -= (sizeof(MMDAT_T) + (_dat)->siz);	\
	free((_dat));										\
}

#define	CHK_OPTSW(_sw,_ch)	{					\
	if ( (_sw) & MMOPT_CLEAR_PROG )				\
		optBuf.ch[(_ch)].prog = -1;				\
	if ( (_sw) & MMOPT_CLEAR_PITCH )			\
		optBuf.ch[(_ch)].pitch = -1;			\
	if ( (_sw) & MMOPT_CLEAR_PAF )				\
	{	int		_note;							\
		for ( _note = 0; _note < 128; ++_note )	\
			optBuf.ch[(_ch)].paf[_note] = -1;	\
	}											\
	if ( (_sw) & MMOPT_CLEAR_CAF )				\
		optBuf.ch[(_ch)].caf = -1;				\
	if ( (_sw) & MMOPT_CLEAR_CC )				\
	{	int		_cc;							\
		for ( _cc = 0; _cc < 128; ++_cc )		\
			optBuf.ch[(_ch)].ccv[_cc] = -1;		\
	}											\
}

		while ( dat != NULL )
		{
			UCHAR	   *p;
			int			ch;

			next = dat->next;
			p = dat->dat;
			ch = (*p) & 0x0F;
			switch ( *p )
			{
#ifdef	__HIGHC__
				case 0x80..0x8F:	/* note off */
#else
				case 0x80: case 0x81: case 0x82: case 0x83: case 0x84: case 0x85: case 0x86: case 0x87:
				case 0x88: case 0x89: case 0x8A: case 0x8B: case 0x8C: case 0x8D: case 0x8E: case 0x8F:
#endif
					CHK_OPTSW(opt->note,ch);
					break;

#ifdef	__HIGHC__
				case 0x90..0x9F:	/* note on */
#else
				case 0x90: case 0x91: case 0x92: case 0x93: case 0x94: case 0x95: case 0x96: case 0x97:
				case 0x98: case 0x99: case 0x9A: case 0x9B: case 0x9C: case 0x9D: case 0x9E: case 0x9F:
#endif
					CHK_OPTSW(opt->note,ch);
					break;

#ifdef	__HIGHC__
				case 0xA0..0xAF:	/* polyphonic after touch */
#else
				case 0xA0: case 0xA1: case 0xA2: case 0xA3: case 0xA4: case 0xA5: case 0xA6: case 0xA7:
				case 0xA8: case 0xA9: case 0xAA: case 0xAB: case 0xAC: case 0xAD: case 0xAE: case 0xAF:
#endif
				{
					int		note, pres;

					note = p[1];
					pres = p[2];
					if ( opt->paf & MMOPT_SW_ON )
					{	if ( optBuf.ch[ch].paf[note] == pres )
						{	DEL(dat);
							break;
						} else
							optBuf.ch[ch].paf[note] = pres;
					}
					CHK_OPTSW(opt->paf,ch);
					break;
				}

#ifdef	__HIGHC__
				case 0xB0..0xBF:	/* control change */
#else
				case 0xB0: case 0xB1: case 0xB2: case 0xB3: case 0xB4: case 0xB5: case 0xB6: case 0xB7:
				case 0xB8: case 0xB9: case 0xBA: case 0xBB: case 0xBC: case 0xBD: case 0xBE: case 0xBF:
#endif
				{
					int		cc, val;

					cc = p[1];
					val = p[2];
					if ( opt->cc[cc] & MMOPT_SW_ON )
					{	if ( optBuf.ch[ch].ccv[cc] == val )
						{	DEL(dat);
							break;
						} else
							optBuf.ch[ch].ccv[cc] = val;
					}
					CHK_OPTSW(opt->cc[cc],ch);
					break;
				}

#ifdef	__HIGHC__
				case 0xC0..0xCF:	/* program change */
#else
				case 0xC0: case 0xC1: case 0xC2: case 0xC3: case 0xC4: case 0xC5: case 0xC6: case 0xC7:
				case 0xC8: case 0xC9: case 0xCA: case 0xCB: case 0xCC: case 0xCD: case 0xCE: case 0xCF:
#endif
				{
					int		prog;

					prog = p[1];
					if ( opt->prog & MMOPT_SW_ON )
					{	if ( optBuf.ch[ch].prog == prog )
						{	DEL(dat);
							break;
						} else
							optBuf.ch[ch].prog = prog;
					}
					CHK_OPTSW(opt->prog,ch);
					break;
				}
#ifdef	__HIGHC__
				case 0xD0..0xDF:	/* channel after touch */
#else
				case 0xD0: case 0xD1: case 0xD2: case 0xD3: case 0xD4: case 0xD5: case 0xD6: case 0xD7:
				case 0xD8: case 0xD9: case 0xDA: case 0xDB: case 0xDC: case 0xDD: case 0xDE: case 0xDF:
#endif
				{
					int		pres;

					pres = p[1];
					if ( opt->caf & MMOPT_SW_ON )
					{	if ( optBuf.ch[ch].caf == pres )
						{	DEL(dat);
							break;
						} else
							optBuf.ch[ch].caf = pres;
					}
					CHK_OPTSW(opt->caf,ch);
					break;
				}

#ifdef	__HIGHC__
				case 0xE0..0xEF:	/* pitchbend */
#else
				case 0xE0: case 0xE1: case 0xE2: case 0xE3: case 0xE4: case 0xE5: case 0xE6: case 0xE7:
				case 0xE8: case 0xE9: case 0xEA: case 0xEB: case 0xEC: case 0xED: case 0xEE: case 0xEF:
#endif
				{
					int		pitch;

					pitch = (p[1]<<7) + p[2];
					if ( opt->pitch & MMOPT_SW_ON )
					{
						if ( optBuf.ch[ch].pitch == pitch )
						{
							DEL(dat);
							break;
						} else
							optBuf.ch[ch].pitch = pitch;
					}
					CHK_OPTSW(opt->pitch,ch);
					break;
				}

				case 0xF0:	/* system exclusive message   */
				case 0xF7:	/* system exclusive message 2 */
					allch_reset( &optBuf, opt->excl);
					break;

				case 0xFF:
				{
					switch( p[1] )
					{
						case SMF_MET_ENDOFTRK:	/* track end */
							break;
						case SMF_MET_TEMPO:		/* tempo */
						{
							long	tempo;

							tempo = (p[3]<<16)+(p[4]<<8)+p[5];
							if ( opt->tempo & MMOPT_SW_ON )
							{
								if ( optBuf.tempo == tempo )
								{
									DEL(dat);
									break;
								} else
									optBuf.tempo = tempo;
							}
						/*	CHK_OPTSW(opt->tempo,ch); */
							break;
						}
						case SMF_MET_SIGNATURE:	/* signature */
							break;

						case 0xFF:
						{
							switch ( p[2] )
							{
								case MMTRK_MARK_OPT_CLEAR:
								{
									unsigned int	flags;

									flags = *(unsigned short *)(p + 3);
									allch_reset( &optBuf, flags);
									if ( flags & MMOPT_CLEAR_TEMPO )
										optBuf.tempo = -1;
									break;
								}
							}
							break;
						}
					}
					break;
				}
			}
			dat = next;
		}
	}
	trk->datPtr = NULL;
	if ( sqr->trkWork.mode == MMTRKWORK_MODE_FILE )
	{	/* ե⡼ɡǡ¸	*/
		if ( mmtrk_datSave( trk ) )
			return (ERR);
	}
	return (NORMAL);
}

static void _FAST	all_reset( MMOPTBUF_T *optBuf )
{
	int		ch;

	optBuf->tempo = -1;
	for ( ch = 0; ch < 16; ++ch )
	{
		int		i;

		optBuf->ch[ch].pitch = -1;
		optBuf->ch[ch].prog  = -1;
		optBuf->ch[ch].caf   = -1;
		for ( i = 0; i < 128; ++i )
		{
			optBuf->ch[ch].paf[i] = -1;
			optBuf->ch[ch].ccv[i] = -1;
		}
	}
}

static void _FAST	allch_reset( MMOPTBUF_T *optBuf, unsigned int flags )
{
	register int	ch;

	if ( flags & MMOPT_CLEAR_PROG )
	{
		for ( ch = 0; ch < 16; ++ch )
			optBuf->ch[ch].prog = -1;
	}
	if ( flags & MMOPT_CLEAR_PITCH )
	{
		for ( ch = 0; ch < 16; ++ch )
			optBuf->ch[ch].pitch = -1;
	}
	if ( flags & MMOPT_CLEAR_PAF )
	{
		for ( ch = 0; ch < 16; ++ch )
		{
			register int		note;

			for ( note = 0; note < 128; ++note )
				optBuf->ch[ch].paf[note] = -1;
		}
	}
	if ( flags & MMOPT_CLEAR_CAF )
	{
		for ( ch = 0; ch < 16; ++ch )
			optBuf->ch[ch].caf = -1;
	}
	if ( flags & MMOPT_CLEAR_CC )
	{
		for ( ch = 0; ch < 16; ++ch )
		{
			register int		cc;

			for ( cc = 0; cc < 128; ++cc )
				optBuf->ch[ch].ccv[cc] = -1;
		}
	}
}

int		MM_optimize( MMSQR_T *sqr )
{
	int		i;

	HE_printf( sqr, _HE_MSG_INF, _msg_mmopt_Optimizing[TypMsg] );

	for ( i = 0; i < _MMSQR_TRK_HASH_MAX; ++i )
	{
		MMTRK_T	*trk;

		trk = sqr->trkTbl[i];
		while ( trk )
		{
			if ( MMopt_trk( sqr, trk ) )
				return (ERR);
			trk = trk->next;
		}
	}
	return (NORMAL);
}

/*************************************************************************
*	ȥåץޥꥳޥ
*-------------------------------------------------------------------------
*	@OPT(<typ>,<flag>,...)
*		<typ>
*************************************************************************/

static int _FAST	mmopt_get_flag( MMTRK_T *trk, int argc, char **argv );

static int		dec_trkOptOld(MMSQR_T *sqr, MMTRK_T *trk, int argc, char **argv )
{
	int			typ = ERR, cc;
	enum _opt_para_
	{
		_OPT_NOTE ,
		_OPT_PROG ,
		_OPT_PITCH,
		_OPT_PRES ,
		_OPT_PAF  ,
		_OPT_CAF  ,
		_OPT_CC   ,
		_OPT_EXCL ,
		_OPT_TEMPO,
	};
	if ( argc < 1 )
		goto _ERR;

	if ( mm_strncmpi( argv[0],"cc:",3) == 0 )
	{	/* ȥ	*/
		const char	   *s = argv[0] + 3;

		if ( mm_getIntDigit(&cc,&s) || cc < 0 || cc > 127 )
			goto _ERR;
		typ = _OPT_CC;
	} else
	{
		static SEA_NO tbl[] =
		{
			{ _caf_    , _OPT_CAF    },
			{ _excl_   , _OPT_EXCL   },
			{ _paf_    , _OPT_PAF    },
			{ _pitch_  , _OPT_PITCH  },
			{ _pres_   , _OPT_PRES   },
			{ _prog_   , _OPT_PROG   },
			{ _note_   , _OPT_NOTE   },
			{ _tempo_  , _OPT_TEMPO  },
		};

		if ( (typ = sea_getno(argv[0], tbl, sizeof(tbl)/sizeof(*tbl))) < 0 )
			goto _ERR;
	}

	{
		int		ret;

		if ( (ret = mmopt_get_flag( trk, argc - 1, &argv[1] )) >= 0 )
		{
			switch ( typ )
			{
				case _OPT_NOTE :
					trk->opt.note   = ret & (~(MMOPT_SW_ON | MMOPT_CLEAR_NOTE));
					break;
				case _OPT_PROG :
					trk->opt.prog   = ret;
					break;
				case _OPT_PITCH:
					trk->opt.pitch  = ret;
					break;
				case _OPT_PRES :
					trk->opt.paf    = ret;
					trk->opt.caf    = ret;
					break;
				case _OPT_PAF  :
					trk->opt.paf    = ret;
					break;
				case _OPT_CAF  :
					trk->opt.caf    = ret;
					break;
				case _OPT_CC   :
					trk->opt.cc[cc] = ret;
					break;

				case _OPT_EXCL:
					trk->opt.excl   = ret & (~MMOPT_SW_ON);
					break;
				case _OPT_TEMPO:
					trk->opt.tempo  = ret & MMOPT_SW_ON;
					break;

				default:
					goto _ERR;
			}
			ret = 0;
		}
		return (ret);
	}

_ERR:
	sqr->errMsg = _msg_mmopt_Optimize_command_error[TypMsg];
	return (-1);
}

static int _FAST	mmopt_get_flag( MMTRK_T *trk, int argc, char **argv )
{
	USHORT		flags;

	if ( argc < 1 )
		goto _ERR;

	{
		int		n;

		flags = 0;
		for ( n = 0; n < argc; ++n )
		{
			if ( set_flagsw( argv[n], &flags) < 0 )
				goto _ERR;
		}
	}
	return (int)flags;

_ERR:
	((MMSQR_T *)(trk->sqr))->errMsg = _msg_mmopt_Optimize_flag_error[TypMsg];
	return (-1);
}

/*************************************************************************
*	ȥåץޥꥳޥ
*-------------------------------------------------------------------------
*	@OPT(CLEAR, [<flag>...<flag n>])
*************************************************************************/

static int _FAST	get_flag( const char *name );

int		MMdec_trkOptimize(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		   *trk = part->trk;
	MMCLK_T			clk = mmpart_get_clock(part);
	int				typ;
	enum _typ_num
	{
		_OPT_CLEAR,
	};

	if ( argc < 1 )
		goto _ERR;

	{
		static SEA_NO tbl[] =
		{
			{ "clear"  , _OPT_CLEAR  },
		};

		if ( (typ = sea_getno(argv[0], tbl, sizeof(tbl)/sizeof(*tbl))) < 0 )
		{
			return dec_trkOptOld(sqr,trk,argc,argv);
		}
	}

	switch ( typ )
	{
		case _OPT_CLEAR:
		{
			int		flags;

			if ( argc == 1 )
			{
				flags = 0xFFFF;
			} else
			{
				int			n, ret;

				flags = 0;
				for ( n = 1; n < argc; ++n )
				{
					if ( (ret = get_flag(argv[n])) < 0 )
						goto _ERR;
					flags |= ret;
				}
			}
			if ( mmtrk_set_mark_word( trk, clk, MMTRK_MARK_OPT_CLEAR, flags ) < 0 )
				return (ERR);
			break;
		}

		default:
			goto _ERR;
	}
	return (0);

_ERR:
	sqr->errMsg = _msg_mmopt_Optimize_command_error[TypMsg];
	return (-1);
}

static int _FAST	get_flag( const char *name )
{
	SEA_NO	tbl[] =
	{
		{ _caf_    , MMOPT_FLAG_CAF    },
		{ _cc_     , MMOPT_FLAG_CC     },
		{ _excl_   , MMOPT_FLAG_EXCL   },
		{ _note_   , MMOPT_FLAG_NOTE   },
		{ _paf_    , MMOPT_FLAG_PAF    },
		{ _pitch_  , MMOPT_FLAG_PITCH  },
		{ _pres_   , MMOPT_FLAG_PRES   },
		{ _prog_   , MMOPT_FLAG_PROG   },
		{ _tempo_  , MMOPT_FLAG_TEMPO  },
	};

	return sea_getno(name, tbl, sizeof(tbl)/sizeof(*tbl));
}


/*************************************************************************
*	ȥԤꤹ
*-------------------------------------------------------------------------
*	.optset	<track no> <typ> <sw> [... <sw n>]
*************************************************************************/

int _FAST	MMctr_optset( MMSQR_T *sqr, const char *s)
{
	MMTRK_T		   *trk;
	int				typ, cc;
	USHORT		   *flagptr;
	enum _typ_enum
	{
		_OPT_NOTE ,
		_OPT_PROG ,
		_OPT_PITCH,
		_OPT_PAF  ,
		_OPT_CAF  ,
		_OPT_CC   ,
		_OPT_EXCL ,
		_OPT_TEMPO,
	};

	if ( (trk = MMtrk_gettrk3(sqr,&s)) == NULL )
		return (-1);

	/* <typ> μ	*/
	{
		static SEA_NO tbl[] =
		{
			{ _caf_    , _OPT_CAF    },
			{ _cc_     , _OPT_CC     },
			{ _excl_   , _OPT_EXCL   },
			{ _note_   , _OPT_NOTE   },
			{ _paf_    , _OPT_PAF    },
			{ _pitch_  , _OPT_PITCH  },
			{ _prog_   , _OPT_PROG   },
			{ _tempo_  , _OPT_TEMPO  },
		};
		char		typName[80];

		if ( mm_getname(typName, sizeof(typName)-1,&s) < 0 )
			goto _ERR;
		if ( (typ = sea_getno(typName, tbl, sizeof(tbl)/sizeof(*tbl))) < 0 )
			goto _ERR;
	}
	SKIP_SPACE(s);
	if ( *s == ',' )
		++s;

	if ( typ == _OPT_CC )
	{
		SKIP_SPACE(s);
		if ( *s != ':' )
			goto _ERR;
		++s;	/* skip ':' */
		SKIP_SPACE(s);
		if ( mm_getIntDigit( &cc, &s ) < 0 || cc < 0 || cc > 127 )
			goto _ERR;
	}

	switch ( typ )
	{
		case _OPT_NOTE :	flagptr = &trk->opt.note;	break;
		case _OPT_PROG :	flagptr = &trk->opt.prog;	break;
		case _OPT_PITCH:	flagptr = &trk->opt.prog;	break;
		case _OPT_PAF  :	flagptr = &trk->opt.paf ;	break;
		case _OPT_CAF  :	flagptr = &trk->opt.caf ;	break;
		case _OPT_CC   :	flagptr = &trk->opt.cc[cc];	break;
		case _OPT_EXCL :	flagptr = &trk->opt.excl;	break;
		case _OPT_TEMPO:	flagptr = &trk->opt.tempo;	break;
		default:
			goto _ERR;
	}

	*flagptr = 0;
	for (;;)
	{
		char		name[80];

		SKIP_SPACE(s);
		if ( *s == ',' )
			++s;
		if ( *s == '\0' )
			break;
		if ( mm_getname(name, sizeof(name)-1,&s) < 0 )
			goto _ERR;
		if ( set_flagsw( name, flagptr) < 0 )
		{
			((MMSQR_T *)(trk->sqr))->errMsg = _msg_mmopt_Optimize_flag_error[TypMsg];
			return (-1);
		}
	}

	switch ( typ )
	{
		case _OPT_NOTE:
		case _OPT_EXCL:
			/* ŬϾ̵				*/
			*flagptr &= ~MMOPT_SW_ON;
			break;

		case _OPT_TEMPO:
			/* on/off ʳǤʤ	*/
			*flagptr &= MMOPT_SW_ON;
			break;
	}

	return (0);

_ERR:
	sqr->errMsg = "Optimizer setting error!";
	return (-1);
}

static int _FAST	set_flagsw( const char *name, USHORT *flagptr)
{
	SEA_NO	tbl[] =
	{
		{ _caf_    , MMOPT_FLAG_CAF    },
		{ _cc_     , MMOPT_FLAG_CC     },
		{ _excl_   , MMOPT_FLAG_EXCL   },
		{ _note_   , MMOPT_FLAG_NOTE   },
		{ _off_    , MMOPT_SW_OFF      },
		{ _on_     , MMOPT_SW_ON       },
		{ _paf_    , MMOPT_FLAG_PAF    },
		{ _pitch_  , MMOPT_FLAG_PITCH  },
		{ _pres_   , MMOPT_FLAG_PRES   },
		{ _prog_   , MMOPT_FLAG_PROG   },
		{ _tempo_  , MMOPT_FLAG_TEMPO  },
	};
	int		ret;

	if ( (ret = sea_getno(name, tbl, sizeof(tbl)/sizeof(*tbl))) < 0 )
		return (-1);

	switch ( ret )
	{
		case MMOPT_SW_ON:
			*flagptr |= MMOPT_SW_ON;
			break;

		case MMOPT_SW_OFF:
			*flagptr &= (~MMOPT_SW_ON);
			break;

		default:
			*flagptr |= ret;
			break;
	}

	return (0);
}


/*************************************************************************
*	ȥåץޥ
*************************************************************************/

void	mmopt_init( MMOPT_T *opt )
{
	opt->tempo = MMOPT_SW_ON;
	opt->note  = MMOPT_SW_OFF | MMOPT_CLEAR_PRES;
	opt->pitch = MMOPT_SW_ON;
	opt->prog  = MMOPT_SW_ON  | MMOPT_CLEAR_PITCH | MMOPT_CLEAR_CC | MMOPT_CLEAR_PRES;
	opt->paf   = MMOPT_SW_ON  | MMOPT_CLEAR_CAF;
	opt->caf   = MMOPT_SW_ON  | MMOPT_CLEAR_PAF;
	opt->excl  = MMOPT_SW_OFF | MMOPT_CLEAR_NOTE | MMOPT_CLEAR_PROG | MMOPT_CLEAR_PITCH | MMOPT_CLEAR_CC | MMOPT_CLEAR_PRES;

	{
		REG int		cc;

		for ( cc = 0; cc < 128; ++cc )
			opt->cc[cc] = MMOPT_SW_OFF;
	}

	opt->cc[MID_CC_BANK_SELECT]   = MMOPT_SW_OFF | MMOPT_CLEAR_PROG;
	opt->cc[MID_CC_MODURATION]    = MMOPT_SW_ON;
	opt->cc[MID_CC_VOLUME]        = MMOPT_SW_ON;
	opt->cc[MID_CC_PANPOT]        = MMOPT_SW_ON;
	opt->cc[MID_CC_EXPRESSION]    = MMOPT_SW_ON;
	opt->cc[MID_CC_EFFECT1_DEPTH] = MMOPT_SW_ON;
	opt->cc[MID_CC_EFFECT3_DEPTH] = MMOPT_SW_ON;
	opt->cc[MID_CC_ALL_SOUND_OFF] = MMOPT_SW_OFF | MMOPT_CLEAR_NOTE;
	opt->cc[MID_CC_RESET_ALL_CONTOROLLER]
	                              = MMOPT_SW_OFF | MMOPT_CLEAR_NOTE | MMOPT_CLEAR_PITCH | MMOPT_CLEAR_CC | MMOPT_CLEAR_PRES;
	opt->cc[MID_CC_ALL_NOTE_OFF]  = MMOPT_SW_OFF | MMOPT_CLEAR_NOTE | MMOPT_CLEAR_PITCH | MMOPT_CLEAR_CC | MMOPT_CLEAR_PRES;
	opt->cc[MID_CC_OMNI_OFF]      = MMOPT_SW_OFF | MMOPT_CLEAR_NOTE | MMOPT_CLEAR_PITCH | MMOPT_CLEAR_CC | MMOPT_CLEAR_PRES;
	opt->cc[MID_CC_OMNI_ON]       = MMOPT_SW_OFF | MMOPT_CLEAR_NOTE | MMOPT_CLEAR_PITCH | MMOPT_CLEAR_CC | MMOPT_CLEAR_PRES;
	opt->cc[MID_CC_OMNI_MONO]     = MMOPT_SW_OFF | MMOPT_CLEAR_NOTE | MMOPT_CLEAR_PITCH | MMOPT_CLEAR_CC | MMOPT_CLEAR_PRES;
	opt->cc[MID_CC_OMNI_POLY]     = MMOPT_SW_OFF | MMOPT_CLEAR_NOTE | MMOPT_CLEAR_PITCH | MMOPT_CLEAR_CC | MMOPT_CLEAR_PRES;
}
