/*************************************************************************
*	ѡ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"midicc.h"
#include	"mml.h"
#include	"mmac.h"
#include	"mmlib.h"
#include	"mmpart.h"
#include	"mmpin.h"
#include	"mmsetter.h"
#include	"mmoffset.h"
#include	"msgdat.h"

#define	HASH(_partNo)	(((_partNo) * 31) & (_MMTRK_PART_HASH_MAX-1))

int		MMpart_init( MMSQR_T *sqr )
{
	return (NORMAL);
}

void	MMpart_term( MMSQR_T *sqr )
{
}

void	MMpart_free( MMTRK_T *trk )
{
	int			i;
	MMSQR_T	   *sqr = trk->sqr;

	for ( i = 0; i < _MMTRK_PART_HASH_MAX; ++i )
	{
		MMPART_T	*part;

		part = trk->partTbl[i];
		while ( part )
		{
			MMPART_T	*next;

			next = part->next;
			mmset_allfree( part );		/* γ		*/
			mmofs_allfree( part );		/* եåγ	*/
			mmpin_allfree( part );		/* ԥγ		*/
			free( part );	sqr->workSize -= sizeof(MMPART_T);
			part = next;
		}
		trk->partTbl[i] = NULL;
	}
}

int		MMpart_clear( MMTRK_T *trk, MMPART_T *part )
{
	MMSQR_T			*sqr = trk->sqr;
	MMPART_PARA_T	*partPara;

	memset( part, 0, sizeof(MMPART_T) );

	{	/* MML ޥ	*/
		int			i;
		MMSQR_T		*sqr = trk->sqr;

		for ( i = 0; i <26; ++i )
			part->mmlCmd[i] = sqr->mmlCmd[i];
	}

	part->trk = trk;
	part->ch  = 16; /* trk->ch > 0 ? trk->ch - 1 : trk->ch; */
	part->clk = trk->clk;
	part->noteLast = -1;

	part->gateMode = MMGATE_MODE_RATIO;
	part->cafMode  = MMPRES_MODE_OFF;	/* OFF */
	part->pafMode  = MMPRES_MODE_OFF;	/* OFF */

	/* 	*/
	partPara = &(part->set);
	MM_setValue( &(partPara->tempo)    , _MMVAL_ABS  , trk->tempo );
	MM_setValue( &(partPara->octave)   , _MMVAL_ABS  ,  4 );
	MM_setValue( &(partPara->delay)    , _MMVAL_ABS  ,  0 );

	MM_setValue( &(partPara->keyShift) , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->vel)      , _MMVAL_ABS  , 127 );
	MM_setValue( &(partPara->stepTime) , _MMVAL_ABS  , _MM_NOTELEN_4(sqr->division) );
	MM_setValue( &(partPara->gateRatio), _MMVAL_ABS  , 100 );
	MM_setValue( &(partPara->gateTime) , _MMVAL_ABS  , sqr->division );

	MM_setValue( &(partPara->prog)     , _MMVAL_ABS  ,  1 );
	MM_setValue( &(partPara->pitch)    , _MMVAL_ABS  ,  trk->pitch - 8192 );
	MM_setValue( &(partPara->caf)      , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->paf)      , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->cafDelay) , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->pafDelay) , _MMVAL_ABS  ,  0 );
	{
		int		cc;

		for ( cc = 0; cc < 128; ++cc )
			MM_setValue( &(partPara->ccv[cc]), _MMVAL_ABS, trk->ccv[cc] - trk->tbl.ccvBase[cc] );
	}

	/* եå	*/
	partPara = &(part->ofs);
	MM_setValue( &(partPara->tempo)    , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->octave)   , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->delay)    , _MMVAL_ABS  ,  0 );

	MM_setValue( &(partPara->keyShift) , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->vel)      , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->offVel)   , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->stepTime) , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->gateRatio), _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->gateTime) , _MMVAL_ABS  ,  0 );

	MM_setValue( &(partPara->prog)     , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->pitch)    , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->caf)      , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->paf)      , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->cafDelay) , _MMVAL_ABS  ,  0 );
	MM_setValue( &(partPara->pafDelay) , _MMVAL_ABS  ,  0 );
	{
		int		cc;
		for ( cc = 0; cc < 128; ++cc )
			MM_setValue( &(partPara->ccv[cc]), _MMVAL_ABS, 0 );
	}
	{
		int		i;

		for ( i = 0; i < 7; ++i )
			part->alShift[i] = 0;
	}
	return (NORMAL);
}

/*************************************************************************
*	ȥåλֹΥѡȾ
*************************************************************************/

MMPART_T * _FAST MMpart_get( MMTRK_T *trk, int partNo)
{
	MMSQR_T		   *sqr = trk->sqr;
	MMPART_T	   *part;
	int				hash = HASH(partNo);

	if ( (part = trk->partTbl[hash]) != NULL )
	{
		while ( part )
		{
			if ( part->partNo == partNo )
				return (part);
			part = part->next;
		}
	}
	/* ѡȺ	*/
	if ( (part = malloc(sizeof(MMPART_T))) == NULL )
	{
		sqr->errMsg = _OUT_OF_MEMORY;
		return (NULL);
	}
	sqr->workSize += sizeof(MMPART_T);

	MMpart_clear( trk, part );
	part->partNo = partNo;

	{
		MMPART_T	**partPtr;

		partPtr = &(trk->partTbl[hash]);
		part->next = *partPtr;
		*partPtr = part;
	}
	return (part);
}
