/*************************************************************************
*	ѡȥޥ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"midicc.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmtrk.h"
#include	"mmpart.h"
#include	"msgdat.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*#define	_DEBUG*/
/*----------------------------------------------------------------------*/

/*************************************************************************
*	åμ
*************************************************************************/

MMCLK_T _FAST mmpart_get_clock( REG MMPART_T *part )
{
	REG long		clk;

	clk = MMPART_CLK(part) + mmtrk_get_delay(part->trk);
	if ( clk < 0 )
		clk = 0;
	return (MMCLK_T)(clk);
}

/*************************************************************************
*	ƥ
*************************************************************************/

int _FAST		mmpart_set_tempo( MMPART_T *part, MMCLK_T clk, MMVALUE_T *val )
{
	int		tempo;

	tempo  = MM_READVALUE(val);
	if ( tempo < MMTEMPO_MIN || tempo > MMTEMPO_MAX )
	{
		MM_setErrMsg( MMPART_SQR(part), "Tempo error! (%d%d)",
		                                      MMTEMPO_MIN, MMTEMPO_MAX );
		return (ERR);
	}

	{	/* եå	*/
		int		ofs;
		ofs = MM_READVALUE( &(part->ofs.tempo) );
		tempo += ofs;
	}
	if ( tempo < MMTEMPO_MIN )
		tempo = MMTEMPO_MIN;
	else if ( tempo > MMTEMPO_MAX )
		tempo = MMTEMPO_MAX;

	part->set.tempo = *val;

#ifdef	__HIGHC__
	return mmtrk_set_tempo( part->trk,clk, 60_000_000/tempo);
#else
	return mmtrk_set_tempo( part->trk,clk, 60000000l / tempo);
#endif
}

/*************************************************************************
*	MIDIͥ
*************************************************************************/

int _FAST	mmpart_set_midich( MMPART_T *part, int ch )
{
#if	0
	/* ϰϳΤȤϥȥåꤵƤMIDIͥȤ	*/
	if ( ch < 0 || ch > 15 )
	{
		MM_setErrMsg( MMPART_SQR(part), "MIDI channel error!");
		return (ERR);
	}
#endif

	part->ch = ch;
	return (NORMAL);
}

/*************************************************************************
*	ǥ쥤
*************************************************************************/

int _FAST	mmpart_set_delay( MMPART_T *part, MMVALUE_T *val )
{
	int		delay;

	delay = MM_READVALUE(val);
	if ( delay < -32768 || delay > 32767 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Delay error!");
		return (ERR);
	}

	part->set.delay = *val;
	return (NORMAL);
}

/*************************************************************************
*	ե
*************************************************************************/

int _FAST	mmpart_set_keyShift( MMPART_T *part, MMVALUE_T *val )
{
	int		key;

	key = MM_READVALUE(val);
	if ( key < -127 || key > 127 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Keyshift error! (-127+127)");
		return (ERR);
	}

	part->set.keyShift = *val;
	return (NORMAL);
}

/*************************************************************************
*	
*************************************************************************/

int _FAST	mmpart_set_octave( MMPART_T *part, MMVALUE_T *val )
{
	int		octave;

	octave = MM_READVALUE(val);
	if ( octave < MMOCTAVE_MIN || octave > MMOCTAVE_MAX )
	{
		MM_setErrMsg( MMPART_SQR(part), "Octave error! (%d%d)",
		                                      MMOCTAVE_MIN, MMOCTAVE_MAX );
		return (ERR);
	}

	part->set.octave = *val;
	return (NORMAL);
}

/*************************************************************************
*	٥ƥ
*************************************************************************/

int _FAST	mmpart_set_velocity( MMPART_T *part, MMVALUE_T *val )
{
	int		vel;

	vel = MM_READVALUE(val);
	if ( vel < 1 || vel > 127 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Velocity error! (1127)");
		return (ERR);
	}

	part->set.vel = *val;
	return (NORMAL);
}

/*************************************************************************
*	ա٥ƥ
*************************************************************************/

int _FAST	mmpart_set_offVelocity( MMPART_T *part, MMVALUE_T *val )
{
	int		vel;

	vel = MM_READVALUE(val);
	if ( vel < 1 || vel > 127 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Off-velocity error! (0127)");
		return (ERR);
	}

	part->set.offVel = *val;
	return (NORMAL);
}


/*************************************************************************
*	Ρȡƥåץ
*************************************************************************/

int _FAST	mmpart_set_steptime( MMPART_T *part, MMVALUE_T *val )
{
	int		step;

	step = MM_READVALUE(val);
	if ( step < 0 || step > 0xFFFF )
	{
		MM_setErrMsg( MMPART_SQR(part), "Steptime error!");
		return (ERR);
	}

	part->set.stepTime = *val;
	return (NORMAL);
}

/*************************************************************************
*	ΡȡȥΨ
*************************************************************************/

int _FAST	mmpart_set_gateratio( MMPART_T *part, MMVALUE_T *val )
{
	int		per;

	per = MM_READVALUE(val);
	if ( per < 1 || per > 10000 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Gatetime ratio error!");
		return (ERR);
	}

	part->gateMode = MMGATE_MODE_RATIO;	/* å	*/
	part->set.gateRatio = *val;
	return (NORMAL);
}


/*************************************************************************
*	Ρȡȥ
*************************************************************************/

int _FAST	mmpart_set_gatetime( MMPART_T *part, MMVALUE_T *val )
{
	int		gate;

	gate = MM_READVALUE(val);
	if ( gate < 0 || gate > 0xFFFF )
	{
		MM_setErrMsg( MMPART_SQR(part), "Gatetime error!");
		return (ERR);
	}

	part->gateMode = MMGATE_MODE_CLOCK;	/* å	*/
	part->set.gateTime = *val;
	return (NORMAL);
}


/*************************************************************************
*	ץ	val 1128
*************************************************************************/

int _FAST	mmpart_set_prog( MMPART_T *part, MMCLK_T clk, MMVALUE_T *val )
{
	MMTRK_T	*trk = part->trk;
	int		prog;

	prog  = MM_READVALUE(val) - 1;
	if ( prog < 0 || prog > 127 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Program change error!");
		return (ERR);
	}
	{	/* եå	*/
		int		ofs;
		ofs = MM_READVALUE( &(part->ofs.prog) );
		prog += ofs;
		if ( prog < 0 || prog > 127 )
		{
			MM_setErrMsg( MMPART_SQR(part), "Program change offset error!");
			return (ERR);
		}
	}

	part->set.prog = *val;
	{	/* ץॢ	*/
		MMPROGASN_T	*progAsn = &(trk->progAsn);

		if ( progAsn->abs.pitch_flag || progAsn->off.pitch_flag )
		{
			int		pitch;

			if ( progAsn->abs.pitch_flag
			    && progAsn->abs.pitch
			    && (progAsn->abs.pitch[prog]&0xFFFF) != 0xFFFF )
				pitch = progAsn->abs.pitch[prog] - 8192;
			else
				pitch = MM_READVALUE(&(part->set.pitch));
			if ( progAsn->off.pitch_flag )
				pitch += progAsn->off.pitch[prog];
			if ( pitch < -8192 )
				pitch = -8192;
			else if ( pitch > 8191 )
				pitch = 8191;
			mmtrk_set_pitch( part->trk, clk, part->ch, pitch + 8192);
		}

		{
			REG int		cc;

			for ( cc = 0; cc < 128; ++cc )
			{
				if ( progAsn->abs.cc[cc].cc_flag || progAsn->off.cc[cc].cc_flag )
				{
					REG int		ccv;
					int			base = trk->tbl.ccvBase[cc];

					if ( progAsn->abs.cc[cc].cc_flag
					    && progAsn->abs.cc[cc].ccv
					    && (progAsn->abs.cc[cc].ccv[prog]&0xFF) != 0xFF )
						ccv = progAsn->abs.cc[cc].ccv[prog] - base;	/* 1996/02/09	*/
					else
						ccv = MM_READVALUE(&(part->set.ccv[cc]));
					if ( progAsn->off.cc[cc].cc_flag && progAsn->off.cc[cc].ccv )
						ccv += progAsn->off.cc[cc].ccv[prog];
					if ( ccv < -base )
						ccv = -base;
					else if ( ccv > 127 - base )
						ccv = 127 - base;
					mmtrk_set_cc( part->trk, clk, part->ch, cc, ccv);
				}
			}
		}

	}
	return	mmtrk_set_prog( part->trk, clk, part->ch, prog);
}

/*************************************************************************
*	ԥå٥
*************************************************************************/

int _FAST	mmpart_set_pitch( MMPART_T *part, MMCLK_T clk, MMVALUE_T *val )
{
	int		pitch;

	pitch  = MM_READVALUE(val);
	if ( pitch < -8192 || pitch > 8191 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Pitchbend error!");
		return (ERR);
	}
	{	/* եå	*/
		int		ofs = MM_READVALUE( &(part->ofs.pitch) );

		pitch += ofs;
		if ( pitch < -8192 )
			pitch = -8192;
		else if ( pitch > 8191 )
			pitch = 8191;
	}

	part->set.pitch = *val;
	return	mmtrk_set_pitch( part->trk, clk, part->ch, pitch + 8192);
}

/*************************************************************************
*	ͥ롦եå
*************************************************************************/

int _FAST	mmpart_set_caf( MMPART_T *part, MMCLK_T clk, MMVALUE_T *val )
{
	int		pres;

	pres = MM_READVALUE(val);
	if ( pres < 0 || pres > 127 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Channel-after-touch error!");
		return (ERR);
	}

	part->set.caf = *val;
	return	mmtrk_set_caf( part->trk, clk, part->ch, pres );
}

/*************************************************************************
*	ͥ롦եåץå㡼
*************************************************************************/

int _FAST	mmpart_set_cafPres( MMPART_T *part, MMVALUE_T *val )
{
	int		pres;

	pres = MM_READVALUE(val);
	if ( pres < 0 || pres > 127 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Channel-after-touch pressure error!");
		return (ERR);
	}

	part->set.caf = *val;
	return (NORMAL);
}

/*************************************************************************
*	ͥ롦եåǥ쥤
*************************************************************************/

int _FAST	mmpart_set_cafDelay( MMPART_T *part, MMVALUE_T *val )
{
	int		delay;

	delay = MM_READVALUE(val);
	if ( delay < 0 || delay > 32767 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Channel-after-touch delay error!");
		return (ERR);
	}

	part->set.cafDelay = *val;
	return (NORMAL);
}

/*************************************************************************
*	ݥե˥åեå
*************************************************************************/

int _FAST	mmpart_set_paf( MMPART_T *part, MMCLK_T clk, int note, MMVALUE_T *val )
{
	int		pres;

	pres = MM_READVALUE(val);
	if ( pres < 0 || pres > 127 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Polyphonic-after-touch error!");
		return (ERR);
	}

	part->set.paf = *val;
	return mmtrk_set_paf( part->trk, clk, part->ch, note, pres );
}

/*************************************************************************
*	ݥե˥åեåץå㡼
*************************************************************************/

int _FAST	mmpart_set_pafPres( MMPART_T *part, MMVALUE_T *val )
{
	int		pres;

	pres = MM_READVALUE(val);
	if ( pres < 0 || pres > 127 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Polyphonic-after-touch error!");
		return (ERR);
	}

	part->set.paf = *val;
	return (NORMAL);
}

/*************************************************************************
*	ݥե˥åեåǥ쥤
*************************************************************************/

int _FAST	mmpart_set_pafDelay( MMPART_T *part, MMVALUE_T *val )
{
	int		delay;

	delay = MM_READVALUE(val);
	if ( delay < 0 || delay > 32767 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Polyphonic-after-touch delay error!");
		return (ERR);
	}

	part->set.pafDelay = *val;
	return (NORMAL);
}

/*************************************************************************
*	ȥ롦
*************************************************************************/

int _FAST	mmpart_set_cc( MMPART_T *part, MMCLK_T clk, int cc, MMVALUE_T *val )
{
	MMTRK_T	*trk = part->trk;
	int		ccv, base;

	if ( cc < 0 || cc > 127 )
	{
		MM_setErrMsg( MMPART_SQR(part), "Illegal controller number %d (%Xh)!", cc, cc );
		return (ERR);
	}

	ccv = MM_READVALUE(val);
 	base = trk->tbl.ccvBase[cc];
 	if ( ccv < -base || ccv > 127 - base )
	{
		MM_setErrMsg( MMPART_SQR(part), "Control (%02X) change  error!", cc );
		return (ERR);
	}
	{	/* եå	*/
		int		ofs = MM_READVALUE( &(part->ofs.ccv[cc]) );

		ccv += ofs;
		if ( ccv < -base )
			ccv = -base;
		else if ( ccv > 127 - base )
			ccv = 127 - base;
	}
	part->set.ccv[cc] = *val;
	return mmtrk_set_cc( part->trk, clk, part->ch, cc, ccv);
}
