/*************************************************************************
*	ĥMML ޥ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"midicc.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmtrk.h"
#include	"mmpart.h"
#include	"mmdec.h"
#include	"msgdat.h"
#include	"midicc.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*#define	_DEBUG*/
/*----------------------------------------------------------------------*/

static int		dec_mmlcmd(MMSQR_T *sqr,MMPART_T *part,int argc,char **argv);
static int		dec_natural(MMSQR_T *sqr,MMPART_T *part,int argc,char **argv);
static int		dec_sharp(MMSQR_T *sqr,MMPART_T *part,int argc,char **argv);
static int		dec_flat(MMSQR_T *sqr,MMPART_T *part,int argc,char **argv);

#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
struct	_partcmdtbl_t
{
	CONST char	*name;
	int			(*func)(MMSQR_T *, MMPART_T *, int, char **);
} PartCmdTbl[] =
{
	{ "flat"      ,	dec_flat			},
	{ "mmlcmd"    ,	dec_mmlcmd			},
	{ "natural"   ,	dec_natural			},
	{ "sharp"     ,	dec_sharp			},
};
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

static int		cmpFunc( const struct _partcmdtbl_t *c1, const struct _partcmdtbl_t *c2 )
{
	return (mm_strcmpi(c1->name,c2->name));
}


/*************************************************************************
*	ĥѡȥޥ
*-----------------------------------------------------------------------
*	^(<command>,parameter)
*************************************************************************/

int _FAST	MMdec_partCmd( MMSQR_T *sqr, MMPART_T *part, CONST char **s )
{
	CONST char	   *p;

	++(*s);	/* skip '^' */
	SKIP_SPACE(*s);
	p = *s;
	if ( *(*s) != '(' )
	{
_PART_ERR:
		sqr->errPoint = p;
		sqr->errMsg = "'^' part command error!";
		return (ERR);
	}

	{
		struct _partcmdtbl_t	key;
		struct _partcmdtbl_t   *cmd;
		int						ret, argc;
		char				   **argv;

		if ( (argc = mm_get_arg(s, &argv)) <= 0 )
			goto _PART_ERR;
		key.name = argv[0];
		key.func = (int (*)(MMSQR_T *,MMPART_T *, int, char **))0;
		cmd = bsearch( &key, PartCmdTbl, sizeof(PartCmdTbl)/sizeof(*PartCmdTbl),
		  sizeof(*PartCmdTbl), (int (*)(const void *, const void *))cmpFunc );
		if ( !cmd )
		{
			mm_clear_arg(argc,argv);
			goto _PART_ERR;
		}
		ret = (cmd->func)(sqr,part,argc,argv);
		mm_clear_arg(argc,argv);
		return (ret);
	}
}

/*************************************************************************
*	ޥ
*-------------------------------------------------------------------------
*	^(mmlcmd,ch,command)
*************************************************************************/

static int		dec_mmlcmd(MMSQR_T *sqr,MMPART_T *part,int argc,char **argv)
{
	int		n, typ;

	if ( argc < 3 )
	{
_PARA_ERR:
		sqr->errMsg = "^(MMLCMD) parameter error!";
		return (ERR);
	}

	{
		CONST char 	*s = argv[1];

		n = tolower(*s) - 'a';
		if ( n < 0 || n > 25 || sqr->mmlCmd[n] < 0 )
			goto _PARA_ERR;
	}

	{
		CONST char 	*s = argv[2];

		if ( (typ = mm_get_mmlcmd( &s )) < 0 )
			goto _PARA_ERR;
	}
	part->mmlCmd[n] = typ;

	return (NORMAL);
}

static int		set_alShift(MMPART_T *part, CONST char *s, int shift)
{
	int				ch;

	while ( *s )
	{
		ch = toupper(*s);
		if ( ch >= 'A' && ch <= 'G' )
			part->alShift[ch - 'A'] = shift;
		else if ( !isspace(*s) )
			return (ERR);
		++s;
	}
	return (NORMAL);
}

/*************************************************************************
*	ʥ
*-------------------------------------------------------------------------
*	^(natunal,abcdefg)
*************************************************************************/

static int		dec_natural(MMSQR_T *sqr,MMPART_T *part,int argc,char **argv)
{
	if ( argc == 1 )
	{
		int		i;

		for ( i = 0; i < 7; ++i )
			part->alShift[i] = 0;
	} else if ( argc == 2 )
	{
		if ( set_alShift(part, argv[1], 0) )
			goto _PARA_ERR;
	} else
	{
_PARA_ERR:
		sqr->errMsg = "^(natural) error!";
		return (ERR);
	}
	return (NORMAL);
}


/*************************************************************************
*	㡼׻
*-------------------------------------------------------------------------
*	^(sharp,abcdefg)
*************************************************************************/

static int		dec_sharp(MMSQR_T *sqr,MMPART_T *part,int argc,char **argv)
{
	if ( argc == 1 )
	{
		int		i;

		for ( i = 0; i < 7; ++i )
			part->alShift[i] = 1;
	} else if ( argc == 2 )
	{
		if ( set_alShift(part, argv[1], 1) )
			goto _PARA_ERR;
	} else
	{
_PARA_ERR:
		sqr->errMsg = "^(sharp) error!";
		return (ERR);
	}
	return (NORMAL);
}

/*************************************************************************
*	եåȻ
*-------------------------------------------------------------------------
*	^(flat,abcdefg)
*************************************************************************/

static int		dec_flat(MMSQR_T *sqr,MMPART_T *part,int argc,char **argv)
{
	if ( argc == 1 )
	{
		int		i;

		for ( i = 0; i < 7; ++i )
			part->alShift[i] = -1;
	} else if ( argc == 2 )
	{
		if ( set_alShift(part, argv[1], -1) )
			goto _PARA_ERR;
	} else
	{
_PARA_ERR:
		sqr->errMsg = "^(flat) error!";
		return (ERR);
	}
	return (NORMAL);
}

