/*************************************************************************
*	ԥ󥻥å
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"midicc.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmpart.h"
#include	"mmpin.h"
#include	"mmdec.h"
#include	"mmsg.h"
#include	"msgdat.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

#define	PIN_HASH(_pinNo)	(((_pinNo) * 31) & (_MMPIN_HASH_MAX - 1))

/*************************************************************************
*	ԥγ
*************************************************************************/

void _FAST	mmpin_allfree( MMPART_T *part )
{
	MMSQR_T		*sqr = ((MMTRK_T *)(part->trk))->sqr;
	int			j;

	for ( j = 0; j < _MMPIN_HASH_MAX; ++j )
	{
		MMPIN_T	*pin, *pinNext;

		pin = part->pinTbl[j];
		while ( pin )
		{
			pinNext = pin->next;
			{
				MMSETV_T	*pv, *pvNext;

				pv = pin->v;
				while ( pv )
				{
					pvNext = pv->next;
					free( pv );		sqr->workSize -= sizeof(MMSETV_T);
					pv = pvNext;
				}
			}
			free(pin);		sqr->workSize -= sizeof(MMPIN_T);
			pin = pinNext;
		}
		part->pinTbl[j] = NULL;
	}
}

/*************************************************************************
*	ԥֹΥԥ֤
*************************************************************************/

MMPIN_T * _FAST	mmpin_getPin( MMPART_T *part, int pinNo )
{
	MMPIN_T	*pin = part->pinTbl[ PIN_HASH(pinNo) ];

	while ( pin )
	{
		if ( pin->no == pinNo )
			break;
		pin = pin->next;
	}
	return (pin);
}

/*************************************************************************
*	ԥѰդ
*************************************************************************/

MMPIN_T	* _FAST mmpin_newPin( MMPART_T *part, int pinNo)
{
	MMPIN_T	*pin = mmpin_getPin(part,pinNo);

	if ( pin == NULL )
	{
		if ( (pin = calloc(sizeof(MMPIN_T),1)) != NULL )
		{
			MMPIN_T	**pinPtr = &(part->pinTbl[ PIN_HASH(pinNo) ]);

			((MMSQR_T *)(((MMTRK_T *)(part->trk))->sqr))->workSize += sizeof(MMPIN_T);
			pin->no   = pinNo;
			pin->next = *pinPtr;
			*pinPtr   = pin;
		}
	} else
	{	/* 򥯥ꥢ	*/
		MMSETV_T	*pv;
		MMSQR_T		*sqr = ((MMTRK_T *)(part->trk))->sqr;

		pv = pin->v;
		while ( pv )
		{
			MMSETV_T	*pvNext;
			pvNext = pv->next;
			free( pv );		sqr->workSize -= sizeof(MMSETV_T);
			pv = pvNext;
		}
		pin->v = NULL;
	}
	return (pin);
}

/*************************************************************************
*	ԥǡɲä
*************************************************************************/

int _FAST	mmpin_setpin( MMPIN_T *pin, int typ, MMVALUE_T *val )
{
	MMSETV_T	*vdat, *v = pin->v;

	if ( (vdat = calloc(sizeof(MMSETV_T),1)) == NULL )
		return (ERR);
	vdat->typ = typ;
	vdat->val = *val;

	if ( v == NULL )
		pin->v = vdat;
	else
	{
		while ( v->next )
			v = v->next;
		v->next = vdat;
	}
	return (NORMAL);
}

#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
static struct	 _cmdtbl_t
{
	CONST char	   *name;
	int				typ;
} CmdTbl[] =
{
	{ _MM_CAF_      , MMSETYP_CAF         },
	{ _MM_CAFDELAY_ , MMSETYP_CAFDELAY    },
	{ _MM_CAFPRES_  , MMSETYP_CAFPRES     },
	{ _MM_CC_       , MMSETYP_CC          },
	{ _MM_CD_       , MMSETYP_CAFDELAY    },
	{ _MM_CH_       , MMSETYP_CH          },
	{ _MM_D_        , MMSETYP_DELAY       },
	{ _MM_DELAY_    , MMSETYP_DELAY       },
	{ _MM_G_        , MMSETYP_GATETIME    },
	{ _MM_GATE_     , MMSETYP_GATETIME    },
	{ _MM_GATEPER_  , MMSETYP_GATERATIO   },
	{ _MM_GP_       , MMSETYP_GATERATIO   },
	{ _MM_K_        , MMSETYP_KEYSHIFT    },
	{ _MM_KEY_      , MMSETYP_KEYSHIFT    },
	{ _MM_O_        , MMSETYP_OCTAVE      },
	{ _MM_OCTAVE_   , MMSETYP_OCTAVE      },
	{ _MM_OFFVEL_   , MMSETYP_OFFVELOCITY },
	{ _MM_OV_       , MMSETYP_OFFVELOCITY },
	{ _MM_P_        , MMSETYP_PITCH       },
	{ _MM_PAF_      , MMSETYP_PAF         },
	{ _MM_PAFDELAY_ , MMSETYP_PAFDELAY    },
	{ _MM_PAFPRES_  , MMSETYP_PAFPRES     },
	{ _MM_PD_       , MMSETYP_PAFDELAY    },
	{ _MM_PG_       , MMSETYP_PROG        },
	{ _MM_PITCH_    , MMSETYP_PITCH       },
	{ _MM_PROG_     , MMSETYP_PROG        },
	{ _MM_S_        , MMSETYP_STEPTIME    },
	{ _MM_STEP_     , MMSETYP_STEPTIME    },
	{ _MM_T_        , MMSETYP_TEMPO       },
	{ _MM_TEMPO_    , MMSETYP_TEMPO       },
	{ _MM_V_        , MMSETYP_VELOCITY    },
	{ _MM_VEL_      , MMSETYP_VELOCITY    },
};
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

static int		cmd_name_len = 0;

static int		cmpFunc( const struct _cmdtbl_t *c1, const struct _cmdtbl_t *c2 )
{
	return (mm_strncmpi(c1->name,c2->name,cmd_name_len));
}

/*************************************************************************
*	!	PIN ޥ
*************************************************************************/

int _FAST	MMdec_pin( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMTRK_T		   *trk = part->trk;
	MMPIN_T		   *pin;
	int				pinNo;
	CONST char	   *err = NULL;

	++(*s);	/* skip '!' */
	if ( isdigit(*(*s)) )
	{	/* ֹɤ߼	*/
		if ( mm_getIntDigit(&pinNo,s) || pinNo < 1 )
		{
			char	tmp[128];

_PIN_ERR:
			if ( err )
				sprintf( tmp, " '%s'", err );
			else
				tmp[0] = '\0';
			MM_setErrMsg( sqr, _msg_mmpin_Pin_command_error[TypMsg], tmp );
			return (ERR);
		}
	} else
		pinNo = 0;	/* ƥԥֹ	*/

	if ( *(*s) == '(' )
	{	/* ѥ᡼ɤ߼	*/
		int		argc;
		char	**argv;

		part->pinFlag = FALSE;
		/* ԥѰդ	*/
		if ( (pin = mmpin_newPin(part,pinNo)) == NULL )
		{
/*_MEM_ERR:*/
			sqr->errMsg = _msg_out_of_memory[TypMsg];
			return (ERR);
		}
		pin->flag    = FALSE;
		part->pinPtr = pin;

		if ( (argc = mm_get_arg( s, &argv )) > 0 )
		{
			int		i;

			for ( i = 0; i < argc; ++i )
			{
				int			typ;
				CONST char	*ap;

				err = ap = argv[i];
				typ = ERR;
				{
					struct _cmdtbl_t	key;
					struct _cmdtbl_t	*cmd;

					key.typ  = -1;
					key.name = ap;
					cmd_name_len = 0;
					while ( *ap )
					{
						++cmd_name_len;
						if ( *ap == ':' )
							break;
						++ap;
					}
					if ( *ap != ':' )
						goto _PIN_ERR;
					++ap;
					cmd = bsearch( &key, CmdTbl, sizeof(CmdTbl)/sizeof(*CmdTbl),
					  sizeof(*CmdTbl), (int (*)(const void *, const void *))cmpFunc );
					if ( cmd )
						typ = cmd->typ;
				}

				{
					MMPART_PARA_T	*para;
					MMVALUE_T		val;

					para = &(part->set);
					switch ( typ )
					{
						case MMSETYP_TEMPO:
						{
							if ( trk->trkNo > 0 )
							{
								sqr->errMsg = _msg_Tempo_change_error[TypMsg];
								return (ERR);
							}
							val = para->tempo;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,MMTEMPO_MIN,MMTEMPO_MAX) )
								goto _PIN_ERR;
							break;
						}
						case MMSETYP_CH:
						{
							int		ch;
							if ( mm_getIntDigit( &ch, &ap ) || ch < 1 || ch > 16 )
								goto _PIN_ERR;
							MM_setValue( &val, _MMVAL_ABS, ch - 1 );
							break;
						}
						case MMSETYP_DELAY:
						{
							val = para->delay;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,-32768,32767) )
									goto _PIN_ERR;
							}
							break;
						}
						case MMSETYP_KEYSHIFT:
						{
							val = para->keyShift;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,-127,127) )
									goto _PIN_ERR;
							}
							break;
						}
						case MMSETYP_OCTAVE:
						{
							val = para->octave;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,MMOCTAVE_MIN,MMOCTAVE_MAX) )
									goto _PIN_ERR;
							}
							break;
						}
						case MMSETYP_VELOCITY:
						{
							val = para->vel;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,1,127) )
									goto _PIN_ERR;
							} else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < 1 )
									val.value = 1;
								else if ( val.value > 127 )
									val.value = 127;
							}
							break;
						}
						case MMSETYP_OFFVELOCITY:
						{
							val = para->offVel;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,0,127) )
									goto _PIN_ERR;
							} else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < 0 )
									val.value = 0;
								else if ( val.value > 127 )
									val.value = 127;
							}
							break;
						}
						case MMSETYP_STEPTIME:
						{
							val = para->stepTime;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,0,65535) )
									goto _PIN_ERR;
							}
							break;
						}
						case MMSETYP_GATERATIO:
						{
							val = para->gateRatio;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,1,1000) )
									goto _PIN_ERR;
							}
							break;
						}
						case MMSETYP_GATETIME:
						{
							val = para->gateTime;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,0,65535) )
									goto _PIN_ERR;
							}
							break;
						}
						case MMSETYP_PROG:
						{
							val = para->prog;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,1,128) )
									goto _PIN_ERR;
							}
							break;
						}
						case MMSETYP_PITCH:
						{
							val = para->pitch;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,-8192,8191) )
									goto _PIN_ERR;
							} else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < -8192 )
									val.value = -8192;
								else if ( val.value > 8191 )
									val.value = 8191;
							}
							break;
						}
						case MMSETYP_CAF:
						case MMSETYP_CAFPRES:
						{
							val = para->caf;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,0,127) )
									goto _PIN_ERR;
							} else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < 0 )
									val.value = 0;
								else if ( val.value > 127 )
									val.value = 127;
							}
							break;
						}
						case MMSETYP_CAFDELAY:
						{
							val = para->cafDelay;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,0,65535) )
									goto _PIN_ERR;
							}
							break;
						}
						case MMSETYP_PAF:
						case MMSETYP_PAFPRES:
						{
							val = para->paf;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,0,127) )
									goto _PIN_ERR;
							} else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < 0 )
									val.value = 0;
								else if ( val.value > 127 )
									val.value = 127;
							}
							break;
						}
						case MMSETYP_PAFDELAY:
						{
							val = para->pafDelay;
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,0,65535) )
									goto _PIN_ERR;
							}
							break;
						}
						case MMSETYP_CC:
						{
							int		cc, base;

							if ( mm_getIntDigit( &cc, &ap ) || cc < 0 || cc > 127 )
								goto _PIN_ERR;
							if ( *ap != '/' )	goto _PIN_ERR;
							++ap;
							base = trk->tbl.ccvBase[cc];
							typ = cc + MMSETYP_CC;
							val = para->ccv[cc];
							if ( mm_getValue2( &val, &ap ) )
								goto _PIN_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && !(val.mode & _MMVAL_RATIO) )
							{	if ( MM_CHKVALUE(&val,-base,127-base) )
									goto _PIN_ERR;
							} else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < -base )
									val.value = -base;
								else if ( val.value > 127-base )
									val.value = 127-base;
							}
							break;
						}
						default:
							goto _PIN_ERR;
					}
					/* ԥ	*/
					if ( mmpin_setpin( pin, typ, &val ) )
						return (ERR);
					((MMSQR_T *)(trk->sqr))->workSize += sizeof(MMSETV_T);
				}
			}
			mm_clear_arg(argc,argv);
			if ( pinNo == 0 )
				goto _PIN_SETUP;
		}
	} else
	{	/* 	*/
_PIN_SETUP:
		/* ֹΥԥѰդ	*/
		if ( (pin = mmpin_getPin(part,pinNo)) == NULL )
		{
			MM_setErrMsg( sqr, _msg_mmpin_Unknown_pin_number[TypMsg], pinNo );
			return (ERR);
		}
		pin->flag     = TRUE;
		part->pinPtr  = pin;
		part->pinFlag = TRUE;
	}
	return (NORMAL);
}
