/*************************************************************************
*	MML ץץå
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>

#include	"he386.h"
#include	"mmfile.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmcci.h"
#include	"mmpp.h"
#include	"mmac.h"
#include	"cci.h"
#include	"msgdat.h"
#include	"mmsg.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

#define	_IF_OFF		(0)
#define	_IF_TRUE	(1)
#define	_IF_FALSE	(2)
#define	_IF_INV		(3)	/* ̵	*/
#define	_IF_GO		(0x80)

static int _FAST	MMpp_line( MMSQR_T *sqr, CONST char *s );

/*************************************************************************
	MPP Υץ
*************************************************************************/

int		MMpp_open( MMSQR_T *sqr, CONST char *fn)
{
	MMINC_T	   *mminc;
	int			i;

	sqr->incLevel = 0;
	for ( i = 0; i < _MMINC_MAX; ++i )
	{
		mminc = &(sqr->inc[i]);
		mminc->fp = NULL;
		mminc->cNestMax = 0;
	}

	{	/* ǥեȥޥϿ	*/
		char		tmp[256], mac[256];

		FS_getFnamPath(tmp,fn);
		mac[0] = '_';
		FS_getFnam(&mac[1], tmp);
		MMac_define( sqr, mac, NULL, 0 );
	}

	return MMpp_fopen( sqr, fn );
}

void	MMpp_close( MMSQR_T *sqr )
{
	MMINC_T	*mminc;
	int		i;

	for ( i = 0; i < _MMINC_MAX; ++i )
	{
		mminc = &(sqr->inc[i]);
		if ( mminc->fp )
		{
			SP_FCLOSE(mminc->fp);	mminc->fp = NULL;
		}
	}
}

/*************************************************************************
	ե륪ץ
*************************************************************************/

int		MMpp_fopen( MMSQR_T *sqr, CONST char *fn )
{
	MMINC_T	*mminc;

	if ( sqr->incLevel >= _MMINC_MAX )
	{
		sqr->errMsg = _msg_Too_many_file_open[TypMsg];
		return (-1);
	}

	mminc = &(sqr->inc[sqr->incLevel++]);
	mminc->ln = 0;
	mminc->cNestMax = mminc->cLevel = 0;
	{
		int		i;

		for ( i = 0; i < _MMNEST_MAX; ++i )
			mminc->cFlag[i] = _IF_OFF;
	}

	strcpy( mminc->fn, fn );
	if ( (mminc->fp = MM_fopen(sqr, mminc->fn, FOPEN_READ_BIN)) == NULL )
	{
		MM_setErrMsg( sqr, "%s : %s", mminc->fn, _msg_File_open_error[TypMsg] );
		return (-1);
	}

	return (0);
}

#define	MACRO_NEST_MAX	(128)
static	int		MacroNest;	/* ޥƵŸå	*/

/*************************************************************************
*	ϹԤμ
*************************************************************************/

char * _FAST MMpp_getline( MMSQR_T *sqr )
{
	MMINC_T	   *mminc;
	size_t		ofs;

	if ( sqr->incLevel <= 0 || sqr->incLevel >= _MMINC_MAX )
	{
		MM_setErrMsg( sqr,"CPP input errror!!");
		MM_error(sqr);
	}

NEXT_LINE:
	ofs = 0;
	mminc = &(sqr->inc[sqr->incLevel-1]);

NEXT_READ:
	if ( fgets( &(sqr->linBuf[ofs]), _MM_DEC_BUFSIZ - ofs, mminc->fp ) == NULL )
	{	/* ERROR or EOF */
		SP_FCLOSE(mminc->fp);	mminc->fp = NULL;
		if ( mminc->cNestMax > 0 )
		{	/* #ifdefEOF 򸡽Ф	*/
			sqr->errMsg = _msg_Eof_encountered_with_in_if_construct[TypMsg];
			MM_error(sqr);
		}
		if ( --(sqr->incLevel) == 0 )
			return (NULL);	/* EOF (normal end) */
		goto NEXT_LINE;
	}
	++(mminc->ln);

	{	/* βԤ	*/
		int		len;

		len = strlen(sqr->linBuf);
		while ( len > 0 )
		{
			int		ch;

			ch = sqr->linBuf[len-1];
			if ( ch == '\n' || ch == '\r' )
			{
				--len;
				sqr->linBuf[len] = '\0';
			} else
				break;
		}

		if ( sqr->output.src )
			HE_printf(sqr,_HE_MSG_INP,"%5d:%s", mminc->ln, sqr->linBuf );

		if ( len > 0 )
		{
			char	   *s;
			int			i, kan;

			s = sqr->linBuf;
			i = kan = 0;
			for (;;)
			{
				if ( iskan( &s[i]) )
				{
					kan = 1;
					i += 2;
				} else
				{
					kan = 0;
					++i;
				}
				if ( i >= len )
					break;
			}
			if ( kan == 0 && sqr->linBuf[len-1] == '\\' )
			{
				ofs = len;
				goto NEXT_READ;
			}
		}
	}


	{
		char	*s;
		int		mode;

		s = sqr->linBuf;

		/* ץץå	*/
		if ( *s == '#' )
		{
			if ( MMpp_line(sqr,s) < 0 )
				return (NULL);
			goto NEXT_LINE;
		}

		mode = mminc->cFlag[mminc->cLevel];
		if ( mode == _IF_OFF || (mode & _IF_GO) )
		{	/* ޥִ	*/
			int		er;

			if ( sqr->linBuf[0] == '/' )
			{
				if ( sqr->output.rem )
					HE_printf(sqr,_HE_MSG_REM,"%5d:%s", mminc->ln, sqr->linBuf );
				goto NEXT_LINE;
			} else
			{
				MacroNest = 0;
				er = MMpp_decode( sqr, _MM_DEC_BUFSIZ, sqr->decBuf, sqr->linBuf, -1, NULL );

				if ( er < 0 )
					return (NULL);
				else
				{
					if ( sqr->output.mpp )
						HE_printf(sqr,_HE_MSG_MPP,"%5d:%s", mminc->ln, sqr->decBuf );
					return (sqr->decBuf);
				}
			}
		} else
		{
			goto NEXT_LINE;
		}
	}
}

/*************************************************************************
*	ޥѥ᡼դŸ
*************************************************************************/

static int _FAST	MMpp_macDecode( MMSQR_T *sqr, size_t bufSiz, char *dst, CONST char **src, int _argc, char **_argv )
{
#	define	ARG_MAX		(128)
#	define	ARG_BUFSIZ	(512)
	char		name[256];
	int			er, i, argc;
	char	   *argv[ARG_MAX];

	{
		CONST char	   *sp  = *src;
		char		   **av, *mp = name, *tmpbuf;

		mp = name;
		while ( *sp )
		{
			if ( MMAC_ISCH(*sp) )
			{
				*mp++ = *sp++;
			} else
				break;
		}
		*mp = '\0';
		SKIP_SPACE(sp);

		if ( *sp == '(' )
		{	/* ѥ᡼μФ	*/
			argc = mm_get_arg( &sp, &av );
		} else
			argc = 0;

		if ( (tmpbuf = malloc(ARG_BUFSIZ)) == NULL )
		{
			sqr->errMsg = _OUT_OF_MEMORY;
			return (ERR);
		}
		for ( i = 0; i < argc; ++i )
		{
			int		ret;

			if ( (ret = MMpp_decode( sqr, ARG_BUFSIZ-1, tmpbuf, av[i], _argc, _argv )) < 0 )
				return (ERR);
			if ( (argv[i] = malloc(ret+1)) == NULL )
			{
				sqr->errMsg = _OUT_OF_MEMORY;
				return (ERR);
			}
			memcpy(argv[i],tmpbuf,ret+1);
		}
		free(tmpbuf);
		mm_clear_arg(argc,av);
		*src = sp;
	}

	{
		MMAC_T		*mac;

		if ( (mac = MMac_getmac(sqr,name)) == NULL )
		{
			MM_setErrMsg( sqr, "Can't define macro %s ", name );
			er = ERR;	goto _RET;
		}
		switch ( mac->att )
		{
			case	MMAC_ATT_NORMAL:
			case	MMAC_ATT_INP:
				if ( mac->str )
				{
					if ( ++MacroNest > MACRO_NEST_MAX )
					{
						sqr->errMsg = "Macro stack over!";
						er = ERR;
					} else
					{
						er = MMpp_decode( sqr, bufSiz, dst, mac->str, argc, argv );
						--MacroNest;
					}
				}
				break;

			case	MMAC_ATT_TABLE:
			{
				if ( argc >= 0 )
				{
					int			n, len;
					int			*ar = (int *)(mac->str);
					char		tmp[32];

					if ( argc == 0 || argv[0][0] == '\0' )
						n = 0;
					else
					{
						CONST char	*bufptr = argv[0];

						if ( mm_getIntDigit( &n, &bufptr)
						    || n < 0 || (size_t)n >= mac->len/(sizeof(int)) )
						{
							sqr->errMsg = "Table error!";
							er = ERR;	goto _RET;
						}
					}
					sprintf( tmp, "%d", ar[n] );
					len = strlen(tmp);
					if ( (size_t)len >= bufSiz )
					{
						sqr->errMsg = _OUT_OF_STRING_SPACE;
						er = ERR;	goto _RET;
					}
					memcpy( dst, tmp, len );
					er = len;
				}
				break;
			}
			case	MMAC_ATT_FUNC:
				if ( mac->func )
					er = (mac->func)(sqr,bufSiz,dst,argc,argv);
				break;

			case	MMAC_ATT_EXT:	/* CCI */
				er = CCI_exec(mac->str, 5, sqr, bufSiz, dst, argc, argv);
				break;
		}
	}

_RET:
	for ( i = 0; i < argc; ++i )
		free( argv[i] );
	return (er);
}

int		MMpp_repeat( MMSQR_T *sqr, size_t bufsiz, char *dst, CONST char **src, int argc, char **argv )
{
	size_t		ds = 0;
	char		*dp = dst;
	CONST char	*sp = *src;

	{
		size_t		len;
		int			count, nest;
		CONST char	*start;

		start = ++sp;	/* skip '(' */
		len  = 0;
		nest = 1;
		while ( *sp )
		{
			if ( *sp == '(' )
			{
				++nest;
			} else if ( *sp == ')' )
			{	if ( --nest == 0 )
					break;
			}
			++sp;
			++len;
		}
		if ( *sp != ')' )
		{
_REPART_ERR:
			sqr->errMsg = "Repeat error!";
			return (ERR);
		}
		++sp;
		if ( mm_getIntDigit( &count, &sp) == NORMAL )
		{
			if ( count < 1 )
				goto _REPART_ERR;
		} else
			count = 2;
		if ( len > 0 )
		{
			char	*buf;

			if ( (buf = malloc(len + 1)) == NULL )
			{
				sqr->errMsg = _OUT_OF_MEMORY;
				return (ERR);
			}
			memcpy( buf, start, len );
			buf[len] = '\0';
			while ( count-- > 0 )
			{
				int		er;
				er = MMpp_decode( sqr,
				              bufsiz - ds, dp, buf, argc, argv );
				if ( er < 0 )
				{
					free( buf );
					return (er);
				}
				dp += er;	ds += er;
			}
			free( buf );
		}
	}
	*src = sp;

	return (ds);
}

int _FAST	MMpp_decode( MMSQR_T *sqr, size_t bufsiz, char *dst, CONST char *src, int argc, char **argv )
{
	int			remark = 0;
	size_t		ds = 0;
	char		*dp = dst;
	CONST char	*sp = src;

	while ( *sp )
	{
		switch( *sp )
		{
			case '\\':
			{
				switch( *(sp++) )
				{
					case 't':
						*dp++ = '\t';	++ds;
						goto SET_CHA;

					case 'x':
					{
						int		c1, c2;

						c1 = mm_getXdigit(*(sp++));
						c2 = mm_getXdigit(*(sp++));
						if ( c1 < 0 || c2 < 0 )
							break;
						*dp++ = (c1<<4) | c2;	++ds;
						goto SET_CHA;
					}
					default:
						*dp++ = *sp++;	++ds;
						goto SET_CHA;
				}
				break;
			}
			case '$':
			{	/* ޥ	*/
				++sp;	/* skip '$' */
				if ( *sp == '(' )
				{	/* ԡ	*/
					int		er;

					er = MMpp_repeat( sqr, bufsiz - ds, dp, &sp, argc, argv );
					if ( er < 0 )
						return (er);
					ds += er;	dp += er;
					break;
				} else if ( isxdigit(*sp) && isxdigit(sp[1])
				    && (!MMAC_ISCH(sp[2]) ) )
				{	/* 16ʿ	*/
					int		len;
					char	tmp[8];

					sprintf( tmp, "%d",
					    (mm_getXdigit(*sp)<<4) + mm_getXdigit(sp[1]) );
					len = strlen(tmp);
					sp += 2;
					if ( ds + len >= bufsiz )
						goto SET_ERR;
					strcpy( dp, tmp );
					dp += len;
					ds += len;
					goto SET_CHA;
				} else if ( argc >= 0 && *sp >= '1' && *sp <= '9'
				    && !isdigit(sp[1]) )
				{	/* ޥΰ	*/
					int		n;

					n = *sp - '1';
					++sp;
					if ( n < argc )
					{
						int		er;

						er = MMpp_decode( sqr,
						              bufsiz - ds, dp, argv[n], -1, NULL );
						if ( er < 0 )
							return (er);
						dp += er;	ds += er;
					}
					break;
				} else if ( *sp == '$' )	/* "$$" */
				{
					++sp;
					*dp++ = '$';
					 ds++;
					break;
				} else if ( !MMAC_ISTOPCH(*sp) )
				{
					sqr->errMsg = _msg_Macro_name_must_be_identifier[TypMsg];
					return (-1);
				}
				{
					int		er;

					er = MMpp_macDecode( sqr, bufsiz - ds, dp, &sp, argc, argv );
					if ( er < 0 )
						return (er);
					dp += er;	ds += er;
				}
				break;
			}
			case '/':
			{
				if ( sp[1] == '*' )
				{	/* 	*/
					++remark;
					sp += 2;
					while ( *sp )
					{
						if ( *sp == '*' && sp[1] == '/' )
						{
							sp += 2;
							if ( --remark == 0 )
								break;
						} else if ( *sp == '/' && sp[1] == '*' )
						{
							sp += 2;
							++remark;
						} else
							++sp;
					}
				} else
				{
					*dp++ = *sp++;	++ds;
					goto SET_CHA;
				}
				break;
			}
			default:
				*dp++ = *sp++;	++ds;
SET_CHA:		if ( ds >= bufsiz )
				{
SET_ERR:			sqr->errMsg = _OUT_OF_STRING_SPACE;
					return (ERR);
				}
				break;
		}
	}
	*dp = '\0';

	return ((int)ds);
}

/*************************************************************************
*	ƥץץåޥɤʬ
*************************************************************************/

static int _FAST	MMpp_include( MMSQR_T *sqr, CONST char *s );

static int _FAST	MMpp_define( MMSQR_T *sqr, CONST char *s );
static int _FAST	MMpp_undef( MMSQR_T *sqr, CONST char *s );
static int _FAST	MMpp_table( MMSQR_T *sqr, CONST char *s );

static int _FAST	MMpp_if( MMSQR_T *sqr, CONST char *s );
static int _FAST	MMpp_ifdef( MMSQR_T *sqr, CONST char *s );
static int _FAST	MMpp_ifndef( MMSQR_T *sqr, CONST char *s );
static int _FAST	MMpp_else( MMSQR_T *sqr, CONST char *s );
static int _FAST	MMpp_endif( MMSQR_T *sqr, CONST char *s );

static int _FAST	MMpp_error( MMSQR_T *sqr, CONST char *s );

#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
static CONST struct _mppcmdtbl_t
{
	CONST char	   *name;
#if	defined(_MSC_VER) || defined(__WATCOMC__)
	int	    (_FAST *func)(MMSQR_T *sqr, CONST char *s);
#else
	int _FAST     (*func)(MMSQR_T *sqr, CONST char *s);
#endif
} MppCmdTbl[] =
{
	{ "define" ,	MMpp_define		},
	{ "else"   ,	MMpp_else		},
	{ "endif"  ,	MMpp_endif		},
	{ "error"  ,	MMpp_error		},
	{ "if"     ,	MMpp_if			},
	{ "ifdef"  ,	MMpp_ifdef		},
	{ "ifndef" ,	MMpp_ifndef		},
	{ "include",	MMpp_include	},
	{ "table"  ,	MMpp_table		},
	{ "undef"  ,	MMpp_undef		},
};
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

static int		cmpFunc(const struct _mppcmdtbl_t * c1, const struct _mppcmdtbl_t * c2 );

static int _FAST	MMpp_line( MMSQR_T *sqr, CONST char *s )
{
	CONST char	   *name;

	if ( *s == '#' )
		++s;	/* skip '#'	*/
	SKIP_SPACE(s);
	if ( *s == '\0' )
		return (NORMAL);

	if ( *s == '$' )
	{	/* ex. #$MACRO ...	*/
		return MMpp_define(sqr,s);
	}

	/* ޥ̾Ф	*/
	name = s;
	for (;;)
	{
		if ( MM_ISSTRTERM(*s) )
			break;
		s++;
	}

	SKIP_SPACE(s);

	{	/* ̿ʬ	*/
		struct _mppcmdtbl_t		key, *cmd;

		key.name = name;
#if	defined(_MSC_VER) || defined(__WATCOMC__)
		key.func = (int (_FAST *)(MMSQR_T *,CONST char *))0;
#else
		key.func = (int _FAST (*)(MMSQR_T *,CONST char *))0;
#endif
		cmd = bsearch( &key, MppCmdTbl, sizeof(MppCmdTbl)/sizeof(*MppCmdTbl),
		  sizeof(*MppCmdTbl), (int (*)(const void *, const void *))cmpFunc );
		if ( cmd )
			return (cmd->func)(sqr,s);
	}
	return (NORMAL);
}

static int		cmpFunc( const struct _mppcmdtbl_t *c1, const struct _mppcmdtbl_t *c2 )
{
	return (mm_strcmpi(c1->name,c2->name));
}

#define	CHK_IF(_sqr)	{								\
	int		mode;										\
	MMINC_T	*mminc;										\
	mminc = &((_sqr)->inc[sqr->incLevel-1]);			\
	mode = mminc->cFlag[mminc->cLevel];					\
	if ( mode != _IF_OFF && (mode & _IF_GO) == 0 )		\
		return(NORMAL);									\
}

static int _FAST	MMpp_include( MMSQR_T *sqr, CONST char *s )
{
	int		ch;
	char	fn[256];	/* ե̾	*/
	int		i = 0;

	CHK_IF(sqr);
	SKIP_SPACE(s);
	switch ( *s++ )
	{
		case	'"':	ch = '"';	break;
		case	'<':	ch = '>';	break;
		default:
		{	/* error */
_ERR:		sqr->errMsg = _msg_File_name_must_be_indentifier[TypMsg];
			return (ERR);
		}
	}
	while ( *s && !isspace(*s) && i < 256 )
	{
		if ( *s == ch )
			break;
		fn[i++] = *(s++);
	}
	if ( *s != ch )		goto _ERR;
	fn[i] = '\0';
	return	MMpp_fopen( sqr, fn );
}

#define	_MAC_NAME_MAX	(256)

static int _FAST	MMpp_getMacName( MMSQR_T *sqr, char *name, CONST char **s )
{
	int		i;

	SKIP_SPACE(*s);
	if ( *(*s) == '\0' )
		return (0);
	if ( !MMAC_ISTOPCH(*(*s)) )
	{
		sqr->errMsg = _msg_Macro_name_must_be_identifier[TypMsg];
		return (-1);
	}

	i = 0;
	while ( *(*s) )
	{
		int		ch;

		ch = (*((*s)++)) & 0xFF;
		if ( MM_ISSTRTERM(ch) )
			break;
		if ( !MMAC_ISCH(ch) )
		{
			sqr->errMsg = _msg_Macro_name_must_be_identifier[TypMsg];
			return (-1);
		}
		name[i++] = ch;
		if ( i >= _MAC_NAME_MAX )
		{
			sqr->errMsg = _TOO_LONG_MACRO_NAME;
			return (-1);
		}
	}
	name[i] = '\0';
	return (0);
}

/*************************************************************************
*	ޥ
*************************************************************************/

static int _FAST	MMpp_define( MMSQR_T *sqr, CONST char *s )
{
	char	name[_MAC_NAME_MAX];
	int		mode;

	CHK_IF(sqr);
	SKIP_SPACE(s);
	if ( *s == '$' )
	{
		++s;
		mode = 1;
	} else
		mode = 0;
	if ( MMpp_getMacName(sqr,name,&s) )
		return (ERR);
	SKIP_SPACE(s);
	return MMac_define( sqr, name, s, mode );
}

static int _FAST	MMpp_undef( MMSQR_T *sqr, CONST char *s )
{
	char	name[_MAC_NAME_MAX];

	CHK_IF(sqr);
	if ( MMpp_getMacName(sqr,name,&s) )
		return (ERR);
	SKIP_SPACE(s);
	return MMac_undef( sqr, name );
}

static int _FAST	MMpp_table( MMSQR_T *sqr, CONST char *s )
{
	char	name[_MAC_NAME_MAX];

	CHK_IF(sqr);
	if ( MMpp_getMacName(sqr,name,&s) )
		return (ERR);
	SKIP_SPACE(s);
	return MMac_table( sqr, name, s );
}

/*************************************************************************
*	ʬ
*************************************************************************/

static int _FAST	MMpp_if( MMSQR_T *sqr, CONST char *s )
{
	MMINC_T	   *mminc;
	int			flag;

	mminc = &(sqr->inc[sqr->incLevel-1]);
	{
		int		mode;

		mode = mminc->cFlag[mminc->cLevel];
		if ( mode == _IF_OFF || (mode & _IF_GO) )
			flag = TRUE;	/* ¹Ok */
		else
			flag = FALSE;
	}
	if ( mminc->cNestMax + 1 >= _MMNEST_MAX )
	{
		sqr->errMsg = _TOO_MANY_NESTED_IF_STATEMENTS;
		return (ERR);
	}
	mminc->cLevel = (mminc->cNestMax)++;

	SKIP_SPACE(s);

	if ( flag )
	{
		if ( atoi(s) )
		{	/* if  else ֤¹	*/
			mminc->cFlag[mminc->cLevel] = _IF_TRUE | _IF_GO;
		} else
		{	/* else  endif ֤¹	*/
			mminc->cFlag[mminc->cLevel] = _IF_FALSE;
		}
	} else
			mminc->cFlag[mminc->cLevel] = _IF_INV;
	return (NORMAL);
}

static int _FAST	MMpp_ifdef( MMSQR_T *sqr, CONST char *s )
{
	char	name[_MAC_NAME_MAX];
	MMINC_T	*mminc;
	int		flag;

	mminc = &(sqr->inc[sqr->incLevel-1]);
	{
		int		mode;

		mode = mminc->cFlag[mminc->cLevel];
		if ( mode == _IF_OFF || (mode & _IF_GO) )
			flag = TRUE;	/* ¹Ok */
		else
			flag = FALSE;
	}
	if ( mminc->cNestMax + 1 >= _MMNEST_MAX )
	{
		sqr->errMsg = _TOO_MANY_NESTED_IF_STATEMENTS;
		return (ERR);
	}
	mminc->cLevel = (mminc->cNestMax)++;

	if ( MMpp_getMacName(sqr,name,&s) )
		return (ERR);

	if ( flag )
	{
		if ( MMac_getmac( sqr,name ) )
		{	/* ifdef  else ֤¹	*/
			mminc->cFlag[mminc->cLevel] = _IF_TRUE | _IF_GO;
		} else
		{	/* else  endif ֤¹	*/
			mminc->cFlag[mminc->cLevel] = _IF_FALSE;
		}
	} else
			mminc->cFlag[mminc->cLevel] = _IF_INV;

	return (NORMAL);
}


static int _FAST	MMpp_ifndef( MMSQR_T *sqr, CONST char *s )
{
	char	name[_MAC_NAME_MAX];
	MMINC_T	*mminc;
	int		flag;

	mminc = &(sqr->inc[sqr->incLevel-1]);
	{
		int		mode;

		mode = mminc->cFlag[mminc->cLevel];
		if ( mode == _IF_OFF || (mode & _IF_GO) )
			flag = TRUE;	/* ¹Ok */
		else
			flag = FALSE;
	}
	if ( mminc->cNestMax + 1 >= _MMNEST_MAX )
	{
		sqr->errMsg = _TOO_MANY_NESTED_IF_STATEMENTS;
		return (ERR);
	}
	mminc->cLevel = (mminc->cNestMax)++;

	if ( MMpp_getMacName(sqr,name,&s) )
		return (ERR);

	if ( flag )
	{
		if ( MMac_getmac( sqr,name ) == NULL )
		{	/* ifndef  else ֤¹	*/
			mminc->cFlag[mminc->cLevel] = _IF_TRUE | _IF_GO;
		} else
		{	/* else  endif ֤¹	*/
			mminc->cFlag[mminc->cLevel] = _IF_FALSE;
		}
	} else
			mminc->cFlag[mminc->cLevel] = _IF_INV;

	return (NORMAL);
}

static int _FAST	MMpp_else( MMSQR_T *sqr, CONST char *s )
{
	MMINC_T	*mminc;

	mminc = &(sqr->inc[sqr->incLevel-1]);
	if ( mminc->cNestMax == 0 )
	{
		sqr->errMsg = "#else must be in an #if";
		return (ERR);
	}
	switch ( mminc->cFlag[mminc->cLevel] & 0x0F )
	{
		case _IF_TRUE :	mminc->cFlag[mminc->cLevel] &= ~(_IF_GO);	break;
		case _IF_FALSE:	mminc->cFlag[mminc->cLevel] |=   _IF_GO;	break;
	}
	return (NORMAL);
}

static int _FAST	MMpp_endif( MMSQR_T *sqr, CONST char *s )
{
	MMINC_T	*mminc;

	mminc = &(sqr->inc[sqr->incLevel-1]);
	if ( mminc->cNestMax == 0 )
	{
		sqr->errMsg = "#endif must be in an #if";
		return (ERR);
	}
	mminc->cFlag[mminc->cLevel] = _IF_OFF;
	if ( mminc->cLevel > 0 )
		--(mminc->cLevel);
	--(mminc->cNestMax);

	return (NORMAL);
}

/*************************************************************************
*	顼ȯ
*************************************************************************/

static int _FAST	MMpp_error( MMSQR_T *sqr, CONST char *s )
{
	SKIP_SPACE(s);

	MM_setErrMsg( sqr, "#error : %s", s );
	MM_error(sqr);
	return (ERR);
}
