/*************************************************************************
*	ѥ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"he386.h"
#include	"midicc.h"
#include	"mml.h"
#include	"mmac.h"
#include	"mmlib.h"
#include	"mmpart.h"
#include	"mmtrk.h"
#include	"mmdec.h"
#include	"mmptn.h"
#include	"msgdat.h"

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

static int _FAST	hash( CONST char *name );

int		MMptn_init( MMSQR_T *sqr )
{
	int		i;

	for ( i = 0; i < _MMPTN_HASH_MAX; ++i )
		sqr->ptnTbl[i] = NULL;
	return (0);
}

void	MMptn_term( MMSQR_T *sqr )
{
	int		i;

	for ( i = 0; i < _MMPTN_HASH_MAX; ++i )
	{
		MMPTN_T	*ptn;

		ptn = sqr->ptnTbl[i];
		while ( ptn )
		{
			{
				MMPTNDAT_T	*ptnDat;

				ptnDat = ptn->ptnDat;
				while ( ptnDat )
				{
					MMPTNDAT_T	*ptnDatNext;
					size_t		len;

					ptnDatNext = ptnDat->next;
					len = strlen(ptnDat->ptn);
					free( ptnDat );
					sqr->workSize -= (sizeof(MMPTNDAT_T) + len + 1);
					ptnDat = ptnDatNext;
				}
				ptn->ptnDat = NULL;
			}
			{
				MMPTN_T	   *ptnNext;
				size_t		len;

				ptnNext = ptn->next;
				len = strlen(ptn->name);
				free( ptn );	sqr->workSize -= (sizeof(MMPTN_T) + len);
				ptn = ptnNext;
			}
		}
		sqr->ptnTbl[i] = NULL;
	}
}


MMPTN_T	   *mmptn_getPattern( MMSQR_T *sqr, CONST char *name )
{
	MMPTN_T	*ptn = sqr->ptnTbl[hash(name)];

	while ( ptn )
	{
		if ( strcmpi( name, ptn->name) == 0 )
			break;
		ptn = ptn->next;
	}
	return (ptn);
}

static int _FAST	hash( CONST char *name )
{
	register int		hash = 0;

	while ( *name )
	{
		hash = hash + (tolower(*name)) * 31;
		++name;
	}
	return (hash & (_MMPTN_HASH_MAX-1));
}

/*************************************************************************
*	ѥϿ
*************************************************************************/

MMPTN_T	*mmptn_setNewPattern( MMSQR_T *sqr, CONST char *name )
{
	MMPTN_T	*newPtn;

	{
		size_t	len = strlen(name);

		if ( (newPtn = calloc(sizeof(MMPTN_T) + len,1)) == NULL )
		{
			sqr->errMsg = _OUT_OF_MEMORY;
			return (NULL);
		}
		sqr->workSize += (sizeof(MMPTN_T) + len);
		strcpy( newPtn->name, name );
	}

	{
		MMPTN_T	**ptn = &(sqr->ptnTbl[hash(name)]);

		newPtn->next = *ptn;
		*ptn = newPtn;
	}
	return (newPtn);
}

/*************************************************************************
*	ѥϿ
*************************************************************************/

int _FAST	MMptn_setPattern( MMSQR_T *sqr, CONST char *name, int no, CONST char *str )
{
	MMPTN_T		*ptn;

	if ( (ptn = mmptn_getPattern(sqr,name)) == NULL )
	{
		if ( (ptn = mmptn_setNewPattern(sqr,name)) == NULL )
			return (ERR);
	}

	/* Ʊֹ椬뤫Ĵ٤	*/
	{
		MMPTNDAT_T	*ptnDat;

		ptnDat = ptn->ptnDat;
		while ( ptnDat )
		{
			if ( ptnDat->no == no )
			{
				MM_setErrMsg( sqr, "Redefining defined pattern \x22%s\x22 no.%d ",
				    name, no );
				return (ERR);
			} else if ( ptnDat->no > no )
				break;
			ptnDat = ptnDat->next;
		}
	}

	{	/* ѥХåեκ	*/
		MMPTNDAT_T	*newPtnDat;
		size_t		len = strlen(str);

		if ( (newPtnDat = calloc(sizeof(MMPTNDAT_T) + len + 1,1)) == NULL )
		{
			sqr->errMsg = _OUT_OF_MEMORY;
			return (ERR);
		}
		sqr->workSize += (sizeof(MMPTNDAT_T) + len);
		strcpy( newPtnDat->ptn, str );
		newPtnDat->no = no;

		/*	Ͽ	*/
		{
			MMPTNDAT_T	*ptnDat;

			if ( (ptnDat = ptn->ptnDat) == NULL )
				ptn->ptnDat = newPtnDat;
			else
			{
				while ( ptnDat )
				{
					if ( no < ptnDat->no )
					{	/* 	*/
						newPtnDat->next = ptnDat;
						newPtnDat->prev = ptnDat->prev;
						if ( newPtnDat->next )
							newPtnDat->next->prev = newPtnDat;
						if ( newPtnDat->prev )
							newPtnDat->prev->next = newPtnDat;
						if ( ptn->ptnDat == ptnDat )	/* Append 1993/12/06 */
							ptn->ptnDat = newPtnDat;
						break;
					} else /* if ( no > ptnDat->no ) */
					{
						if ( ptnDat->next == NULL )
						{	/* Ǹɲ	*/
							newPtnDat->prev = ptnDat;
							ptnDat->next    = newPtnDat;
							break;
						}
						ptnDat = ptnDat->next;
					}
				}
			}
		}
		++(ptn->n);
	}

	return (NORMAL);
}


/*************************************************************************
*	ѥŸ
*************************************************************************/
int _FAST	MMdec_pattern( MMSQR_T *sqr, MMPART_T *part, CONST char **s )
{
	char	name[256];

	sqr->errPoint = *s;
	++(*s);	/* skip '*' */

	if ( *(*s) != '(' )
	{
_PTN_ERR:
		sqr->errMsg = "Pattern syntax error!";
		return (ERR);
	}
	++(*s);
	if ( mm_getname( name, 255, s ) || name[0] == '\0' )
	{
		sqr->errMsg = "Pattern name must be identifier!";
		return (ERR);
	}
	if ( *(*s) != ')' )
		goto _PTN_ERR;
	++(*s);

	{
		MMPTN_T	*ptn = mmptn_getPattern( sqr, name );

		if ( ptn == NULL )
		{
			MM_setErrMsg( sqr, "Unknown pattern \x22%s\x22 ", name );
			return (ERR);
		}

		{
			MMPTNDAT_T	*ptnDat = ptn->ptnDat;
			MMCLK_T		start_clk = part->clk;

			while ( ptnDat )
			{
				part->clk = start_clk;
				if ( MMdec_line( sqr, part->trk, part->partNo, ptnDat->ptn ) )
					return (ERR);
				ptnDat = ptnDat->next;
			}
		}
	}
	return (NORMAL);
}
