/*************************************************************************
*	å
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"midicc.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmtrk.h"
#include	"mmpart.h"
#include	"mmdec.h"
#include	"mmsetter.h"
#include	"mmoffset.h"
#include	"mmsg.h"
#include	"msgdat.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

#define	SET_HASH(_setNo)	((_setNo * 31) & (_MMSET_HASH_MAX - 1))

/*************************************************************************
*	åγ
*************************************************************************/

void _FAST	mmset_allfree( MMPART_T *part )
{
	MMSQR_T		*sqr = ((MMTRK_T *)(part->trk))->sqr;
	int			j;

	for ( j = 0; j < _MMSET_HASH_MAX; ++j )
	{
		MMSET_T	*set, *setNext;

		set = part->setTbl[j];
		while ( set )
		{
			setNext = set->next;
			{
				MMSETV_T	*pv, *pvNext;

				pv = set->v;
				while ( pv )
				{
					pvNext = pv->next;
					free( pv );		sqr->workSize -= sizeof(MMSETV_T);
					pv = pvNext;
				}
			}
			free(set);		sqr->workSize -= sizeof(MMSET_T);
			set = setNext;
		}
		part->setTbl[j] = NULL;
	}
}

/*************************************************************************
*	ԥֹΥԥ֤
*************************************************************************/

static MMSET_T * _FAST mmset_getSetter( MMPART_T *part, int setNo )
{
	MMSET_T	*set = part->setTbl[SET_HASH(setNo)];

	while ( set )
	{
		if ( set->no == setNo )
			break;
		set = set->next;
	}
	return (set);
}

/*************************************************************************
*	ԥѰդ
*************************************************************************/

static MMSET_T * _FAST mmset_newSetter( MMPART_T *part, int setNo)
{
	MMSET_T	*set = mmset_getSetter(part,setNo);

	if ( set == NULL )
	{
		if ( (set = calloc(sizeof(MMSET_T),1)) != NULL )
		{
			MMSET_T	**setPtr = &(part->setTbl[ SET_HASH(setNo) ]);

			((MMSQR_T *)(((MMTRK_T *)(part->trk))->sqr))->workSize += sizeof(MMSET_T);
			set->no   = setNo;
			set->next = *setPtr;
			*setPtr   = set;
		}
	} else
	{	/* 򥯥ꥢ	*/
		MMSETV_T	*pv;
		MMSQR_T		*sqr = ((MMTRK_T *)(part->trk))->sqr;

		pv = set->v;
		while ( pv )
		{
			MMSETV_T	*pvNext;
			pvNext = pv->next;
			free( pv );		sqr->workSize -= sizeof(MMSETV_T);
			pv = pvNext;
		}
		set->v = NULL;
	}
	return (set);
}

#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
static struct 		_cmdtbl_t
{
	CONST char	   *name;
	int				typ;
} CmdTbl[] =
{
	{ _MM_CAF_      , MMSETYP_CAF			},
	{ _MM_CAFDELAY_ , MMSETYP_CAFDELAY		},
	{ _MM_CAFPRES_  , MMSETYP_CAFPRES		},
	{ _MM_CC_       , MMSETYP_CC			},
	{ _MM_CD_       , MMSETYP_CAFDELAY		},
	{ _MM_CH_       , MMSETYP_CH			},
	{ _MM_D_        , MMSETYP_DELAY			},
	{ _MM_DELAY_    , MMSETYP_DELAY			},
	{ _MM_G_        , MMSETYP_GATETIME		},
	{ _MM_GATE_     , MMSETYP_GATETIME		},
	{ _MM_GATEPER_  , MMSETYP_GATERATIO		},
	{ _MM_GP_       , MMSETYP_GATERATIO		},
	{ _MM_K_        , MMSETYP_KEYSHIFT		},
	{ _MM_KEY_      , MMSETYP_KEYSHIFT		},
	{ _MM_O_        , MMSETYP_OCTAVE		},
	{ _MM_OCTAVE_   , MMSETYP_OCTAVE		},
	{ _MM_OFFVEL_   , MMSETYP_OFFVELOCITY	},
	{ _MM_OV_       , MMSETYP_OFFVELOCITY	},
	{ _MM_P_        , MMSETYP_PITCH			},
	{ _MM_PAF_      , MMSETYP_PAF			},
	{ _MM_PAFDELAY_ , MMSETYP_PAFDELAY		},
	{ _MM_PAFPRES_  , MMSETYP_PAFPRES		},
	{ _MM_PD_       , MMSETYP_PAFDELAY		},
	{ _MM_PG_       , MMSETYP_PROG			},
	{ _MM_PITCH_    , MMSETYP_PITCH			},
	{ _MM_PROG_     , MMSETYP_PROG			},
	{ _MM_S_        , MMSETYP_STEPTIME		},
	{ _MM_STEP_     , MMSETYP_STEPTIME		},
	{ _MM_T_        , MMSETYP_TEMPO			},
	{ _MM_TEMPO_    , MMSETYP_TEMPO			},
	{ _MM_V_        , MMSETYP_VELOCITY		},
	{ _MM_VEL_      , MMSETYP_VELOCITY		},
};
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

static int		cmd_name_len = 0;

static int		cmpFunc( const struct _cmdtbl_t *c1, const struct _cmdtbl_t *c2 )
{
	return (mm_strncmpi(c1->name,c2->name,cmd_name_len));
}

/*************************************************************************
*	ԥǡɲä
*************************************************************************/

int _FAST	mmset_setter( MMSET_T *set, int typ, MMVALUE_T *val )
{
	MMSETV_T	*vdat, *v = set->v;

	if ( (vdat = calloc(sizeof(MMSETV_T),1)) == NULL )
		return (ERR);
	vdat->typ = typ;
	vdat->val = *val;

	if ( v == NULL )
		set->v = vdat;
	else
	{
		for(;;)
		{
			if ( v->next == NULL )
			{
				v->next = vdat;
				break;
			}
			v = v->next;
		}
	}
	return (NORMAL);
}

/*************************************************************************
*		ѡȥå
*-------------------------------------------------------------------------
*	% <n> [(parameters)]
*************************************************************************/

int _FAST	MMdec_setter( MMSQR_T *sqr, MMPART_T *part, CONST char **s)
{
	MMTRK_T		   *trk = part->trk;
	MMSET_T		   *set;
	int				setNo;
	CONST char	   *err = NULL;

	++(*s);	/* skip '?' */
	if ( *(*s) == '#' )
	{	/* եå	*/
		return MMdec_offset(sqr,part,s);
	}

	if ( isdigit(*(*s)) )
	{	/* ֹɤ߼	*/
		if ( mm_getIntDigit(&setNo,s) || setNo < 1 )
		{
			char	tmp[128];

_SET_ERR:	if ( err )
				sprintf( tmp, " '%s'", err );
			else
				tmp[0] = '\0';
			MM_setErrMsg( sqr, _msg_mmsetter_Setter_command_error[TypMsg], tmp );
			return (ERR);
		}
	} else
		setNo = 0;	/* ƥॻåֹ	*/

	if ( *(*s) == '(' )
	{	/* ѥ᡼ɤ߼	*/
		int		argc;
		char	**argv;

		/* åѰդ	*/
		if ( (set = mmset_newSetter(part,setNo)) == NULL )
		{
/*_MEM_ERR:*/
			sqr->errMsg = _msg_out_of_memory[TypMsg];
			return (ERR);
		}
		part->setPtr = set;

		if ( (argc = mm_get_arg( s, &argv )) > 0 )
		{
			int		i;

			for ( i = 0; i < argc; ++i )
			{
				int			typ;
				CONST char	*ap;

				err = ap = argv[i];
				typ = ERR;
				{
					struct _cmdtbl_t	key;
					struct _cmdtbl_t	*cmd;

					key.typ  = -1;
					key.name = ap;
					cmd_name_len = 0;
					while ( *ap )
					{
						++cmd_name_len;
						if ( *ap == ':' )
							break;
						++ap;
					}
					if ( *ap != ':' )
						goto _SET_ERR;
					++ap;
					cmd = bsearch( &key, CmdTbl, sizeof(CmdTbl)/sizeof(*CmdTbl),
					  sizeof(*CmdTbl), (int (*)(const void *, const void *))cmpFunc );
					if ( cmd )
						typ = cmd->typ;
				}

				{
					MMPART_PARA_T	*para;
					MMVALUE_T		val;

					para = &(part->set);
					switch ( typ )
					{
						case MMSETYP_TEMPO:
						{
							if ( trk->trkNo > 0 )
							{
								sqr->errMsg = _msg_Tempo_change_error[TypMsg];
								return (ERR);
							}
							val = para->tempo;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,MMTEMPO_MIN,MMTEMPO_MAX) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_CH:
						{
							int		ch;
							if ( mm_getIntDigit( &ch, &ap ) || ch < 1 || ch > 16 )
								goto _SET_ERR;
							MM_setValue( &val, _MMVAL_ABS, ch - 1);
							break;
						}
						case MMSETYP_DELAY:
						{
							val = para->delay;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-32768,32767) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_KEYSHIFT:
						{
							val = para->keyShift;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,-127,127) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_OCTAVE:
						{
							val = para->octave;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,MMOCTAVE_MIN,MMOCTAVE_MAX) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_VELOCITY:
						{
							val = para->vel;
							if ( mm_getValue( &val, &ap ) )
								goto _SET_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,1,127) )
								goto _SET_ERR;
							else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < 1 )
									val.value = 1;
								else if ( val.value > 127 )
									val.value = 127;
							}
							break;
						}
						case MMSETYP_OFFVELOCITY:
						{
							val = para->offVel;
							if ( mm_getValue( &val, &ap ) )
								goto _SET_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
								goto _SET_ERR;
							else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < 0 )
									val.value = 0;
								else if ( val.value > 127 )
									val.value = 127;
							}
							break;
						}
						case MMSETYP_STEPTIME:
						{
							val = para->stepTime;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,0,65535) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_GATERATIO:
						{
							val = para->gateRatio;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,1,1000) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_GATETIME:
						{
							val = para->gateTime;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,0,65535) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_PROG:
						{
							val = para->prog;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,1,128) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_PITCH:
						{
							val = para->pitch;
							if ( mm_getValue( &val, &ap ) )
								goto _SET_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,-8192,8191) )
								goto _SET_ERR;
							else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < -8192 )
									val.value = -8192;
								else if ( val.value > 8191 )
									val.value = 8191;
							}
							break;
						}
						case MMSETYP_CAF:
						case MMSETYP_CAFPRES:
						{
							val = para->caf;
							if ( mm_getValue( &val, &ap ) )
								goto _SET_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
								goto _SET_ERR;
							else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < 0 )
									val.value = 0;
								else if ( val.value > 127 )
									val.value = 127;
							}
							break;
						}
						case MMSETYP_CAFDELAY:
						{
							val = para->cafDelay;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,0,32767) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_PAF:
						case MMSETYP_PAFPRES:
						{
							val = para->paf;
							if ( mm_getValue( &val, &ap ) )
								goto _SET_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,0,127) )
								goto _SET_ERR;
							else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < 0 )
									val.value = 0;
								else if ( val.value > 127 )
									val.value = 127;
							}
							break;
						}
						case MMSETYP_PAFDELAY:
						{
							val = para->pafDelay;
							if ( mm_getValue( &val, &ap )
							    || MM_CHKVALUE(&val,0,32767) )
								goto _SET_ERR;
							break;
						}
						case MMSETYP_CC:
						{
							int		cc, base;

							if ( mm_getIntDigit( &cc, &ap ) || cc < 0 || cc > 127 )
								goto _SET_ERR;
							if ( *ap != '/' )
								goto _SET_ERR;
							++ap;
							base = trk->tbl.ccvBase[cc];
							typ = cc + MMSETYP_CC;
							val = para->ccv[cc];
							if ( mm_getValue( &val, &ap ) )
								goto _SET_ERR;
							if ( !(val.mode & _MMVAL_RELATIVE) && MM_CHKVALUE(&val,-base,127-base) )
								goto _SET_ERR;
							else if ( !(val.mode & _MMVAL_RANDOM) )
							{
								if ( val.value < -base )
									val.value = -base;
								else if ( val.value > 127 - base )
									val.value = 127 - base;
							}
							break;
						}
						default:
							goto _SET_ERR;
					}
					/* å	*/
					if ( mmset_setter( set, typ, &val ) )
						return (ERR);
					((MMSQR_T *)(trk->sqr))->workSize += sizeof(MMSETV_T);
				}
			}
			mm_clear_arg(argc,argv);
			if ( setNo == 0 )
				goto _SET_SETUP;
		}
	} else
	{	/* 	*/
		MMCLK_T		clk;
_SET_SETUP:
		/* ֹΥåѰդ	*/
		if ( (set = mmset_getSetter(part,setNo)) == NULL )
		{
			MM_setErrMsg( sqr, _msg_mmsetter_Unknown_setter_number[TypMsg], setNo );
			return (ERR);
		}

		clk = mmpart_get_clock(part);
		part->setPtr  = set;
		{
			MMSETV_T	*vp;
			vp = set->v;
			while ( vp )
			{
				switch ( vp->typ )
				{
					case MMSETYP_TEMPO:
					{
						if ( mmpart_set_tempo( part, clk, &(vp->val) ) )
							return (ERR);
						break;
					}
					case MMSETYP_CH:
					{
						int		ch;
						ch = MM_READVALUE( &(vp->val) );
						if ( mmpart_set_midich( part, ch) )
							return (ERR);
						break;
					}
					case MMSETYP_DELAY:
					{
						if ( mmpart_set_delay( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_KEYSHIFT:
					{
						if ( mmpart_set_keyShift( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_OCTAVE:
					{
						if ( mmpart_set_octave( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_VELOCITY:
					{
						if ( mmpart_set_velocity( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_OFFVELOCITY:
					{
						if ( mmpart_set_offVelocity( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_STEPTIME:
					{
						if ( mmpart_set_steptime( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_GATERATIO:
					{
						if ( mmpart_set_gateratio( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_GATETIME:
					{
						if ( mmpart_set_gatetime( part,  &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_PROG:
					{	/* 1128 */
						if ( mmpart_set_prog( part, clk, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_PITCH:
					{
						if ( mmpart_set_pitch( part, clk, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_CAF:
					{
						if ( mmpart_set_caf( part, clk, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_CAFPRES:
					{
						if ( mmpart_set_cafPres( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_CAFDELAY:
					{
						if ( mmpart_set_cafDelay( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_PAF:
					{
						if ( part->noteLast < 0 )
							goto _SET_ERR;
						if ( mmpart_set_paf( part, clk, part->noteLast, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_PAFPRES:
					{
						if ( mmpart_set_pafPres( part, &(vp->val)) )
							return (ERR);
						break;
					}
					case MMSETYP_PAFDELAY:
					{
						if ( mmpart_set_pafDelay( part, &(vp->val)) )
							return (ERR);
						break;
					}
#ifdef	__HIGHC__
					case MMSETYP_CC..(MMSETYP_CC+127):
#else
					default:
					if ( vp->typ >= MMSETYP_CC && vp->typ <= (MMSETYP_CC+127) )
#endif
					{
						if ( mmpart_set_cc( part, clk, vp->typ - MMSETYP_CC, &(vp->val)) )
							return (ERR);
						break;
					}
				} /* end of switch( vp->typ ) */
				vp = vp->next;
			}
		}
	}

	return (NORMAL);
}
