/*************************************************************************
*	饤
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	<math.h>

#include	"he386.h"
#include	"msgdat.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmpp.h"
#include	"mmac.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

#define	ARG_MAX		(32)
#define	ARG_BUFSIZ	(32)

#define	FT(f)	((float)(f))
#define	F_X1	0
#define	F_X2	1
#define	F_EXP	2
#define	F_SQR	3
#define	F_USR	0x80

/*************************************************************************
*	$slide( note, cmd, n, tie, func, start, end [,start pos] )
*************************************************************************/

int		MMfunc_slide(MMSQR_T *sqr,size_t bufSiz, char *buf,int argc, char **argv)
{
	int			i, ret = NORMAL;
	int			n, sn;
	int			sp, ep, dt;
	int			fun;
	CONST char	*note, *cmd, *tie;
	int			note_len, tie_len;
	int			div;
	int			dl = 0;
	char		*dp, *sbuf = NULL;

#define	term()	{	if ( sbuf )	free( sbuf );}

	if ( argc < 7 )
	{
_PARA_ERR:
		sqr->errMsg = "Slide parameter error!";
		term();
		return (ERR);
	}

	if ( (sbuf = malloc(_MM_DEC_BUFSIZ)) == NULL )
	{
		sqr->errMsg = _OUT_OF_MEMORY;
		term();
		return (ERR);
	}
	dp = sbuf;

	note  = argv[0];	note_len = strlen(note);
	cmd   = argv[1];	
	if ( (n = atoi(argv[2])) < 2 )
		goto _PARA_ERR;
	tie   = argv[3];	tie_len = strlen(tie);

	{
		char	*s = argv[4];

		if ( *s == '&' )
		{
			++s;
			div = 1;	/* 0(n-1) ޤѲ	*/
		} else
			div = 0;	/* 0n     ޤѲ	*/
		if (      strcmpi( s, "x"     ) == 0 )
			fun = F_X1;
		else if ( strcmpi( s, "x*x"   ) == 0 )
			fun = F_X2;
		else if ( strcmpi( s, "sqr"   ) == 0 )
			fun = F_SQR;
		else if ( strcmpi( s, "x^2"   ) == 0 )
			fun = F_X2;
		else if ( strcmpi( s, "sqr(x)") == 0 )
			fun = F_SQR;
		else if ( strcmpi( s, "e^x"   ) == 0 )
			fun = F_EXP;
		else if ( strcmpi( s, "exp(x)") == 0 )
			fun = F_EXP;
		else
			goto _PARA_ERR;
	}
	sp = atoi( argv[5] );
	ep   = atoi( argv[6] );
	if ( argc > 7 )
		sn = atoi(argv[7]);
	else
		sn = 0;
	if ( sn >= n )
		goto _PARA_ERR;
	dt  = ep - sp;
	div = ( div == 0 ) ? (n-1) : n;

	switch( fun )
	{
		case	F_X1:	/* ؿ	*/
		{
			for( i = sn; i < n; ++i )
			{
				char	tmp[256];
				int		l, par;

				par = sp + (int)(FT(i)*FT(dt)/FT(div));
				l = mmac_cmdform( tmp, cmd, par);
				if ( (size_t)(dl + l) >= bufSiz )
					goto _SET_ERR;
				strcpy( dp, tmp );
				dl += l;
				dp += l;
				strcpy( dp, note );
				dl += note_len;
				dp += note_len;
				if ( i < (n-1) )
				{
					if ( (size_t)(dl + tie_len) >= bufSiz )
						goto _SET_ERR;
					strcpy( dp, tie );
					dp += tie_len;
					dl += tie_len;
				}
			}
			break;
		}

		case	F_X2:	/* ؿ	*/
			for( i = sn; i < n; ++i )
			{
				char	tmp[256];
				int		l, par;

				par = sp + (int)( FT(dt)*FT(i)*FT(i)/(FT(div)*FT(div)) );
				l = mmac_cmdform( tmp, cmd, par);
				if ( (size_t)(dl + l) >= bufSiz )
					goto _SET_ERR;
				strcpy( dp, tmp );
				dl += l;
				dp += l;
				strcpy( dp, note );
				dl += note_len;
				dp += note_len;
				if ( i < (n-1) )
				{
					if ( (size_t)(dl + tie_len) >= bufSiz )
						goto _SET_ERR;
					strcpy( dp, tie );
					dp += tie_len;
					dl += tie_len;
				}
			}
			break;

		case	F_EXP:	/* ؿؿ	*/
			for( i = sn; i < n; ++i )
			{
				char	tmp[256];
				int		l, par;

				par = sp +  (int)( FT(dt)*exp(FT(i))/exp(FT(div)) );
				l = mmac_cmdform( tmp, cmd, par);
				if ( (size_t)(dl + l) >= bufSiz )
					goto _SET_ERR;
				strcpy( dp, tmp );
				dl += l;
				dp += l;
				strcpy( dp, note );
				dl += note_len;
				dp += note_len;
				if ( i < (n-1) )
				{
					if ( (size_t)(dl + tie_len) >= bufSiz )
						goto _SET_ERR;
					strcpy( dp, tie );
					dp += tie_len;
					dl += tie_len;
				}
			}
			break;

		case	F_SQR:	/* 躬	*/
			for( i = sn; i < n; ++i )
			{
				char	tmp[256];
				int		l, par;

				par = sp +  (int)(FT(dt)*sqrt(FT(i)) / sqrt(FT(div)));
				l = mmac_cmdform( tmp, cmd, par);
				if ( (size_t)(dl + l) >= bufSiz )
					goto _SET_ERR;
				strcpy( dp, tmp );
				dl += l;
				dp += l;
				strcpy( dp, note );
				dl += note_len;
				dp += note_len;
				if ( i < (n-1) )
				{
					if ( (size_t)(dl + tie_len) >= bufSiz )
						goto _SET_ERR;
					strcpy( dp, tie );
					dp += tie_len;
					dl += tie_len;
				}
			}
			break;
	}

	if ( (size_t)dl >= bufSiz )
	{
_SET_ERR:
		sqr->errMsg = _OUT_OF_STRING_SPACE;
		ret = ERR;
	} else
	{
		memcpy( buf, sbuf, dl );
		ret = dl;
	}

/*_RET:*/
	term();
	return (ret);
}

