/*************************************************************************
*	MIDIե
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<ctype.h>
#include	<string.h>

#include	"he386.h"
#include	"mmfile.h"
#include	"mml.h"
#include	"mmtrk.h"
#include	"mmlib.h"
#include	"mmsg.h"
#include	"msgdat.h"
#include	"midicc.h"
#include	"smfmet.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*----------------------------------------------------------------------*/
#if	defined(WIN32)
#	pragma	pack(push,1)
#endif
typedef	struct
{
	long		filesize;
} MMSMF_T;

MMSMF_T	MMsmf;

typedef	struct
{
	BYTE	id[4];
	BYTE	datasize[4];
	BYTE	format[2];
	BYTE	trackBlock[2];
	BYTE	division[2];
} SMF_HEAD_T;

#if	defined(WIN32)
#	pragma	pack(pop)
#endif

#define	HEADER_SIZE	(6)
#define	SMF_FORMAT	(1)

static int		make_header( MMSQR_T *sqr )
{
#if	defined(__HIGHC__) || defined(_MSC_VER)
	SMF_HEAD_T	head =
	{
		{ 'M','T','h','d'},
		{ HEADER_SIZE>>24, (HEADER_SIZE>>16)&255, (HEADER_SIZE>>8)&255, HEADER_SIZE&255},
		{ (SMF_FORMAT>>8)&255, SMF_FORMAT&255},
		{ ((sqr->trkNum)>>8)&255, (sqr->trkNum)&255},
		{ ((sqr->division)>>8)&255, (sqr->division)&255},
	};
#else
	SMF_HEAD_T	head;
	head.id[0] = (BYTE)'M';
	head.id[1] = (BYTE)'T';
	head.id[2] = (BYTE)'h';
	head.id[3] = (BYTE)'d';
	head.datasize[0]   =  HEADER_SIZE>>24;
	head.datasize[1]   = (HEADER_SIZE>>16)&255;
	head.datasize[2]   = (HEADER_SIZE>> 8)&255;
	head.datasize[3]   =  HEADER_SIZE     &255;
	head.format[0]     = (SMF_FORMAT>>8)&255;
	head.format[1]     =  SMF_FORMAT    &255;
	head.trackBlock[0] = ((sqr->trkNum)>>8)&255;
	head.trackBlock[1] =  (sqr->trkNum    )&255;
	head.division[0]   = ((sqr->division)>>8)&255;
	head.division[1]   =  (sqr->division    )&255;
#endif

	fseek( sqr->outFp, 0l, SEEK_SET);
	fwrite( &head, sizeof(SMF_HEAD_T), 1, sqr->outFp);
	MMsmf.filesize += sizeof(SMF_HEAD_T);

	return (NORMAL);
}

#define	SMF_TRACK_HEADER_SIZE	(8)

#define	PUTCH(_dat)	{				\
	fputc((_dat)&0xFF,sqr->outFp);	\
	++trksiz;						\
	++MMsmf.filesize;				\
}

#define	PUTDAT(_dat,_n)	{				\
	fwrite((_dat),(_n),1,sqr->outFp);	\
	trksiz += (_n);						\
	MMsmf.filesize += (_n);				\
}

#define	PUTLEN(_dt)	{				\
	int		i, j;					\
	UCHAR	buf[5], *bp;			\
	i = j = 0;						\
	bp = buf;						\
	(_dt) &= 0x0FFFFFFF;			\
	do								\
	{	*bp++ = (UCHAR)(((_dt) & 0x7F) | j);	\
		i++;						\
		j = 0x80;					\
		(_dt) >>= 7;				\
	} while ( (_dt) );				\
	while ( i-- > 0 )				\
	{	int		ch;					\
		ch = *--bp;					\
		PUTCH(ch);					\
	}								\
}

static int		trk_output( MMSQR_T *sqr, MMTRK_T *trk )
{
	int		run_stt = 0;	/* ˥󥰥ơ	*/
	long	trksiz;			/* ǡ			*/
	long	header_pos = MMsmf.filesize;

	if ( sqr->trkWork.mode == MMTRKWORK_MODE_FILE )
	{	/* ե⡼ɡǡɤ߹	*/
		if ( mmtrk_datLoad( trk ) )
			return (ERR);
	}

	MMsmf.filesize += SMF_TRACK_HEADER_SIZE;
	fseek( sqr->outFp, MMsmf.filesize, SEEK_SET);
	trksiz = 0l;

	if ( trk == sqr->ctrlTrk )
	{	/* ȥȥå	*/
		size_t	len;

		if ( (len = strlen(sqr->title)) > 0 )
		{	/* ȥ񤭹	*/
			PUTCH(0);		/* ǥ륿	*/
			PUTCH(0xFF);
			PUTCH(SMF_MET_SEQNAME);
			{
				size_t	siz = len;

				PUTLEN(siz);
			}
			PUTDAT(sqr->title,len);
		}
		if ( (len = strlen(sqr->copyright)) > 0 )
		{	/* ԡ饤Ƚ񤭹	*/
			PUTCH(0);		/* ǥ륿	*/
			PUTCH(0xFF);
			PUTCH(SMF_MET_COPYRIGHT);
			{
				size_t	siz = len;

				PUTLEN(siz);
			}
			PUTDAT(sqr->copyright,len);
		}
		{	/* ƥȥ٥	*/
			char	tmp[256];
			time_t	tm;

			tm = time(NULL);
			sprintf( tmp,
			    "High-EUP Compiler ver."
			    _MAIN_VERSION
			    " "
			    _MAIN_EDITION
			    " : %s",
			    mm_getTimeStr(tm) );
			len = strlen(tmp);
			PUTCH(0);		/* ǥ륿	*/
			PUTCH(0xFF);
			PUTCH(SMF_MET_TEXT);
			{
				size_t	siz = len;

				PUTLEN(siz);
			}
			PUTDAT(tmp,len);
		}
	}

	{
		MMCLK_T	clk  = 0;
		MMDAT_T	*dat = trk->datTop;

		while ( dat )
		{
			UCHAR	*p;
			p = dat->dat;

			/* ǥ륿񤭹	*/
#define	PUT_DT()	{				\
			MMCLK_T	dt;				\
			dt = (MMCLK_T)(dat->clk - clk);	\
			PUTLEN(dt);				\
			clk = dat->clk;			\
}

			switch ( *p )
			{
#ifdef	__HIGHC__
				case	0x80..0x8F:	/* note off */
#else
				case 0x80: case 0x81: case 0x82: case 0x83: case 0x84: case 0x85: case 0x86: case 0x87:
				case 0x88: case 0x89: case 0x8A: case 0x8B: case 0x8C: case 0x8D: case 0x8E: case 0x8F:
#endif
				{
					PUT_DT();
					if ( run_stt != *p )
					{
						PUTCH(*p);
						run_stt = *p;
					}
					PUTDAT(&p[1],2);
					break;
				}

#ifdef	__HIGHC__
				case	0x90..0x9F:	/* note on */
#else
				case 0x90: case 0x91: case 0x92: case 0x93: case 0x94: case 0x95: case 0x96: case 0x97:
				case 0x98: case 0x99: case 0x9A: case 0x9B: case 0x9C: case 0x9D: case 0x9E: case 0x9F:
#endif
				{
					PUT_DT();
					if ( run_stt != *p )
					{
						PUTCH(*p);
						run_stt = *p;
					}
					PUTDAT(&p[1],2);
					break;
				}

#ifdef	__HIGHC__
				case	0xA0..0xAF:	/* polyphonic after touch */
#else
				case 0xA0: case 0xA1: case 0xA2: case 0xA3: case 0xA4: case 0xA5: case 0xA6: case 0xA7:
				case 0xA8: case 0xA9: case 0xAA: case 0xAB: case 0xAC: case 0xAD: case 0xAE: case 0xAF:
#endif
				{
					PUT_DT();
					if ( run_stt != *p )
					{
						PUTCH(*p);
						run_stt = *p;
					}
					PUTDAT(&p[1],2);
					break;
				}

#ifdef	__HIGHC__
				case	0xB0..0xBF:	/* control change */
#else
				case 0xB0: case 0xB1: case 0xB2: case 0xB3: case 0xB4: case 0xB5: case 0xB6: case 0xB7:
				case 0xB8: case 0xB9: case 0xBA: case 0xBB: case 0xBC: case 0xBD: case 0xBE: case 0xBF:
#endif
				{
					PUT_DT();
					if ( run_stt != *p )
					{
						PUTCH(*p);
						run_stt = *p;
					}
					PUTDAT(&p[1],2);
					break;
				}

#ifdef	__HIGHC__
				case	0xC0..0xCF:	/* program change */
#else
				case 0xC0: case 0xC1: case 0xC2: case 0xC3: case 0xC4: case 0xC5: case 0xC6: case 0xC7:
				case 0xC8: case 0xC9: case 0xCA: case 0xCB: case 0xCC: case 0xCD: case 0xCE: case 0xCF:
#endif
				{
					PUT_DT();
					if ( run_stt != *p )
					{
						PUTCH(*p);
						run_stt = *p;
					}
					PUTCH(p[1]);
					break;
				}

#ifdef	__HIGHC__
				case	0xD0..0xDF:	/* channel after touch */
#else
				case 0xD0: case 0xD1: case 0xD2: case 0xD3: case 0xD4: case 0xD5: case 0xD6: case 0xD7:
				case 0xD8: case 0xD9: case 0xDA: case 0xDB: case 0xDC: case 0xDD: case 0xDE: case 0xDF:
#endif
				{
					PUT_DT();
					if ( run_stt != *p )
					{
						PUTCH(*p);
						run_stt = *p;
					}
					PUTCH(p[1]);
					break;
				}

#ifdef	__HIGHC__
				case	0xE0..0xEF:	/* pitchbend */
#else
				case 0xE0: case 0xE1: case 0xE2: case 0xE3: case 0xE4: case 0xE5: case 0xE6: case 0xE7:
				case 0xE8: case 0xE9: case 0xEA: case 0xEB: case 0xEC: case 0xED: case 0xEE: case 0xEF:
#endif
				{
					PUT_DT();
					if ( run_stt != *p )
					{
						PUTCH(*p);
						run_stt = *p;
					}
					PUTDAT(&p[1],2);
					break;
				}

				case	0xF0:	/* system exclusive message   */
				case	0xF7:	/* system exclusive message 2 */
				{
					size_t	excl_siz;

					PUT_DT();
					PUTCH(*p);
					excl_siz = dat->siz - 1;
					PUTLEN(excl_siz);			/* ǡХȿ	*/
					excl_siz = dat->siz - 1;
					PUTDAT(&p[1],excl_siz);
					run_stt = 0;
					break;
				}

				case	0xFF:
				{
					run_stt = 0;	/* Append ver.3.01f	*/
					if ( p[1] < 0x80 )
					{
						switch( p[1] )
						{
							case SMF_MET_ENDOFTRK:	/* track end */
							{
								PUT_DT();
								PUTDAT(p,3);
								goto _END;
							}
							case SMF_MET_TEMPO:		/* tempo */
							{
								PUT_DT();
								PUTDAT(p,6);
								break;
							}
							case SMF_MET_SIGNATURE:	/* signature */
							{
								PUT_DT();
								PUTDAT(p,7);
								break;
							}
							default:
							{
								size_t	len;

								PUT_DT();
								len = dat->siz - 2;
								PUTCH(0xFF);
								PUTCH( p[1] );
								PUTLEN(len);
								len = dat->siz - 2;
								PUTDAT(&p[2],len);
								break;
							}
						}
					}
					break;
				}
			}
			dat = dat->next;
		}
	}

_END:
	{	/* ȥåإåν񤭹	*/
		BYTE	s[4];

		fseek( sqr->outFp, header_pos, SEEK_SET);
		fwrite( "MTrk", 4, 1, sqr->outFp);
		s[0] = (BYTE)(trksiz>>24);
		s[1] = (BYTE)(trksiz>>16);
		s[2] = (BYTE)(trksiz>>8);
		s[3] = (BYTE)(trksiz);
		fwrite( s, 4, 1, sqr->outFp);
		fseek( sqr->outFp, MMsmf.filesize, SEEK_SET);
	}

	if ( sqr->trkWork.mode == MMTRKWORK_MODE_FILE )
	{	/* ե⡼ɡǡ¸	*/
		MMDAT_T	*dat = trk->datTop, *next;

		while ( dat != NULL )
		{
			next = dat->next;
			sqr->workSize -= (sizeof(MMDAT_T) + dat->siz);
			free( dat );
			dat = next;
		}
		trk->datTop = trk->datPtr = trk->datLast = NULL;
	}
	return (NORMAL);
}

int		MMsmf_generate( MMSQR_T *sqr )
{
	int		ret;

	{	/* ϥե̾Υץ	*/
		if ( sqr->outFn[0] == '\0' )
			FS_getFnam( sqr->outFn, sqr->inpFn );
		FS_appendSnam( sqr->outFn, sqr->outFn, _SNAM_MID );
		if ( (sqr->outFp = FS_fopen(sqr->outFn, FOPEN_WRITE_BIN)) == NULL )
		{
			HE_printf( sqr, _HE_MSG_ERR, "%s : %s", sqr->outFn, _msg_File_open_error[TypMsg] );
			return (ERR);
		}
		HE_printf( sqr, _HE_MSG_INF, _msg_mmsmf_output_filename[TypMsg], sqr->outFn );
	}

	MMsmf.filesize = 0l;

	{	/* إåκ	*/
		if ( make_header( sqr ) )
		{
			ret = ERR;
			goto _RET;
		}
	}

	{
		int		trkNo = 0, trkNum = sqr->trkNum;

		ret = NORMAL;
		while ( trkNum-- > 0 )
		{
			int		i;
			MMTRK_T	*dspTrk;

			dspTrk = NULL;
			for ( i = 0; i < _MMSQR_TRK_HASH_MAX; ++i )
			{
				MMTRK_T	*trk;

				trk = sqr->trkTbl[i];
				while ( trk )
				{	if ( trk->trkNo >= trkNo )
					{
						if ( dspTrk )
						{	if ( trk->trkNo < dspTrk->trkNo )
								dspTrk = trk;
						} else
							dspTrk = trk;
					}
					trk = trk->next;
				}
			}
			if ( dspTrk )
			{	/* ȥå	*/
				if ( (ret = trk_output( sqr, dspTrk )) < 0 )
					break;
				trkNo = dspTrk->trkNo + 1;
			}
		}
	}

_RET:
	FS_fclose(sqr->outFp);	sqr->outFp = NULL;
	if ( ret )
		FS_remove(sqr->outFn);
	return (ret);
}
