/*************************************************************************
*	饤ǥ󥰥
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	<math.h>

#include	"he386.h"
#include	"msgdat.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmpp.h"
#include	"mmac.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

#define	ARG_MAX		(32)
#define	ARG_BUFSIZ	(32)

#define	FT(f)	((float)(f))

#ifndef PI
# ifdef	_PI
#	define	PI	(_PI)
# else
#	define	PI	(3.14159)
# endif
#endif

/*************************************************************************
*	$swave(note,cmd,len,Tn,wn,tie,slide,sp,ep,
*                                     wave,a,ang[,spdofs[,aofs][,s_sub]])
*************************************************************************/

int		MMfunc_swave(MMSQR_T *sqr,size_t bufSiz, char *buf,int argc, char **argv)
{
	int			i, ret = NORMAL;
	CONST char	*note, *cmd, *tie, *sub;
	int			tie_len;
	int			dl = 0;
	char		*dp, *sbuf = NULL;

#define	term()	{	if ( sbuf )	free( sbuf );}

	int			j, c, l, t;
	int			Tn, wn, sp, ep, a, aa, ang;
	int			spdofs, spdofs_mode, aofs, aofs_mode;
	int			slide, wave;
	int			total_st, total_rt, wave_rt, wave_ct;
	int			par, rev, div, dt;
	int			next_st, gatetime, st_count;

#define	ANG		256
#define	PER		128

	if ( argc < 12 )
	{
_PARA_ERR:
		sqr->errMsg = "Swave parameter error!";
		term();
		return (ERR);
	}
	if ( (sbuf = malloc(_MM_DEC_BUFSIZ)) == NULL )
	{
		sqr->errMsg = _OUT_OF_MEMORY;
		term();
		return (ERR);
	}
	dp = sbuf;

	note  = argv[0];
	cmd   = argv[1];	

	/* ȡ륹ƥåץ׻	*/
	{
		CONST char	*s_len = argv[2];

		if ( *s_len == ':' )
		{	/* ƥåץ	*/
			++s_len;
			total_st = atoi(s_len);
		} else
		{
			{
				if ( mm_getIntDigit( &total_st, &s_len )
				    || total_st < 1 || total_st > 4 * sqr->division )
					goto _PARA_ERR;
			}
			total_st = (4 * sqr->division) / total_st;
			{
				int		st = 0;
				while ( *s_len )
				{
					if ( *s_len != '.' )
						break;
					{
						int		m;
						m = total_st;
						total_st = total_st + (total_st - st)/ 2;
						st = m;
					}
					++s_len;
				}
			}
		}
	}

	Tn    = atoi(argv[3]);
	wn    = atoi(argv[4]);
	tie   = argv[5];	tie_len = strlen(tie);

	{
		CONST char	*s_slide = argv[6];

		if ( *s_slide == '&' )
		{	/* Tn 0n-1 ϰϤѲ	*/
			++s_slide;
			div = 1;
		} else
		{	/* Tn 0Tn ϰϤѲ	*/
			div = 0;
		}
		if ( strcmpi( s_slide, "x" )==0 )
			slide = 0;
		else if ( strcmpi( s_slide, "x^2" )==0 || strcmpi( s_slide, "x*x")==0 )
			slide = 1;
		else if ( strcmpi( s_slide, "exp(x)")==0 || strcmpi( s_slide, "e^x")==0 )
			slide = 2;
		else if ( strcmpi( s_slide, "sqr(x)")==0 || strcmpi( s_slide, "sqr")==0 )
			slide = 3;
		else if  ( *s_slide != '\0' )
			goto _PARA_ERR;
		else
			slide = 0;
	}

	sp     = atoi(argv[7]);
	ep     = atoi(argv[8]);

	{
		CONST char	*s_wave = argv[9];

		if ( *s_wave == '!' )
		{	++s_wave;	/* ȷξ岼դˤʤ	*/
			rev = TRUE;
		} else
			rev = FALSE;
		if (      strcmpi( s_wave, "sin" )==0 )
		{	ang += (rev) ? (ANG/2) : 0;
			wave = 0;
		} else if ( strcmpi( s_wave, "tri" )==0 )
		{	ang += (rev) ? (ANG/2) : 0;
			wave = 1;
		} else if ( strcmpi( s_wave,"saw")==0 )
			wave = 2;
		else if ( *s_wave != '\0' )
			goto _PARA_ERR;
		else
			wave = 0;
	}
	a       = atoi(argv[10]);
	ang     = ANG + ANG * atoi(argv[11]) / 100;

	{
		spdofs_mode = 0;	/* ʬ	*/
		spdofs = 0;
		if ( argc > 12 )
		{
			CONST char	*s_spdofs = argv[12];

			if ( *s_spdofs == '%' )
			{	/* Ψ	*/
				++s_spdofs;
				spdofs_mode = 1;	/* Ψ	*/
				spdofs  = PER * atoi(s_spdofs) / 100;
				if ( spdofs < 1 || spdofs > PER*PER )
					goto _PARA_ERR;
			} else
			{
				spdofs_mode = 0;	/* ʬ	*/
				spdofs  = atoi(s_spdofs);
			}
		}
	}

	{
		aofs_mode = 0;	/* ʬ	*/
		aofs      = 0;
		if ( argc > 13 )
		{
			CONST char	*s_aofs = argv[13];
			if ( *s_aofs == '%' )
			{	/* Ψ	*/
				++s_aofs;
				aofs    = PER * atoi(s_aofs) / 100;
				if ( aofs < 1 || aofs > PER*PER )
					goto _PARA_ERR;
				aofs_mode = 1;
			} else
			{	aofs_mode = 0;	/* ʬ	*/
				aofs    = atoi(s_aofs);
			}
		}
	}
	if ( argc > 14 )
		sub = argv[14];
	else
		sub = "";

	if ( Tn == 0 || wn == 0 )
		goto _PARA_ERR;

	if ( total_st == 0 || total_st < Tn * wn )
		goto _PARA_ERR;

	/* ȡΨη׻	*/
	total_rt = 0;
	for ( i = 0; i < wn; ++i )
	{	if ( spdofs_mode )
		{	j = ANG;
			for ( l = 0; l < i; ++l )
				j = (j * spdofs) / PER;
		} else
			j = ANG + spdofs * i;
		if ( j < Tn )
			j = Tn;
		total_rt += j;
	}

	div = ( div == 0 ) ? (wn*Tn-1) : wn*Tn;
	dt = ep - sp;	/* Ѳ	*/

	dl = 0;
	wave_ct = 0;
	st_count = 0;
	for ( i = 0; i < wn; ++i )
	{
		if ( spdofs_mode )
		{
			wave_rt = ANG;
			for ( l = 0; l < i; ++l )
				wave_rt = (wave_rt * spdofs) / PER;
		} else
			wave_rt = ANG + spdofs * i;
		if ( wave_rt < Tn )
			wave_rt = Tn;

		if ( aofs_mode )	/* 	*/
		{	aa = a;
			for ( l = 0; l < i; ++l )
				aa = (aa * aofs) / PER;
		} else
			aa = a + aofs * i;

		for ( j = 0; j < Tn; ++j )
		{	/*	:-----------------------------------------------------
				:	饤Ѳ
				:-----------------------------------------------------
			*/
			c = i*Tn + j;
			switch( slide )
			{	case	0:	/* 켡ؿ	*/
					par = sp + c*dt/div;
					break;
				case	1:	/* ؿ	*/
					par = sp + dt*c*c/(div*div);
					break;
				case	2:	/* ؿؿ	*/
					par = sp +  (int)( (double)dt*exp((double)c)/exp((double)div) );
					break;
				case	3:	/* 躬	*/
					par = sp +  (int)((double)dt*sqrt((double)c)/sqrt((double)div));
					break;
			}
			/*	:-----------------------------------------------------
				:	
				:-----------------------------------------------------
			*/
			t = (ANG * j) / Tn;	/* 	*/
			switch( wave )
			{	case	0:	/* 	*/
					t = (ang + t) % ANG;
					par = (int)(par +  (double)aa*sin( 2*PI*(double)t/ANG ));
					break;
				case	1:	/* 	*/
					t = (ang + t) % ANG;
					if ( t >= 0 && t < ANG/4 )
						par = par + aa*t/(ANG/4);
					else if ( t >= (ANG/4) && t < (3*ANG/4) )
						par = par + aa - aa*(t-(ANG/4))/(ANG/4);
					else if ( t >= (3*ANG/4) && t < ANG )
						par = par - aa + aa*(t-(3*ANG/4))/(ANG/4);
					break;
				case	2:	/* Υ	*/
					t = (ang + t) % ANG;
					if ( rev )
					{	if ( t >= 0 && t < ANG/2 )
							par = par - aa * t / (ANG/2);
						else
							par = par + aa - aa*(t-(ANG/2))/(ANG/2);
					} else
					{	if ( t >= 0 && t < (ANG/2) )
							par = par + aa * t/(ANG/2);
						else
							par = par - aa + aa*(t-(ANG/2))/(ANG/2);
					}
					break;
			}

			next_st  = (total_st * wave_ct / total_rt) +
			           (total_st * (j+1) * wave_rt /Tn) / total_rt;
			gatetime = next_st - st_count;
			if ( gatetime < 0 )
				gatetime = 0;
			st_count += gatetime;
			if ( i == wn-1 && j == Tn-1 && st_count < total_st )
			{	gatetime += (total_st - st_count);
			}

			{
				int		l;
				char	cmdtmp[256], tmp[256];

				mmac_cmdform( cmdtmp, cmd, par);
				if ( j == 0 )	/* 1s_sub	*/
					sprintf( tmp, "%s%s%s:%d", cmdtmp, sub, note, gatetime );
				else
					sprintf( tmp, "%s%s:%d"  , cmdtmp,      note, gatetime );

				l = strlen( tmp );
				if ( (size_t)(dl + l) >= bufSiz )
					goto _SET_ERR;
				strcpy( dp, tmp );
				dl += l;
				dp += l;
			}
			if ( i < wn - 1 || j < Tn - 1 )
			{	/* Ǹʳ	*/
				if ( (size_t)(dl + tie_len) >= bufSiz )
					goto _SET_ERR;
				strcpy( dp, tie );
				dp += tie_len;
				dl += tie_len;
			}
		}
		wave_ct += wave_rt;
	}

	if ( (size_t)dl >= bufSiz )
	{
_SET_ERR:
		sqr->errMsg = _OUT_OF_STRING_SPACE;
		ret = ERR;
	} else
	{
		memcpy( buf, sbuf, dl );
		ret = dl;
	}

/*_RET:*/
	term();
	return (ret);
}
