/*************************************************************************
*	ȥå
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"mmfile.h"
#include	"midicc.h"
#include	"mml.h"
#include	"mmac.h"
#include	"mmlib.h"
#include	"mmpart.h"
#include	"mmtrk.h"
#include	"msgdat.h"

/*	config	------------------------------------------------------------*/
/*#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

extern void		mmopt_init( MMOPT_T *opt );	/* look "mmopt.c"	*/

#define				_MM_SYS_TRACK_NO		(0)
#define				_MM_SYS_TRACK_PORT		(0)
#define				_MM_SYS_TRACK_CH		(0)
static CONST char	_MM_SYS_TRACK_MACRO[] = "CTRL";

static int _FAST		trk_hash( CONST char *name );
#define	HASH(_name)	trk_hash((_name))

int		MMtrk_init( MMSQR_T *sqr )
{
	int		i;

	sqr->ctrlTrk = NULL;
	for ( i = 0; i < _MMSQR_TRK_HASH_MAX; ++i )
		sqr->trkTbl[i] = NULL;
	sqr->trkNum = 0;

	i = MMtrk_set( sqr,_MM_SYS_TRACK_NO, _MM_SYS_TRACK_MACRO,
	    _MM_SYS_TRACK_PORT, _MM_SYS_TRACK_CH);		/* ƥȥå	*/
	sqr->ctrlTrk = MMtrk_gettrk( sqr, _MM_SYS_TRACK_MACRO );
	if ( i || sqr->ctrlTrk == NULL )
		return (ERR);

	{
		MMTRKWORK_T	*trkWork = &(sqr->trkWork);

		if ( trkWork->mode == MMTRKWORK_MODE_FILE )
		{	/* ե⡼ɡѥǥ쥯ȥ	*/
			if ( trkWork->path[0] == '\0' )
			{
				char	*p;
				if ( (p = getenv("TMP")) == NULL )
					strcpy( trkWork->path,"./");
				else
				{
					int		l;
					strcpy( trkWork->path, p );
					l = strlen(trkWork->path);
					if ( l > 0 && !FS_ISDELIM(trkWork->path[l-1]) )
						strcat( trkWork->path, "/");
				}
			}
		}
		trkWork->pos = 0;
		for ( i = 0; i < MMFOPEN_MAX; ++i )
		{
			trkWork->fwk[i].count  = 0;
			trkWork->fwk[i].trkPtr = NULL;
		}
	}

	HE_puts(sqr,_HE_MSG_DE1,"$$$ MMtrk_int() Ok");

	return (NORMAL);
}

void	MMtrk_term( MMSQR_T *sqr )
{
	int		i;

	{
		MMTRKWORK_T	*trkWork = &(sqr->trkWork);

		for ( i = 0; i < MMFOPEN_MAX; ++i )
		{
			MMTRK_T	*trkPtr;

			if ( (trkPtr = trkWork->fwk[i].trkPtr) != NULL )
			{
				if ( trkPtr->fp )
				{
					FS_fclose( trkPtr->fp );
					trkPtr->fp = NULL;
					if ( trkPtr->fn[0] )
					{
						FS_remove( trkPtr->fn );
						trkPtr->fn[0] = '\0';
					}
				}
				trkWork->fwk[i].trkPtr = NULL;
			}
		}
	}

	for ( i = 0; i < _MMSQR_TRK_HASH_MAX; ++i )
	{
		MMTRK_T	*trkPtr;

		trkPtr = sqr->trkTbl[i];
		while ( trkPtr )
		{
			MMtrk_workFree( sqr, trkPtr );

			{
				if ( trkPtr->fp )			FS_fclose( trkPtr->fp );
				if ( trkPtr->fn[0] )		FS_remove( trkPtr->fn );
			}

			{	/* եǡγ	*/
				MMDAT_T	*dat = trkPtr->datTop, *next;

				while ( dat )
				{
					next = dat->next;
					sqr->workSize -= (sizeof(MMDAT_T) + dat->siz);
					free( dat );
					dat = next;
				}
			}

			{
				MMTRK_T	*trkNext;

				trkNext = trkPtr->next;
				free( trkPtr );		sqr->workSize -= sizeof(MMTRK_T);
				trkPtr = trkNext;
			}
		}
		sqr->trkTbl[i] = NULL;
	}
	sqr->trkNum = 0;
}

/*************************************************************************
*	ȥåΥǥɽλ
*************************************************************************/

void	MMtrk_workFree( MMSQR_T *sqr, MMTRK_T *trk )
{
	{
		REG int		cc;

		if ( trk->extTbl.pitch )
		{
			free( trk->extTbl.pitch );
			trk->extTbl.pitch = NULL;
		}
		for ( cc = 0; cc < 128; ++cc )
		{
			if ( trk->extTbl.ccv[cc] )
			{
				free( trk->extTbl.ccv[cc] );
				trk->extTbl.ccv[cc] = NULL;
			}
		}

		/* Ρȥ	*/
		{
			MMNOTEASN_T	*noteAsn;

			noteAsn = &(trk->noteAsn);

			if ( noteAsn->abs.vel )		{ free( noteAsn->abs.vel );		noteAsn->abs.vel   = NULL; }
			if ( noteAsn->abs.pitch )	{ free( noteAsn->abs.pitch );	noteAsn->abs.pitch = NULL; }
			if ( noteAsn->abs.prog )	{ free( noteAsn->abs.prog );	noteAsn->abs.prog  = NULL; }
			if ( noteAsn->abs.caf )		{ free( noteAsn->abs.caf );		noteAsn->abs.caf   = NULL; }
			if ( noteAsn->abs.paf )		{ free( noteAsn->abs.paf );		noteAsn->abs.paf   = NULL; }
			for ( cc = 0; cc < 128; ++cc )
				if ( noteAsn->abs.cc[cc].ccv )	{ free( noteAsn->abs.cc[cc].ccv );	noteAsn->abs.cc[cc].ccv = NULL; }

			if ( noteAsn->off.vel )		{ free( noteAsn->off.vel );		noteAsn->off.vel   = NULL; }
			if ( noteAsn->off.pitch )	{ free( noteAsn->off.pitch );	noteAsn->off.pitch = NULL; }
			if ( noteAsn->off.caf )		{ free( noteAsn->off.caf );		noteAsn->off.caf   = NULL; }
			if ( noteAsn->off.paf )		{ free( noteAsn->off.paf );		noteAsn->off.paf   = NULL; }
			for ( cc = 0; cc < 128; ++cc )
				if ( noteAsn->off.cc[cc].ccv )	{ free( noteAsn->off.cc[cc].ccv );	noteAsn->off.cc[cc].ccv = NULL; }
		}
		{	/* ץॢ	*/
			MMPROGASN_T	*progAsn;

			progAsn = &(trk->progAsn);
			if ( progAsn->abs.vel )		{ free( progAsn->abs.vel );		progAsn->abs.vel   = NULL; }
			if ( progAsn->abs.note )	{ free( progAsn->abs.note );	progAsn->abs.note  = NULL; }
			if ( progAsn->abs.pitch )	{ free( progAsn->abs.pitch );	progAsn->abs.pitch = NULL; }
			if ( progAsn->abs.caf )		{ free( progAsn->abs.caf );		progAsn->abs.caf   = NULL; }
			if ( progAsn->abs.paf )		{ free( progAsn->abs.paf );		progAsn->abs.paf   = NULL; }
			for ( cc = 0; cc < 128; ++cc )
				if ( progAsn->abs.cc[cc].ccv )	{ free( progAsn->abs.cc[cc].ccv );	progAsn->abs.cc[cc].ccv = NULL; }

			if ( progAsn->off.vel )		{ free( progAsn->off.vel );		progAsn->off.vel   = NULL; }
			if ( progAsn->off.note )	{ free( progAsn->off.note );	progAsn->off.note  = NULL; }
			if ( progAsn->off.pitch )	{ free( progAsn->off.pitch );	progAsn->off.pitch = NULL; }
			if ( progAsn->off.caf )		{ free( progAsn->off.caf );		progAsn->off.caf   = NULL; }
			if ( progAsn->off.paf )		{ free( progAsn->off.paf );		progAsn->off.paf   = NULL; }
			for ( cc = 0; cc < 128; ++cc )
				if ( progAsn->off.cc[cc].ccv )	{ free( progAsn->off.cc[cc].ccv );	progAsn->off.cc[cc].ccv = NULL; }
		}
	}
	MMpart_free( trk );	/* ѡȾγ	*/
}

/*************************************************************************
*	ȥåν
*************************************************************************/

void	MMtrk_clear( MMSQR_T *sqr, MMTRK_T *trk )
{
	if ( trk == NULL )
		return;
	memset( trk, 0, sizeof(MMTRK_T) );

	trk->sqr   = sqr;
//	trk->trkNo = 0;
//	trk->name[0] = '\0';

//	trk->port = 0;
//	trk->ch   = 0;

//	trk->top        = 0;
	trk->delay_flag = TRUE;
//	trk->delay      = 0;

	trk->prog  =   0;
	trk->pitch = 8192;

	trk->ccv[MID_CC_VOLUME]        = 100;
	trk->ccv[MID_CC_PANPOT]        =  64;	/* 	*/
	trk->ccv[MID_CC_EXPRESSION]    = 127;
	trk->ccv[MID_CC_EFFECT1_DEPTH] = 64;
	trk->ccv[MID_CC_EFFECT3_DEPTH] = 64;

	{	/* ɸơ֥	*/
		REG int		i;

		/* MIDIͥơ֥	*/
		for ( i = 0; i < 16; ++i )
			trk->tbl.ch[i] = i;

		for ( i = 0; i < 128; ++i )
		{
			trk->tbl.note[i] = i;
			trk->tbl.vel[i]  = i;
			trk->tbl.prog[i] = i;
			trk->tbl.caf[i]  = i;
			trk->tbl.paf[i]  = i;
		}
		{	/* ȥ	*/
			REG int		cc;
			for ( cc = 0; cc < 128; ++cc )
			{
				trk->tbl.cc[cc]     = cc;
				trk->tbl.ccvBase[i] = 0;
			}
			trk->tbl.ccvBase[MID_CC_PANPOT] = 64;
		}
	}

	{	/* ĥơ֥	*/
		REG int		cc;
		trk->extTbl.pitch = NULL;
		for ( cc = 0; cc < 128; ++cc )
			trk->extTbl.ccv[cc] = NULL;
	}

	{	/* Ρȥ	*/
		REG int		cc;

		trk->noteAsn.abs.vel_flag   = FALSE;
		trk->noteAsn.abs.pitch_flag = FALSE;
		trk->noteAsn.abs.prog_flag  = FALSE;
		trk->noteAsn.abs.caf_flag   = FALSE;
		trk->noteAsn.abs.paf_flag   = FALSE;
		for ( cc = 0; cc < 128; ++cc )
			trk->noteAsn.abs.cc[cc].cc_flag = FALSE;

		trk->noteAsn.off.vel_flag   = FALSE;
		trk->noteAsn.off.pitch_flag = FALSE;
		trk->noteAsn.off.caf_flag   = FALSE;
		trk->noteAsn.off.paf_flag   = FALSE;
		for ( cc = 0; cc < 128; ++cc )
			trk->noteAsn.off.cc[cc].cc_flag = FALSE;
	}

	{	/* ץॢ	*/
		REG int		cc;

		trk->progAsn.abs.pitch_flag = FALSE;
		trk->progAsn.abs.caf_flag   = FALSE;
		trk->progAsn.abs.paf_flag   = FALSE;
		for ( cc = 0; cc < 128; ++cc )
			trk->progAsn.abs.cc[cc].cc_flag = FALSE;

		trk->progAsn.off.pitch_flag = FALSE;
		for ( cc = 0; cc < 128; ++cc )
			trk->progAsn.off.cc[cc].cc_flag = FALSE;
	}

	/* ե륿	*/
	{	/* ƥ	*/
		MMFILTER32_T	*filter = &(trk->filter.tempo);
		filter->ratio   = _MMVAL_RATIO_BASE;	/* 100% */
		filter->offset  = 0;
		filter->min     = 60000000l / 384;
		filter->max     = 60000000l / 24;
		filter->max_bit = 24;
		filter->bit     = 24;
		filter->att     = 1;
		filter->rnd     = FALSE;
		filter->rnd_min = 60000000l / 384;
		filter->rnd_max = 60000000l / 24;
	}
	{	/* ǥ쥤	*/
		MMFILTER16_T	*filter = &(trk->filter.delay);
		filter->ratio   = _MMVAL_RATIO_BASE;	/* 100% */
		filter->offset  = 0;
		filter->min     = -1024;
		filter->max     =  1024;
		filter->max_bit = 16;
		filter->bit     = 16;
		filter->att     = 1;
		filter->rnd     = FALSE;
		filter->rnd_min = -1024;
		filter->rnd_max =  1024;
	}
	{	/* 	*/
		MMFILTER08_T	*filter = &(trk->filter.note);
		filter->ratio   = _MMVAL_RATIO_BASE;	/* 100% */
		filter->offset  = 0;
		filter->min     =   0;
		filter->max     = 127;
		filter->max_bit = 7;
		filter->bit     = 7;
		filter->att     = 0;
		filter->rnd     = FALSE;
		filter->rnd_min =   0;
		filter->rnd_max = 127;
	}
	{	/* ٥ƥ	*/
		MMFILTER08_T	*filter = &(trk->filter.vel);
		filter->ratio   = _MMVAL_RATIO_BASE;	/* 100% */
		filter->offset  = 0;
		filter->min     =   1;
		filter->max     = 127;
		filter->max_bit =   7;
		filter->bit     =   7;
		filter->att     = 1;
		filter->rnd     = FALSE;
		filter->rnd_min =   1;
		filter->rnd_max = 127;
	}
	{	/* ԥå٥	*/
		MMFILTER16_T	*filter = &(trk->filter.pitch);
		filter->ratio   = _MMVAL_RATIO_BASE;	/* 100% */
		filter->offset  = 0;
		filter->min     =     0;
		filter->max     = 16383;
		filter->max_bit = 14;
		filter->bit     = 14;
		filter->att     = 1;
		filter->rnd     = FALSE;
		filter->rnd_min =     0;
		filter->rnd_max = 16383;
	}
	{	/* ץ	*/
		MMFILTER08_T	*filter = &(trk->filter.prog);
		filter->ratio   = _MMVAL_RATIO_BASE;	/* 100% */
		filter->offset  = 0;
		filter->min     =   0;
		filter->max     = 127;
		filter->max_bit = 7;
		filter->bit     = 7;
		filter->att     = 1;
		filter->rnd     = FALSE;
		filter->rnd_min =   0;
		filter->rnd_max = 127;
	}
	{	/* ͥ롦եå	*/
		MMFILTER08_T	*filter = &(trk->filter.caf);
		filter->ratio   = _MMVAL_RATIO_BASE;	/* 100% */
		filter->offset  = 0;
		filter->min     =   0;
		filter->max     = 127;
		filter->max_bit = 7;
		filter->bit     = 7;
		filter->att     = 1;
		filter->rnd     = FALSE;
		filter->rnd_min =   0;
		filter->rnd_max = 127;
	}
	{	/* ݥե˥åեå	*/
		MMFILTER08_T	*filter = &(trk->filter.paf);
		filter->ratio   = _MMVAL_RATIO_BASE;	/* 100% */
		filter->offset  = 0;
		filter->min     =   0;
		filter->max     = 127;
		filter->max_bit = 7;
		filter->bit     = 7;
		filter->att     = 1;
		filter->rnd     = FALSE;
		filter->rnd_min =   0;
		filter->rnd_max = 127;
	}
	{
		REG int		cc;

		for ( cc = 0; cc < 128; ++cc )
		{
			MMFILTER08_T	*filter;

			filter = &(trk->filter.ccv[cc]);
			filter->ratio   = _MMVAL_RATIO_BASE;	/* 100% */
			filter->offset  = 0;
			filter->min     = -trk->tbl.ccvBase[cc];
			filter->max     = 127 - trk->tbl.ccvBase[cc];
			filter->max_bit = 7;
			filter->bit     = 7;
			filter->att     = 1;
			filter->rnd     = FALSE;
			filter->rnd_min = -trk->tbl.ccvBase[cc];
			filter->rnd_max = 127 - trk->tbl.ccvBase[cc];
		}
	}
	/* ץƥޥ	*/
	mmopt_init( &(trk->opt) );

	trk->datTop = trk->datPtr = trk->datLast = NULL;
}

static int _FAST		trk_hash( CONST char *name )
{
	register int		hash = 0;

	while ( *name )
	{
		hash = hash + tolower(*name) * 31;
		++name;
	}
	return (hash & (_MMSQR_TRK_HASH_MAX-1));
}

MMTRK_T * _FAST MMtrk_gettrk( MMSQR_T *sqr, CONST char *name )
{
	MMTRK_T	*trkPtr;

	trkPtr = sqr->trkTbl[HASH(name)];
	while ( trkPtr )
	{
		if ( strcmpi(trkPtr->name,name) == 0 )
			return (trkPtr);
		trkPtr = trkPtr->next;
	}
	return (NULL);
}

MMTRK_T * _FAST MMtrk_gettrk2( MMSQR_T *sqr, int trkNo )
{
	MMTRK_T	*trkPtr;
	int		i;

	for ( i = 0; i < _MMSQR_TRK_HASH_MAX; ++i )
	{
		trkPtr = sqr->trkTbl[i];
		while ( trkPtr )
		{
			if ( trkPtr->trkNo == trkNo )
				return (trkPtr);
			trkPtr = trkPtr->next;
		}
	}
	return (NULL);
}

MMTRK_T * _FAST MMtrk_gettrk3( MMSQR_T *sqr, const char **s )
{
	MMTRK_T	   *trk;

	SKIP_SPACE(*s);
	if ( isdigit(**s) )
	{
		int		trkNo;

		if ( mm_getIntDigit( &trkNo, s ) || trkNo < 1 )
			goto _SET_ERR;
		if ( (trk = MMtrk_gettrk2( sqr, trkNo )) == NULL )
			MM_setErrMsg(sqr,"Track no.%d not use!", trkNo);
	} else
	{
		char		name[256];

		if ( mm_getname( name, sizeof(name)-1, s ) < 0 )
			goto _SET_ERR;
		if ( (trk = MMtrk_gettrk( sqr, name )) == NULL )
			MM_setErrMsg(sqr,"Track macro:'%s' not use!", name);
	}
	return (trk);

_SET_ERR:
	sqr->errMsg = "Track Macro/Number error!";
	return (NULL);
}


/*************************************************************************
*	ȥå
*************************************************************************/

int		MMtrk_set( MMSQR_T *sqr, int trkNo, CONST char *name, int port, int ch )
{
	MMTRK_T	*trk;

#ifdef	_DEBUG
	HE_printf(sqr,_HE_MSG_DE2,"--- MMtrk_set(%2d,\x22%s\x22,%d,%d)",
	    trkNo, name, port, ch );
#endif
	if ( (trk = MMtrk_gettrk( sqr, name )) == NULL )
	{
		if ( MMtrk_gettrk2( sqr, trkNo ) )
		{
			MM_setErrMsg(sqr,"Using track no.%d !",trkNo);
			return (ERR);
		}

		if ( (trk = calloc(sizeof(MMTRK_T),1)) == NULL )
		{
			sqr->errMsg = _OUT_OF_MEMORY;
			return (ERR);
		}
		sqr->workSize += sizeof(MMTRK_T);
		MMtrk_clear(sqr,trk);
	} else
	{	/* Υȥåϴ¸ߤƤ	*/
		MM_setErrMsg(sqr, "Using track macro 0x22%s0x22 !",name);
		return (ERR);
	}

	strncpy( trk->name, name, _MMTRK_NAME_LEN - 1);
	trk->name[_MMTRK_NAME_LEN - 1] = '\0';

	trk->trkNo   = trkNo;
	trk->port    = port;
	trk->ch      = ch;

	trk->end_flag = FALSE;
	trk->clk      = sqr->clk;
	trk->max_clk  = 0;

#if	1
	{
		MMTRK_T	**trkPtr;

		trkPtr = &(sqr->trkTbl[HASH(name)]);
		trk->next = *trkPtr;
		*trkPtr = trk;
	}
#else
	{
		MMTRK_T	*trkPtr;
		int		hash = HASH(name);

		if ( (trkPtr = (sqr->trkTbl[hash])) == NULL )
			sqr->trkTbl[hash] = trk;
		else
		{
			for(;;)
			{
				if ( trkPtr->next == NULL )
					break;
				trkPtr = trkPtr->next;
			}
			trkPtr->next = trk;
		}
	}
#endif
	++(sqr->trkNum);

	return (NORMAL);
}

/*************************************************************************
*	ȥåѡȤΥå·
*************************************************************************/

void _FAST	MMtrk_setClock( MMSQR_T *sqr, MMTRK_T *trk, MMCLK_T clk )
{
	int		j;

	trk->clk = clk;
	for ( j = 0; j < _MMTRK_PART_HASH_MAX; ++j )
	{
		MMPART_T	*part;

		part = trk->partTbl[j];
		while ( part )
		{
			part->clk = clk;
			part = part->next;
		}
	}
}

/* ԥå٥ɥơ֥	*/
int		mmtrk_set_pitchTable( MMTRK_T *trk )
{
	REG int		i;

	if ( trk->extTbl.pitch == NULL )
	{
		MMSQR_T	*sqr = trk->sqr;

		if ( (trk->extTbl.pitch = malloc(sizeof(USHORT) * 16384)) == NULL )
		{
			sqr->errMsg = _OUT_OF_MEMORY;
			return (ERR);
		}
		sqr->workSize += (sizeof(USHORT) * 16384);
	}
	for ( i = 0; i < 16384; ++i )
		trk->extTbl.pitch[i] = i;
	return (NORMAL);
}

/* ȥХ塼ơ֥	*/
int		mmtrk_set_ccvTable( MMTRK_T *trk, int cc )
{
	REG int		i;

	if ( trk->extTbl.ccv[cc] == NULL )
	{
		MMSQR_T	*sqr = trk->sqr;

		if ( (trk->extTbl.ccv[cc] = malloc(sizeof(char) * 128)) == NULL )
		{
			sqr->errMsg = _OUT_OF_MEMORY;
			return (ERR);
		}
		sqr->workSize += (sizeof(char) * 128);
	}
	for ( i = 0; i < 128; ++i )
		trk->extTbl.ccv[cc][i] = i;
	return (NORMAL);
}
