#ifndef	_MMTRK_H
#define	_MMTRK_H

#ifndef	_MML_H
#	include	"mml.h"
#endif

/*----------------------------------------------------------------------*/
#define	MMTRK_MARK_OPT_CLEAR	(0x10)

/*----------------------------------------------------------------------*/
extern int				MMtrk_init( MMSQR_T *sqr );
extern void				MMtrk_term( MMSQR_T *sqr );
extern void				MMtrk_clear( MMSQR_T *sqr, MMTRK_T *trk );
extern void				MMtrk_workFree( MMSQR_T *sqr, MMTRK_T *trk );
extern MMTRK_T * _FAST  MMtrk_gettrk( MMSQR_T *sqr, CONST char *name );
extern MMTRK_T * _FAST  MMtrk_gettrk2( MMSQR_T *sqr, int trkNo );
extern MMTRK_T * _FAST  MMtrk_gettrk3( MMSQR_T *sqr, const char **s );
extern int				MMtrk_set( MMSQR_T *sqr, int trkNo, CONST char *name, int port, int ch );
extern void _FAST		MMtrk_setClock( MMSQR_T *sqr, MMTRK_T *trk, MMCLK_T clk );
extern int				mmtrk_set_pitchTable( MMTRK_T *trk );
extern int				mmtrk_set_ccvTable( MMTRK_T *trk, int cc );

/*----------------------------------------------------------------------*/
extern int _FAST		mmtrk_get_delay( MMTRK_T *trk );
extern int _FAST		mmtrk_set_dat( MMTRK_T *trk, MMDAT_T *dat );
extern MMDAT_T * _FAST  mmtrk_datAlloc( MMTRK_T *trk, MMCLK_T clk, size_t siz );

/*----------------------------------------------------------------------*/
extern int _FAST	mmtrk_set_meta( MMTRK_T *trk, MMCLK_T clk, int type, size_t size, const void *data );
extern int _FAST	mmtrk_set_tempo( MMTRK_T *trk, MMCLK_T clk, unsigned long int msec);
extern int _FAST	mmtrk_set_signature( MMTRK_T *trk, MMCLK_T clk, UCHAR sign[4] );
extern int _FAST	mmtrk_set_end( MMTRK_T *trk, MMCLK_T clk );
extern int _FAST	mmtrk_set_noteon( MMTRK_T *trk, MMCLK_T clk, int ch, int note, int vel);
extern int _FAST	mmtrk_set_noteoff( MMTRK_T *trk, MMCLK_T clk, int ch, int note, int vel);
extern int _FAST	mmtrk_set_prog( MMTRK_T *trk, MMCLK_T clk, int ch, int prog);
extern int _FAST	mmtrk_set_pitch( MMTRK_T *trk, MMCLK_T clk, int ch, int pitch);
extern int _FAST	mmtrk_set_cc( MMTRK_T *trk, MMCLK_T clk, int ch, int cc, int val);
extern int _FAST	mmtrk_set_caf( MMTRK_T *trk, MMCLK_T clk, int ch, int pres);
extern int _FAST	mmtrk_set_paf( MMTRK_T *trk, MMCLK_T clk, int ch, int note, int pres);
extern int _FAST	mmtrk_set_excl( MMTRK_T *trk, MMCLK_T clk, size_t siz, CONST UCHAR *dat );
extern int _FAST	mmtrk_set_excl2( MMTRK_T *trk, MMCLK_T clk, size_t size, const void *excl );
extern int _FAST	mmtrk_set_seqno( MMTRK_T *trk, MMCLK_T clk, int no );
extern int _FAST	mmtrk_set_text( MMTRK_T *trk, MMCLK_T clk, CONST char *str );
extern int _FAST	mmtrk_set_instname( MMTRK_T *trk, MMCLK_T clk, CONST char *name );
extern int _FAST	mmtrk_set_words( MMTRK_T *trk, MMCLK_T clk, CONST char *str );
extern int _FAST	mmtrk_set_mark( MMTRK_T *trk, MMCLK_T clk, int mark, int para );
extern int _FAST	mmtrk_set_mark_word( MMTRK_T *trk, MMCLK_T clk, int mark, int para );

/*	"mmtrk20.c"		----------------------------------------------------*/
extern int		mmtrk_write_dat( MMTRK_T *trk, MMDAT_T *dat );
extern int		mmtrk_datLoad( MMTRK_T *trk );
extern int		mmtrk_datSave( MMTRK_T *trk );

/*----------------------------------------------------------------------*/
extern int _FAST	MMdec_trackCmd( MMSQR_T *sqr, MMPART_T *part, CONST char **s );

/*----------------------------------------------------------------------*/
#define	MMTRK_DELAY(_trk)	(												\
	((_trk)->delay_flag)													\
	? ( (_trk)->delay +														\
	     + ((_trk)->filter.delay.offset)									\
	     + ( ((_trk)->filter.delay.att & (_trk)->filter.delay.rnd )			\
	         ? ((_trk)->filter.delay.rnd_min								\
	            + (mm_rand() % ((_trk)->filter.delay.rnd_max				\
	                            - (_trk)->filter.delay.rnd_min + 1))		\
	            )															\
	         : (0)															\
	        )																\
	     + ((_trk)->delay * (_trk)->filter.delay.ratio						\
	         / _MMVAL_RATIO_BASE - (_trk)->delay)							\
	  )																		\
	: (0)																	\
)


#endif
