/*************************************************************************
*	ȥåǡ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"he386.h"
#include	"midicc.h"
#include	"smfmet.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmtrk.h"
#include	"msgdat.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG		*/
/*	#define	_DAT_DEBUG	*/
/*--------------------------------------------------------------------*/

#define	MMTRK_CH(_trk,_ch)	((_trk)->tbl.ch[ ((_ch) >= 0 && (_ch) <= 15) ? (_ch) : (_trk)->ch ])

#if	0
static UINT	bit32[] =
{
	0x0000_0000, 0x8000_0000, 0xC000_0000, 0xE000_0000, 0xF000_0000, 0xF800_0000, 0xFC00_0000, 0xFE00_0000,
	0xFF00_0000, 0xFF80_0000, 0xFFC0_0000, 0xFFE0_0000, 0xFFF0_0000, 0xFFF8_0000, 0xFFFC_0000, 0xFFFE_0000,
	0xFFFF_0000, 0xFFFF_8000, 0xFFFF_C000, 0xFFFF_E000, 0xFFFF_F000, 0xFFFF_F800, 0xFFFF_FC00, 0xFFFF_FE00,
	0xFFFF_FF00, 0xFFFF_FF80, 0xFFFF_FFC0, 0xFFFF_FFE0, 0xFFFF_FFF0, 0xFFFF_FFF8, 0xFFFF_FFFC, 0xFFFF_FFFE,
	0xFFFF_FFFF,
};
#endif

static CONST UINT	bit24[] =
{
#ifdef	__HIGHC__
	0x0000_00, 0x8000_00, 0xC000_00, 0xE000_00, 0xF000_00, 0xF800_00, 0xFC00_00, 0xFE00_00,
	0xFF00_00, 0xFF80_00, 0xFFC0_00, 0xFFE0_00, 0xFFF0_00, 0xFFF8_00, 0xFFFC_00, 0xFFFE_00,
	0xFFFF_00, 0xFFFF_80, 0xFFFF_C0, 0xFFFF_E0, 0xFFFF_F0, 0xFFFF_F8, 0xFFFF_FC, 0xFFFF_FE,
	0xFFFF_FF,
#else
	0x000000, 0x800000, 0xC00000, 0xE00000, 0xF00000, 0xF80000, 0xFC0000, 0xFE0000,
	0xFF0000, 0xFF8000, 0xFFC000, 0xFFE000, 0xFFF000, 0xFFF800, 0xFFFC00, 0xFFFE00,
	0xFFFF00, 0xFFFF80, 0xFFFFC0, 0xFFFFE0, 0xFFFFF0, 0xFFFFF8, 0xFFFFFC, 0xFFFFFE,
	0xFFFFFF,
#endif
};

#if	0
static	UINT	bit16[] =
{	0x0000, 0x8000, 0xC000, 0xE000, 0xF000, 0xF800, 0xFC00, 0xFE00,
	0xFF00, 0xFF80, 0xFFC0, 0xFFE0, 0xFFF0, 0xFFF8, 0xFFFC, 0xFFFE,
	0xFFFF,
};
#endif

static CONST UINT	bit14[] =
{	0xC000, 0x2000, 0x3000, 0x3800, 0x3C00, 0x3E00, 0x3F00, 0x3F80,
	0x3FC0, 0x3FE0, 0x3FF0, 0x3FF8, 0x3FFC, 0x3FFE, 0x3FFF,
};

static CONST UINT	bit7[] =
{
	0x00, 0x40, 0x60, 0x70, 0x78, 0x7C, 0x7E, 0x7F,
};

/*************************************************************************
*	ȥåǥ쥤åμ
*************************************************************************/

int _FAST	mmtrk_get_delay( MMTRK_T *trk )
{
	REG int				delay;
	REG MMFILTER16_T	*filter = &(trk->filter.delay);

	if ( trk->delay_flag )
	{
		delay = trk->delay;
		delay = MMFILTER_READ(filter,delay);
		if ( delay < filter->min )
			delay = filter->min;
		else if ( delay > filter->max )
			delay = filter->max;
	} else
		delay = 0;
	return (delay);
}


/*************************************************************************
*	ȥåǡν񤭹
*************************************************************************/

int _FAST	mmtrk_set_dat( MMTRK_T *trk, MMDAT_T *dat )
{
	if ( trk->datTop == NULL )
	{
		dat->next = dat->prev = NULL;
		trk->datTop = trk->datLast = dat;
	} else if ( dat->clk < trk->datTop->clk )
	{	/* Ƭɲ	*/
		dat->prev          = NULL;
		dat->next          = trk->datTop;
		trk->datTop->prev  = dat;
		trk->datTop        = dat;
	} else if ( dat->clk >= trk->datLast->clk )
	{	/* Ǹɲ	*/
		dat->next          = NULL;
		dat->prev          = trk->datLast;
		trk->datLast->next = dat;
		trk->datLast       = dat;
	} else
	{
		REG MMDAT_T	*datptr;

		if ( (datptr = trk->datPtr) == NULL )
			datptr = trk->datTop;

		if ( dat->clk >= datptr->clk )
		{
			for(;;)
			{
				datptr = datptr->next;
				if ( dat->clk < datptr->clk )
				{	/* dat, datptr ˤʤ褦³	*/
					dat->prev         = datptr->prev;
					dat->next         = datptr;
					(dat->prev)->next = dat;
					(dat->next)->prev = dat;
					break;
				}
			}
		} else /* if ( dat->clk < datptr->clk ) */
		{
			for(;;)
			{
				datptr = datptr->prev;
				if ( dat->clk >= datptr->clk )
				{	/* datptr, dat ˤʤ褦³	*/
					dat->prev         = datptr;
					dat->next         = datptr->next;
					(dat->next)->prev = dat;
					(dat->prev)->next = dat;
					break;
				}
			}
		}
	}
	trk->datPtr = dat;
	if ( trk->max_clk < dat->clk )
		trk->max_clk = dat->clk;
	return (NORMAL);
}

MMDAT_T * _FAST mmtrk_datAlloc( MMTRK_T *trk, MMCLK_T clk, size_t siz )
{
	MMDAT_T	*dat;

	if ( (dat = calloc( SIZEOF_MMDAT + siz,1)) == NULL )
	{
		((MMSQR_T *)(trk->sqr))->errMsg = _OUT_OF_MEMORY;
		return (NULL);
	}
	{
		MMSQR_T	*sqr = trk->sqr;

		sqr->workSize += (SIZEOF_MMDAT + siz);
	}

	dat->clk = clk;
	dat->trk = trk;
	dat->siz = siz;
	return (dat);
}

#define	SET_TRKDAT(_trk,_dat)							\
{	MMSQR_T	*_sqr = (_trk)->sqr;						\
	if ( _sqr->trkWork.mode == MMTRKWORK_MODE_MEMORY )	\
		return mmtrk_set_dat( _trk, _dat );				\
	else												\
	{	if ( mmtrk_write_dat( _trk, _dat ) )			\
			return (ERR);								\
		_sqr->workSize -= (SIZEOF_MMDAT + (_dat)->siz);	\
		free( _dat );									\
		return (NORMAL);								\
	}													\
}

/*************************************************************************
*	᥿٥
*************************************************************************/

int _FAST	mmtrk_set_meta( MMTRK_T *trk, MMCLK_T clk, int type, size_t size, const void *data )
{
	MMDAT_T				*dat;

	if ( (dat = mmtrk_datAlloc(trk,clk, 2 + size)) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = type;
		memcpy( p, data, size);
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	ƥݥ
*************************************************************************/

int _FAST	mmtrk_set_tempo( MMTRK_T *trk, MMCLK_T clk, unsigned long int msec)
{
	MMDAT_T				*dat;

#ifdef	_DEBUG
	{
		int					tempo = 60000000 / msec;
		HE_printf(trk->sqr,_HE_MSG_DE3,"<<< mmtrk_set_tempo(   clk:%8u, ch:--, tempo:%3d (%8u msec) ",
		    clk, tempo, msec );
	}
#endif
	if ( (dat = mmtrk_datAlloc(trk,clk,6)) == NULL )
		return (ERR);

	{	/* ե륿	*/
		MMFILTER32_T	*filter = &(trk->filter.tempo);
		msec = MMFILTER_READ(filter,msec);
		if ( msec < (unsigned int)filter->min )
			msec = filter->min;
		else if ( msec > (unsigned int)filter->max )
			msec = filter->max;
		msec &= bit24[ filter->bit ];
	}
#ifdef	_DEBUG
	HE_printf(trk->sqr,_HE_MSG_DE4,"----------------------------------------------------- (%8u msec) ",
		msec );
#endif

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = SMF_MET_TEMPO;
		*p++ = 0x03;
		*p++ = (UCHAR)((msec/65536) & 0xFF);
		*p++ = (UCHAR)((msec/256  ) & 0xFF);
		*p   = (UCHAR)( msec        & 0xFF);
	}
	((MMSQR_T *)(trk->sqr))->tempoSetFlag = TRUE;

	{
		MMTRK_T	*trkptr = ((MMSQR_T *)(trk->sqr))->ctrlTrk;
		SET_TRKDAT(trkptr,dat);
	}
}

/*************************************************************************
*	
*************************************************************************/

int _FAST	mmtrk_set_signature( MMTRK_T *trk, MMCLK_T clk, UCHAR sign[4] )
{
	MMDAT_T				*dat;

	if ( trk->trkNo != 0 )
	{
		((MMSQR_T *)(trk->sqr))->errMsg = "Signature meta event must set on control track!";
		return (ERR);
	}

#ifdef	_DEBUG
	HE_printf(trk->sqr,_HE_MSG_DE3,"<<< mmtrk_set_signature( clk:%8u, ch:--, %3d/%-3d ",
		clk, sign[0], 1<<sign[1] );
#endif
	if ( (dat = mmtrk_datAlloc(trk,clk,7)) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = SMF_MET_SIGNATURE;
		*p++ = 0x04;
		*p++ = sign[0];
		*p++ = sign[1];
		*p++ = sign[2];
		*p   = sign[3];
	}
	((MMSQR_T *)(trk->sqr))->signSetFlag = TRUE;

	{
		MMTRK_T	*trkptr = ((MMSQR_T *)(trk->sqr))->ctrlTrk;
		SET_TRKDAT(trkptr,dat);
	}
}

/*************************************************************************
*	ȥåǡλ
*************************************************************************/

int _FAST	mmtrk_set_end( MMTRK_T *trk, MMCLK_T clk )
{
	MMDAT_T				*dat;

#ifdef	_DEBUG
	HE_printf(trk->sqr,_HE_MSG_DE3,"<<< mmtrk_set_end( clk:%8u ");
#endif
	if ( (dat = mmtrk_datAlloc(trk,clk,3)) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = SMF_MET_ENDOFTRK;
		*p   = 0x00;
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	Ρȥ
*************************************************************************/

int _FAST	mmtrk_set_noteon( MMTRK_T *trk, MMCLK_T clk, int ch, int note, int vel)
{
	MMDAT_T				*dat;

#ifdef	_DEBUG
	HE_printf(trk->sqr,_HE_MSG_DE3,"<<< mmtrk_set_noteon(  clk:%8u, ch:%02d, note:%3d, vel:%3d ) ",
		clk, MMTRK_CH(trk,ch) + 1, note, vel );
#endif
	if ( (dat = mmtrk_datAlloc(trk,clk,3)) == NULL )
		return (ERR);

	{	/* ե륿	*/
		MMFILTER08_T	*filter = &(trk->filter.note);
		note = MMFILTER_READ(filter,note);
		if ( note < filter->min )
			note = filter->min;
		else if ( note > filter->max )
			note = filter->max;
		note &= bit7[ filter->bit ];
	}

	{	/* ե륿	*/
		MMFILTER08_T	*filter = &(trk->filter.vel);
		vel = MMFILTER_READ(filter,vel);
		if ( vel < filter->min )
			vel = filter->min;
		else if ( vel > filter->max )
			vel = filter->max;
		vel &= bit7[ filter->bit ];
	}

	{
		UCHAR	*p = dat->dat;

		*p++ = 0x90 + MMTRK_CH(trk,ch);
		*p++ = trk->tbl.note[ note & 0x7F ];
		*p   = trk->tbl.vel[ vel ];
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	Ρȥ
*************************************************************************/

int _FAST	mmtrk_set_noteoff( MMTRK_T *trk, MMCLK_T clk, int ch, int note, int vel)
{
	MMDAT_T				*dat;

#ifdef	_DEBUG
	HE_printf(trk->sqr,_HE_MSG_DE3,"<<< mmtrk_set_noteoff( clk:%8u, ch:%02d, note:%3d, vel:%3d ) ",
		clk, MMTRK_CH(trk,ch) + 1, note, vel );
#endif
	if ( (dat = mmtrk_datAlloc(trk,clk,3)) == NULL )
		return (ERR);

	{	/* ե륿	*/
		MMFILTER08_T	*filter = &(trk->filter.note);
		note = MMFILTER_READ(filter,note);
		if ( note < filter->min )
			note = filter->min;
		else if ( note > filter->max )
			note = filter->max;
		note &= bit7[ filter->bit ];
	}

#if	0
	{	/* ե륿	*/
		MMFILTER08_T	*filter = &(trk->filter.vel);
		vel = MMFILTER_READ(filter,vel);
		if ( vel < filter->min )
			vel = filter->min;
		else if ( vel > filter->max )
			vel = filter->max;
		vel &= bit7[ filter->bit ];
	}
#endif

	if ( vel == 0 )
	{
		UCHAR	*p = dat->dat;

		*p++ = 0x90 + MMTRK_CH(trk,ch);
		*p++ = trk->tbl.note[ note ];
		*p   = 0;
	} else
	{
		UCHAR	*p = dat->dat;

		*p++ = 0x80 + MMTRK_CH(trk,ch);
		*p++ = trk->tbl.note[ note ];
		*p   = vel;
	}

	SET_TRKDAT(trk,dat);
}


/*************************************************************************
*	ץ
*************************************************************************/

int _FAST	mmtrk_set_prog( MMTRK_T *trk, MMCLK_T clk, int ch, int prog)
{
	MMDAT_T				*dat;

	if ( (dat = mmtrk_datAlloc(trk,clk,2)) == NULL )
		return (ERR);

	{	/* ե륿	*/
		MMFILTER08_T	*filter = &(trk->filter.prog);
		prog = MMFILTER_READ(filter,prog);
		if ( prog < filter->min )
			prog = filter->min;
		else if ( prog > filter->max )
			prog = filter->max;
		prog &= bit7[ filter->bit ];
	}

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xC0 + MMTRK_CH(trk,ch);
		*p   = trk->tbl.prog[ prog ];
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	ԥå٥	(pitch 016383)
*************************************************************************/

int _FAST	mmtrk_set_pitch( MMTRK_T *trk, MMCLK_T clk, int ch, int pitch)
{
	MMDAT_T				*dat;

#ifdef	_DEBUG
	HE_printf(trk->sqr,_HE_MSG_DE3,"<<< mmtrk_set_pitch(   clk:%8u, ch:%02d, pitch:%5u ) ",
		clk, MMTRK_CH(trk,ch) + 1, pitch );
#endif

	if ( (dat = mmtrk_datAlloc(trk,clk,3)) == NULL )
		return (ERR);

	{	/* ե륿	*/
		MMFILTER16_T	*filter = &(trk->filter.pitch);
		pitch = MMFILTER_READ(filter,pitch);
		if ( pitch < filter->min )
			pitch = filter->min;
		else if ( pitch > filter->max )
			pitch = filter->max;
		pitch &= bit14[ filter->bit ];
	}

	{
		UCHAR	*p = dat->dat;

		if ( trk->extTbl.pitch )
			pitch = trk->extTbl.pitch[ pitch ];
		*p++ = 0xE0 + MMTRK_CH(trk,ch);
		*p++ = (pitch)       & 0x7F;
		*p   = (pitch >>7 )  & 0x7F;
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	ȥ
*	val (-ccvBase)  (127 - ccvBase)
*************************************************************************/

int _FAST	mmtrk_set_cc( MMTRK_T *trk, MMCLK_T clk, int ch, int cc, int val)
{
	MMDAT_T				*dat;

#ifdef	_DEBUG
	HE_printf(trk->sqr,_HE_MSG_DE3,"<<< mmtrk_set_cc(      clk:%8u, ch:%02d, cc:%3d, val:%3d ) ",
		clk, MMTRK_CH(trk,ch) + 1, cc, val );
#endif
	if ( (dat = mmtrk_datAlloc(trk,clk,3)) == NULL )
		return (ERR);

	{	/* ե륿	*/
		MMFILTER08_T	*filter = &(trk->filter.ccv[cc]);
		val = MMFILTER_READ(filter,val);
		if ( val < filter->min )
			val = filter->min;
		else if ( val > filter->max )
			val = filter->max;
		val += trk->tbl.ccvBase[cc];
		val &= bit7[ filter->bit ];
	}

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xB0 + MMTRK_CH(trk,ch);
		*p++ = trk->tbl.cc[ cc ];
		if ( trk->extTbl.ccv[cc] )
			*p = trk->extTbl.ccv[cc][ val ];
		else
			*p = val;
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	ͥ롦եå
*************************************************************************/

int _FAST	mmtrk_set_caf( MMTRK_T *trk, MMCLK_T clk, int ch, int pres)
{
	MMDAT_T				*dat;

	if ( (dat = mmtrk_datAlloc(trk,clk,2)) == NULL )
		return (ERR);

	{	/* ե륿	*/
		MMFILTER08_T	*filter = &(trk->filter.caf);
		pres = MMFILTER_READ(filter,pres);
		if ( pres < filter->min )
			pres = filter->min;
		else if ( pres > filter->max )
			pres = filter->max;
		pres &= bit7[ filter->bit ];
	}

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xD0 + MMTRK_CH(trk,ch);
		*p   = trk->tbl.caf[ pres & 0x7F ];
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	ݥե˥åեå
*************************************************************************/

int _FAST	mmtrk_set_paf( MMTRK_T *trk, MMCLK_T clk, int ch, int note, int pres)
{
	MMDAT_T				*dat;

	if ( (dat = mmtrk_datAlloc(trk,clk,3)) == NULL )
		return (ERR);

	{	/* ե륿	*/
		MMFILTER08_T	*filter = &(trk->filter.note);
		note = MMFILTER_READ(filter,note);
		if ( note < filter->min )
			note = filter->min;
		else if ( note > filter->max )
			note = filter->max;
		note &= bit7[ filter->bit ];
	}

	{	/* ե륿	*/
		MMFILTER08_T	*filter = &(trk->filter.caf);
		pres = MMFILTER_READ(filter,pres);
		if ( pres < filter->min )
			pres = filter->min;
		else if ( pres > filter->max )
			pres = filter->max;
		pres &= bit7[ filter->bit ];
	}

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xA0 + MMTRK_CH(trk,ch);
		*p++ = trk->tbl.note[ note ];
		*p   = trk->tbl.paf[ pres & 0x7F ];
	}

	SET_TRKDAT(trk,dat);
}


/*************************************************************************
*	ƥࡦ롼֡å
*	dat ˤF0F7ϴޤʤ
*************************************************************************/

int _FAST	mmtrk_set_excl( MMTRK_T *trk, MMCLK_T clk, size_t siz, CONST UCHAR *excl )
{
	MMDAT_T				*dat;

	if ( (dat = mmtrk_datAlloc(trk,clk,siz + 2)) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xF0;
		memcpy( p, excl, siz );
		p += siz;
		*p   = 0xF7;
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	ƥࡦ롼֡å 2
*************************************************************************/

int _FAST	mmtrk_set_excl2( MMTRK_T *trk, MMCLK_T clk, size_t size, const void *excl )
{
	MMDAT_T				*dat;

	if ( (dat = mmtrk_datAlloc(trk,clk,size + 1)) == NULL )
		return (-1);

	{
		unsigned char	   *p = dat->dat;

		*p++ = 0xF7;
		memcpy( p, excl, size);
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	󥹥ʥ
*************************************************************************/

int _FAST	mmtrk_set_seqno( MMTRK_T *trk, MMCLK_T clk, int no )
{
	MMDAT_T				*dat;

	if ( (dat = mmtrk_datAlloc(trk,clk,4)) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = SMF_MET_SEQNO;
		*p++ = (no>>8) & 0xFF;
		*p++ =  no     & 0xFF;
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	ƥȥ٥
*************************************************************************/

int _FAST	mmtrk_set_text( MMTRK_T *trk, MMCLK_T clk, CONST char *str )
{
	MMDAT_T				*dat;
	size_t				len = strlen(str);

	if ( (dat = mmtrk_datAlloc(trk,clk,len + 2)) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = SMF_MET_TEXT;
		memcpy( p, str, len );
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	ڴ̾
*************************************************************************/

int _FAST	mmtrk_set_instname( MMTRK_T *trk, MMCLK_T clk, CONST char *str )
{
	MMDAT_T				*dat;
	size_t				len = strlen(str);

	if ( (dat = mmtrk_datAlloc(trk,clk,len + 2)) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = SMF_MET_INSTNAME;
		memcpy( p, str, len );
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	λ쥤٥
*************************************************************************/

int _FAST	mmtrk_set_words( MMTRK_T *trk, MMCLK_T clk, CONST char *str )
{
	MMDAT_T				*dat;
	size_t				len = strlen(str);

	if ( (dat = mmtrk_datAlloc(trk,clk,len + 2)) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = SMF_MET_WORDS;
		memcpy( p, str, len );
	}

	SET_TRKDAT(trk,dat);
}


/*************************************************************************
*	ѥޡ
*************************************************************************/

int _FAST	mmtrk_set_mark( MMTRK_T *trk, MMCLK_T clk, int mark, int para )
{
	MMDAT_T				*dat;

	if ( (dat = mmtrk_datAlloc(trk,clk, 4)) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = 0xFF;
		*p++ = mark;
		*p   = para;
	}

	SET_TRKDAT(trk,dat);
}

/*************************************************************************
*	ץƥޥޡ
*************************************************************************/

int _FAST	mmtrk_set_mark_word( MMTRK_T *trk, MMCLK_T clk, int mark, int para )
{
	MMDAT_T				*dat;

	if ( (dat = mmtrk_datAlloc(trk,clk, 3+sizeof(USHORT))) == NULL )
		return (ERR);

	{
		UCHAR	*p = dat->dat;

		*p++ = 0xFF;
		*p++ = 0xFF;
		*p++ = mark;
		*(USHORT *)(p) = (USHORT )para;
	}

	SET_TRKDAT(trk,dat);
}
