/*************************************************************************
*	ȥåǡ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<errno.h>

#include	"he386.h"
#include	"mmfile.h"
#include	"midicc.h"
#include	"smfmet.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmtrk.h"
#include	"msgdat.h"
#include	"mmsg.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

int		mmtrk_set_fp( MMTRK_T *trk )
{
	MMSQR_T	*sqr = trk->sqr;
	int		i, base = ((sqr->trkWork.pos)++) % MMFOPEN_MAX;
	int		pos = -1;

	for ( i = 0; i < MMFOPEN_MAX; ++i )
	{
		int		ofs;

		ofs = (base + i) % MMFOPEN_MAX;
		if ( sqr->trkWork.fwk[ofs].trkPtr == NULL )
		{
			sqr->trkWork.fwk[ofs].trkPtr = trk;
			return (pos);
		}
	}
	{
#if	0
		int		min = 0x7FFF;

		for ( i = 0; i < MMFOPEN_MAX; ++i )
		{
			int		ofs;

			ofs = (base + i) % MMFOPEN_MAX;
			if ( min >= sqr->trkWork.fwk[ofs].count )
			{
				min = sqr->trkWork.fwk[ofs].count;
				pos = ofs;
			}
		}
		if ( pos >= 0 )
		{
			for ( i = 0; i < MMFOPEN_MAX; ++i )
				sqr->trkWork.fwk[i].count -= min;
		} else
			pos = base;
#else
		pos = base;
#endif

		{
			MMTRK_T	*trkptr = sqr->trkWork.fwk[pos].trkPtr;

			FS_fclose(trkptr->fp);
			trkptr->fp = NULL;
		}
		sqr->trkWork.fwk[pos].trkPtr = trk;
	}
	return (pos);
}

int		mmtrk_fclose_one( MMTRK_T *trk )
{
	MMSQR_T	*sqr = trk->sqr;
	int		i, base = ((sqr->trkWork.pos)++) % MMFOPEN_MAX;

	for ( i = 0; i < MMFOPEN_MAX; ++i )
	{
		int		ofs;

		ofs = (base + i) % MMFOPEN_MAX;
		if ( sqr->trkWork.fwk[ofs].trkPtr )
		{
			MMTRK_T	*trkptr = sqr->trkWork.fwk[ofs].trkPtr;

			sqr->trkWork.fwk[ofs].trkPtr = NULL;
			FS_fclose(trkptr->fp);
			trkptr->fp = NULL;
			return (NORMAL);
		}
	}
	return (ERR);
}

FILE	*mmtrk_get_fp( MMTRK_T *trk, CONST char *md )
{
	MMSQR_T	*sqr = trk->sqr;

	if ( trk->fp == NULL )
	{
		if ( trk->fn[0] == '\0' )
		{	/* ե	*/
			unsigned int		count = 0;

			for(;;)
			{
				FILE	*fp;
				char	fnbuf[256];

				sprintf( fnbuf, "%s_he%05u.)0(", sqr->trkWork.path, count );
				errno = 0;
				if ( (fp = FS_fopen(fnbuf,"r")) == NULL )
				{
					if ( errno == EMFILE )
					{	/* ե򥪡ץ󤷤	*/
						if ( mmtrk_fclose_one( trk ) )
						{
							sqr->errMsg = _msg_Too_many_file_open[TypMsg];
							MM_error(sqr);
							return (NULL);
						}
						continue;
					}  else
					{
						strcpy( trk->fn, fnbuf );
						break;
					}
				}
				FS_fclose(fp);
				if ( ++count > 9999u )
				{
					sqr->errMsg = _msg_File_open_error[TypMsg];
					MM_error(sqr);
				}
			}
		}
		errno = 0;
		do
		{
			if ( (trk->fp = FS_fopen( trk->fn, md )) == NULL )
			{	/* ե륪ץ󥨥顼	*/
				if ( errno == EMFILE )
				{	/* ե򥪡ץ󤷤	*/
					if ( mmtrk_fclose_one( trk ) )
					{
						sqr->errMsg = _msg_Too_many_file_open[TypMsg];
						MM_error(sqr);
						return (NULL);
					}
				} else
				{
					sqr->errMsg = _msg_File_open_error[TypMsg];
					MM_error(sqr);
					return (NULL);
				}
			}
		} while ( trk->fp == NULL );
		mmtrk_set_fp( trk );
	}
	return (trk->fp);
}

/*************************************************************************
*	ȥåǡν񤭹ߡʥե
*************************************************************************/

int		mmtrk_write_dat( MMTRK_T *trk, MMDAT_T *dat )
{
	if ( trk->fp == NULL )
	{
		if ( mmtrk_get_fp( trk, "ab" ) == NULL )
			return (ERR);
	}
	fwrite( &(dat->clk), sizeof(MMCLK_T), 1, trk->fp );	/* å		*/
	fwrite( &(dat->siz), sizeof(size_t) , 1, trk->fp );	/* ǡ	*/
	fwrite( dat->dat   , dat->siz       , 1, trk->fp );	/* ǡ	*/

	return (NORMAL);
}

int		mmtrk_fclose( MMTRK_T *trk )
{
	if ( trk->fp )
	{
		int		i;
		MMSQR_T	*sqr = trk->sqr;

		for ( i = 0; i < MMFOPEN_MAX; ++i )
		{
			if ( sqr->trkWork.fwk[i].trkPtr == trk )
			{
				sqr->trkWork.fwk[i].trkPtr = NULL;
				break;
			}
		}
		FS_fclose( trk->fp );	trk->fp = NULL;
	}
	return (NORMAL);
}

/*************************************************************************
*	ȥåǡ˥
*************************************************************************/

int		mmtrk_datLoad( MMTRK_T *trk )
{
	MMSQR_T	*sqr = trk->sqr;

	mmtrk_fclose( trk );
	if ( mmtrk_get_fp( trk, FOPEN_READ_BIN) == NULL )
		return (ERR);

	for(;;)
	{
		MMCLK_T		clk;
		size_t		siz;
		MMDAT_T		*dat;

		if ( fread( &clk, sizeof(MMCLK_T), 1, trk->fp) < 1 )
			break;
		if ( fread( &siz, sizeof(size_t) , 1, trk->fp) < 1 )
		{	/* error */
			mmtrk_fclose( trk );
			sqr->errMsg = _msg_Eof_encountered[TypMsg];
			return (ERR);
		}
		if ( (dat = mmtrk_datAlloc(trk,clk,siz)) == NULL )
		{	/* memory allocation error */
			mmtrk_fclose( trk );
			return (ERR);
		}
		if ( fread( dat->dat, siz, 1, trk->fp) < 1 )
		{	/* error */
			sqr->workSize -= (SIZEOF_MMDAT + siz);
			free( dat );
			mmtrk_fclose( trk );
			sqr->errMsg = _msg_Eof_encountered[TypMsg];
			return (ERR);
		}
		if ( mmtrk_set_dat( trk, dat ) )
		{
			mmtrk_fclose( trk );
			return (ERR);
		}
	}
	mmtrk_fclose( trk );
	return (NORMAL);
}

/*************************************************************************
*	ȥåǡե¸
*************************************************************************/

int		mmtrk_datSave( MMTRK_T *trk )
{
	MMSQR_T		*sqr = trk->sqr;
	MMDAT_T		*dat = trk->datTop;

	mmtrk_fclose( trk );
	if ( mmtrk_get_fp( trk, FOPEN_WRITE_BIN) == NULL )
		return (ERR);

	while ( dat )
	{
		fwrite( &(dat->clk), sizeof(MMCLK_T), 1, trk->fp );	/* å		*/
		fwrite( &(dat->siz), sizeof(size_t) , 1, trk->fp );	/* ǡ	*/
		fwrite( dat->dat   , dat->siz       , 1, trk->fp );	/* ǡ	*/
		{
			MMDAT_T	*next;

			next = dat->next;
			sqr->workSize -= (SIZEOF_MMDAT + dat->siz);
			free( dat );
			dat = next;
		}
	}
	trk->datTop = trk->datPtr = trk->datLast = NULL;
	mmtrk_fclose( trk );
	return (NORMAL);
}
