/*************************************************************************
*	ȥåϥޥ
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"he386.h"
#include	"midicc.h"
#include	"mml.h"
#include	"mmac.h"
#include	"mmlib.h"
#include	"mmpart.h"
#include	"mmtrk.h"
#include	"mmsg.h"
#include	"msgdat.h"
#include	"smfmet.h"
#include	"search.h"

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

static int		MMdec_trkTempo(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv);
static int		MMdec_trkDelay(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkNoteon(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkNoteoff(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkCC(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkPitch(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkProg(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkCaf(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkPaf(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkExcl(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkExcl2(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkInstname(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkText(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkWords(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkMeta(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
static int		MMdec_trkEnd(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );

extern int		MMdec_trkNoteAsn(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
extern int		MMdec_trkFilter(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
extern int		MMdec_trkProgAsn(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );
extern int		MMdec_trkOptimize(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );

extern int		MMdec_trkCall(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv );

#if	defined(WIN32)
#	pragma	pack(push,4)
#endif
struct _trkcmdtbl_t
{
	const char	*name;
	int			(*func)(MMSQR_T *, MMPART_T *, int, char **);
} TrkCmdTbl[] =
{
	{ "CALL"    ,	MMdec_trkCall		},
	{ "CAF"     ,	MMdec_trkCaf		},
	{ "CC"      ,	MMdec_trkCC			},
	{ "DELAY"   ,	MMdec_trkDelay		},
	{ "END"     ,	MMdec_trkEnd		},
	{ "EXCL"    ,	MMdec_trkExcl		},
	{ "EXCL2"   ,	MMdec_trkExcl2		},
	{ "FILTER"  ,	MMdec_trkFilter		},
	{ "INSTNAME",	MMdec_trkInstname	},
	{ "META"    ,	MMdec_trkMeta		},
	{ "NOTEASN" ,	MMdec_trkNoteAsn	},
	{ "NOTEOFF" ,	MMdec_trkNoteoff	},
	{ "NOTEON"  ,	MMdec_trkNoteon		},
	{ "OPT"     ,	MMdec_trkOptimize	},
	{ "PAF"     ,	MMdec_trkPaf		},
	{ "PITCH"   ,	MMdec_trkPitch		},
	{ "PROG"    ,	MMdec_trkProg		},
	{ "PROGASN" ,	MMdec_trkProgAsn	},
	{ "TEMPO"   ,	MMdec_trkTempo		},
	{ "TEXT"    ,	MMdec_trkText		},
	{ "WORDS"   ,	MMdec_trkWords		},
};
#if	defined(WIN32)
#	pragma	pack(pop)
#endif

static	int		cmpFunc( const struct _trkcmdtbl_t *c1, const struct _trkcmdtbl_t *c2 )
{
	return (mm_strcmpi(c1->name,c2->name));
}


int _FAST	MMdec_trackCmd( MMSQR_T *sqr, MMPART_T *part, CONST char **s )
{
	char		name[128];
	CONST char	*p;

	++(*s);	/* skip '@' */
	while ( isspace(*(*s)) )
		++(*s);
	p = (*s);
	if ( mm_getname(name,127,s) || name[0] == '\0' || *(*s) != '(' )
	{
_TRK_ERR:
		sqr->errPoint = p;
		sqr->errMsg = "Track command error!";
		return (ERR);
	}

	{
#ifdef	__HIGHC__
		struct _trkcmdtbl_t	key = { name, (int (*)(MMSQR_T *,MMPART_T *, int, char **))0 };
#else
		struct _trkcmdtbl_t	key;
#endif
		struct _trkcmdtbl_t	*cmd;
		int					ret, argc;
		char				**argv;

#ifndef	__HIGHC__
		key.name = name;
		key.func = (int (*)(MMSQR_T *,MMPART_T *, int, char **))0;
#endif
		argc = mm_get_arg(s, &argv);
		cmd = bsearch( &key, TrkCmdTbl, sizeof(TrkCmdTbl)/sizeof(*TrkCmdTbl),
		  sizeof(*TrkCmdTbl), (int (*)(const void *, const void *))cmpFunc );
		if ( !cmd )
		{
			mm_clear_arg(argc,argv);
			goto _TRK_ERR;
		}
		ret = (cmd->func)(sqr,part,argc,argv);
		mm_clear_arg(argc,argv);
		return (ret);
	}
}

/*************************************************************************
*	ȥåƥݥ
*	@TEMPO(<msec>)
*************************************************************************/
static	int		MMdec_trkTempo(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv)
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( trk->trkNo != 0 )
	{
		sqr->errMsg = _msg_Tempo_change_error[TypMsg];
		return (ERR);
	}

	if ( argc < 1 )
	{
_TEMPO_ERR:
		sqr->errMsg = "Track tempo error!";
		return (ERR);
	}

	{
		int		msec;
		msec = atoi(argv[0]);
		if ( msec <= 0 )
			goto _TEMPO_ERR;
		ret = mmtrk_set_tempo( trk, mmpart_get_clock(part), msec);
	}

	return (ret);
}

/*************************************************************************
*	ȥåǥ쥤
*	@DELAY(<n>)
*************************************************************************/
static	int		MMdec_trkDelay(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;

	if ( argc < 1 )
	{
_DELAY_ERR:
		sqr->errMsg = "Track delay error!";
		return (ERR);
	}

	{
		int		delay;
		delay = atoi(argv[0]);
		if ( delay < -65535 || delay > 65535)
			goto _DELAY_ERR;
		trk->delay = delay;
	}

	return (NORMAL);
}

/*************************************************************************
*	ȥåΡȥ
*	@NOTEON(<note>,<vel>)
*************************************************************************/
static	int		MMdec_trkNoteon(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 2 )
	{
_NOTEON_ERR:
		sqr->errMsg = "Track note-on error!";
		return (ERR);
	}

	{
		int		note, vel;

		{
			CONST char	*p = argv[0];
			note = mm_getnote( &p );
		}
		if ( note < 0 || note > 127 )
			goto _NOTEON_ERR;

		vel  = atoi(argv[1]);
		if ( vel < 1 || vel > 127 )
			goto _NOTEON_ERR;
		ret = mmtrk_set_noteon( trk, mmpart_get_clock(part), part->ch, note, vel);
	}

	return (ret);
}

/*************************************************************************
*	ȥåΡȥ
*	@NOTEOFF(<note>,<vel>)
*************************************************************************/
static	int		MMdec_trkNoteoff(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 2 )
	{
_NOTEOFF_ERR:
		sqr->errMsg = "Track note-off error!";
		return (ERR);
	}

	{
		int		note, vel;

		{
			CONST char	*p = argv[0];
			note = mm_getnote( &p );
		}
		if ( note < 0 || note > 127 )
			goto _NOTEOFF_ERR;

		vel  = atoi(argv[1]);
		if ( vel < 0 || vel > 127 )
			goto _NOTEOFF_ERR;
		ret = mmtrk_set_noteoff( trk, mmpart_get_clock(part), part->ch, note, vel);
	}

	return (ret);
}

/*************************************************************************
*	ȥåȥ
*	@CC(<cc>,<val>)
*************************************************************************/
static	int		MMdec_trkCC(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 2 )
	{
_CC_ERR:
		sqr->errMsg = "Track control change error!";
		return (ERR);
	}

	{
		int		cc, val, base;

		cc = atoi(argv[0]);
		if ( cc < 0 || cc > 127 )
			goto _CC_ERR;
		base = trk->tbl.ccvBase[cc];

		val = atoi(argv[1]);
		if ( val < -base || val > 127-base )
			goto _CC_ERR;
		trk->ccv[cc] = val + base;
		ret = mmtrk_set_cc( trk, mmpart_get_clock(part), part->ch, cc, val);
	}

	return (ret);
}

/*************************************************************************
*	ȥåԥå٥
*	@PITCH(<pitch>)
*************************************************************************/
static	int		MMdec_trkPitch(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 1 )
	{
_PITCH_ERR:
		sqr->errMsg = "Track pitchbend error!";
		return (ERR);
	}

	{
		int		pitch;

		pitch = atoi(argv[0]);
		if ( pitch < -8192 || pitch > 8191 )
			goto _PITCH_ERR;
		trk->pitch = pitch + 8192;
		ret = mmtrk_set_pitch( trk, mmpart_get_clock(part), part->ch, pitch + 8192);
	}

	return (ret);
}

/*************************************************************************
*	ȥåץ
*	@PROG(<prog>)
*************************************************************************/
static	int		MMdec_trkProg(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 1 )
	{
_PROG_ERR:
		sqr->errMsg = "Track program change error!";
		return (ERR);
	}

	{
		int		prog;

		prog = atoi(argv[0]) - 1;
		if ( prog < 0 || prog > 127 )
			goto _PROG_ERR;
		ret = mmtrk_set_prog( trk, mmpart_get_clock(part), part->ch, prog );
	}

	return (ret);
}

/*************************************************************************
*	ȥåͥ륢եå
*	@CAF(<pres>)
*************************************************************************/
static	int		MMdec_trkCaf(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 1 )
	{
_CAF_ERR:
		sqr->errMsg = "Track channel-after-touch error!";
		return (ERR);
	}

	{
		int		pres;

		pres  = atoi(argv[0]);
		if ( pres < 0 || pres > 127 )
			goto _CAF_ERR;
		ret = mmtrk_set_caf( trk, mmpart_get_clock(part), part->ch, pres);
	}

	return (ret);
}


/*************************************************************************
*	ȥåݥե˥åեå
*	@PAF(<note>,<pres>)
*************************************************************************/
static int		MMdec_trkPaf(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 2 )
	{
_PAF_ERR:
		sqr->errMsg = "Track polyphonic-after-touch error!";
		return (ERR);
	}

	{
		int		note, pres;

		{
			CONST char	*p = argv[0];
			note = mm_getnote( &p );
		}
		if ( note < 0 || note > 127 )
			goto _PAF_ERR;

		pres  = atoi(argv[1]);
		if ( pres < 0 || pres > 127 )
			goto _PAF_ERR;
		ret = mmtrk_set_paf( trk, mmpart_get_clock(part), part->ch, note, pres);
	}

	return (ret);
}

/*************************************************************************
*	ȥå롼
*	@EXCL(<dat1>,<dat2>...)
*************************************************************************/

static int		MMdec_trkExcl(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 1 )
	{
_EXCL_ERR:
		sqr->errMsg = "Track system exclusive message error!";
		return (ERR);
	}

	{
		REG int		i;
		UCHAR		*buf;

		if ( (buf = malloc(argc)) == NULL )
		{
			sqr->errMsg = _OUT_OF_MEMORY;
			return (ERR);
		}
		for ( i = 0; i < argc; ++i )
		{
			REG int		dat;

			dat = atoi(argv[i]);
			if ( dat < 0 || dat > 127 )
				goto _EXCL_ERR;
			buf[i] = dat;
		}
		ret = mmtrk_set_excl( trk, mmpart_get_clock(part), argc, buf );
		free(buf);
	}

	return (ret);
}

/*************************************************************************
*	ȥå롼
*	@EXCL2(<dat1>,<dat2>...)
*************************************************************************/

static int		MMdec_trkExcl2(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 1 )
	{
_EXCL_ERR:
		sqr->errMsg = "Track system exclusive 2 message error!";
		return (-1);
	}

	{
		register unsigned	n;
		unsigned char	   *buf;

		if ( (buf = malloc(argc)) == NULL )
		{
			sqr->errMsg = _OUT_OF_MEMORY;
			return (-1);
		}
		for ( n = 0; n < (unsigned)argc; ++n )
		{
			register int		data;

			data = atoi(argv[n]);
			if ( data < 0 || data > 255 )
				goto _EXCL_ERR;
			buf[n] = data;
		}
		ret = mmtrk_set_excl2( trk, mmpart_get_clock(part), argc, buf );
		free(buf);
	}

	return (ret);
}

/*************************************************************************
*	ƥȥ٥
*	@TEXT(<str>)
*************************************************************************/

static int		MMdec_trkText(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 1 )
	{
		sqr->errMsg = "Track text event error!";
		return (-1);
	}

	{
		char	   *str = argv[0];

		ret = mmtrk_set_text( trk, mmpart_get_clock(part), str );
	}

	return (ret);
}

/*************************************************************************
*	ȥå󥹥ȥȥ͡
*	@INST(<name>)
*************************************************************************/

static int		MMdec_trkInstname(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 1 )
	{
		sqr->errMsg = "Track insturment name error!";
		return (-1);
	}

	{
		char	   *name = argv[0];

		ret = mmtrk_set_instname( trk, mmpart_get_clock(part), name );
	}

	return (ret);
}

/*************************************************************************
*	λ쥤٥
*	@WORDS(<str>)
*************************************************************************/

static int		MMdec_trkWords(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;

	if ( argc < 1 )
	{
		sqr->errMsg = "Track words event error!";
		return (-1);
	}

	{
		char	   *str = argv[0];

		ret = mmtrk_set_words( trk, mmpart_get_clock(part), str );
	}

	return (ret);
}


/*************************************************************************
*	᥿٥
*	@META(<type>, <data-type>, ...)
*		data-type	= txt	ƥ
*					= bin	Хʥ
*************************************************************************/

static int		MMdec_trkMeta(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;
	int			ret;
	int			type, datatype;
	enum _type_enum
	{
		_DATATYPE_TXT,
		_DATATYPE_BIN,
	};

	if ( argc < 3 )
		goto _ERR;

	/* <type> */
	{
		const char	*s = argv[0];

		if ( mm_getIntDigit( &type, &s) < 0 || type < 0 || type > 127 )
			goto _ERR;

		switch ( type )
		{
			case SMF_MET_ENDOFTRK:
			case SMF_MET_TEMPO:
			case SMF_MET_SIGNATURE:
				goto _ERR;
		}
	}

	/* <data-type> */
	{
		const char	   *s = argv[1];
		static SEA_NO tbl[] = 
		{
			{ "bin"   , _DATATYPE_BIN },
			{ "binary", _DATATYPE_BIN },
			{ "text"  , _DATATYPE_TXT },
			{ "txt"   , _DATATYPE_TXT },
		};

		if ( (datatype = sea_getno( s, tbl, sizeof(tbl)/sizeof(*tbl))) < 0 )
			goto _ERR;
	}

	switch ( datatype )
	{
		case _DATATYPE_TXT:
		{
			char	   *s = argv[2];

			ret = mmtrk_set_meta( trk, mmpart_get_clock(part), type, strlen(s), s);
			break;
		}

		case _DATATYPE_BIN:
		{
			unsigned int		n, len;
			unsigned char	   *buf;

			len = argc - 2;
			if ( (buf = malloc(len+1)) == NULL )
			{
				sqr->errMsg = _OUT_OF_MEMORY;
				return (-1);
			}
			for ( n = 2; n < (unsigned)argc; ++n )
			{
				register int		data;

				data = atoi(argv[n]);
				if ( data < 0 || data > 255 )
					goto _ERR;
				buf[n-2] = data;
				ret = mmtrk_set_meta( trk, mmpart_get_clock(part), type, len, buf);
			}
			free(buf);
			break;
		}
	}
	return (ret);

_ERR:
	sqr->errMsg = "Track meta event error!";
	return (-1);
}

/*************************************************************************
*	ȥåǥɽλ
*************************************************************************/

static int		MMdec_trkEnd(MMSQR_T *sqr, MMPART_T *part, int argc, char **argv )
{
	MMTRK_T		*trk = part->trk;

	MMtrk_workFree( sqr, trk );
	return (NORMAL);
}
