/*************************************************************************
*	
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	<math.h>

#include	"he386.h"
#include	"msgdat.h"
#include	"mml.h"
#include	"mmlib.h"
#include	"mmpp.h"
#include	"mmac.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif

/*	config	------------------------------------------------------------*/
/*	#define	_DEBUG	*/
/*--------------------------------------------------------------------*/

#define	ARG_MAX		(32)
#define	ARG_BUFSIZ	(32)

#define	FT(f)	((float)(f))

#ifndef PI
# ifdef	_PI
#	define	PI	(_PI)
# else
#	define	PI	(3.14159)
# endif
#endif

/*************************************************************************
*	$wave( note, cmd, n, tie, func, home, amp, speed [,ang] )
*************************************************************************/

int		MMfunc_wave(MMSQR_T *sqr,size_t bufSiz, char *buf,int argc, char **argv)
{
	int			i, ret = NORMAL;
	int			n;
	int			home, amp, speed, ang, rev;
	int			fun;
	CONST char	*note, *cmd, *tie;
	int			note_len, tie_len;
	int			dl = 0;
	char		*dp, *sbuf = NULL;

#define	term()	{	if ( sbuf )	free( sbuf );}

	if ( argc < 8 )
	{
_PARA_ERR:
		sqr->errMsg = "Wave parameter error!";
		term();
		return (ERR);
	}

	if ( (sbuf = malloc(_MM_DEC_BUFSIZ)) == NULL )
	{
		sqr->errMsg = _OUT_OF_MEMORY;
		term();
		return (ERR);
	}
	dp = sbuf;

	note  = argv[0];	note_len = strlen(note);
	cmd   = argv[1];	
	if ( (n = atoi(argv[2])) < 2 )
		goto _PARA_ERR;
	tie   = argv[3];	tie_len = strlen(tie);
	{
		char	*s = argv[4];

		if ( *s == '!' )
		{
			++s;
			rev = 1;	/* ȷξ岼	*/
		} else
			rev = 0;
		if ( strcmpi( s, "tri" ) == 0 )
			fun = 1;
		else if ( strcmpi( s,"saw") == 0 )
			fun = 2;
	}
	home  = atoi(argv[5]);
	amp   = atoi(argv[6]);
	speed = atoi(argv[7]);
	if ( argc > 8 )
		ang = atoi(argv[8]);
	else
		ang = 0;

	dl = 0;
	switch( fun )
	{
		case	1:	/* 	*/
		{
			ang += (rev) ? 180 : 0;
			for( i = 0; i < n; ++i )
			{
				char	tmp[256];
				int		t, par, l;

				t = (ang + i*speed) % 360;	/* ١ʸˡ	*/
				if ( t >= 0 && t < 90 )
					par = home + amp*t / 90;
				else if ( t >= 90 && t < 270 )
					par = home + amp - amp*(t-90)/90;
				else if ( t >= 270 && t < 360 )
					par = home - amp + amp*(t-270)/90;

				l = mmac_cmdform( tmp, cmd, par);
				if ( (size_t)(dl + l) >= bufSiz )
					goto _SET_ERR;
				strcpy( dp, tmp );
				dl += l;
				dp += l;
				strcpy( dp, note );
				dl += note_len;
				dp += note_len;
				if ( i < (n-1) )
				{
					if ( (size_t)(dl + tie_len) >= bufSiz )
						goto _SET_ERR;
					strcpy( dp, tie );
					dp += tie_len;
					dl += tie_len;
				}
			}
			break;
		}

		case	2:	/* Υ	*/
		{
			for( i = 0; i < n; ++i )
			{
				char	tmp[256];
				int		t, par, l;

				t = (ang + i*speed) % 360;	/* ١ʸˡ	*/
				if ( rev )
				{	if ( t >= 0 && t < 180 )
						par = home - amp * t/180;
					else
						par = home + amp - amp*(t-180)/180;
				} else
				{	if ( t >= 0 && t < 180 )
						par = home + amp * t/180;
					else
						par = home - amp + amp*(t-180)/180;
				}

				l = mmac_cmdform( tmp, cmd, par);
				if ( (size_t)(dl + l) >= bufSiz )
					goto _SET_ERR;
				strcpy( dp, tmp );
				dl += l;
				dp += l;
				strcpy( dp, note );
				dl += note_len;
				dp += note_len;
				if ( i < (n-1) )
				{
					if ( (size_t)(dl + tie_len) >= bufSiz )
						goto _SET_ERR;
					strcpy( dp, tie );
					dp += tie_len;
					dl += tie_len;
				}
			}
			break;
		}

		default:	/* 	*/
		{
			ang += (rev) ? 180 : 0;
			for( i = 0; i < n; ++i )
			{
				char	tmp[256];
				int		par, l;

				par = home + (int)( FT(amp)*sin( 2*PI*FT(ang + i*speed)/FT(360) ) );

				l = mmac_cmdform( tmp, cmd, par);
				if ( (size_t)(dl + l) >= bufSiz )
					goto _SET_ERR;
				strcpy( dp, tmp );
				dl += l;
				dp += l;
				strcpy( dp, note );
				dl += note_len;
				dp += note_len;
				if ( i < (n-1) )
				{
					if ( (size_t)(dl + tie_len) >= bufSiz )
						goto _SET_ERR;
					strcpy( dp, tie );
					dp += tie_len;
					dl += tie_len;
				}
			}
			break;
		}
	}

	if ( (size_t)dl >= bufSiz )
	{
_SET_ERR:
		sqr->errMsg = _OUT_OF_STRING_SPACE;
		ret = ERR;
	} else
	{
		memcpy( buf, sbuf, dl );
		ret = dl;
	}

/*_RET:*/
	term();
	return (ret);
}
