/*************************************************************************
*
*************************************************************************/

#include	<stdlib.h>
#include	<string.h>

#include	"search.h"

/*************************************************************************
*	Search Key Number
*************************************************************************/

static int		cmpfunc_search_key( const SEA_NO *key1, const SEA_NO *key2);

int _FAST	sea_getno( const char *s, SEA_NO *tbl, unsigned tblnum )
{
	SEA_NO			key, *keyptr;

	key.name = s;
	if ( (keyptr = bsearch( &key, tbl, tblnum, sizeof(*tbl),
	    (int (*)(const void *, const void *))cmpfunc_search_key )) != NULL )
		return (keyptr->no);
	return (-1);
}

static int		cmpfunc_search_key( const SEA_NO *key1, const SEA_NO *key2)
{
	return (strcmpi(key1->name,key2->name));
}

/*************************************************************************
*	Search Key Function
*************************************************************************/

static int		cmpfunc_search_fnc( const SEA_FNC *fnc1, const SEA_FNC *fnc2);

SEA_FNC * _FAST	sea_getfnc( const char *s, SEA_FNC *tbl, size_t tblnum )
{
	SEA_FNC		key;

	key.name = s;
	return bsearch( &key, tbl, tblnum, sizeof(*tbl),
	    (int (*)(const void *, const void *))cmpfunc_search_fnc);
}

static int		cmpfunc_search_fnc( const SEA_FNC *fnc1, const SEA_FNC *fnc2)
{
	return (strcmpi(fnc1->name,fnc2->name));
}
